﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports PDF.DAL.MSSQL
Imports Utils
Imports System.Collections.Generic
Imports System.ComponentModel

Namespace BackEnd 
    Public Class Alert

        Public Shared Function GetFormLookups(Optional ByRef aConContext As ConnectionContext = Nothing) As DataTable  
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "SELECT AT_ID AS ID, AT_NAME AS TITLE FROM TBL_ALERTTYPE ORDER BY AT_ORDERID"

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            Return aDT
        End Function


        Public Shared Function Search(aSDate As String, aEDate As String, aType As Integer, aStatus As Integer, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.StringStringStringString) 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = "", aWhere As String = ""
            Dim aResult As New List(Of Utils.StringStringStringString)

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "SELECT AL_ID AS ID, AL_TITLE AS TITLE, AL_INFO AS INFO, CONVERT(NVARCHAR(50), AL_CREATEDON, 110) AS CREATEDON, AT_NAME AS TYPE FROM TBL_ALERT T1 INNER JOIN TBL_ALERTUSER T2 ON T1.AL_ID=T2.AU_ALERTID AND T2.AU_USERID=" & aUserId & " INNER JOIN TBL_ALERTTYPE T3 ON T1.AL_TYPE=T3.AT_ID "

            If aSDate <> "" Then aWhere &= " AND AL_CREATEDON >='" & aSDate & " 00:00:00' "

            If aEDate <> "" Then aWhere &= " AND AL_CREATEDON <='" & aEDate & " 23:59:59' "

            If aStatus = 0 Then 'NOT VIEWED
                aWhere &= " AND T2.AU_ISVIEWED='FALSE' "
            ElseIf aStatus = 1 Then 'VIEWED
                aWhere &= " AND T2.AU_ISVIEWED='TRUE' "
            End If

            If aType > 0 Then aWhere &= " AND AL_TYPE=" & aType

            If aWhere <> "" Then aSQL &= " WHERE " & aWhere.Substring(4)

            aSQL &= " ORDER BY AL_CREATEDON DESC, AL_ID DESC"

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.StringStringStringString (aDRow("CREATEDON"), aDRow("TYPE"), aDRow("TITLE"), aDRow("INFO")))
            Next

            Return aResult
        End Function

        Public Shared Function GetNotViewed(aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerString) 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerString)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "SELECT AL_ID AS ID, AL_TITLE AS TITLE FROM TBL_ALERT T1 INNER JOIN TBL_ALERTUSER T2 ON T1.AL_ID=T2.AU_ALERTID WHERE T2.AU_USERID=" & aUserId & " AND T2.AU_ISVIEWED='FALSE' ORDER BY T1.AL_CREATEDON DESC, T1.AL_ID DESC"

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerString (aDRow("ID"), aDRow("TITLE")))
            Next

            Return aResult
        End Function

        Public Shared Sub MarkAsViewed(ids As String, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aSQL As String = ""

            If aUserId =- 1 Then Return  

            If ids Is Nothing OrElse ids.Trim().Length <1 Then Return

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If ids="all" Then
                aSQL ="UPDATE TBL_ALERTUSER SET AU_ISVIEWED='TRUE' WHERE AU_USERID=" & aUserId 
            Else
                aSQL = "UPDATE TBL_ALERTUSER SET AU_ISVIEWED='TRUE' WHERE AU_ALERTID In (" & ids & ")" 
            End If

            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
        End Sub
    End Class
End Namespace