﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports PDF.DAL.MSSQL
Imports Utils
Imports System.Collections.Generic

Namespace BackEnd
    Public Class Client2

        Public Id As Integer
        Public Name As String
        Public Cell As String
        Public Phone As String
        Public Email As String
        Public Address As String
        Public Source As Integer
        Public IsActive As Boolean
        Public Notes As String
        Public Info As String 
        Public CreatedOn As DateTime
        Public CreatedBy As Integer

        Public Shared Function Load(ByVal aId As Integer, ByRef aTagsIds As String, ByRef aTagsTitles As String, Optional ByRef aConContext As ConnectionContext = Nothing) As Client2 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet, aDT As DataTable , aDRow As DataRow
            Dim aSQL As String = ""   
            Dim aResult As New Client2 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            'Get Source Name and Property Type Name
            aSQL = "Select * From Tbl_Client Where CT_ID=" & aId & "; "

            aSQL &= "Select TG_ID As Id, TG_NAME As Name From Tbl_ClientTag T1 Inner Join Tbl_Tag T2 on T1.CT_TAG=T2.TG_ID Where T1.CT_CLIENT=" & aId & "; "

            aParams = New List(Of SqlClient.SqlParameter)

            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

            aDT = aDS.Tables(0)

            If aDT Is Nothing OrElse  aDT.Rows.Count < 1 Then Throw New Exception("Invalid client specified.")

            aDRow = aDT.Rows(0)

            With aResult
                .Id = aDRow("CT_ID")
                .Name = aDRow("CT_Name")
                .Cell = aDRow("CT_Cell")
                .Phone=aDRow("CT_Phone")
                .Email=aDRow("CT_Email")
                .Address=aDRow("CT_Address")
                .Source=aDRow("CT_Source")
                .IsActive=aDRow("CT_IsActive")
                .Notes=aDRow("CT_Notes")
                .Info=aDRow("CT_Info")
                .CreatedOn = aDRow("CT_Date")
                .CreatedBy = aDRow("CT_CreatedBy")
            End With                 


            'Tags
            aTagsIds = ""
            aTagsTitles = ""

            aDT = aDS.Tables(1)
            If aDT.Rows.Count > 0 Then
                For Each aDRow In aDT.Rows
                    aTagsIds &= "," & aDRow("ID")
                    aTagsTitles &= "," & aDRow("NAME")
                Next

                aTagsIds = aTagsIds.Substring(1)
                aTagsTitles = aTagsTitles.Substring(1)
            End if

            Return aResult 
        End Function 

        Public Shared Sub Create (ByRef aObj As Client2, aTagsIds As String, aTagsTitles As String, Optional ByRef  aConContext As ConnectionContext = Nothing)
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aUseTransaction As Boolean, aCommitTransactionWhenTerminates As Boolean, aCloseConnectionWhenTerminates As Boolean 
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aSQL As String = ""   
            Dim aDT As DataTable 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aUseTransaction = aConContext.UseTransaction
                aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates
                aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates 

                aConContext.UseTransaction = aUseTransaction Or False 'Or My Setting 
                aConContext.CommitTransactionWhenTerminates = False 'My Setting
                aConContext.CloseConnectionWhenTerminates = False 'My Setting
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            'Clean Phone and cell
            aObj.Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)
            if aObj.Phone IsNot Nothing Then aObj.Phone = Utils.Utils.CleanPhoneNumber(aObj.Phone)

            'Make sure that if phone exists, it is different than cell
            If aObj.Cell = aObj.Phone Then Throw New Exception("The phone must be different than the cell.")

            'Make sure no other clientr has the same phone nor cell
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select CT_ID, CT_NAME From Tbl_Client Where CT_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or CT_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR CT_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or CT_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select CT_ID, CT_NAME From Tbl_Client Where CT_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or CT_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("CT_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The client that you specified is already registered.")
                Else
                   Throw New Exception("A client ( " & aDT.Rows(0)("CT_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                End If
            End If

            With aObj 
                'Update Phase       
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Insert Into Tbl_Client (CT_Name, CT_Cell, CT_Email, CT_Phone, CT_Address, CT_Source, CT_Date, CT_Notes, CT_Info, CT_ISActive, CT_CreatedBy) Values(N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Cell.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Email) & "', N'" & Utils.Utils.FixQuotes(.Phone) & "', N'" & Utils.Utils.FixQuotes(.Address) & "', " & .Source & ",'" & .CreatedOn & "',N'" & Utils.Utils.FixQuotes(.Notes) & "',N'" & Utils.Utils.FixQuotes(.Info) & "', '" & .IsActive & "'," & .CreatedBy & ")"
                DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

                'Read Client Id
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 CT_ID From Tbl_Client Where CT_Name Like N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "' Order By CT_ID DESC"
                .Id = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Handle the tags
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim().Length > 0 AndAlso aTagsTitles IsNot Nothing AndAlso aTagsTitles.Trim().Length > 0 Then
                    Dim aTagsIdsArr As String () = aTagsIds.Split(",")
                    Dim aTagsTitlesArr As String() = aTagsTitles.Split(",")
                    Dim aStrId, aStrTitle As String
                    Dim aTagId As Object

                    If aTagsIdsArr.Length > 0 Then
                        For i As Integer = 0 To aTagsIdsArr.Length - 1
                            aStrId = aTagsIds(i)
                            aStrTitle = aTagsTitlesArr(i).Trim()

                            'Check if there exists a tag with that title after trimming and case insensitive
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE LTRIM(RTRIM(LOWER(TG_NAME))) LIKE N'" & Utils.Utils.FixQuotes(aStrTitle.ToLower()) & "';"
                            aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                            If aTagId Is Nothing Then
                                'Create the tag and get its id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Insert Into TBL_Tag(TG_NAME) VALUES(N'" & Utils.Utils.FixQuotes(aStrTitle) & "') ;"
                                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                                'Read id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE TG_NAME LIKE N'" & Utils.Utils.FixQuotes(aStrTitle) & "';"
                                aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                            End If

                            'Insert Into Tbl_ClientRequestTag
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Insert Into TBL_ClientTag(CT_CLIENT, CT_TAG) VALUES(" & aObj.Id & "," & CInt(aTagId) & ") ;"
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        Next
                    End If
                End If


                'Last DB Operation
                'My Settings
                aConContext.CommitTransactionWhenTerminates = False 
                aConContext.CloseConnectionWhenTerminates = True

                If aIsConnectionPassed = True Then
                    If aUseTransaction = False Then
                        aConContext.CommitTransactionWhenTerminates = False 'My Setting
                    Else
                        aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates 
                    End If

                    aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                End If 

                aConContext.CommitTransactionWhenTerminates = True
                aConContext.CloseConnectionWhenTerminates=True

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 CT_ID From Tbl_Client Where CT_Name Like N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "' Order By CT_ID DESC"
                DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
            End With
        End Sub

        Public Shared Sub Update (ByRef aObj As Client2, aTagsIds As String, aTagsTitles As String, Optional ByRef  aConContext As ConnectionContext = Nothing)
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aUseTransaction As Boolean, aCommitTransactionWhenTerminates As Boolean, aCloseConnectionWhenTerminates As Boolean 
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aSQL As String = ""   
            Dim aDT As DataTable 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aUseTransaction = aConContext.UseTransaction
                aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates
                aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates 

                aConContext.UseTransaction = aUseTransaction Or False 'Or My Setting 
                aConContext.CommitTransactionWhenTerminates = False 'My Setting
                aConContext.CloseConnectionWhenTerminates = False 'My Setting
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            'Clean Phone and cell
            aObj.Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)
            if aObj.Phone IsNot Nothing Then aObj.Phone = Utils.Utils.CleanPhoneNumber(aObj.Phone)

            'Make sure that if phone exists, it is different than cell
            If aObj.Cell = aObj.Phone Then Throw New Exception("The phone must be different than the cell.")

            'Make sure no other clientr has the same phone nor cell
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select CT_ID, CT_NAME From Tbl_Client Where CT_ID<>" & aObj.Id & " AND (CT_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or CT_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR CT_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or CT_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "')"
            Else
                aSQL = "Select CT_ID, CT_NAME From Tbl_Client Where CT_ID<>" & aObj.Id & " AND (CT_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or CT_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "')"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("CT_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The client that you specified is already registered.")
                Else
                   Throw New Exception("A client ( " & aDT.Rows(0)("CT_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                End If
            End If


            With aObj 

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Update Tbl_Client Set CT_Name=N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "', CT_Cell=N'" & Utils.Utils.FixQuotes(.Cell) & "', CT_Email=N'" & Utils.Utils.FixQuotes(.Email) & "', CT_Phone=N'" & Utils.Utils.FixQuotes(.Phone) & "',"
                aSQL &="CT_Address=N'" & Utils.Utils.FixQuotes(.Address) & "', CT_Source=" & .Source & ", CT_Date='" & .CreatedOn & "', CT_Notes=N'" & Utils.Utils.FixQuotes(.Notes) & "', CT_Info=N'" & Utils.Utils.FixQuotes(.Info) & "', CT_ISActive='" & .IsActive & "', CT_CreatedBy=" & .CreatedBy & " Where CT_ID=" & .id
                DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)


                'Handle the tags
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Delete From Tbl_ClientTag Where CT_Client=" & aObj.Id & ";"
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim().Length > 0 AndAlso aTagsTitles IsNot Nothing AndAlso aTagsTitles.Trim().Length > 0 Then
                    Dim aTagsIdsArr As String () = aTagsIds.Split(",")
                    Dim aTagsTitlesArr As String() = aTagsTitles.Split(",")
                    Dim aStrId, aStrTitle As String
                    Dim aTagId As Object

                    If aTagsIdsArr.Length > 0 Then
                        For i As Integer = 0 To aTagsIdsArr.Length - 1
                            aStrId = aTagsIds(i)
                            aStrTitle = aTagsTitlesArr(i).Trim()

                            'Check if there exists a tag with that title after trimming and case insensitive
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE LTRIM(RTRIM(LOWER(TG_NAME))) LIKE N'" & Utils.Utils.FixQuotes(aStrTitle.ToLower()) & "';"
                            aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                            If aTagId Is Nothing Then
                                'Create the tag and get its id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Insert Into TBL_Tag(TG_NAME) VALUES(N'" & Utils.Utils.FixQuotes(aStrTitle) & "') ;"
                                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                                'Read id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE TG_NAME LIKE N'" & Utils.Utils.FixQuotes(aStrTitle) & "';"
                                aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                            End If

                            'Insert Into Tbl_ClientRequestTag
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Insert Into TBL_ClientTag(CT_CLIENT, CT_TAG) VALUES(" & aObj.Id & "," & CInt(aTagId) & ") ;"
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        Next
                    End If
                End If


                'Update Phase
                'Last DB Operation
                'My Settings
                aConContext.CommitTransactionWhenTerminates = False 
                aConContext.CloseConnectionWhenTerminates = True

                If aIsConnectionPassed = True Then
                   If aUseTransaction = False Then
                      aConContext.CommitTransactionWhenTerminates = False 'My Setting
                   Else
                      aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates 
                   End If

                   aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                End If 

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 CT_ID From Tbl_Client Where CT_Name Like N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "' Order By CT_ID DESC"
                DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)                    
            End With
        End Sub


        Public Shared Function GetFormLookups(Optional ByRef aConContext As ConnectionContext = Nothing) As DataSet
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            Dim aSQL As String = "Select MS_ID As ID, MS_ShortTitle As Title From Tbl_MarketingChannelSource Order By MS_OrderId;"

            aParams = New List(Of SqlClient.SqlParameter)
            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            Return aDS
        End Function

        Public Shared Function GetClientsWhoseNamesStartWith(name As string, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringBoolean) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringBoolean)

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "Select Top 15 CT_ID as ID, CT_NAME AS NAME, CT_CELL AS CELL, CT_ISACTIVE AS ISACTIVE FROM TBL_CLIENT WHERE CT_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' Order By CT_NAME"

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerStringStringBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("ISACTIVE")))
            Next

            Return aResult
        End Function

        Public Shared Function GetClientsWhoseNamesOrPhonesStartWith(name As string, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringBoolean) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringBoolean)

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            Dim aPhone As string = Utils.Utils.CleanPhoneNumber(name)

            If IsNumeric(aPhone) = True Then
                aSQL = "Select Top 15 CT_ID as ID, CT_NAME AS NAME, CT_CELL AS CELL, CT_ISACTIVE AS ISACTIVE FROM TBL_CLIENT WHERE CT_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR CT_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%'  Order By CT_NAME"
            Else
                aSQL = "Select Top 15 CT_ID as ID, CT_NAME AS NAME, CT_CELL AS CELL, CT_ISACTIVE AS ISACTIVE FROM TBL_CLIENT WHERE CT_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' Order By CT_NAME"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerStringStringBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("ISACTIVE")))
            Next

            Return aResult
        End Function


    End Class

End Namespace
