﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports PDF.DAL.MSSQL
Imports Utils
Imports System.Collections.Generic
Imports System.ComponentModel

Namespace BackEnd

    Public Enum ClientRequestStatuses
        [New] =1
        InProcess = 2
        OnHold = 3
        NoDeal = 4
        DealClosed = 5
    End Enum

    Public Enum ClientRequestSubstatuses
       ClientNotContactedYet = 1
    End Enum

    Public Enum ClientRequestImportances
        Normal=1
        Important = 2
        NotImportant = 3
    End Enum

    Public Class ClientRequest2
        Public Id As Integer = 0
        Public ClientId As Integer = 0 
        Public ClientName As String = ""
        Public Cell As String = ""
        Public Email As String = ""
        Public Source As Integer = 0
        Public AreaType As Integer = 0 
        Public AreaMin As Integer = 0
        Public AreaMax As Integer = 0
        Public ForSale As Boolean
        Public SaleMin As Integer = 0 
        Public SaleMax As Integer = 0 
        Public ForRent As Boolean
        Public RentMin As Integer = 0 
        Public RentMax As Integer = 0 
        Public BedroomsMin As Integer = 0
        Public BedroomsMax As Integer = 0
        Public View As Integer = 0
        Public Age As Integer = 0
        Public PropertiesIds As String = "", DistrictsIds As String = "", CitiesGroupsIds As String = "", CitiesIds As String = "", NotCitiesIds As String = "",  PropertyTypesIds As String="" 
        Public ParkingType As Integer = 0, ParkingCount As Integer = 0
        Public LTB As Boolean = False
        Public Furnished As Boolean = False
        Public Decorated As Boolean = False
        Public NotUsed As Boolean = False
        Public Lux As Boolean = False
        Public Duplex As Boolean = False
        Public Commercial As Boolean = False
        Public Exchange As Boolean = False
        Public NoSlope As Boolean = False
        Public GF As Boolean = False
        Public FirstFloor As Boolean = False
        Public NotGF As Boolean = False
        Public NotFirstFloor As Boolean = False
        Public NotLastFloor As Boolean = False
        Public Garden As Boolean = False
        Public Terrace As Boolean = False
        Public Balcony As Boolean = False
        Public MaidRoom As Boolean = False
        Public MaidBath As Boolean = False
        Public Heating As Boolean = False
        Public Solar As Boolean = False
        Public CentralAC As Boolean = False
        Public Storage As Boolean = False
        Public DoubleG As Boolean = False
        Public Interphone As Boolean = False
        Public Videophone As Boolean = False
        Public BIW As Boolean = False
        Public Concierge As Boolean = False
        Public Security As Boolean = False
        Public Pool As Boolean = False
        Public Pets As Boolean = False
        Public Roof As Boolean = False
        Public ClientNotes As String = ""
        Public AgentNotes As String = ""
        Public CreatedOn As Date
        Public CreatedBy As Integer = 0 
        Public Status As Integer = ClientRequestStatuses.[New] 
        Public Substatus As Integer = ClientRequestSubstatuses.ClientNotContactedYet
        Public Importance As Integer = ClientRequestImportances.Normal 
        Public StatusText As String 
        Public PrimaryAgent As Integer = 0
        Public Urgency As Integer = 0 
        Public MatchNotify As Boolean = True

        Public PropertiesTitles As String = "",  DistrictsTitles As String = "",  CitiesGroupsTitles As String = "",  CitiesTitles As String = "",  NotCitiesTitles As String = "", PropertyTypesTitles As String = ""

        
        Public Shared Function Load(ByVal aId As Integer, aUserId As Integer, aUserIsNotAdminNorSuperUser As Boolean, ByRef aTagsIds As String, ByRef aTagsTitles As String, Optional ByRef aConContext As ConnectionContext = Nothing) As ClientRequest2
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet, aDT As DataTable, aDRow As DataRow
            Dim aSQL As String = ""   
            Dim aResult As New ClientRequest2

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False 
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            'Get Source Name and Property Type Name
            aSQL = "Select * From Tbl_ClientRequestList T1 Inner Join Tbl_Client T2 on T1.CR_CLIENT=T2.CT_ID Inner Join Tbl_ClientRequestStatus T3 on T1.CR_Status=T3.CS_ID Inner Join Tbl_ClientRequestSubstatus T4 on T1.CR_SUBSTATUS=T4.CU_ID Where CR_ID=" & aId & "; "
            aSQL &="Select CA_ID From Tbl_ClientRequestAgent Where CA_Request=" & aId & " And CA_Agent=" & aUserId 

            aParams = New List(Of SqlClient.SqlParameter)

            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

            If (aDS.Tables(0).Rows.Count = 0) Then
                aConContext.CloseConnections()
                Throw New Exception("Invalid request specified.")
            End If

            aDRow = aDS.Tables(0).Rows(0)

            'Validate Security of access (only admin, s.u. or primary agent
            If aUserIsNotAdminNorSuperUser = True AndAlso aUserId <> aDRow("CR_PrimaryAgent") AndAlso aDS.Tables(1).Rows.Count=0 Then
                aConContext.CloseConnections()
                Return Nothing
            End If

            With aResult
                .Id = aDRow("CR_ID")
                .ClientId = aDRow("CT_ID")
                .ClientName = aDRow("CT_Name")
                .Cell = aDRow("CR_Cell")
                .Email=aDRow("CR_Email")
                .Source=aDRow("CR_Source")
                .AreaType=aDRow("CR_AreaType")
                .AreaMin=aDRow("CR_AreaMin")
                .AreaMax=aDRow("CR_AreaMax")
                .ForSale=aDRow("CR_ForSale")
                .SaleMin=aDRow("CR_SaleMin")
                .SaleMax=aDRow("CR_SaleMax")
                .ForRent=aDRow("CR_ForRent")
                .RentMin=aDRow("CR_RentMin")
                .RentMax=aDRow("CR_RentMax")
                .BedroomsMin=aDRow("CR_BedroomsMin")
                .BedroomsMax=aDRow("CR_BedroomsMax")
                .View=aDRow("CR_View")
                .Age=aDRow("CR_Age")
                .PropertiesIds=""
                .DistrictsIds=""
                .CitiesGroupsIds=""
                .CitiesIds=""
                .NotCitiesIds=""
                .ParkingType=aDRow("CR_ParkingType")
                .ParkingCount=aDRow("CR_ParkingCount")
                .LTB=aDRow("CR_LTB")
                .Furnished=aDRow("CR_Furnished")
                .Decorated=aDRow("CR_Decorated")
                .NotUsed=aDRow("CR_NotUsed")
                .Lux=aDRow("CR_Lux")
                .Duplex =aDRow("CR_Duplex")
                .Commercial =aDRow("CR_Commercial")
                .Exchange=aDRow("CR_Exchange")
                .NoSlope =aDRow("CR_NoSlope")
                .GF =aDRow("CR_GF")
                .FirstFloor =aDRow("CR_FirstFloor")
                .NotGF =aDRow("CR_NotGF")
                .NotFirstFloor =aDRow("CR_NotFirstFloor")
                .NotLastFloor =aDRow("CR_NotLastFloor")
                .Garden =aDRow("CR_Garden")
                .Terrace =aDRow("CR_Terrace")
                .Balcony =aDRow("CR_Balcony")
                .MaidRoom =aDRow("CR_MaidRoom")
                .MaidBath =aDRow("CR_MaidBath")
                .Heating =aDRow("CR_Heating")
                .Solar =aDRow("CR_Solar")
                .CentralAC =aDRow("CR_CentralAC")
                .Storage =aDRow("CR_Storage")
                .DoubleG =aDRow("CR_DoubleG")
                .Interphone =aDRow("CR_Interphone")
                .Videophone =aDRow("CR_Videophone")
                .BIW =aDRow("CR_BIW")
                .Concierge =aDRow("CR_Concierge")
                .Security =aDRow("CR_Security")
                .Pool =aDRow("CR_Pool")
                .Pets =aDRow("CR_Pets")
                .Roof =aDRow("CR_Roof")
                .ClientNotes =aDRow("CR_ClientNotes")
                .AgentNotes =aDRow("CR_AgentNotes")
                .Status =aDRow("CR_Status")
                .CreatedOn =aDRow("CR_CreatedOn")
                .CreatedBy =aDRow("CR_CreatedBy")
                .PrimaryAgent =aDRow("CR_PrimaryAgent")
                .Urgency = aDRow("CR_Urgency")
                .Status = aDRow("CS_ID")
                .Substatus= aDRow("CU_ID")
                .StatusText = aDRow("CS_NAME") & " - " & aDRow("CU_NAME")
                .Importance = aDRow("CR_IMPORTANCE")
                .MatchNotify = aDRow("CR_MATCHNOTIFY")

                'The Ids
                aSQL= ""

                If aDRow("CR_PropertiesIds").ToString().Trim() = "" Then
                   aSQL &= "Select PR_ID As Id, PR_PropertyKey As Name From Tbl_Property Where PR_ID IN (-1); "
                Else
                   aSQL &= "Select PR_ID As Id, PR_PropertyKey As Name From Tbl_Property Where PR_ID IN (" & aDRow("CR_PropertiesIds") & "); "
                End If

                If aDRow("CR_DistrictsIds").ToString().Trim() = "" Then
                   aSQL &= "Select CO_ID As Id, CO_NAME As Name From Tbl_Country Where CO_ID IN (-1); "
                Else
                   aSQL &= "Select CO_ID As Id, CO_NAME As Name From Tbl_Country Where CO_ID IN (" & aDRow("CR_DistrictsIds") & "); "
                End If

                If aDRow("CR_CitiesGroupsIds").ToString().Trim() = "" Then
                   aSQL &= "Select CG_ID As Id, CG_NAME As Name From Tbl_CityGroup Where CG_ID IN (-1); "
                Else
                   aSQL &= "Select CG_ID As Id, CG_NAME As Name From Tbl_CityGroup Where CG_ID IN (" & aDRow("CR_CitiesGroupsIds") & "); "
                End If

                If aDRow("CR_CitiesIds").ToString().Trim() = "" Then
                   aSQL &= "Select CI_ID As Id, CI_NAME As Name From Tbl_City Where CI_ID IN (-1); "
                Else
                   aSQL &= "Select CI_ID As Id, CI_NAME As Name From Tbl_City Where CI_ID IN (" & aDRow("CR_CitiesIds") & "); "
                End If

                If aDRow("CR_NotCitiesIds").ToString().Trim() = "" Then
                   aSQL &= "Select CI_ID As Id, CI_NAME As Name From Tbl_City Where CI_ID IN (-1); "
                Else
                   aSQL &= "Select CI_ID As Id, CI_NAME As Name From Tbl_City Where CI_ID IN (" & aDRow("CR_NotCitiesIds") & "); "
                End If

                aSQL &= "Select TG_ID As Id, TG_NAME As Name From Tbl_ClientRequestTag T1 Inner Join Tbl_Tag T2 on T1.CT_TAG=T2.TG_ID Where T1.CT_REQUEST=" & aId & "; "

                If aDRow("CR_PropertyTypesIds").ToString().Trim() = "" Then
                   aSQL &= "Select PT_ID As Id, PT_NAME As Name From Tbl_PropertyType Where PT_ID IN (-1); "
                Else
                   aSQL &= "Select PT_ID As Id, PT_NAME As Name From Tbl_PropertyType Where PT_ID IN (" & aDRow("CR_PropertyTypesIds") & "); "
                End If

                aConContext.CloseConnectionWhenTerminates = True 

                aParams = New List(Of SqlClient.SqlParameter)
                aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
            
                'PropertiesTitles
                aDT = aDS.Tables(0)
                If aDT.Rows.Count > 0 Then
                    For Each aDRow in aDT.Rows
                        aResult.PropertiesIds &= "," & aDRow("ID") 
                        aResult.PropertiesTitles &= "," & aDRow("Name") 
                    Next

                    aResult.PropertiesIds = aResult.PropertiesIds.Substring(1)
                    aResult.PropertiesTitles = aResult.PropertiesTitles.Substring(1)
                End If

                'DistrictsTitles
                aDT = aDS.Tables(1)
                If aDT.Rows.Count > 0 Then
                    For Each aDRow in aDT.Rows
                        aResult.DistrictsIds &= "," & aDRow("ID") 
                        aResult.DistrictsTitles &= "," & aDRow("Name") 
                    Next

                    aResult.DistrictsIds = aResult.DistrictsIds.Substring(1)
                    aResult.DistrictsTitles = aResult.DistrictsTitles.Substring(1)
                End If

                'CitiesGroupsTitles
                aDT = aDS.Tables(2)
                If aDT.Rows.Count > 0 Then
                    For Each aDRow in aDT.Rows
                        aResult.CitiesGroupsIds &= "," & aDRow("ID") 
                        aResult.CitiesGroupsTitles &= "," & aDRow("Name") 
                    Next

                    aResult.CitiesGroupsIds = aResult.CitiesGroupsIds.Substring(1)
                    aResult.CitiesGroupsTitles = aResult.CitiesGroupsTitles.Substring(1)
                End If

                'CitiesTitles
                aDT = aDS.Tables(3)
                If aDT.Rows.Count > 0 Then
                    For Each aDRow in aDT.Rows
                        aResult.CitiesIds &= "," & aDRow("ID") 
                        aResult.CitiesTitles &= "," & aDRow("Name") 
                    Next

                    aResult.CitiesIds = aResult.CitiesIds.Substring(1)
                    aResult.CitiesTitles = aResult.CitiesTitles.Substring(1)
                End If

                'NotCitiesTitles
                aDT = aDS.Tables(4)
                If aDT.Rows.Count > 0 Then
                    For Each aDRow in aDT.Rows
                        aResult.NotCitiesIds &= "," & aDRow("ID") 
                        aResult.NotCitiesTitles &= "," & aDRow("Name") 
                    Next

                    aResult.NotCitiesIds = aResult.NotCitiesIds.Substring(1)
                    aResult.NotCitiesTitles = aResult.NotCitiesTitles.Substring(1)
                End If                   

                'PropertyTypes
                aDT = aDS.Tables(6)
                If aDT.Rows.Count > 0 Then
                    For Each aDRow in aDT.Rows
                        aResult.PropertyTypesIds &= "," & aDRow("ID") 
                        aResult.PropertyTypesTitles &= "," & aDRow("Name") 
                    Next

                    aResult.PropertyTypesIds = aResult.PropertyTypesIds.Substring(1)
                    aResult.PropertyTypesTitles = aResult.PropertyTypesTitles.Substring(1)
                End If               
            End With

            'Tags
            aTagsIds = ""
            aTagsTitles = ""

            aDT = aDS.Tables(5)
            If aDT.Rows.Count > 0 Then
                For Each aDRow In aDT.Rows
                    aTagsIds &= "," & aDRow("ID")
                    aTagsTitles &= "," & aDRow("NAME")
                Next

                aTagsIds = aTagsIds.Substring(1)
                aTagsTitles = aTagsTitles.Substring(1)
            End if

            Return aResult 
        End Function 

        Public Shared Function CreateClientRequestText(aId As Integer, aClientName As String, aCell As String, aEmail As String, aSource As Integer, aAreaType As Integer, aAreaMin As Integer, aAreaMax As Integer, aForSale As Boolean, aSaleMin As Integer, aSaleMax As Integer, aForRent As Boolean, aRentMin As Integer, aRentMax As Integer, aBedroomsMin As Integer, aBedroomsMax As Integer, _
                                       aView As Integer, aAge As Integer, aParkingType As Integer, aParkingCount As Integer, aLTB As Integer, aFurnished As Boolean, aDecorated As Boolean, aNotUsed As Boolean, aLux As Boolean, aDuplex As Boolean, aCommercial As Boolean, aExchange As Boolean, aNoSlope As Boolean, aGF As Boolean, aFirstFloor As Boolean, aNotGF As Boolean, aNotFirstFloor As Boolean, aNotLastFloor As Boolean, _
                                       aGarden As Boolean, aTerrace As Boolean, aBalcony As Boolean, aMaidRoom As Boolean, aMaidBath As Boolean, aHeating As Boolean, aSolar As Boolean, aCentralAC As Boolean, aStorage As Boolean, aDoubleG As Boolean, aInterphone As Boolean, aVideophone As Boolean, aBIW As Boolean, aConcierge As Boolean, aSecurity As Boolean, aPool As Boolean, aPets As Boolean, aRoof As Boolean, aClientNotes As String, _
                                       aPropertiesIds As String, aDistrictsIds As String, aCitiesGroupsIds As String, aCitiesIds As String, aNotCitiesIds As String, aPropertyTypesIds As String, aUrgency As Integer, ByRef aTitle As String, Optional ByRef aConContext As ConnectionContext = Nothing) As String
            
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet, aDT As DataTable 
            Dim aSQL As String = ""   
            Dim aResult As String = ""
            Dim aSourceName As String=""
            Dim aPropertiesSQL As String = ""
            Dim aSpecificProperties As String =""
            Dim aSpecificDistricts As String =""
            Dim aSpecificCitiesGroups As String =""
            Dim aSpecificCities As String =""
            Dim aSpecificNotCities As String =""
            Dim aSpecificPropertyTypes As String = ""

            Dim aGenericCriteria As String = ""
            Dim aIsContextCreated As Boolean  = False
            Dim aCitiesS As String = ""

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False 

                aIsContextCreated = true
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            'Get Source Name and Property Type Name
            aSQL = "Select MS_SHORTTITLE AS NAME FROM TBL_MARKETINGCHANNELSOURCE WHERE MS_ID=" & aSource & ";"

            aParams = New List(Of SqlClient.SqlParameter)

            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

            If aDS.Tables(0).Rows.Count > 0 Then aSourceName = aDS.Tables(0).Rows(0)("NAME")

            aResult = "A client request ( CR-" & aId.ToString() & " ) was submitted by " & aClientName & ", " & aCell

            If String.IsNullOrEmpty(aEmail) = False Then aResult &= ", " & aEmail 

            If aSourceName <> "" Then aResult &= " from " & aSourceName

            aResult &= "." & "--MYNEWLINE----MYNEWLINE--"

            aTitle = aResult 

            'Mention the specific properties if any
            If String.IsNullOrEmpty(aPropertiesIds) = False Then 
                aSpecificProperties = "Properties: "

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select DISTINCT PR_ID AS ID, PR_PROPERTYKEY AS PROPERTYKEY FROM TBL_PROPERTY WHERE PR_ID IN (" & aPropertiesIds & ")" 
                aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                For Each aDRow As DataRow In aDT.Rows
                    aSpecificProperties &= aDRow("PROPERTYKEY") & " - http://www.pierrefrancis.com/properties-detail-print.aspx?id=" & aDRow("ID") & ", "
                Next

                aSpecificProperties = aSpecificProperties.Substring(0, aSpecificProperties.Length - 2)
            End If

            'Mention the specific property types if any
            If String.IsNullOrEmpty(aPropertyTypesIds) = False Then 
                aSpecificPropertyTypes = "Property Types: "

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select DISTINCT PT_ID AS ID, PT_NAME AS NAME FROM TBL_PROPERTYTYPE WHERE PT_ID IN (" & aPropertyTypesIds & ")" 
                aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                For Each aDRow As DataRow In aDT.Rows
                    aSpecificPropertyTypes &= aDRow("NAME") & ", "
                Next

                aSpecificPropertyTypes = aSpecificPropertyTypes.Substring(0, aSpecificPropertyTypes.Length - 2)
            End If



            'Mention the specific districts if any
            If String.IsNullOrEmpty(aDistrictsIds) = False Then 
                aSpecificDistricts = "Districts: "

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select DISTINCT CO_ID AS ID, CO_NAME AS NAME FROM TBL_Country WHERE CO_ID IN (" & aDistrictsIds & ")" 
                aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                For Each aDRow As DataRow In aDT.Rows
                    aSpecificDistricts &= aDRow("NAME") & ", "
                Next

                aSpecificDistricts = aSpecificDistricts.Substring(0, aSpecificDistricts.Length - 2)
            End If

            'Mention the specific CitiesGroups if any
            If String.IsNullOrEmpty(aCitiesGroupsIds) = False Then 
                aSpecificCitiesGroups = "Cities Groups: "

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select DISTINCT CG_ID AS ID, CG_NAME AS NAME FROM TBL_CityGroup WHERE CG_ID IN (" & aCitiesGroupsIds & ")" 
                aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                For Each aDRow As DataRow In aDT.Rows
                    aSpecificCitiesGroups &= aDRow("NAME") & ", "
                Next

                aSpecificCitiesGroups = aSpecificCitiesGroups.Substring(0, aSpecificCitiesGroups.Length - 2)
            End If

            'Mention the specific Cities if any
            If String.IsNullOrEmpty(aCitiesIds) = False Then 
                aSpecificCities = "Cities: "

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select DISTINCT CI_ID AS ID, CI_NAME AS NAME FROM TBL_City WHERE CI_ID IN (" & aCitiesIds & ")" 
                aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                For Each aDRow As DataRow In aDT.Rows
                    aSpecificCities &= aDRow("NAME") & ", "
                Next

                aSpecificCities = aSpecificCities.Substring(0, aSpecificCities.Length - 2)
            End If

            'Mention the specific NotCities if any
            If String.IsNullOrEmpty(aNotCitiesIds) = False Then 
                aSpecificNotCities = "NOT In: "

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select DISTINCT CI_ID AS ID, CI_NAME AS NAME FROM TBL_City WHERE CI_ID IN (" & aNotCitiesIds & ")" 
                aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                For Each aDRow As DataRow In aDT.Rows
                    aSpecificNotCities &= aDRow("NAME") & ", "
                Next

                aSpecificNotCities = aSpecificNotCities.Substring(0, aSpecificNotCities.Length - 2)
            End If

            'Close Connection
            If aIsContextCreated Then aConContext.CloseConnections()


            If aAreaType = 1 Then
                If aAreaMin > 0 AndAlso aAreaMax > 0 Then
                    aGenericCriteria &= "Area between " & aAreaMin & "m2 and " & aAreaMax & "m2, "
                Else If aAreaMin > 0 Then
                    aGenericCriteria &= "Area >= " & aAreaMin & "m2, "
                Else If aAreaMax > 0 Then
                    aGenericCriteria &= "Area <= " & aAreaMax & "m2, "
                End If
            Else
                If aAreaMin > 0 AndAlso aAreaMax > 0 Then
                    aGenericCriteria &= "Sellable Area between " & aAreaMin & "m2 and " & aAreaMax & "m2, "
                Else If aAreaMin > 0 Then
                    aGenericCriteria &= "Sellable Area >= " & aAreaMin & "m2, "
                Else If aAreaMax > 0 Then
                    aGenericCriteria &= "Sellable Area <= " & aAreaMax & "m2, "
                End If
            End If

            If aForSale = True Then
                If aSaleMin > 0 AndAlso aSaleMax > 0 Then
                    aGenericCriteria &= "For Sale between " & aSaleMin & "$ and " & aSaleMax & "$, "
                Else If aSaleMin > 0 Then
                    aGenericCriteria &= "For Sale >= " & aSaleMin & "$, "
                Else If aSaleMax > 0 Then
                    aGenericCriteria &= "For Sale <= " & aSaleMax & "$, "
                Else
                    aGenericCriteria &= "For Sale, "
                End If
            End If

            If aForRent = True Then
                If aRentMin > 0 AndAlso aRentMax > 0 Then
                    aGenericCriteria &= "For Rent between " & aRentMin & "$ and " & aRentMax & "$, "
                Else If aRentMin > 0 Then
                    aGenericCriteria &= "For Rent >= " & aRentMin & "$, "
                Else If aRentMax > 0 Then
                    aGenericCriteria &= "For Rent <= " & aRentMax & "$, "
                Else
                    aGenericCriteria &= "For Rent, "
                End If
            End If

            If aBedroomsMin > 0 AndAlso aBedroomsMax > 0 Then
                aGenericCriteria &= "Bedrooms between " & aBedroomsMin & " and " & aBedroomsMax & ", "
            Else If aBedroomsMin > 0 Then
                aGenericCriteria &= "Bedrooms >= " & aBedroomsMin & ", "
            Else If aBedroomsMax > 0 Then
                aGenericCriteria &= "Bedrooms <= " & aBedroomsMax & ", "
            End If

            If aView=1 Then
                aGenericCriteria &= "View: Any, "
            ElseIf aView=2 Then
                aGenericCriteria &= "View: City, "
            ElseIf aView=3 Then
                aGenericCriteria &= "View: Mountain, "
            ElseIf aView=4 Then
                aGenericCriteria &= "View: Sea, "
            ElseIf aView=5 Then
                aGenericCriteria &= "View: City + Mountain, "
            ElseIf aView=6 Then
                aGenericCriteria &= "View: Mountain + City, "
            ElseIf aView=7 Then
                aGenericCriteria &= "View: City + Sea, "
            ElseIf aView=8 Then
                aGenericCriteria &= "View: All, "
            End If

            If aAge = -3 Then
                aGenericCriteria &= "Age <= 15 years, "
            ElseIf aAge = -2 Then
                aGenericCriteria &= "Age <= 10 years, "
            ElseIf aAge = -1 Then
                aGenericCriteria &= "Age <= 5 years, "
            ElseIf aAge = 1 Then
                aGenericCriteria &= "Age: New, "
            ElseIf aAge = 2 Then
                aGenericCriteria &= "Age: Under Con., "
            End If

            If aParkingType = 1 Then
                If aParkingCount = 0 Then
                    aGenericCriteria &= "Parking: 1+(Any), "
                ElseIf aParkingCount > 0 Then
                    aGenericCriteria &= "Parking: " & aParkingCount & "+(Any), "
                End If
            ElseIf aParkingType = 2 Then
                If aParkingCount = 0 Then
                    aGenericCriteria &= "Parking: 1+(Uncovered), "
                ElseIf aParkingCount > 0 Then
                    aGenericCriteria &= "Parking: " & aParkingCount & "+(Uncovered), "
                End If
            ElseIf aParkingType = 3 Then
                If aParkingCount = 0 Then
                    aGenericCriteria &= "Parking: 1+(Covered), "
                ElseIf aParkingCount > 0 Then
                    aGenericCriteria &= "Parking: " & aParkingCount & "+(Covered), "
                End If
            ElseIf aParkingType = 4 Then
                If aParkingCount = 0 Then
                    aGenericCriteria &= "Parking: 1+(Underground), "
                ElseIf aParkingCount > 0 Then
                    aGenericCriteria &= "Parking: " & aParkingCount & "+(Underground), "
                End If
            ElseIf aParkingType = 5 Then
                If aParkingCount = 0 Then
                    aGenericCriteria &= "Parking: 1+(Covered Or Underground), "
                ElseIf aParkingCount > 0 Then
                    aGenericCriteria &= "Parking: " & aParkingCount & "+(Covered Or Underground), "
                End If
            End If

            If aLTB = True Then  aGenericCriteria &= "L.T.B: Y, "
            If aFurnished = True Then  aGenericCriteria &= "Furnished: Y, "
            If aDecorated = True Then  aGenericCriteria &= "Decorated: Y, "
            If aNotUsed = True Then  aGenericCriteria &= "Not Used: Y, "
            If aLux = True Then  aGenericCriteria &= "Lux: Y, "
            If aDuplex = True Then  aGenericCriteria &= "Duplex: Y, "
            If aCommercial = True Then  aGenericCriteria &= "Commercial: Y, "
            If aExchange = True Then  aGenericCriteria &= "Exchange: Y, "
            If aNoSlope = True Then  aGenericCriteria &= "No Slope: Y, "
            If aGF = True Then  aGenericCriteria &= "G.F.: Y, "
            If aFirstFloor = True Then  aGenericCriteria &= "1st Floor: Y, "
            If aNotGF = True Then  aGenericCriteria &= "Not G.F.: Y, "
            If aNotFirstFloor = True Then  aGenericCriteria &= "Not 1st Floor: Y, "
            If aNotLastFloor = True Then  aGenericCriteria &= "Not Last Floor: Y, "
            If aGarden = True Then  aGenericCriteria &= "Garden: Y, "
            If aTerrace = True Then  aGenericCriteria &= "Terrace: Y, "
            If aBalcony = True Then  aGenericCriteria &= "Balcony: Y, "
            If aMaidRoom = True Then  aGenericCriteria &= "Maid Room: Y, "
            If aMaidBath = True Then  aGenericCriteria &= "Maid Bath: Y, "
            If aHeating = True Then  aGenericCriteria &= "Heating: Y, "
            If aSolar = True Then  aGenericCriteria &= "Solar: Y, "
            If aCentralAC = True Then  aGenericCriteria &= "Central AC: Y, "
            If aStorage = True Then  aGenericCriteria &= "Storage: Y, "
            If aDoubleG = True Then  aGenericCriteria &= "Double Glazing: Y, "
            If aInterphone = True Then  aGenericCriteria &= "Interphone: Y, "
            If aVideoPhone = True Then  aGenericCriteria &= "Videophone: Y, "
            If aBIW = True Then  aGenericCriteria &= "Built-In W.: Y, "
            If aConcierge = True Then  aGenericCriteria &= "Concierge: Y, "
            If aSecurity = True Then  aGenericCriteria &= "Security: Y, "
            If aPool = True Then  aGenericCriteria &= "Pool: Y, "
            If aPets = True Then  aGenericCriteria &= "Pets Allowed: Y, "
            If aRoof = True Then  aGenericCriteria &= "Roof: Y, "

            If aSpecificPropertyTypes = "" AndAlso aSpecificProperties = "" AndAlso aSpecificDistricts = "" AndAlso aSpecificCitiesGroups ="" AndAlso aSpecificCities ="" AndAlso aSpecificNotCities="" AndAlso aGenericCriteria = "" AndAlso aClientNotes = "" Then Return ""

            If aSpecificProperties <> "" Then aResult &= aSpecificProperties & "--MYNEWLINE----MYNEWLINE--"
            If aSpecificPropertyTypes <> "" Then aResult &= aSpecificPropertyTypes & "--MYNEWLINE----MYNEWLINE--"
            If aSpecificDistricts <> "" Then aResult &= aSpecificDistricts & "--MYNEWLINE----MYNEWLINE--"
            If aSpecificCitiesGroups <> "" Then aResult &= aSpecificCitiesGroups & "--MYNEWLINE----MYNEWLINE--"
            If aSpecificCities <> "" Then aResult &= aSpecificCities & "--MYNEWLINE----MYNEWLINE--"
            If aSpecificNotCities <> "" Then aResult &= aSpecificNotCities & "--MYNEWLINE----MYNEWLINE--"

            If aGenericCriteria <> "" Then aResult &= aGenericCriteria.Substring(0, aGenericCriteria.Length-2) & "--MYNEWLINE----MYNEWLINE--"

            If aUrgency = 1 Then
                aResult &= "Urgency: Normal" & "--MYNEWLINE----MYNEWLINE--"
            Else
                aResult &= "Urgency: URGENT" & "--MYNEWLINE----MYNEWLINE--"
            End If

            If aClientNotes <> "" Then aResult &= aClientNotes & "--MYNEWLINE----MYNEWLINE--"

            If aResult.ToLower().EndsWith("--mynewline--") Then aResult = aResult.Substring(0, aResult.Length-26)
            
            Return aResult
        End Function

        Public Shared Sub Create (ByRef aObj As ClientRequest2, aTitleMessage As String, aTagsIds As String, aTagsTitles As String, ByRef aMessage As String, Optional ByRef  aConContext As ConnectionContext = Nothing)
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable 
            Dim aSQL As String = ""   
            Dim aTempID As Object

            Dim aAgentId As Integer = 0
            Dim aAgentName As String =""
            Dim aAgentCell As String = ""
            Dim aAgentEmail As String = ""
            Dim aPropertiesKeysS As String = ""
            Dim aPropertiesIds As New List(Of Integer)
            Dim aDistrictsIds As String()
            Dim aCitiesGroupsIds As String()
            Dim aCitiesIds As String()
            Dim aNotInCitiesIds As String()
            Dim aPropertyTypesIds As String()

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False 
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            With aObj
                'Clean the cell
                .Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)

                'If aClientId < 1 => New Client => make sure Cell is unique => need to create client
                'Else => aClientId must exist in db        
                If .ClientId < 1 Then
                    If String.IsNullOrEmpty(.ClientName) OrElse String.IsNullOrEmpty(.Cell) Then Throw New Exception("Since the client is new, both the name and cell must be specified.")

                    'Make sure the cell  does not correspond to an existing client
                    aParams = New List(Of SqlClient.SqlParameter)

                    aSQL = "Select Top 1 CT_NAME From Tbl_Client Where CT_Cell Like N'" & Utils.Utils.FixQuotes(.cell) & "' Or CT_Phone Like N'" & Utils.Utils.FixQuotes(.cell) & "'"
                    aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
                    If aDT.Rows.Count > 0 Then
                        aConContext.CloseConnections()

                        Throw New Exception ("A client ( " & aDT.Rows(0)("CT_NAME") & " ) with the same phone/cell already exists.")
                    End If             
                Else
                    'The client must exist 
                    aParams = New List(Of SqlClient.SqlParameter)

                    aSQL = "Select Top 1 CT_ID From Tbl_Client Where CT_ID=" & .ClientId 
                    aTempID = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
                    If aTempID Is Nothing Then 
                        aConContext.CloseConnections()

                        Throw New Exception ("The specified client does not exist.")
                    End If
                End If

                'Make sure that status + substatus are specified and not deal closed
                If IsNumeric(.Status) = False OrElse CInt(.Status) < 1 OrElse IsNumeric(.Substatus) = False OrElse CInt(.Substatus) < 1 Then
                    aConContext.CloseConnections()

                    Throw New Exception ("Please, specify a valid status.")
                ElseIf CInt(.Status) = ClientRequestStatuses.DealClosed Then
                        aConContext.CloseConnections()

                        Throw New Exception ("Invalid status specified: cannot be deal closed.")
                End If

                'Make sure importance is specified
                 If IsNumeric(.Importance) = False OrElse CInt(.Importance) < 1 Then
                        aConContext.CloseConnections()

                        Throw New Exception ("Please, specify the importance of the request.")
                 End If

                'Fill aPropertiesIds and Detect the agent
                If String.IsNullOrEmpty(.PropertiesIds) = False Then
                    'Fill aPropertiesIds
                    Dim tempArr As String() = .PropertiesIds.Split(",")

                    aParams = New List(Of SqlClient.SqlParameter)

                    aSQL = "Select DISTINCT PR_ID AS ID FROM TBL_PROPERTY WHERE PR_ID IN (" & .PropertiesIds & ")" 
                    aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                    If aDT.Rows.Count <> tempArr.Length Then 
                        aConContext.CloseConnections()

                        Throw New Exception("The properties are not all valid. There might be invalid keys or repetition.")
                        return
                    End If

                    For Each aId As String In tempArr
                        aPropertiesIds.Add(Integer.Parse(aId.Trim()))
                    Next

                    'Detect Agent
                    aParams = New List(Of SqlClient.SqlParameter)

                    aSQL = "Select DISTINCT PR_AGENTID AS ID, UR_NAME As NAME, UR_EMAIL AS EMAIL, UR_CELL AS CELL FROM TBL_PROPERTY T1 INNER JOIN TBL_USER T2 ON T1.PR_AGENTID=T2.UR_ID WHERE PR_ID IN (" & .PropertiesIds & ")" 
                    aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                    If aDT IsNot Nothing AndAlso aDT.Rows.Count = 1 Then
                        aAgentId =aDT.Rows(0)("ID")    
                        aAgentName =aDT.Rows(0)("NAME")    
                        aAgentCell = aDT.Rows(0)("CELL")
                        aAgentEmail =aDT.Rows(0)("EMAIL")            
                    End If
                End If

                'Update Phase
                aConContext.UseTransaction = True 
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False 
        

               'Register the client if new
                If .ClientId < 1 Then 
                    aParams = New List(Of SqlClient.SqlParameter)
                    aSQL = "Insert Into Tbl_Client (CT_Name, CT_Cell, CT_Email, CT_Phone, CT_Address, CT_Source, CT_Date, CT_Notes, CT_Info, CT_ISActive, CT_CreatedBy) Values(N'" & Utils.Utils.FixQuotes(.ClientName.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Cell) & "', N'" & Utils.Utils.FixQuotes(.Email) & "', '', '', " & .Source & ",'" & .CreatedOn & "','','', 'True'," & .CreatedBy & ")"
                    DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

                    'Read the ClientId
                    aParams = New List(Of SqlClient.SqlParameter)
                    aSQL = "Select Top 1 CT_ID From Tbl_Client Where CT_Name Like N'" & Utils.Utils.FixQuotes(.ClientName.Trim()) & "' Order By CT_ID DESC"
                    .ClientId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                End If 

                'Create Request
                aParams = New List(Of SqlClient.SqlParameter)

                aSQL = "Insert Into TBL_CLIENTREQUESTLIST (CR_Client, CR_Cell, CR_Email, CR_Source, CR_Status, CR_AreaType, CR_AreaMin, CR_AreaMax, CR_ForSale, CR_SaleMin, CR_SaleMax, CR_ForRent, CR_RentMin, CR_RentMax, CR_BedroomsMin, CR_BedroomsMax"
                aSQL &= ", CR_View, CR_Age, CR_PropertiesIds, CR_DistrictsIds, CR_CitiesGroupsIds, CR_CitiesIds, CR_NotCitiesIds, CR_ParkingType, CR_ParkingCount, CR_LTB, CR_Furnished, CR_Decorated, CR_NotUsed, CR_Lux, CR_Duplex, CR_Commercial, CR_Exchange, CR_NoSlope, CR_GF, CR_FirstFloor, CR_NotGF, CR_NotFirstFloor"
                aSQL &=", CR_NotLastFloor, CR_Garden, CR_Terrace, CR_Balcony, CR_MaidRoom, CR_MaidBath, CR_Heating, CR_Solar, CR_CentralAC, CR_Storage, CR_DoubleG, CR_Interphone, CR_VideoPhone, CR_BIW, CR_Concierge, CR_Security, CR_Pool, CR_Pets, CR_Roof"
                aSQL &= ",CR_ClientNotes, CR_AgentNotes, CR_CreatedOn, CR_CreatedBy, CR_PRIMARYAGENT, CR_URGENCY, CR_SUBSTATUS, CR_IMPORTANCE, CR_MATCHNOTIFY) Values("
                aSQL &= .ClientId & ",N'" & Utils.Utils.FixQuotes(.Cell) & "', N'" & Utils.Utils.FixQuotes(.Email) & "'," & .Source & "," & .Status & "," & .AreaType & "," & .AreaMin & "," & .AreaMax & ",'" & .ForSale & "', " & .SaleMin & "," & .SaleMax & ",'" & .ForRent & "'," & .RentMin & "," & .RentMax  
                aSQL &= "," & .BedroomsMin & "," & .BedroomsMax & "," &.View & "," & .Age & ",'" & .PropertiesIds & "','" & .DistrictsIds & "','" & .CitiesGroupsIds & "','" & .CitiesIds & "','" & .NotCitiesIds & "'," & .ParkingType & "," & .ParkingCount & ",'" & .LTB 
                aSQL &= "','" & .Furnished & "','" & .Decorated & "','" & .NotUsed & "','" & .Lux & "','" & .Duplex & "','" & .Commercial & "','" & .Exchange & "','" & .NoSlope & "','" & .GF & "','" & .FirstFloor & "','" & .NotGF  & "','" & .NotFirstFloor 
                aSQL &= "','" & .NotLastFloor & "','" & .Garden & "','" & .Terrace & "','" & .Balcony & "','" & .MaidRoom & "','" & .MaidBath & "','" & .Heating & "','" & .Solar & "','" & .CentralAC & "','" & .Storage & "','" & .DoubleG  & "','" & .Interphone 
                aSQL &= "','" & .Videophone & "','" & .BIW & "','" & .Concierge & "','" & .Security & "','" & .Pool & "','" & .Pets & "','" & .Roof & "'"
                aSQL &= ",N'" & Utils.Utils.FixQuotes(.ClientNotes) & "', N'" & Utils.Utils.FixQuotes(.AgentNotes) & "','" & .CreatedOn & "'," & .CreatedBy & "," & aAgentId  & "," & .Urgency & "," & .Substatus  & "," & .Importance & ",'" & .MatchNotify & "')"
           
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)                            


                'Get ID
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select TOP 1 CR_ID AS ID FROM TBL_ClientRequestList Where CR_Client=" & .ClientId & " ORDER BY CR_ID DESC"
                aObj.Id = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Insert Into Tbl_ClientRequestProperty
                If aPropertiesIds.Count > 0 Then
                    aSQL = ""

                    aParams = New List(Of SqlClient.SqlParameter)
                    For Each aPropId As Integer In aPropertiesIds
                        aSQL &= "Insert Into Tbl_ClientRequestProperty (CP_PropertyId, CP_RequestId) Values (" & aPropId & "," & aObj.Id & "); "
                    Next

                    DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                End If

                'Insert into Tbl_ClientRequestDistrict
                aSQL = ""
                If aObj.DistrictsIds IsNot Nothing AndAlso aObj.DistrictsIds.Trim().Length > 0 Then
                    aDistrictsIds = aObj.DistrictsIds.Split(",")

                    If aDistrictsIds IsNot Nothing AndAlso aDistrictsIds.Length > 0 Then
                        For Each aId As string in aDistrictsIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestDistrict (CD_REQUEST, CD_DISTRICT) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next

                        If aSQL <> "" Then
                            aParams = New List(Of SqlClient.SqlParameter)
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        End If
                    End If
                End If

                'Insert into Tbl_ClientRequestCityGroup
                aSQL = ""
                If aObj.CitiesGroupsIds IsNot Nothing AndAlso aObj.CitiesGroupsIds.Trim().Length > 0 Then
                    aCitiesGroupsIds = aObj.CitiesGroupsIds.Split(",")

                    If aCitiesGroupsIds IsNot Nothing AndAlso aCitiesGroupsIds.Length > 0 Then
                        For Each aId As string in aCitiesGroupsIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestCityGroup (CG_REQUEST, CG_GROUP) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next

                        If aSQL <> "" Then
                            aParams = New List(Of SqlClient.SqlParameter)
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        End If
                    End If
                End If

                'Insert into Tbl_ClientRequestCity
                aSQL = ""
                If aObj.CitiesIds IsNot Nothing AndAlso aObj.CitiesIds.Trim().Length > 0 Then
                    aCitiesIds = aObj.CitiesIds.Split(",")

                    If aCitiesIds IsNot Nothing AndAlso aCitiesIds.Length > 0 Then
                        For Each aId As string in aCitiesIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestCity (CC_REQUEST, CC_CITY) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next

                        If aSQL <> "" Then
                            aParams = New List(Of SqlClient.SqlParameter)
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        End If
                    End If
                End If

                'Insert into Tbl_ClientRequestNotCity
                aSQL = ""
                If aObj.NotCitiesIds IsNot Nothing AndAlso aObj.NotCitiesIds.Trim().Length > 0 Then
                    aNotInCitiesIds = aObj.NotCitiesIds.Split(",")

                    If aNotInCitiesIds IsNot Nothing AndAlso aNotInCitiesIds.Length > 0 Then
                        For Each aId As string in aNotInCitiesIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestNotCity (CC_REQUEST, CC_CITY) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next

                        If aSQL <> "" Then
                            aParams = New List(Of SqlClient.SqlParameter)
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        End If
                    End If
                End If

                'Insert into Tbl_ClientRequestPropertyType
                aSQL = ""
                If aObj.PropertyTypesIds IsNot Nothing AndAlso aObj.PropertyTypesIds.Trim().Length > 0 Then
                    aPropertyTypesIds = aObj.PropertyTypesIds.Split(",")

                    If aPropertyTypesIds IsNot Nothing AndAlso aPropertyTypesIds.Length > 0 Then
                        For Each aId As string in aPropertyTypesIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestPropertyType (CP_REQUEST, CP_PROPERTYTYPE) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next

                        If aSQL <> "" Then
                            aParams = New List(Of SqlClient.SqlParameter)
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        End If
                    End If
                End If

                'Handle the tags
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim().Length > 0 AndAlso aTagsTitles IsNot Nothing AndAlso aTagsTitles.Trim().Length > 0 Then
                    Dim aTagsIdsArr As String () = aTagsIds.Split(",")
                    Dim aTagsTitlesArr As String() = aTagsTitles.Split(",")
                    Dim aStrId, aStrTitle As String
                    Dim aTagId As Object

                    If aTagsIdsArr.Length > 0 Then
                        For i As Integer = 0 To aTagsIdsArr.Length - 1
                            aStrId = aTagsIds(i)
                            aStrTitle = aTagsTitlesArr(i).Trim()

                            'Check if there exists a tag with that title after trimming and case insensitive
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE LTRIM(RTRIM(LOWER(TG_NAME))) LIKE N'" & Utils.Utils.FixQuotes(aStrTitle.ToLower()) & "';"
                            aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                            If aTagId Is Nothing Then
                                'Create the tag and get its id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Insert Into TBL_Tag(TG_NAME) VALUES(N'" & Utils.Utils.FixQuotes(aStrTitle) & "') ;"
                                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                                'Read id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE TG_NAME LIKE N'" & Utils.Utils.FixQuotes(aStrTitle) & "';"
                                aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                            End If

                            'Insert Into Tbl_ClientRequestTag
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Insert Into TBL_ClientRequestTag(CT_REQUEST, CT_TAG) VALUES(" & aObj.Id & "," & CInt(aTagId) & ") ;"
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        Next
                    End If
                End If


                'Create the message
                Dim aMessageTitle As String = ""
                aMessage = CreateClientRequestText(aObj.Id, .ClientName, .Cell, .Email, .Source, .AreaType, .AreaMin, .AreaMax, .ForSale, .SaleMin, .SaleMax, .ForRent, .RentMin, .RentMax, .BedroomsMin, .BedroomsMax, .View, .Age, .ParkingType, .ParkingCount, .LTB, _
                                    .Furnished, .Decorated, .NotUsed, .Lux, .Duplex, .Commercial, .Exchange, .NoSlope, .GF, .FirstFloor, .NotGF, .NotFirstFloor, .NotLastFloor, .Garden, .Terrace, .Balcony, .MaidRoom, .MaidBath, .Heating, .Solar, .CentralAC, _
                                    .Storage, .DoubleG, .Interphone, .Videophone, .BIW, .Concierge, .Security, .Pool, .Pets, .Roof, .ClientNotes, .PropertiesIds, .DistrictsIds, .CitiesGroupsIds, .CitiesIds, .NotCitiesIds, .PropertyTypesIds, .Urgency, aMessageTitle, aConContext)


                'Create Activity
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Insert Into Tbl_Activity (AC_Type, AC_CreatedBy, AC_ClientRequestId, AC_ClientId) Values(6, " & .CreatedBy & ", " & aObj.Id & "," & aObj.ClientId & "); "
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)        


                'Create Alerts and Send Emails
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Distinct UR_ID As ID, UR_EMAIL As Email From Tbl_User Where UR_ISACTIVE='TRUE' AND (UR_IsSuperUser='True' OR UR_ID=" & aAgentId & ")"
                aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)        

                If aDT IsNot Nothing AndAlso aDT.Rows.Count > 0 Then
                    'Create Alert
                    aParams = New List(Of SqlClient.SqlParameter)
                    aSQL = "Insert Into Tbl_Alert (AL_Title, AL_Info, AL_Type, AL_ClientRequestId, AL_ClientId, AL_CreatedBy) Values (N'" & Utils.Utils.FixQuotes(aMessageTitle.Replace("--MYNEWLINE--", vbCrLf)) & "', N'" & Utils.Utils.FixQuotes(aMessage.Replace("--MYNEWLINE--", vbCrLf)) & "', 1, " & .Id & "," & .ClientId & "," & .CreatedBy & "); " 
                    aSQL &= "Select Top 1 AL_ID From Tbl_Alert Where AL_CreatedBy=" & .CreatedBy & " Order By AL_ID DESC; "
                    Dim alertId As Object = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)        

                    aSQL = ""
                    For Each aDRow As DataRow In aDT.Rows
                        aParams = New List(Of SqlClient.SqlParameter)
                        aSQL &= "Insert Into Tbl_AlertUser (AU_AlertId, AU_UserId, AU_IsViewed) Values(" & alertId & "," & aDRow("ID") & ",'False'); "
                        DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)        
                    
                        'Mail.SendMail(aDRow("Email"), "", "", aMessageTitle.Replace("--MYNEWLINE--", "<BR>") , aMessage.Replace("--MYNEWLINE--", "<BR>"))
                    Next
                End If
            End With

            'Commit
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates=True

            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "Select TOP 1 MC_ID AS ID FROM TBL_MarketingChannel ORDER BY MC_ID"
            aTempID = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

            If aAgentId = 0 Then
                aTitleMessage="Use WhatsApp to send the below message to the MANAGER"
            Else
                aTitleMessage="Use WhatsApp to send the below message to (" & aAgentName & ")"
                If aAgentCell <> "" Then aTitleMessage &= " Cell#: " & aAgentCell 
            End If
            aMessage = aMessage.Replace("--MYNEWLINE--", vbCrLf)

            aObj.PrimaryAgent = aAgentId 
        End Sub

        Public Shared Sub Update (ByRef aObj As ClientRequest2, aTagsIds As String, aTagsTitles As String, Optional ByRef  aConContext As ConnectionContext = Nothing)

            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet, aDT As DataTable 
            Dim aSQL As String = ""   
            Dim aTempID As Object
            Dim aDistrictsIds As String()
            Dim aCitiesGroupsIds As String()
            Dim aCitiesIds As String()
            Dim aNotInCitiesIds As String()
            Dim aPropertyTypesIds As String()

            If  Not IsNumeric(aObj.Id) OrElse CInt(aObj.Id)< 1 Then
                Throw New Exception("Invalid client request specified.")
                Return 
            End If

            With aObj 
                'Make sure that status is specified and not deal closed
                If IsNumeric(.Status) = False OrElse CInt(.Status) < 1 OrElse IsNumeric(.Substatus) = False OrElse CInt(.Substatus) < 1 Then
                    Throw New Exception ("Please, specify a valid status.")
                ElseIf CInt(.Status) = ClientRequestStatuses.DealClosed Then
                    Throw New Exception ("Invalid status specified: cannot be deal closed.")
                End If

                'Make sure importance is specified
                If IsNumeric(.Importance) = False OrElse CInt(.Importance) < 1 Then
                    Throw New Exception ("Please, specify the importance of the request.")
                End If
            End With

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = True 
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False 
             End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            With aObj 
                'Update Request
                aParams = New List(Of SqlClient.SqlParameter)

                aSQL = "Update TBL_CLIENTREQUESTLIST Set CR_Cell=N'" & Utils.Utils.FixQuotes(.Cell) & "', CR_Email=N'" & Utils.Utils.FixQuotes(.Email) & "', CR_Source=" & .Source & ", CR_Status=" & .Status & ", CR_AreaType=" & .AreaType & ",CR_ForSale='" & .ForSale & "', CR_SaleMin=" & .SaleMin & ", CR_SaleMax=" & .SaleMax & ", CR_ForRent='" & .ForRent & "', CR_RentMin=" & .RentMin & ","
                aSQL &= "CR_RentMax=" & .RentMax & ", CR_AreaMin=" & .AreaMin & ", CR_AreaMax=" & .AreaMax & ", CR_BedroomsMin=" & .BedroomsMin & ", CR_BedroomsMax=" & .BedroomsMax & ", CR_View=" & .View & ", CR_Age=" & .Age & ", CR_PropertiesIds='" & .PropertiesIds & "',"
                aSQL &= "CR_DistrictsIds='" & .DistrictsIds & "', CR_CitiesGroupsIds='" & .CitiesGroupsIds & "', CR_CitiesIds='" & .CitiesIds & "', CR_NotCitiesIds='" & .NotCitiesIds & "', CR_PropertyTypesIds='" & .PropertyTypesIds & "', CR_ParkingType=" & .ParkingType & ", CR_ParkingCount=" & .ParkingCount & ", CR_LTB='" & .LTB & "', CR_Furnished='" & .Furnished  & "', CR_Decorated='" & .Decorated  & "', CR_NotUsed='" & .NotUsed  & "'," 
                aSQL &= "CR_Lux='" & .Lux  & "', CR_Duplex='" & .Duplex  & "', CR_Commercial='" & .Commercial  & "', CR_Exchange='" & .Exchange  & "', CR_NoSlope='" & .NoSlope  & "', CR_GF='" & .GF  & "', CR_FirstFloor='" & .FirstFloor  & "', CR_NotGF='" & .NotGF  & "', CR_NotFirstFloor='" & .NotFirstFloor  & "', CR_NotLastFloor='" & .NotLastFloor  & "', CR_Garden='" & .Garden & "',"
                aSQL &= "CR_Terrace='" & .Terrace  & "', CR_Balcony='" & .Balcony  & "', CR_MaidRoom='" & .MaidRoom  & "', CR_MaidBath='" & .MaidBath  & "', CR_Heating='" & .Heating  & "', CR_Solar='" & .Solar  & "', CR_CentralAC='" & .CentralAC  & "', CR_Storage='" & .Storage  & "', CR_DoubleG='" & .DoubleG  & "', CR_Interphone='" & .Interphone  & "', CR_Videophone='" & .Videophone & "',"
                aSQL &= "CR_BIW='" & .BIW  & "', CR_Concierge='" & .Concierge  & "', CR_Security='" & .Security  & "', CR_Pool='" & .Pool  & "', CR_Pets='" & .Pets  & "', CR_Roof='" & .Roof  & "',"
                aSQL &= "CR_ClientNotes=N'" & Utils.Utils.FixQuotes(.ClientNotes) & "', CR_AgentNotes=N'" & Utils.Utils.FixQuotes(.AgentNotes) & "', CR_URGENCY=" & .Urgency & ", CR_Substatus=" & .Substatus & ", CR_Importance=" & .Importance & ", CR_MATCHNOTIFY='" & .MatchNotify & "' Where CR_ID=" & aObj.Id
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                
                'Handle PropertiesIds
                aParams = New List(Of SqlClient.SqlParameter)

                aSQL = "Delete From Tbl_ClientRequestProperty Where CP_RequestId=" & aObj.Id
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                If aObj.PropertiesIds.Trim() <> "" Then
                    Dim tempArr As String() = aObj.PropertiesIds.Split(",")

                    If tempArr.Length > 0 Then
                        aSQL = ""

                        For Each aPropIdS As String In tempArr
                            aSQL &= "Insert Into Tbl_ClientRequestProperty (CP_PropertyId, CP_RequestId) Values (" & Cint(aPropIdS.Trim()) & "," & aObj.Id & "); "
                        Next

                        DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                    End If
                End If 

                'Handle DistrictsIds
                aSQL = "Delete From Tbl_ClientRequestDistrict Where CD_Request=" & aObj.Id & "; "

                If aObj.DistrictsIds IsNot Nothing AndAlso aObj.DistrictsIds.Trim().Length > 0 Then
                    aDistrictsIds = aObj.DistrictsIds.Split(",")

                    If aDistrictsIds IsNot Nothing AndAlso aDistrictsIds.Length > 0 Then
                        For Each aId As string in aDistrictsIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestDistrict (CD_REQUEST, CD_DISTRICT) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next
                    End If
                End If

                aParams = New List(Of SqlClient.SqlParameter)
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Handle CitiesGroupsIds
                aSQL = "Delete From Tbl_ClientRequestCityGroup Where CG_Request=" & aObj.Id & "; "

                If aObj.CitiesGroupsIds IsNot Nothing AndAlso aObj.CitiesGroupsIds.Trim().Length > 0 Then
                    aCitiesGroupsIds = aObj.CitiesGroupsIds.Split(",")

                    If aCitiesGroupsIds IsNot Nothing AndAlso aCitiesGroupsIds.Length > 0 Then
                        For Each aId As string in aCitiesGroupsIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestCityGroup (CG_REQUEST, CG_GROUP) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next
                    End If
                End If

                aParams = New List(Of SqlClient.SqlParameter)
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Handle CitiesIds
                aSQL = "Delete From Tbl_ClientRequestCity Where CC_Request=" & aObj.Id & "; "

                If aObj.CitiesIds IsNot Nothing AndAlso aObj.CitiesIds.Trim().Length > 0 Then
                    aCitiesIds = aObj.CitiesIds.Split(",")

                    If aCitiesIds IsNot Nothing AndAlso aCitiesIds.Length > 0 Then
                        For Each aId As string in aCitiesIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestCity (CC_REQUEST, CC_CITY) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next
                    End If
                End If

                aParams = New List(Of SqlClient.SqlParameter)
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Handle NotCitiesIds
                aSQL = "Delete From Tbl_ClientRequestNotCity Where CC_Request=" & aObj.Id & "; "

                If aObj.NotCitiesIds IsNot Nothing AndAlso aObj.NotCitiesIds.Trim().Length > 0 Then
                    aNotInCitiesIds = aObj.NotCitiesIds.Split(",")

                    If aNotInCitiesIds IsNot Nothing AndAlso aNotInCitiesIds.Length > 0 Then
                        For Each aId As string in aNotInCitiesIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestNotCity (CC_REQUEST, CC_CITY) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next
                    End If
                End If

                aParams = New List(Of SqlClient.SqlParameter)
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Handle PropertyTypes
                aSQL = "Delete From Tbl_ClientRequestPropertyType Where CP_Request=" & aObj.Id & "; "

                If aObj.PropertyTypesIds IsNot Nothing AndAlso aObj.PropertyTypesIds.Trim().Length > 0 Then
                    aPropertyTypesIds = aObj.PropertyTypesIds.Split(",")

                    If aPropertyTypesIds IsNot Nothing AndAlso aPropertyTypesIds.Length > 0 Then
                        For Each aId As string in aPropertyTypesIds
                            If IsNumeric (aId.Trim()) Then
                                aSQL &= " Insert Into Tbl_ClientRequestPropertyType (CP_REQUEST, CP_PropertyType) Values(" & aObj.Id & "," & CInt(aId.Trim()) & "); "
                            End If
                        Next
                    End If
                End If

                aParams = New List(Of SqlClient.SqlParameter)
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Handle the tags
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Delete From Tbl_ClientRequestTag Where CT_Request=" & aObj.Id & ";"
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim().Length > 0 AndAlso aTagsTitles IsNot Nothing AndAlso aTagsTitles.Trim().Length > 0 Then
                    Dim aTagsIdsArr As String () = aTagsIds.Split(",")
                    Dim aTagsTitlesArr As String() = aTagsTitles.Split(",")
                    Dim aStrId, aStrTitle As String
                    Dim aTagId As Object

                    If aTagsIdsArr.Length > 0 Then
                        For i As Integer = 0 To aTagsIdsArr.Length - 1
                            aStrId = aTagsIds(i)
                            aStrTitle = aTagsTitlesArr(i).Trim()

                            'Check if there exists a tag with that title after trimming and case insensitive
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE LTRIM(RTRIM(LOWER(TG_NAME))) LIKE N'" & Utils.Utils.FixQuotes(aStrTitle.ToLower()) & "';"
                            aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                            If aTagId Is Nothing Then
                                'Create the tag and get its id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Insert Into TBL_Tag(TG_NAME) VALUES(N'" & Utils.Utils.FixQuotes(aStrTitle) & "') ;"
                                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                                'Read id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE TG_NAME LIKE N'" & Utils.Utils.FixQuotes(aStrTitle) & "';"
                                aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                            End If

                            'Insert Into Tbl_ClientRequestTag
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Insert Into TBL_ClientRequestTag(CT_REQUEST, CT_TAG) VALUES(" & aObj.Id & "," & CInt(aTagId) & ") ;"
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        Next
                    End If
                End If

                '???Create Notifications??
                'aParams = New List(Of SqlClient.SqlParameter)
                'aSQL = "Select Distinct UR_ID As ID, UR_EMAIL As Email From Tbl_User Where UR_ISACTIVE='TRUE' AND (UR_IsSuperUser='True' OR UR_ID=" & aAgentId & ")"
                'aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)        

                'For Each aDRow As DataRow In aDT.Rows
                '    aParams = New List(Of SqlClient.SqlParameter)

                '    aSQL= "Insert Into Tbl_Notification (NO_Title, NO_CreatedOn, NO_CreatedTo, NO_User, NO_Category, NO_IsViewed, NO_Property, NO_Request) Values(N'" & Utils.Utils.FixQuotes(aMessage.Replace("--MYNEWLINE--", vbCrLf)) & "','" & .CreatedOn & "'," & aDRow("ID") & "," & .CreatedBy & ", 7,'False',0," & .Id & ")" 
                '    DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)        

                '    Dim TempS As String = "Client Request CR-" & .Id & "<br>" & aMessage.Replace("--MYNEWLINE--", "<BR>")
                'Next
            End With

            'Commit
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates=True

            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "Select TOP 1 MC_ID AS ID FROM TBL_MarketingChannel ORDER BY MC_ID"
            aTempID = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
        End Sub

        Public Shared Function GetFormLookups(Optional ByRef aConContext As ConnectionContext = Nothing) As DataSet
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            Dim aSQL As String = "Select UR_ID as Id, UR_NAME As Name From Tbl_User Where UR_ISADMIN='TRUE' OR UR_ISSUPERUSER='TRUE' ORDER BY UR_NAME;"

            aSQL &= "Select MS_ID As ID, MS_ShortTitle As Title From Tbl_MarketingChannelSource Order By MS_OrderId;"
            aSQL &= "Select PT_ID As ID, PT_NAME AS NAME From Tbl_PropertyType Order By PT_OrderId;"
            aSQL &= "Select CI_ID As ID, CI_NAME AS NAME From Tbl_ClientRequestImportance Order By CI_OrderId;"

            aParams = New List(Of SqlClient.SqlParameter)
            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            Return aDS
        End Function

        'Auto-Complete
        Public Shared Function GetClientsRequestsWhoseNamesStartWith(name As string, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringStringIntegerBoolean) 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringStringIntegerBoolean)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If aUserId = 0 Then 
                aSQL = "Select Top 15 T2.CR_ID as ID, CT_NAME AS NAME, CT_CELL AS CELL, CONVERT(NVARCHAR(14), T2.CR_CREATEDON, 101) AS CREATEDON, IIF(MC_SHORTTITLE Is Null, '', MC_SHORTTITLE) AS Channel, T2.CR_IMPORTANCE As Importance, T2.CR_Status As Status FROM TBL_CLIENT T1 INNER JOIN TBL_CLIENTREQUESTLIST T2 ON T2.CR_CLIENT=T1.CT_ID Left Outer Join Tbl_MarketingChannel T3 on T2.CR_Source=T3.MC_ID WHERE T1.CT_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' Order By CT_NAME, CR_CREATEDON DESC"
            Else
                aSQL = "Select Top 15 T2.CR_ID as ID, CT_NAME AS NAME, CT_CELL AS CELL, CONVERT(NVARCHAR(14), T2.CR_CREATEDON, 101) AS CREATEDON, IIF(MC_SHORTTITLE Is Null, '', MC_SHORTTITLE) AS Channel, T2.CR_Importance As Importance, T2.CR_Status As Status FROM TBL_CLIENT T1 INNER JOIN TBL_CLIENTREQUESTLIST T2 ON T2.CR_CLIENT=T1.CT_ID Left Outer Join Tbl_MarketingChannel T3 on T2.CR_Source=T3.MC_ID WHERE T1.CT_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (T2.CR_PRIMARYAGENT=" & aUserId & " OR T2.CR_ID IN (SELECT TOP 1 CA_REQUEST FROM TBL_CLIENTREQUESTAGENT WHERE CA_AGENT=" & aUserId & ")) Order By CT_NAME, CR_CREATEDON DESC"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                If aDRow("Status") = ClientRequestStatuses.NoDeal OrElse aDRow("Status") = ClientRequestStatuses.DealClosed Then
                    aResult.Add(New Utils.IntegerStringStringStringStringIntegerBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("Channel"), aDRow("CREATEDON"), aDRow("Importance"), False))
                Else
                    aResult.Add(New Utils.IntegerStringStringStringStringIntegerBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("Channel"), aDRow("CREATEDON"), aDRow("Importance"), True))
                End If
            Next

            Return aResult
        End Function

        Public Shared Function GetClientsRequestsWhoseIdsStartWith(id As string, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringStringIntegerBoolean) 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringStringIntegerBoolean)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If aUserId = 0 Then 
                aSQL = "Select Top 15 T2.CR_ID as ID, CT_NAME AS NAME, CT_CELL AS CELL, CONVERT(NVARCHAR(14), T2.CR_CREATEDON, 101) AS CREATEDON, IIF(MC_SHORTTITLE Is Null, '', MC_SHORTTITLE) As Channel, T2.CR_IMPORTANCE As Importance, T2.CR_Status As Status FROM TBL_CLIENT T1 INNER JOIN TBL_CLIENTREQUESTLIST T2 ON T2.CR_CLIENT=T1.CT_ID Left Outer Join Tbl_MarketingChannel T3 on T2.CR_Source=T3.MC_ID WHERE CONVERT(NVARCHAR(10),T2.CR_ID) Like N'" & id & "%' Order By CR_ID"
            Else
                aSQL = "Select Top 15 T2.CR_ID as ID, CT_NAME AS NAME, CT_CELL AS CELL, CONVERT(NVARCHAR(14), T2.CR_CREATEDON, 101) AS CREATEDON, IIF(MC_SHORTTITLE Is Null, '', MC_SHORTTITLE) As Channel, T2.CR_IMPORTANCE As Importance, T2.CR_Status As Status FROM TBL_CLIENT T1 INNER JOIN TBL_CLIENTREQUESTLIST T2 ON T2.CR_CLIENT=T1.CT_ID Left Outer Join Tbl_MarketingChannel T3 on T2.CR_Source=T3.MC_ID WHERE CONVERT(NVARCHAR(10),T2.CR_ID) LIKE N'" & id & "%' AND (T2.CR_PRIMARYAGENT=" & aUserId & " OR T2.CR_ID IN (SELECT TOP 1 CA_REQUEST FROM TBL_CLIENTREQUESTAGENT WHERE CA_AGENT=" & aUserId & "))  Order By CR_ID"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                If aDRow("Status") = ClientRequestStatuses.NoDeal OrElse aDRow("Status") = ClientRequestStatuses.DealClosed Then
                    aResult.Add(New Utils.IntegerStringStringStringStringIntegerBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("Channel"), aDRow("CREATEDON"), aDRow("Importance"), False))
                Else
                    aResult.Add(New Utils.IntegerStringStringStringStringIntegerBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("Channel"), aDRow("CREATEDON"), aDRow("Importance"), True))
                End If 
            Next

            Return aResult
        End Function

        Public Shared Function GetStatusesAndSubstatusesStartingWith(aName As String, Optional aIncludeNew As Boolean = True, Optional aIncludeInProcess As Boolean=True, Optional aIncludeOnHold As Boolean = True, Optional aIncludeNoDeal As Boolean = True, Optional aIncludeDealClosed As Boolean=false, Optional aIncludeAll As Boolean = False, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringString) 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = "", aWhere As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringString)
            Dim aSkipNew As Boolean =False, aSkipInProcess As Boolean = False, aSkipOnHold As Boolean=False, aSkipNoDeal As Boolean = False, aSkipDealClosed As Boolean = false

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If aIncludeNew = False Then aWhere &= " AND CS_ID <> " & ClientRequestStatuses.[New]
            If aIncludeInProcess = False Then aWhere &= " AND CS_ID <> " & ClientRequestStatuses.InProcess 
            If aIncludeOnHold = False Then aWhere &= " AND CS_ID <> " & ClientRequestStatuses.OnHold 
            If aIncludeNoDeal = False Then aWhere &= " AND CS_ID <> " & ClientRequestStatuses.NoDeal 
            If aIncludeDealClosed = False Then aWhere &= " AND CS_ID <> " & ClientRequestStatuses.DealClosed 

            aSQL = "Select CS_ID As StatusId, CU_ID As SubstatusId, CS_Name As StatusTitle, CU_Name As SubstatusTitle From Tbl_ClientRequestStatus T1 Inner Join Tbl_ClientRequestSubstatus T2 On T1.CS_ID=T2.CU_STATUS WHERE CONCAT(CS_NAME, ' - ', CU_NAME) Like '" & aName & "%' "

            If aWhere <> "" Then aSQL &= aWhere 

            aSQL &= " ORDER By CS_ORDERID, CU_ORDERID"

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                If aIncludeAll = True Then 
                    If aDRow("StatusId") = ClientRequestStatuses.[New] And aSkipNew = False Then
                        aResult.Add(New Utils.IntegerStringStringString (aDRow("StatusId"), 0, aDRow("StatusTitle"), "All"))
                        aSkipNew = True 
                    ElseIf aDRow("StatusId") = ClientRequestStatuses.InProcess And aSkipInProcess = False Then
                        aResult.Add(New Utils.IntegerStringStringString (aDRow("StatusId"), 0, aDRow("StatusTitle"), "All"))
                        aSkipInProcess = True 
                    ElseIf aDRow("StatusId") = ClientRequestStatuses.OnHold And aSkipOnHold = False Then
                        aResult.Add(New Utils.IntegerStringStringString (aDRow("StatusId"), 0, aDRow("StatusTitle"), "All"))
                        aSkipOnHold = True 
                    ElseIf aDRow("StatusId") = ClientRequestStatuses.NoDeal And aSkipNoDeal = False Then
                        aResult.Add(New Utils.IntegerStringStringString (aDRow("StatusId"), 0, aDRow("StatusTitle"), "All"))
                        aSkipNoDeal = True 
                    ElseIf aDRow("StatusId") = ClientRequestStatuses.DealClosed And aSkipDealClosed = False Then
                        aResult.Add(New Utils.IntegerStringStringString (aDRow("StatusId"), 0, aDRow("StatusTitle"), "All"))
                        aSkipDealClosed = True 
                    End If
                End If 


                aResult.Add(New Utils.IntegerStringStringString (aDRow("StatusId"), aDRow("SubstatusId"), aDRow("StatusTitle"), aDRow("SubstatusTitle")))
            Next

            Return aResult
        End Function

        Public Shared Function SearchApi(aSDate As String, aEDate As String, aUrgency As Integer, aImportance As Integer, aForSale As Boolean, aSaleMin As Integer, aSaleMax As Integer, aForRent As Boolean, aRentMin As Integer, aRentMax As Integer, aStatuses As string, aPropertyTypesIds As String, aDistrictsIds As String, aCitiesIds As String, aNotInCitiesIds As String, aPropertiesIds As String, aRequestsIds As String, aTags As String, aTagsAnd As Boolean, aSourcesIds As String, aClientsIds As String, aAgentsIds As String, aIsActive As Integer, aIsInactive As Integer, aIsLTB As Integer, aIsExchange As Integer, aIsFurnished As Integer, aIsDecorated As Integer, aIsCommercial As integer, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As ApiResultClientRequestData
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aTagsTitles As String = ""
            Dim aSQL As String = "", aWhere As String = ""
            Dim aResult As New ApiResultClientRequestData ()

            'Dim aResult As New List(Of Utils.IntegerStringStringStringStringStringStringInteger)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "SELECT DISTINCT CR_ID AS ID, 'CR-' + CONVERT(NVARCHAR(50), CR_ID) AS [KEY], CT_NAME AS CLIENTNAME, IIF(CR_CELL <> '', CR_CELL, CT_CELL) AS CELL, IIF(UR_NAME IS NULL, '', UR_NAME) AS PRIMARYAGENT,"
            aSQL &= " CONCAT(T6.CS_NAME, ' - ', T7.CU_NAME) AS STATUS,  CONVERT(NVARCHAR(50), CR_CREATEDON, 110) AS CREATEDON, CR_IMPORTANCE AS IMPORTANCE, CR_STATUS AS STATUSID "
            aSQL &= " ,TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_CLIENTREQUESTTAG T INNER JOIN TBL_TAG TG ON T.CT_TAG = TG.TG_ID WHERE T1.CR_ID = T.CT_REQUEST ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
            aSQL &= " FROM TBL_CLIENTREQUESTLIST T1 INNER JOIN TBL_CLIENT T3 ON T1.CR_CLIENT=T3.CT_ID LEFT OUTER JOIN TBL_USER T4 ON T1.CR_PRIMARYAGENT=T4.UR_ID "
            aSQL &= " INNER JOIN TBL_CLIENTREQUESTIMPORTANCE T5 ON T1.CR_IMPORTANCE=T5.CI_ID INNER JOIN TBL_CLIENTREQUESTSTATUS T6 ON T1.CR_STATUS=T6.CS_ID INNER JOIN TBL_CLIENTREQUESTSUBSTATUS T7 ON T1.CR_SUBSTATUS=T7.CU_ID "            
            aSQL &= " LEFT OUTER JOIN TBL_CLIENTREQUESTPROPERTY T8 ON T1.CR_ID=T8.CP_REQUESTID LEFT OUTER JOIN TBL_PROPERTY T9 ON T8.CP_PROPERTYID=T9.PR_ID "

            If aUserId > 0 Then
                aSQL &= " INNER JOIN TBL_CLIENTREQUESTAGENT T2 ON T1.CR_ID=T2.CA_REQUEST "
                aWhere &= " AND (CR_PRIMARYAGENT=" & aUserId & " OR CA_AGENT=" & aUserId & ") "
            End If

            'sDate: '' or mm-dd-yyyy
            If aSDate <> "" Then aWhere &= " AND CR_CREATEDON >= '" & aSDate & " 00:00:00' "

            'eDate:'' or mm-dd-yyyy
            If aEDate <> "" Then aWhere &= " AND CR_CREATEDON <= '" & aEDate & " 23:59:59' "

            'aUrgency
            If aUrgency > 0 Then aWhere &= " AND CR_URGENCY=" & aUrgency & " "

            'aImportance
            If aImportance > 0 Then aWhere &= " AND CR_IMPORTANCE=" & aImportance & " "

            'aForSale
            If aForSale = True Then aWhere &= " AND (CR_FORSALE='TRUE' OR T9.PR_FORSALE='TRUE') "

            'aSaleMin/Max
            If aSaleMin > 0 Or aSaleMax > 0 Then
                If aSaleMax = 0 Then aSaleMax  = 1000000000

                aWhere &= " AND (DBO.NUMBERSINTERSECT(CR_SALEMIN, IIF(CR_SALEMIN > 0 AND CR_SALEMAX = 0, 1000000000, CR_SALEMAX), " & aSaleMin & ", " & aSaleMax & ") = 'TRUE' OR (PR_FORSALE='TRUE' AND PR_SALEAMOUNT >= " & aSaleMin & " AND PR_SALEAMOUNT <= " & aSaleMax & " ))"
            End If

            'aForRent
            If aForRent = True Then aWhere &= " AND (CR_FORRENT='TRUE' OR T9.PR_FORRENT='TRUE') "

            'aRentMin/Max
            If aRentMin > 0 Or aRentMax > 0 Then
                If aRentMax = 0 Then aRentMax  = 1000000000

                aWhere &= " AND (DBO.NUMBERSINTERSECT(CR_RENTMIN, IIF(CR_RENTMIN > 0 AND CR_RENTMAX = 0, 1000000000, CR_RENTMAX), " & aRentMin & ", " & aRentMax & ") = 'TRUE' OR (PR_FORRENT='TRUE' AND PR_RENTAMOUNT >= " & aRentMin & " AND PR_RENTAMOUNT <= " & aRentMax & " ))"
            End If

            'aStatuses
            If aStatuses <> "" Then
                Dim statusesArr As String() = aStatuses.Split(",")

                If statusesArr.Length > 0 Then
                    Dim st As String ="", ss As String = ""
                    Dim aWhere1 As String = ""

                    For Each aStr As String In statusesArr
                        st = aStr.Split(";")(0)
                        ss = aStr.Split(";")(1)

                        If ss = 0 Then
                           aWhere1 &= " OR CR_STATUS=" & st & " "
                        Else
                            aWhere1 &= " OR (CR_STATUS=" & st & " AND CR_SUBSTATUS = " & ss & ") "
                        End If
                    Next

                    aWhere &= " AND (" & aWhere1.Substring(3) & ") "
                End If
            End If

            'aPropertyTypesIDs
            If aPropertyTypesIds <> "" Then aWhere &= " AND (CR_PROPERTYTYPE IN (" & aPropertyTypesIds & ") OR PR_PROPERTYTYPE IN (" & aPropertyTypesIds & ")) "  

            'aDistrictsIds
            If aDistrictsIds <> "" Then aWhere &= " AND (CR_ID IN (SELECT CD_REQUEST FROM TBL_CLIENTREQUESTDISTRICT WHERE CD_DISTRICT IN (" & aDistrictsIds & ")) OR PR_COUNTRY IN (" & aDistrictsIds & ")) "  

            'aCitiesIds
            If aCitiesIds <> "" Then aWhere &= " AND (CR_ID IN (SELECT CC_REQUEST FROM TBL_CLIENTREQUESTCITY WHERE CC_CITY IN (" & aCitiesIds & ")) OR PR_CITY IN (" & aCitiesIds & ")) "  

            'aNotInCitiesIds
            If aNotInCitiesIds <> "" Then aWhere &= " AND (CR_ID IN (SELECT CC_REQUEST FROM TBL_CLIENTREQUESTNOTCITY WHERE CC_CITY NOT IN (" & aNotInCitiesIds & ")) OR PR_CITY NOT IN (" & aNotInCitiesIds & ")) "  

            'aPropertiesIds
            If aPropertiesIds <> "" Then aWhere &= " AND (CR_ID IN (SELECT CP_REQUESTID FROM TBL_CLIENTREQUESTPROPERTY WHERE CP_PROPERTYID IN (" & aPropertiesIds & ")) OR PR_ID IN (" & aPropertiesIds & "))"  


            'aTags            
            If aTags <> "" Then
                If aTagsAnd = False Then 
                    aWhere &= "AND CR_ID IN (SELECT CT_REQUEST FROM TBL_CLIENTREQUESTTAG WHERE CT_TAG IN (" & aTags & ")) "  
                Else
                    Dim aTagsArr As String() = aTags.Split(",")

                    If aTagsArr IsNot Nothing AndAlso aTagsArr.Length>0 Then
                        For Each aStr As String In aTagsArr
                            aWhere &= " AND CR_ID IN (SELECT CT_REQUEST FROM TBL_CLIENTREQUESTTAG WHERE CT_TAG =" & CInt(aStr.Trim()) & ")"
                        Next
                    End If
                End If 
            End If

            'aSourcesIds : user searches for SOURCE i.e. P.F. as a group
            If aSourcesIds <> "" Then aWhere &= " AND CR_SOURCE IN (" & aSourcesIds & ") "

            'aClientId
            If aClientsIds <> "" Then aWhere &=" AND CR_CLIENT In (" & aClientsIds & ") "

            'aAgentId
            If aAgentsIds <> "" Then aWhere &=" AND (CR_PRIMARYAGENT IN (" & aAgentsIds & ") OR CR_ID IN (SELECT CA_REQUEST FROM TBL_CLIENTREQUESTAGENT WHERE CA_AGENT IN (" & aAgentsIds & "))) "

            'aIsActive : 1:True
            If aIsActive = 1 Then aWhere &= " AND (CR_STATUS=1 OR CR_STATUS=2 OR CR_STATUS=3) "

            'aIsInActive : 1:True
            If aIsInActive = 1 Then aWhere &= " AND (CR_STATUS=4 OR CR_STATUS=5) "

            'aIsLTB : 1:True
            If aIsLTB = 1 Then aWhere &= " AND (CR_LTB='TRUE') "

            'aIsExchange : 1:True
            If aIsExchange = 1 Then aWhere &= " AND (CR_EXCHANGE='TRUE') "

            'aIsFurnished : 1:True
            If aIsFurnished = 1 Then aWhere &= " AND (CR_FURNISHED='TRUE') "

            'aIsDecorated : 1:True
            If aIsDecorated = 1 Then aWhere &= " AND (CR_DECORATED='TRUE') "

            'aIsCommercial
            If aIsCommercial = 1 Then aWhere &= " AND (CR_COMMERCIAL='TRUE') "
            'aRequestsIds
            If aRequestsIds <> "" Then
                If aWhere <> "" Then
                    aWhere = " WHERE (" & aWhere.Substring(4) & ") OR CR_ID IN (" & aRequestsIds & ")"
                Else
                    aWhere = " WHERE CR_ID IN (" & aRequestsIds & ")"
                End If
            ElseIf aWhere <> "" Then
                aWhere = " WHERE " & aWhere.Substring(4)            
            End If

            If aWhere <> "" Then aSQL &= " " & aWhere & " "

            aSQL &= " ORDER By CR_ID DESC"

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            aResult.Data = New List(Of IntegerStringStringStringStringStringStringIntegerIntegerString)()

            For Each aDRow As DataRow In aDT.Rows
                If IsDbNull(aDRow("TagsTitles")) Then
                    aTagsTitles = ""
                ElseIf aDRow("TagsTitles").ToString().Length>35 Then
                    aTagsTitles = aDRow("TagsTitles").ToString().Substring(0,35)
                Else
                    aTagsTitles = aDRow("TagsTitles")
                End If

                If aDRow("StatusID") = ClientRequestStatuses.NoDeal OrElse aDRow("StatusID") = ClientRequestStatuses.DealClosed Then
                    aResult.Data.Add(New Utils.IntegerStringStringStringStringStringStringIntegerIntegerString (aDRow("ID"), aDRow("Key"), aDRow("ClientName"), aDRow("Cell"), aDRow("PrimaryAgent"), aDRow("Status"), aDRow("CreatedOn"), aDRow("Importance"), 0, aTagsTitles))
                Else
                    aResult.Data.Add(New Utils.IntegerStringStringStringStringStringStringIntegerIntegerString (aDRow("ID"), aDRow("Key"), aDRow("ClientName"), aDRow("Cell"), aDRow("PrimaryAgent"), aDRow("Status"), aDRow("CreatedOn"), aDRow("Importance"), 1, aTagsTitles))                    
                End If
            Next

            Return aResult
        End Function


        'To Be Deleted
        Public Shared Function GetProperties(city As Integer, Optional saleAmount As Integer=0, Optional saleSign As Integer=1, Optional rentAmount As Integer =0, Optional rentSign As Integer=1, Optional area As Integer = 0, Optional areaSign As Integer=1, Optional bedrooms As Integer=0, Optional bedroomsSign As Integer=1, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.StringIntegerIntegerIntegerInteger) 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.StringIntegerIntegerIntegerInteger)

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "Select PR_PROPERTYKEY as PROPERTYKEY, IIF(PR_FORSALE='True', PR_SaleAmount, 0) As SaleAmount, IIF(PR_FORRENT='True', PR_RentAmount, 0) As RentAmount, PR_Area As Area, PR_Bedrooms As Bedrooms From Tbl_Property Where PR_IsActive='true' And PR_City=" & city & " "

            If saleAmount >0 Then
                If saleSign = 0 Then
                    aSQL &= " And PR_SALEAMOUNT=" & saleAmount
                Else
                    aSQL &= " And PR_SALEAMOUNT >=" & saleAmount*0.9 & " And PR_SALEAMOUNT <= " & saleAmount *1.1
                End If
            End If

            If rentAmount >0 Then
                If rentSign = 0 Then
                    aSQL &= " And PR_RENTAMOUNT=" & rentAmount
                Else
                    aSQL &= " And PR_RENTAMOUNT >=" & rentAmount*0.9 & " And PR_RENTAMOUNT <= " & rentAmount *1.1
                End If
            End If

            If area >0 Then
                If areaSign = 0 Then
                    aSQL &= " And PR_AREA=" & area 
                Else
                    aSQL &= " And PR_Area >=" & area*0.9 & " And PR_AREA <= " & area *1.1
                End If
            End If

            If bedrooms >0 Then
                If bedroomsSign = 0 Then
                    aSQL &= " And PR_Bedrooms=" & bedrooms  
                Else
                    aSQL &= " And PR_Bedrooms=" & bedrooms  
                End If
            End If


            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.StringIntegerIntegerIntegerInteger (aDRow("PropertyKey"), aDRow("SaleAmount"), aDRow("RentAmount"), aDRow("Area"), aDRow("Bedrooms")))
            Next
            Return aResult

        End Function

        Public Shared Function GetSearchFormLookups(Optional ByRef aConContext As ConnectionContext = Nothing) As DataSet
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            Dim aSQL As String = "Select CI_ID As ID, CI_NAME AS NAME From Tbl_ClientRequestImportance Order By CI_OrderId;"

            aParams = New List(Of SqlClient.SqlParameter)
            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            Return aDS
        End Function

End Class

    Public Class ApiResultClientRequestData
                Inherits Utils.ApiResponse 

        Public Data As List(Of IntegerStringStringStringStringStringStringIntegerIntegerString)
        
        Public Sub New (Optional aSucceeded As Boolean=True, Optional aData As List(Of IntegerStringStringStringStringStringStringIntegerIntegerString) = Nothing, Optional aErrorNumber As Integer = 0, Optional aErrorMessage As string="")
            Me.Succeeded= aSucceeded
            Me.Data = aData
            Me.ErrorNumber = aErrorNumber
            Me.ErrorMessage = aErrorMessage 
        End Sub
    End Class

End Namespace
