Imports Microsoft.VisualBasic
Imports System.Data, system.Data.SqlClient, System.Collections.Generic, System.ComponentModel
Imports PDF, PDF.DAL, PDF.DAL.MSSQL

Public Class CustomSessionData
    'Fields
    Public p_UserID As Object = 0, p_AgentID As Object = "", p_Language As Object = ""
    Public p_Connection1Key As Object = "", p_AgentKey As Object = "", p_Username As Object = "", p_Password As Object = ""

    'Property
    Public Property UserID() As Object
        Get
            Return p_UserID
        End Get
        Set(ByVal value As Object)
            If p_UserID Is Nothing Then
                'Set default properties
                SetDefaultValues()

                'Set current property
                p_UserID = value

                'Save to DB
                CustomSession.DB_WriteSession(Me)

                'Save to session
                System.Web.HttpContext.Current.Session("CustomSession") = Me
            Else
                'Save To DB
                CustomSession.DB_WriteSessionProperty("UserID", value)

                'Set current property
                p_UserID = value
            End If
        End Set

    End Property

    Public Property Username() As Object
        Get
            Return p_Username
        End Get

        Set(ByVal value As Object)
            If p_Username Is Nothing Then
                'Set default properties
                SetDefaultValues()

                'Set current property
                p_Username = value

                'Save to DB
                CustomSession.DB_WriteSession(Me)

                'Save to session
                System.Web.HttpContext.Current.Session("CustomSession") = Me
            Else
                'Save To DB
                CustomSession.DB_WriteSessionProperty("Username", value)

                'Set current property
                p_Username = value
            End If
        End Set

    End Property

    Public Property Password() As Object
        Get
            Return p_Password
        End Get

        Set(ByVal value As Object)
            If p_Password Is Nothing Then
                'Set default properties
                SetDefaultValues()

                'Set current property
                p_Password = value

                'Save to DB
                CustomSession.DB_WriteSession(Me)

                'Save to session
                System.Web.HttpContext.Current.Session("CustomSession") = Me
            Else
                'Save To DB
                CustomSession.DB_WriteSessionProperty("Password", value)

                'Set current property
                p_Password = value
            End If
        End Set

    End Property


    Public Property Connection1Key() As Object
        Get
            Return p_Connection1Key
        End Get

        Set(ByVal value As Object)
            If p_Connection1Key Is Nothing Then
                'Set default properties
                SetDefaultValues()

                'Set current property
                p_Connection1Key = value

                'Save to DB
                CustomSession.DB_WriteSession(Me)

                'Save to session
                System.Web.HttpContext.Current.Session("CustomSession") = Me
            Else
                'Save To DB
                CustomSession.DB_WriteSessionProperty("Connection1Key", value)

                'Set current property
                p_Connection1Key = value
            End If
        End Set

    End Property

    Public Property AgentKey() As Object
        Get
            Return p_AgentKey
        End Get

        Set(ByVal value As Object)
            If p_AgentKey Is Nothing Then
                'Set default properties
                SetDefaultValues()

                'Set current property
                p_AgentKey = value

                'Save to DB
                CustomSession.DB_WriteSession(Me)

                'Save to session
                System.Web.HttpContext.Current.Session("CustomSession") = Me
            Else
                'Save To DB
                CustomSession.DB_WriteSessionProperty("AgentKey", value)

                'Set current property
                p_AgentKey = value
            End If
        End Set

    End Property

    Public Property AgentID() As Object
        Get
            Return p_AgentID
        End Get

        Set(ByVal value As Object)
            If p_AgentID Is Nothing Then
                'Set default properties
                SetDefaultValues()

                'Set current property
                p_AgentID = value

                'Save to DB
                CustomSession.DB_WriteSession(Me)

                'Save to session
                System.Web.HttpContext.Current.Session("CustomSession") = Me
            Else
                'Save To DB
                CustomSession.DB_WriteSessionProperty("AgentID", value)

                'Set current property
                p_AgentID = value
            End If
        End Set

    End Property

    Public Property Language() As Object
        Get
            Return p_Language
        End Get

        Set(ByVal value As Object)
            If p_Language Is Nothing Then
                'Set default properties
                SetDefaultValues()

                'Set current property
                p_Language = value

                'Save to DB
                CustomSession.DB_WriteSession(Me)

                'Save to session
                System.Web.HttpContext.Current.Session("CustomSession") = Me
            Else
                'Save To DB
                CustomSession.DB_WriteSessionProperty("Language", value)

                'Set current property
                p_Language = value
            End If
        End Set

    End Property



    'Methods
    'Public Sub SetProperties(Optional ByVal aUserID As Object = Nothing, Optional ByVal aUsername As Object = Nothing, Optional ByVal aPassword As Object = Nothing, Optional ByVal aConnection1Key As Object = Nothing, Optional ByVal aAgentKey As Object = Nothing, Optional ByVal aAgentID As Object = Nothing, Optional ByVal aLanguage As Object = Nothing)
    '    Dim aSQL As String = ""

    '    If aUserID IsNot Nothing Then aSQL &= " AND Userid='" & StringMisc.FixQuote(aUserID) & "' "
    '    If aUsername IsNot Nothing Then aSQL &= " AND Username='" & StringMisc.FixQuote(aUsername) & "' "


    '    If aSQL = "" Then Return



    'End Sub


    Private Sub SetDefaultValues()
        p_UserID = 0
        p_Username = ""
        p_Password = ""
        p_Connection1Key = ""
        p_AgentKey = ""
        p_AgentID = 0
        p_Language = 0
    End Sub

End Class


Public Class CustomSession
    'Properties
    Public Shared ReadOnly Property Context() As CustomSessionData
        Get
            Dim aObj As CustomSessionData

            aObj = System.Web.HttpContext.Current.Session("CustomSession")

            If aObj Is Nothing Then
                aObj = DB_ReadSession()

                If aObj Is Nothing Then
                    aObj = New CustomSessionData
                    With aObj
                        .p_UserID = Nothing
                        .p_Username = Nothing
                        .p_Password = Nothing
                        .p_Connection1Key = Nothing
                        .p_AgentKey = Nothing
                        .p_AgentID = Nothing
                        .p_Language = Nothing
                    End With

                    Return aObj
                End If

                'Copy to Session
                System.Web.HttpContext.Current.Session("CustomSession") = aObj

                Return aObj
            End If

            Return aObj
        End Get
    End Property


    'DB Methods

    Public Shared Sub DB_WriteSessionProperty(ByVal aPropertyName As String, ByVal aPropertyValue As Object, Optional ByRef aConContext As ConnectionContext = Nothing)
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aResult As Object
        Dim aDB As ConnectionContextConnection

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates = False
        End If

        aResult = DB.ReadValue_Text("Select Top 1 SessionID From Tbl_Session Where SessionID='" & System.Web.HttpContext.Current.Session.SessionID & "';", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
        If aResult Is Nothing OrElse IsDBNull(aResult) Then
            'Insert 
            DB.CUD_Text("Insert Into Tbl_Session (SessionID, UserID, Username, Password, Connection1Key, AgentKey, AgentID, Language) Values ('" & System.Web.HttpContext.Current.Session.SessionID & "',0, '', '', '', '', 0, 0);", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, False)

            'Update Property
            DB.CUD_Text("Update Tbl_Session Set " & aPropertyName & "='" & StringMisc.FixQuote(aPropertyValue) & "' Where SessionID='" & System.Web.HttpContext.Current.Session.SessionID & "';", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, True)
        Else
            'Update
            DB.CUD_Text("Update Tbl_Session Set " & aPropertyName & "='" & StringMisc.FixQuote(aPropertyValue) & "' Where SessionID='" & System.Web.HttpContext.Current.Session.SessionID & "';", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, True)
        End If
    End Sub


    Public Shared Function DB_ReadSession(Optional ByRef aConContext As ConnectionContext = Nothing) As CustomSessionData
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aDB As ConnectionContextConnection
        Dim aObj As CustomSessionData
        Dim aDT As DataTable, aDR As DataRow
        Dim S As String

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates = True
        End If


        S = System.Web.HttpContext.Current.Session.SessionID

        aDT = DB.ReadDT_Text("Select * From Tbl_Session Where SessionID='" & System.Web.HttpContext.Current.Session.SessionID & "';", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, True)

        If aDT.Rows.Count < 1 Then Return Nothing

        aDR = aDT.Rows(0)

        aObj = New CustomSessionData
        With aObj
            .p_UserID = aDR("UserID")
            .p_Username = aDR("Username")
            .p_Password = aDR("Password")
            .p_Connection1Key = aDR("Connection1Key")
            .p_AgentKey = aDR("AgentKey")
            .p_AgentID = aDR("AgentID")
            .p_Language = aDR("Language")
        End With

        Return aObj
    End Function


    Public Shared Sub DB_WriteSession(ByVal aObj As CustomSessionData, Optional ByRef aConContext As ConnectionContext = Nothing)
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aResult As Object
        Dim aDB As ConnectionContextConnection

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates = False
        End If

        aResult = DB.ReadValue_Text("Select Top 1 SessionID From Tbl_Session Where SessionID='" & System.Web.HttpContext.Current.Session.SessionID & "'", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
        If aResult Is Nothing OrElse IsDBNull(aResult) Then
            'Insert 
            DB.CUD_Text("Insert Into Tbl_Session (SessionID, UserID, Username, Password, Connection1Key, AgentKey, AgentID, Language) Values ('" & StringMisc.FixQuote(System.Web.HttpContext.Current.Session.SessionID) & "'," & aObj.p_UserID & ", '" & StringMisc.FixQuote(aObj.p_Username) & "', '" & StringMisc.FixQuote(aObj.p_Password) & "', '" & StringMisc.FixQuote(aObj.p_Connection1Key) & "', '" & StringMisc.FixQuote(aObj.p_AgentKey) & "', " & aObj.p_AgentID & ", " & aObj.p_Language & ");", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, True)

        Else
            'Update
            DB.CUD_Text("Update Tbl_Session Set UserID=" & aObj.UserID & ", Username='" & StringMisc.FixQuote(aObj.p_Username) & "', Password='" & StringMisc.FixQuote(aObj.p_Password) & "', Connection1Key='" & StringMisc.FixQuote(aObj.p_Connection1Key) & "', AgentKey='" & StringMisc.FixQuote(aObj.p_AgentKey) & "', AgentID=" & aObj.p_AgentID & ", Language=" & aObj.p_Language & " Where SessionID='" & System.Web.HttpContext.Current.Session.SessionID & "';", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, True)
        End If
    End Sub


    Public Shared Sub Logout(Optional ByRef aConContext As ConnectionContext = Nothing)
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aDB As ConnectionContextConnection

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates = True
        End If

        DB.CUD_Text("Delete From Tbl_Session Where SessionID='" & System.Web.HttpContext.Current.Session.SessionID & "' ", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, True)


        System.Web.HttpContext.Current.Session("CustomSession") = Nothing
    End Sub

End Class
