Imports Microsoft.VisualBasic

Imports System.Data, system.Data.SqlClient, System.Collections.Generic, System.ComponentModel

Imports PDF, PDF.DAL, PDF.DAL.MSSQL


Public Enum RedirectOptionEnum
    Transfer = 1
    Redirect = 2
End Enum


<Serializable()> _
Public Class LOG : Inherits PDF.StrongBusinessProvider(Of LOG)

#Region " Fields and Properties "

    'Fields
    Protected p_ErrorPath As String = "", p_ErrorDescription As String = ""

    'Concurrency 
    Public p_Conc As Object = 0


    'Properties
    Public Property ErrorPath() As String
        Get
            Return p_ErrorPath
        End Get
        Set(ByVal value As String)
            If p_ErrorPath = value Then Return

            p_ErrorPath = value
            PropertyHasChanged("ErrorPath")
        End Set
    End Property

    Public Property ErrorDescription() As String
        Get
            Return p_ErrorDescription
        End Get
        Set(ByVal value As String)
            If p_ErrorDescription = value Then Return

            p_ErrorDescription = value
            PropertyHasChanged("ErrorDescription")
        End Set
    End Property


    'Conc
    Public Property Conc() As Object
        Get
            Return p_Conc
        End Get
        Set(ByVal value As Object)
            p_Conc = value
        End Set
    End Property

#End Region

#Region " Initialize "

    Protected Overrides Sub Initialize()
        MyBase.Initialize()
    End Sub

#End Region

#Region " Validation "

    Protected Overrides Sub AddBusinessRules()
        MyBase.AddBusinessRules()
    End Sub


    <Browsable(False)> _
    Public Overrides ReadOnly Property IsValid() As Boolean
        Get
            If MyBase.IsValid = False Then Return False

            Return True
        End Get
    End Property

#End Region

#Region " IsDirty "

    <Browsable(False)> _
    Public Overrides ReadOnly Property IsDirty() As Boolean
        Get
            If MyBase.IsDirty = True Then Return True

            Return False
        End Get
    End Property

#End Region

#Region " EntityInserted "

    Public Overrides Sub EntityInserted()
        MyBase.EntityInserted()
    End Sub

    Public Overrides Sub EntityRemoved()
        MyBase.EntityRemoved()
    End Sub

#End Region

#Region " Instantiation "

    Public Sub New()
        MyBase.New()
    End Sub

    Public Shared Function Create() As LOG
        Dim Obj As New LOG

        With Obj
            .Validation.ValidateAll()
            .MarkNew()
        End With

        Return Obj
    End Function

#End Region

#Region " Business Methods "

    Public Shared Function Load(ByVal aID As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As LOG
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aDS As DataSet, aDR As DataRow
        Dim aResult As New LOG()
        Dim aDB As ConnectionContextConnection

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CloseConnectionWhenTerminates = True
        End If

        aParams.Add(DB.CreateParameter("@ID", SqlDbType.Int, -1, ParameterDirection.Input, aID))

        aDS = DB.ReadDS_SP("SP_LOAD_LOG", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

        aDR = aDS.Tables(0).Rows(0)

        With aResult
            .p_ID = aDR("LO_ID")
            .p_ErrorPath = aDR("LO_ERRORPATH")
            .p_ErrorDescription = aDR("LO_ERRORDESCRIPTION")
            .p_Conc = aDR("LO_CONC")


            .MarkOld()
        End With

        If aDS IsNot Nothing Then aDS.Dispose()

        Return aResult
    End Function


    Public Function Persist(Optional ByVal aInsistIfClean As Boolean = True, Optional ByRef aConContext As ConnectionContext = Nothing) As LOG
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aDB As ConnectionContextConnection
        Dim aUseTransaction As Boolean
        Dim aCloseConnectionWhenTerminates As Boolean 
        Dim aCommitTransactionWhenTerminates As Boolean 

        If Me.IsValid = False Then
            Throw New Exception("The log entry is not in a valid state and hence, it cannot be persisted.")
        End If


        If Me.IsDirty = False AndAlso aInsistIfClean = False Then Return Me


        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        If Me.IsDeleted = True Then
            If Me.IsNew = False Then
                aParams.Add(DB.CreateParameter("@ID", SqlDbType.Int, -1, ParameterDirection.Input, p_ID))
                aParams.Add(DB.CreateParameter("@CONC", SqlDbType.Timestamp, -1, ParameterDirection.Input, p_Conc))
                aParams.Add(DB.CreateParameter("@VERIFYCONC", SqlDbType.Int, -1, ParameterDirection.Input, 1))

                If aConContext.Status = 0 Then
                    aConContext.UseTransaction = True
                    aConContext.CloseConnectionWhenTerminates = True
                    aConContext.CommitTransactionWhenTerminates = True
                End If

                DB.CUD_SP("SP_DELETE_LOG", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            End If

        Else 'Insert 
            aParams.Add(DB.CreateParameter("@ERRORPATH", SqlDbType.NVarChar, 100, ParameterDirection.Input, p_ErrorPath))
            aParams.Add(DB.CreateParameter("@ERRORDESCRIPTION", SqlDbType.NVarChar, 1000, ParameterDirection.Input, p_ErrorDescription))


            aUseTransaction = aConContext.UseTransaction
            aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates

            If aConContext.Status = 0 Then
                aConContext.UseTransaction = True
                aConContext.CloseConnectionWhenTerminates = False
                aConContext.CommitTransactionWhenTerminates = False
            End If

            aParams.Add(DB.CreateParameter("@ID", SqlDbType.Int, -1, ParameterDirection.Output))
            aParams.Add(DB.CreateParameter("@CONC", SqlDbType.Timestamp, -1, ParameterDirection.Output))

            DB.CUD_SP("SP_INSERT_LOG", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            p_ID = CInt(aParams(2).Value)


            'Get the new Conc value
            aParams = New List(Of SqlClient.SqlParameter)
            aParams.Add(DB.CreateParameter("@ID", SqlDbType.Int, -1, ParameterDirection.Input, p_ID))
            If aConContext.Status = 0 Then
                aConContext.UseTransaction = True
                aConContext.CloseConnectionWhenTerminates = True
                aConContext.CommitTransactionWhenTerminates = True
            Else
                aConContext.UseTransaction = aUseTransaction
                aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates
            End If

            p_Conc = DB.ReadValue_SP("SP_GETVERSION_LOG", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aUseTransaction, aCommitTransactionWhenTerminates, aCloseConnectionWhenTerminates)

            Me.CompletePersist()
        End If

        Return Me
    End Function


    Friend Sub CompletePersist()
        Me.MarkOld()
    End Sub


    Public Shared Function GetConcurrency(ByVal aID As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As Object
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aResult As Object
        Dim aDB As ConnectionContextConnection

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        aParams = New List(Of SqlClient.SqlParameter)
        aParams.Add(DB.CreateParameter("@ID", SqlDbType.Int, -1, ParameterDirection.Input, aID))

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = True
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates = True
        End If

        aResult = DB.ReadValue_SP("SP_GETVERSION_LOG", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

        Return aResult
    End Function


    Public Shared Sub Remove(ByVal aID As Integer, Optional ByRef aConContext As ConnectionContext = Nothing)
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aDB As ConnectionContextConnection

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = True
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates = True
        End If

        aParams.Add(DB.CreateParameter("@ID", SqlDbType.Int, -1, ParameterDirection.Input, aID))

        DB.CUD_SP("SP_REMOVE_LOG", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
    End Sub


    Public Shared Function DTLookup(Optional ByVal aSQLSelect As String = "", Optional ByRef aConContext As ConnectionContext = Nothing) As DataTable
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aResult As DataTable
        Dim aDB As ConnectionContextConnection

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CloseConnectionWhenTerminates = True
        End If

        aParams.Add(DB.CreateParameter("@SQLSELECT", SqlDbType.NVarChar, 4000, ParameterDirection.Input, aSQLSelect))

        aResult = DB.ReadDT_SP("SP_LOOKUP", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

        Return aResult
    End Function

    Public Shared Function DSLookup(Optional ByVal aSQLSelect As String = "", Optional ByRef aConContext As ConnectionContext = Nothing) As DataSet
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aResult As DataSet
        Dim aDB As ConnectionContextConnection

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CloseConnectionWhenTerminates = True
        End If

        aParams.Add(DB.CreateParameter("@SQLSELECT", SqlDbType.NVarChar, 4000, ParameterDirection.Input, aSQLSelect))

        aResult = DB.ReadDS_SP("SP_LOOKUP", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

        Return aResult
    End Function



    'Internet
    Public Shared Function I_LookupDT(Optional ByVal aSQLWhere As String = "", Optional ByVal aSIndex As Integer = 0, Optional ByVal aPageSize As Integer = -1, Optional ByRef aConContext As ConnectionContext = Nothing) As DataTable
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aDB As ConnectionContextConnection
        Dim aResult As DataTable

        aParams = New List(Of SqlClient.SqlParameter)

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CloseConnectionWhenTerminates = True
        End If

        Dim aUIndex As Integer

        aSIndex += 1
        If aPageSize = -1 Then
            aUIndex = Integer.MaxValue
        Else
            aUIndex = aSIndex + aPageSize - 1
        End If

        If aSQLWhere = "" Then
            aSQLWhere = "Select LO_ID AS ID, LO_ERRORPATH As ErrorPath, LO_ERRORDESCRIPTION As ErrorDescription, LO_CONC As Conc From (Select LO_ID, LO_ERRORPATH, LO_ERRORDESCRIPTION, LO_CONC, ROW_NUMBER() OVER (ORDER BY LO_ID) As RowNum From LOG e) As DTN Where RowNum Between " & aSIndex & " AND " & aUIndex
        Else
            aSQLWhere = "Select LO_ID AS ID, LO_ERRORPATH As ErrorPath, LO_ERRORDESCRIPTION As ErrorDescription, LO_CONC As Conc From (Select LO_ID, LO_ERRORPATH, LO_ERRORDESCRIPTION, LO_CONC, ROW_NUMBER() OVER (ORDER BY LO_ID) As RowNum From LOG e Where " & aSQLWhere & ") As DTN Where RowNum Between " & aSIndex & " AND " & aUIndex
        End If

        aResult = DB.ReadDT_Text(aSQLWhere, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

        aResult.Columns.Add("IsNew", GetType(Boolean))
        aResult.Columns.Add("ClassError", GetType(String))

        Return aResult
    End Function

    Public Shared Function I_Lookup(Optional ByVal aSQLWhere As String = "", Optional ByVal aSIndex As Integer = 0, Optional ByVal aPageSize As Integer = -1, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of LOG)
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aDB As ConnectionContextConnection
        Dim aDT As DataTable, aDR As DataRow
        Dim aObj As LOG
        Dim aResult As New List(Of LOG)

        aParams = New List(Of SqlClient.SqlParameter)

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CloseConnectionWhenTerminates = True
        End If

        Dim aUIndex As Integer

        aSIndex += 1
        If aPageSize = -1 Then
            aUIndex = Integer.MaxValue
        Else
            aUIndex = aSIndex + aPageSize - 1
        End If

        If aSQLWhere = "" Then
            aSQLWhere = "Select LO_ID AS ID, LO_ERRORPATH As ErrorPath, LO_ERRORDESCRIPTION As ErrorDescription, LO_CONC As Conc From (Select LO_ID, LO_ERRORPATH, LO_ERRORDESCRIPTION, LO_CONC, ROW_NUMBER() OVER (ORDER BY LO_ID) As RowNum From LOG e) As DTN Where RowNum Between " & aSIndex & " AND " & aUIndex
        Else
            aSQLWhere = "Select LO_ID AS ID, LO_ERRORPATH As ErrorPath, LO_ERRORDESCRIPTION As ErrorDescription, LO_CONC As Conc From (Select LO_ID, LO_ERRORPATH, LO_ERRORDESCRIPTION, LO_CONC, ROW_NUMBER() OVER (ORDER BY LO_ID) As RowNum From LOG e Where " & aSQLWhere & ") As DTN Where RowNum Between " & aSIndex & " AND " & aUIndex
        End If

        aDT = DB.ReadDT_Text(aSQLWhere, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

        For Each aDR In aDT.Rows
            aObj = LOG.Create()

            With aObj
                .ErrorPath = aDR("ErrorPath")
                .ErrorDescription = aDR("ErrorDescription")
                .Conc = aDR("Conc")

                .MarkOld()

                aResult.Add(aObj)
            End With
        Next

        Return aResult
    End Function

    Public Shared Function I_Count(Optional ByVal aSQLWhere As String = "", Optional ByRef aConContext As ConnectionContext = Nothing) As Integer
        Dim aParams As New List(Of SqlClient.SqlParameter)
        Dim aDB As ConnectionContextConnection
        Dim aResult As Integer

        aParams = New List(Of SqlClient.SqlParameter)

        If aConContext Is Nothing Then aConContext = New ConnectionContext

        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CloseConnectionWhenTerminates = True
        End If

        aResult = DB.ReadValue_Text("Select Count(*) From Log", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

        Return aResult
    End Function

#End Region

End Class


<Serializable()> _
Public Class Traffic

    Public Shared Sub Track(ByVal aSource As String, ByVal aReferer As String)
        Dim aParams As List(Of SqlClient.SqlParameter)
        Dim aDB As ConnectionContextConnection
        Dim aConContext As ConnectionContext
        aConContext = New ConnectionContext
        aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

     
        If Len(aSource) = 0 Then aSource = ""
        If Len(aReferer) = 0 Then aReferer = ""

        If aConContext.Status = 0 Then
            aConContext.UseTransaction = False
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates = True
        End If

        aParams = New List(Of SqlClient.SqlParameter)

        aParams.Add(DB.CreateParameter("@ID", SqlDbType.Int, -1, ParameterDirection.Output))
        aParams.Add(DB.CreateParameter("@SOURCE", SqlDbType.NVarChar, 100, ParameterDirection.Input, aSource))
        aParams.Add(DB.CreateParameter("@REFERER", SqlDbType.NVarChar, 1000, ParameterDirection.Input, aReferer))

        DB.CUD_SP("SP_INSERT_TRAFFIC", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

    End Sub

End Class