Imports Microsoft.VisualBasic
Imports System.Web.Mail
Imports System.Collections.Generic
Imports System.Data
Imports PDF, PDF.DAL, PDF.DAL.MSSQL
Imports System.Security
Imports System.Security.Cryptography
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Text.RegularExpressions
Imports System.Text


Public Enum BOModeEnum
    NewMode = 1
    EditMode = 2
End Enum


Public Enum SortOrderEnum
    ASC = 1
    DESC = 2
End Enum


Public Enum PageAreaLockTypeEnum
    ClientAreaLock = 1
    PasswordAreaLock = 2
End Enum


Public Enum PageTypeEnum
    HTML = 1
    PhotoGallery = 2
    Download = 3
    News = 4
    Link = 5
    Parliament = 6
    Committee = 7
    [Delegate] = 8
End Enum

Public Enum PageOperationEnum
    Create = 1
    Publish = 2
    UnPublish = 3
    Delete = 4
    Save = 5
End Enum

Public Enum PagePermissionEnum
    Create = 1
    Publish = 2
    UnPublish = 3
    Delete = 4
End Enum


Public Enum StandalonePermissionEnum
    Clients = 21
    ClientAreaLock = 22
    PasswordAreaLock = 23
    Security = 24
    Parliament = 25
End Enum


<Serializable()> _
Public Class PairedItem

    'Fields
    Protected p_ID As Integer = 0, p_Title As String = ""


    'Properties
    Public Property ID() As Integer
        Get
            Return p_ID
        End Get
        Set(ByVal value As Integer)
            p_ID = value
        End Set
    End Property


    Public Property Title() As String
        Get
            Return p_Title
        End Get
        Set(ByVal value As String)
            p_Title = value
        End Set
    End Property


    'Constructors
    Public Sub New()

    End Sub

    Public Sub New(ByVal aID As Integer, ByVal aTitle As String)
        p_ID = aID
        p_Title = aTitle
    End Sub

End Class



<Serializable()> _
Public Class PairedInteger

    'Fields
    Protected p_Val1 As Integer = 0, p_Val2 As Integer = 0


    'Properties
    Public Property Val1() As Integer
        Get
            Return p_Val1
        End Get
        Set(ByVal value As Integer)
            p_Val1 = value
        End Set
    End Property


    Public Property Val2() As Integer
        Get
            Return p_Val2
        End Get
        Set(ByVal value As Integer)
            p_Val2 = value
        End Set
    End Property


    'Constructors
    Public Sub New()

    End Sub

    Public Sub New(ByVal aVal1 As Integer, ByVal aVal2 As Integer)
        p_Val1 = aVal1
        p_Val2 = aVal2
    End Sub

End Class



<Serializable()> _
Public Class StringMisc
    'Pierre


    Public Shared Function RemoveAtLebanonMail(ByVal aStr As String) As String
        Dim s As String = ""

        If aStr Is Nothing Then Return ""

        s = Replace(aStr, "Advertise@advertiselebanon.com", "")

        Return s
    End Function



    Public Shared Function GetMailFromString(ByVal aFileName As String) As String
        Dim a As Integer, b As Integer, L As Integer
        Dim aSubStr As String = "", aSubStr2 As String = ""

        'aFileName = RemoveAdvLebEmail(aFileName)

        b = StringMisc.GetLastIndex(aFileName)

        If b = 0 Then Return ""

        aSubStr = Trim(Left(aFileName, b))
        aSubStr2 = Trim(Left(aFileName, b - 7))

        a = StringMisc.GetFirstIndex(aSubStr2)

        L = aSubStr.Length
        If L > 0 Then
            aSubStr = Trim(Right(aSubStr, L - a - 1))
        End If

        Return aSubStr
    End Function

    Public Shared Function GetFirstIndex(ByVal aFileName As String, Optional aLen As Integer = 0) As Integer
        Dim i As Integer, aResult As Integer = 0

        i = aFileName.LastIndexOf(":")

        If i <= 0 Then
            i = aFileName.LastIndexOf(".")
        End If
        If i <= 0 Then
            i = aFileName.LastIndexOf("<")
        End If
        If i <= 0 Then
            i = aFileName.LastIndexOf(" ")
        End If
        If i <= 0 Then Return 0


        If i > 0 Then aResult = i

        Return aResult
    End Function

    Public Shared Function GetLastIndex(ByVal aFileName As String) As Integer
        Dim i As Integer, aResult As Integer = 0

        i = aFileName.IndexOf(".com")

        If i <= 0 Then
            i = aFileName.IndexOf(".net")
        End If
        If i <= 0 Then
            i = aFileName.IndexOf(".org")
        End If
        If i <= 0 Then
            i = aFileName.IndexOf(".edu")
        End If
        If i <= 0 Then Return 0


        If i > 0 Then aResult = i + 7

        Return aResult
    End Function


    Public Shared Function RemoveAdvLebEmail(ByVal aStr As String) As String
        Return aStr.Replace("Advertise@advertiseLebanon.com", "")
    End Function

    'Leo
    Public Function getEmailFromBody(body As String) As String
        Dim i As Integer = body.IndexOf("@win06")
        Dim j As Integer, k As Integer
        Dim c As Char

        If i >= 0 Then
            i = body.IndexOf("@", i + 6)
        Else
            i = body.IndexOf("@")
        End If


        If i <= 0 Then
            Return ""
        End If

        k = i - 1
        c = System.Convert.ToChar(body.Substring(k, 1))

        While k >= 0 AndAlso (Char.IsLetterOrDigit(c) OrElse c = "_"c OrElse c = "."c OrElse c = "-"c)
            k -= 1
            If k >= 0 Then
                c = System.Convert.ToChar(body.Substring(k, 1))
            End If
        End While


        j = i + 1
        c = System.Convert.ToChar(body.Substring(j, 1))

        While j <= (body.Length - 1) AndAlso (Char.IsLetterOrDigit(c) OrElse c = "_"c OrElse c = "."c OrElse c = "-"c)
            j += 1

            If j < body.Length Then
                c = System.Convert.ToChar(body.Substring(j, 1))
            End If
        End While

        If k >= 0 AndAlso j > k Then
            Return (body.Substring(k + 1, j - k - 1)).Trim()
        Else
            Return ""
        End If
    End Function


    Public Shared Function HandleQuotation(ByVal aStr As String) As String
        If aStr Is Nothing OrElse IsDBNull(aStr) Then aStr = ""

        Return Replace(aStr, "'", "''")
    End Function

    Public Shared Function TrimStrLen(ByVal aStr As String, aLen As String) As String
        If aStr Is Nothing OrElse IsDBNull(aStr) Then aStr = ""

        Return Left(aStr, aLen)
    End Function

    Public Shared Function FormatPhoneCellNb(ByVal aStr As String) As String
        Dim TmpStr As String = ""

        If aStr Is Nothing OrElse IsDBNull(aStr) Then
            Return ""
        Else
            TmpStr = aStr.Replace(" ", "")
            TmpStr = TmpStr.Replace("/", "")
            TmpStr = TmpStr.Replace("-", "")
            TmpStr = TmpStr.Replace("+", "00")
        End If

        Return TmpStr
    End Function

    Public Shared Function FormatPrice(ByVal aStr As String) As String
        Dim TmpStr As String = ""

        If aStr Is Nothing OrElse IsDBNull(aStr) Then
            Return ""
        Else
            TmpStr = aStr.Replace("000", "k")
        End If

        Return TmpStr
    End Function

    Public Shared Function FixQuote(ByVal aStr As String) As String
        FixQuote = aStr.Replace("'", "''")
    End Function

    Public Shared Function StringOccurences(ByVal aText As String, ByVal aSearch As String) As Integer
        Dim i, j, k As Integer
        Dim aResult As Integer = 0

        If aText Is Nothing OrElse aText.Trim = "" Then Return 0

        If aSearch Is Nothing OrElse aSearch.Trim = "" Then Return 0

        i = aText.Length
        j = 0

        While j <= i
            k = aText.IndexOf(aSearch, j)

            If k >= 0 Then
                aResult += 1

                j = k + 1
            Else
                Return aResult
            End If
        End While


        Return aResult
    End Function


    Public Shared Function SplitOnDash(ByVal aStr As String) As String
        Dim s(1) As String

        If Len(aStr.ToString.Trim) = 0 OrElse IsDBNull(aStr) Then
            Return ""
            Exit Function
        End If

        If aStr.ToString.IndexOf("-") < 1 Then
            Return aStr
            Exit Function
        End If

        s = aStr.ToString.Split("-")

        Return s(0)
    End Function

    Public Shared Sub SplitOnDash(ByVal aStr As String, ByRef aStr1 As String, ByRef aStr2 As String)
        Dim s(1) As String

        If Len(aStr.ToString.Trim) = 0 OrElse IsDBNull(aStr) Then
            Exit Sub
        End If

        If aStr.ToString.IndexOf("-") < 1 Then
            Exit Sub
        End If

        s = aStr.ToString.Split("-")

        aStr1 = s(0)
        aStr2 = s(1)
    End Sub

    Public Shared Sub SplitOnArrow(ByVal aStr As String, ByRef aStr1 As String, ByRef aStr2 As String)
        Dim s(1) As String

        If Len(aStr.ToString.Trim) = 0 OrElse IsDBNull(aStr) Then
            Exit Sub
        End If

        If aStr.ToString.IndexOf("-") < 1 Then
            Exit Sub
        End If

        s = aStr.ToString.Split("-")

        aStr1 = s(0)
        aStr2 = s(1)
    End Sub


    Public Shared Function FixDBNull(ByVal aVal As Object) As Object

        If IsDBNull(aVal) = True Then
            Return "-"
        Else
            Return aVal
        End If

    End Function


    Public Shared Function GetFileExtension(ByVal aFileName As String) As String
        Dim i As Integer, aResult As String = ""

        i = aFileName.LastIndexOf(".")
        If i > 0 Then aResult = Right(aFileName, aFileName.Length - i - 1)

        Return aResult
    End Function

    Public Shared Function GetImageNameFromPath(ByVal aFileName As String) As String
        Dim i As Integer, aResult As String = ""

        i = InStr(aFileName, "\Client Resources\")
        If i > 0 Then aResult = Right(aFileName.Substring(i), aFileName.Length - i)

        Return aResult
    End Function

    Public Shared Function HandleSpecialChars(ByVal aStr As String) As String
        Dim s As String = ""

        If aStr Is Nothing Then Return ""

        s = Replace(aStr, "&", "-")
        s = Replace(s, "+", "-")
        s = Replace(s, "%", "-")

        Return s
    End Function


    Public Shared Function GetInfoPreview(ByVal plainText As String, aLen As Integer) As String
        Dim i As Integer = 0, aPreviewText As String = ""

        If Len(plainText.ToString.Trim) = 0 OrElse IsDBNull(plainText) Then
            Return ""
            Exit Function
        End If

        i = plainText.Length

        If aLen > i Then
            aPreviewText = plainText
        Else
            aPreviewText = Left(plainText, aLen)
        End If

        Return aPreviewText
    End Function

    Public Shared Function Encrypt(ByVal plainText As String) As String

        Dim passPhrase As String = "yourPassPhrase"
        Dim saltValue As String = "mySaltValue"
        Dim hashAlgorithm As String = "SHA1"

        Dim passwordIterations As Integer = 2
        Dim initVector As String = "@1B2c3D4e5F6g7H8"
        Dim keySize As Integer = 256

        Dim initVectorBytes As Byte() = Encoding.ASCII.GetBytes(initVector)
        Dim saltValueBytes As Byte() = Encoding.ASCII.GetBytes(saltValue)

        Dim plainTextBytes As Byte() = Encoding.UTF8.GetBytes(plainText)


        Dim password As New PasswordDeriveBytes(passPhrase, saltValueBytes, hashAlgorithm, passwordIterations)

        Dim keyBytes As Byte() = password.GetBytes(keySize \ 8)
        Dim symmetricKey As New RijndaelManaged()

        symmetricKey.Mode = CipherMode.CBC

        Dim encryptor As ICryptoTransform = symmetricKey.CreateEncryptor(keyBytes, initVectorBytes)

        Dim memoryStream As New MemoryStream()
        Dim cryptoStream As New CryptoStream(memoryStream, encryptor, CryptoStreamMode.Write)

        cryptoStream.Write(plainTextBytes, 0, plainTextBytes.Length)
        cryptoStream.FlushFinalBlock()
        Dim cipherTextBytes As Byte() = memoryStream.ToArray()
        memoryStream.Close()
        cryptoStream.Close()
        Dim cipherText As String = Convert.ToBase64String(cipherTextBytes)
        Return cipherText
    End Function

    Public Shared Function Decrypt(ByVal cipherText As String) As String
        Dim passPhrase As String = "yourPassPhrase"
        Dim saltValue As String = "mySaltValue"
        Dim hashAlgorithm As String = "SHA1"

        Dim passwordIterations As Integer = 2
        Dim initVector As String = "@1B2c3D4e5F6g7H8"
        Dim keySize As Integer = 256
        ' Convert strings defining encryption key characteristics into byte
        ' arrays. Let us assume that strings only contain ASCII codes.
        ' If strings include Unicode characters, use Unicode, UTF7, or UTF8
        ' encoding.
        Dim initVectorBytes As Byte() = Encoding.ASCII.GetBytes(initVector)
        Dim saltValueBytes As Byte() = Encoding.ASCII.GetBytes(saltValue)

        ' Convert our ciphertext into a byte array.
        Dim cipherTextBytes As Byte() = Convert.FromBase64String(cipherText)

        ' First, we must create a password, from which the key will be 
        ' derived. This password will be generated from the specified 
        ' passphrase and salt value. The password will be created using
        ' the specified hash algorithm. Password creation can be done in
        ' several iterations.
        Dim password As New PasswordDeriveBytes(passPhrase, saltValueBytes, hashAlgorithm, passwordIterations)

        ' Use the password to generate pseudo-random bytes for the encryption
        ' key. Specify the size of the key in bytes (instead of bits).
        Dim keyBytes As Byte() = password.GetBytes(keySize \ 8)

        ' Create uninitialized Rijndael encryption object.
        Dim symmetricKey As New RijndaelManaged()

        ' It is reasonable to set encryption mode to Cipher Block Chaining
        ' (CBC). Use default options for other symmetric key parameters.
        symmetricKey.Mode = CipherMode.CBC

        ' Generate decryptor from the existing key bytes and initialization 
        ' vector. Key size will be defined based on the number of the key 
        ' bytes.
        Dim decryptor As ICryptoTransform = symmetricKey.CreateDecryptor(keyBytes, initVectorBytes)

        ' Define memory stream which will be used to hold encrypted data.
        Dim memoryStream As New MemoryStream(cipherTextBytes)

        ' Define cryptographic stream (always use Read mode for encryption).
        Dim cryptoStream As New CryptoStream(memoryStream, decryptor, CryptoStreamMode.Read)

        ' Since at this point we don't know what the size of decrypted data
        ' will be, allocate the buffer long enough to hold ciphertext;
        ' plaintext is never longer than ciphertext.
        Dim plainTextBytes As Byte() = New Byte(cipherTextBytes.Length - 1) {}

        ' Start decrypting.
        Dim decryptedByteCount As Integer = cryptoStream.Read(plainTextBytes, 0, plainTextBytes.Length)

        ' Close both streams.
        memoryStream.Close()
        cryptoStream.Close()

        ' Convert decrypted data into a string. 
        ' Let us assume that the original plaintext string was UTF8-encoded.
        Dim plainText As String = Encoding.UTF8.GetString(plainTextBytes, 0, decryptedByteCount)

        ' Return decrypted string.   
        Return plainText
    End Function




End Class

<Serializable()> _
Public Class PictureUtils

    Public Shared Function FixPhotoPath(ByVal aPath As String) As String

        If StringIsNotEmpty(aPath) Then
            Return Replace(Replace(aPath, "\", "/"), " ", "%20")
        Else
            Return ""
        End If
        
    End Function


    Public Shared Function RelativePathFromPhysical(ByVal aPhysicalPath As String) As String
        Dim i As Integer

        i = aPhysicalPath.LastIndexOf("Client Resources")

        If i < 0 Then
            Return ""
        Else
            'Return Replace(Replace(aPhysicalPath.Substring(i), "\", "/"), " ", "%20")
            Return FixPhotoPath(aPhysicalPath.Substring(i))
        End If
    End Function

End Class

