﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports PDF.DAL.MSSQL
Imports Utils
Imports System.Collections.Generic

Namespace BackEnd
    Public Class Owner2

        Public Id As Integer
        Public Name As String
        Public CoName As String
        Public Cell As String
        Public Phone As String
        Public Email As String
        Public Address As String
        Public IsActive As Boolean
        Public Agent As Integer 
        Public Notes As String
        Public Info As String 
        Public CreatedOn As DateTime
        Public CreatedBy As Integer

        Public Shared Function Load(ByVal aId As Integer, ByRef aTagsIds As String, ByRef aTagsTitles As String, Optional ByRef aConContext As ConnectionContext = Nothing) As Owner2 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet, aDT As DataTable , aDRow As DataRow
            Dim aSQL As String = ""   
            Dim aResult As New Owner2 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            'Get Source Name and Property Type Name
            aSQL = "Select * From Tbl_Owner Where OR_ID=" & aId & "; "
            
            aSQL &= "Select TG_ID As Id, TG_NAME As Name From Tbl_OwnerTag T1 Inner Join Tbl_Tag T2 on T1.OT_TAG=T2.TG_ID Where T1.OT_OWNER=" & aId & "; "

            aParams = New List(Of SqlClient.SqlParameter)

            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

            aDT = aDS.Tables(0)
            If aDT Is Nothing OrElse aDT.Rows.Count <1 Then Throw New Exception("Invalid Owner specified.")

            aDRow = aDT.Rows(0)

            With aResult
                .Id = aDRow("OR_ID")
                .Name = aDRow("OR_Name")
                .CoName = aDRow("OR_CoName")
                .Cell = aDRow("OR_Cell")
                .Phone=aDRow("OR_Phone")
                .Email=aDRow("OR_Email")
                .Address=aDRow("OR_Address")
                .IsActive=aDRow("OR_IsActive")
                .Agent=aDRow("OR_Agent")
                .Notes=aDRow("OR_Notes")
                .Info=aDRow("OR_Info")
                .CreatedOn = aDRow("OR_PostDate")
                .CreatedBy = aDRow("OR_CreatedBy")
            End With                 

            'Tags
            aTagsIds = ""
            aTagsTitles = ""

            aDT = aDS.Tables(1)
            If aDT.Rows.Count > 0 Then
                For Each aDRow In aDT.Rows
                    aTagsIds &= "," & aDRow("ID")
                    aTagsTitles &= "," & aDRow("NAME")
                Next

                aTagsIds = aTagsIds.Substring(1)
                aTagsTitles = aTagsTitles.Substring(1)
            End if

            Return aResult 
        End Function 

        Public Shared Sub Create (ByRef aObj As Owner2, aTagsIds As String, aTagsTitles As String, aUser As FrontEnd.User, Optional ByRef  aConContext As ConnectionContext = Nothing)
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aUseTransaction As Boolean, aCommitTransactionWhenTerminates As Boolean, aCloseConnectionWhenTerminates As Boolean 
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aSQL As String = ""   
            Dim aDT As DataTable 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aUseTransaction = aConContext.UseTransaction
                aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates
                aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates 

                aConContext.UseTransaction = aUseTransaction Or False 'Or My Setting 
                aConContext.CommitTransactionWhenTerminates = False 'My Setting
                aConContext.CloseConnectionWhenTerminates = False 'My Setting
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            'Clean Phone and cell
            aObj.Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)
            if aObj.Phone IsNot Nothing Then aObj.Phone = Utils.Utils.CleanPhoneNumber(aObj.Phone)

            'Make sure that if phone exists, it is different than cell
            If aObj.Cell = aObj.Phone Then Throw New Exception("The phone must be different than the cell.")

            'Make sure no other owner nor p. owner has the same phone nor cell
            '[Start With Owners]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("OR_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The owner that you specified is already registered.")
                ElseIf aDT.Rows(0)("OR_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("OR_AGENT") = aUser.ID Then
                   Throw New Exception("An owner ( " & aDT.Rows(0)("OR_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Throw New Exception("An owner with the same cell/phone is already registered.")
                End If
            End If

            '[Now P.O]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone <> "" Then
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("PO_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The owner that you specified is already registered as a potential owner.")
                ElseIf aDT.Rows(0)("PO_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("PO_AGENT") = aUser.ID Then
                   Throw New Exception("A potential owner ( " & aDT.Rows(0)("PO_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Throw New Exception("A potential owner with the same cell/phone is already registered.")
                End If
            End If

            With aObj 
                'Update Phase       
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Insert Into Tbl_Owner (OR_Name, OR_COName, OR_Cell, OR_Email, OR_Phone, OR_Address, OR_Agent, OR_PostDate, OR_Notes, OR_Info, OR_ISActive, OR_CreatedBy) Values(N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "',N'" & Utils.Utils.FixQuotes(.CoName.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Cell.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Email) & "', N'" & Utils.Utils.FixQuotes(.Phone) & "', N'" & Utils.Utils.FixQuotes(.Address) & "', " & .Agent & ",'" & .CreatedOn & "',N'" & Utils.Utils.FixQuotes(.Notes) & "',N'" & Utils.Utils.FixQuotes(.Info) & "', '" & .IsActive & "'," & .CreatedBy & ")"
                DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

                'Read Owner Id
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 OR_ID From Tbl_Owner Where OR_Name Like N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "' Order By OR_ID DESC"
                .Id = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Handle the tags
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim().Length > 0 AndAlso aTagsTitles IsNot Nothing AndAlso aTagsTitles.Trim().Length > 0 Then
                    Dim aTagsIdsArr As String () = aTagsIds.Split(",")
                    Dim aTagsTitlesArr As String() = aTagsTitles.Split(",")
                    Dim aStrId, aStrTitle As String
                    Dim aTagId As Object

                    If aTagsIdsArr.Length > 0 Then
                        For i As Integer = 0 To aTagsIdsArr.Length - 1
                            aStrId = aTagsIds(i)
                            aStrTitle = aTagsTitlesArr(i).Trim()

                            'Check if there exists a tag with that title after trimming and case insensitive
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE LTRIM(RTRIM(LOWER(TG_NAME))) LIKE N'" & Utils.Utils.FixQuotes(aStrTitle.ToLower()) & "';"
                            aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                            If aTagId Is Nothing Then
                                'Create the tag and get its id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Insert Into TBL_Tag(TG_NAME) VALUES(N'" & Utils.Utils.FixQuotes(aStrTitle) & "') ;"
                                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                                'Read id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE TG_NAME LIKE N'" & Utils.Utils.FixQuotes(aStrTitle) & "';"
                                aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                            End If

                            'Insert Into Tbl_ClientRequestTag
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Insert Into TBL_OwnerTag(OT_OWNER, OT_TAG) VALUES(" & aObj.Id & "," & CInt(aTagId) & ") ;"
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        Next
                    End If
                End If

                'Last DB Operation
                'My Settings
                aConContext.CommitTransactionWhenTerminates = False 
                aConContext.CloseConnectionWhenTerminates = True

                If aIsConnectionPassed = True Then
                    If aUseTransaction = False Then
                        aConContext.CommitTransactionWhenTerminates = False 'My Setting
                    Else
                        aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates 
                    End If

                    aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                End If 

                'Read the Owner Id
                aConContext.CommitTransactionWhenTerminates = True
                aConContext.CloseConnectionWhenTerminates=True

                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 OR_ID From Tbl_Owner Where OR_Name Like N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "' Order By OR_ID DESC"
                DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
            End With
        End Sub

        Public Shared Sub Update (ByRef aObj As Owner2, aTagsIds As String, aTagsTitles As String, aUser As FrontEnd.User, Optional ByRef  aConContext As ConnectionContext = Nothing)
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aUseTransaction As Boolean, aCommitTransactionWhenTerminates As Boolean, aCloseConnectionWhenTerminates As Boolean 
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aSQL As String = ""   
            Dim aDT As DataTable 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aUseTransaction = aConContext.UseTransaction
                aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates
                aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates 

                aConContext.UseTransaction = aUseTransaction Or False 'Or My Setting 
                aConContext.CommitTransactionWhenTerminates = False 'My Setting
                aConContext.CloseConnectionWhenTerminates = False 'My Setting
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            'Clean Phone and cell
            aObj.Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)
            if aObj.Phone IsNot Nothing Then aObj.Phone = Utils.Utils.CleanPhoneNumber(aObj.Phone)

            'Make sure that if phone exists, it is different than cell
            If aObj.Cell = aObj.Phone Then Throw New Exception("The phone must be different than the cell.")

            'Make sure no other owner nor p. owner has the same phone nor cell
            '[Start With Owners]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_ID<>" & aObj.Id & " AND (OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "')"
            Else
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_ID<>" & aObj.Id & " AND (OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "')"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("OR_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The owner that you specified is already registered.")
                ElseIf aDT.Rows(0)("OR_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("OR_AGENT") = aUser.ID Then
                   Throw New Exception("An owner ( " & aDT.Rows(0)("OR_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Throw New Exception("An owner with the same cell/phone is already registered.")
                End If
            End If


            '[Now P.O.]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("PO_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The owner that you specified is already registered as a potential owner.")
                ElseIf aDT.Rows(0)("PO_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("PO_AGENT") = aUser.ID Then
                   Throw New Exception("A potential owner ( " & aDT.Rows(0)("PO_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Throw New Exception("A potential owner with the same cell/phone is already registered.")
                End If
            End If


            With aObj 
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Update Tbl_Owner Set OR_Name=N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "', OR_COName=N'" & Utils.Utils.FixQuotes(.CoName) & "', OR_Cell=N'" & Utils.Utils.FixQuotes(.Cell) & "', OR_Email=N'" & Utils.Utils.FixQuotes(.Email) & "', OR_Phone=N'" & Utils.Utils.FixQuotes(.Phone) & "',"
                aSQL &="OR_Address=N'" & Utils.Utils.FixQuotes(.Address) & "', OR_Agent=" & .Agent & ", OR_PostDate='" & .CreatedOn & "', OR_Notes=N'" & Utils.Utils.FixQuotes(.Notes) & "', OR_Info=N'" & Utils.Utils.FixQuotes(.Info) & "', OR_ISActive='" & .IsActive & "', OR_CreatedBy=" & .CreatedBy & " Where OR_ID=" & .id
                DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)


                'Handle the tags
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Delete From Tbl_OwnerTag Where OT_Owner=" & aObj.Id & ";"
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim().Length > 0 AndAlso aTagsTitles IsNot Nothing AndAlso aTagsTitles.Trim().Length > 0 Then
                    Dim aTagsIdsArr As String () = aTagsIds.Split(",")
                    Dim aTagsTitlesArr As String() = aTagsTitles.Split(",")
                    Dim aStrId, aStrTitle As String
                    Dim aTagId As Object

                    If aTagsIdsArr.Length > 0 Then
                        For i As Integer = 0 To aTagsIdsArr.Length - 1
                            aStrId = aTagsIds(i)
                            aStrTitle = aTagsTitlesArr(i).Trim()

                            'Check if there exists a tag with that title after trimming and case insensitive
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE LTRIM(RTRIM(LOWER(TG_NAME))) LIKE N'" & Utils.Utils.FixQuotes(aStrTitle.ToLower()) & "';"
                            aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                            If aTagId Is Nothing Then
                                'Create the tag and get its id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Insert Into TBL_Tag(TG_NAME) VALUES(N'" & Utils.Utils.FixQuotes(aStrTitle) & "') ;"
                                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                                'Read id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE TG_NAME LIKE N'" & Utils.Utils.FixQuotes(aStrTitle) & "';"
                                aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                            End If

                            'Insert Into Tbl_ClientRequestTag
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Insert Into TBL_OwnerTag(OT_OWNER, OT_TAG) VALUES(" & aObj.Id & "," & CInt(aTagId) & ") ;"
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        Next
                    End If
                End If

                'Update Phase
                'Last DB Operation
                'My Settings
                aConContext.CommitTransactionWhenTerminates = False 
                aConContext.CloseConnectionWhenTerminates = True

                If aIsConnectionPassed = True Then
                   If aUseTransaction = False Then
                      aConContext.CommitTransactionWhenTerminates = False 'My Setting
                   Else
                      aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates 
                   End If

                   aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                End If 
        
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 OR_ID From Tbl_Owner Where OR_Name Like N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "' Order By OR_ID DESC"
                DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
            End With
        End Sub

        Public Shared Function GetFormLookups(Optional ByRef aConContext As ConnectionContext = Nothing) As DataSet
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            Dim aSQL As String = "Select UR_ID As ID, UR_Name As Title From Tbl_USER  Where UR_ISAGENT='true' Order By UR_Name;"

            aParams = New List(Of SqlClient.SqlParameter)
            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            Return aDS
        End Function

        Public Shared Function GetOwnersWhoseNamesStartWith(name As string, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringBoolean) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringBoolean)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If aUserId = 0 Then 
                aSQL = "Select Top 15 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE OR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' Order By OR_NAME, OR_POSTDATE"
            Else
                aSQL = "Select Top 15 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE OR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (OR_AGENT=" & aUserId & " OR OR_AGENT=0 OR OR_ID IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) Order By OR_NAME, OR_POSTDATE"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerStringStringStringBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("AGENT"), aDRow("ISACTIVE")))
            Next

            Return aResult
        End Function

        Public Shared Function GetOwnersWhoseNamesOrPhonesStartWith(name As string, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringBoolean) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringBoolean)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            Dim aPhone As String = Utils.Utils.CleanPhoneNumber(name)

            If IsNumeric(aPhone) = True Then
                If aUserId = 0 Then 
                    aSQL = "Select Top 15 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR OR_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' Order By OR_NAME, OR_POSTDATE"
                Else
                    aSQL = "Select Top 15 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE (OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR OR_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%') AND (OR_AGENT=" & aUserId & " OR OR_AGENT=0 OR OR_ID IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) Order By OR_NAME, OR_POSTDATE"
                End If
            Else
                If aUserId = 0 Then 
                    aSQL = "Select Top 15 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE OR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' Order By OR_NAME, OR_POSTDATE"
                Else
                    aSQL = "Select Top 15 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE OR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (OR_AGENT=" & aUserId & " OR OR_AGENT=0 OR OR_ID IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) Order By OR_NAME, OR_POSTDATE"
                End If
            End If 

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerStringStringStringBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("AGENT"), aDRow("ISACTIVE")))
            Next

            Return aResult
        End Function

        Public Shared Function GetOwnersAndPropertyOwnersWhoseNamesOrPhonesStartWith(name As string, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringBooleanInteger) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringBooleanInteger)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            Dim aPhone As String = Utils.Utils.CleanPhoneNumber(name)

            If IsNumeric(aPhone) = True Then
                If aUserId = 0 Then 
                    aSQL = "Select Top 10 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE, 2 As OwnerType  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR OR_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' "
                    aSQL &= " UNION Select Top 10 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE, 1 As OwnerType FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR PO_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' ORDER BY NAME"
                Else
                    aSQL = "Select Top 10 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE, 2 As OwnerType FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE (OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR OR_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%') AND (OR_AGENT=" & aUserId & " OR OR_AGENT=0 OR OR_ID IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) "
                    aSQL &= " UNION Select Top 10 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE, 1 As OwnerType FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE (PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR PO_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%') AND (PO_AGENT=" & aUserId & " OR PO_AGENT=0) Order By NAME"
                End If
            Else
                If aUserId = 0 Then 
                    aSQL = "Select Top 10 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE, 2 As OwnerType  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE OR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                    aSQL &=" UNION Select Top 10 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE, 1 As OwnerType FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE PO_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' Order By NAME"

                Else
                    aSQL = "Select Top 10 OR_ID as ID, OR_NAME AS NAME, OR_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, OR_IsActive As ISACTIVE, 2 As OwnerType  FROM TBL_OWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.OR_AGENT=T2.UR_ID WHERE OR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (OR_AGENT=" & aUserId & " OR OR_AGENT=0 OR OR_ID IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) "
                    aSQL &= "UNION Select Top 10 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE, 1 As OwnerType FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE PO_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (PO_AGENT=" & aUserId & " OR PO_AGENT=0) Order By NAME"
                End If
            End If 

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerStringStringStringBooleanInteger (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("AGENT"), aDRow("ISACTIVE"), aDRow("OwnerType")))
            Next

            Return aResult
        End Function

    End Class

End Namespace

