﻿Imports Microsoft.VisualBasic
Imports System.Data, system.Data.SqlClient, System.Collections.Generic, System.ComponentModel
Imports PDF, PDF.DAL, PDF.DAL.MSSQL
Imports Utils

Namespace BackEnd

    Public Class PhoneBook

        Public Shared Function GetNamesStartingWith(name As string, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerString) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerString)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If aUserId = 0 Then 
                aSQL = "Select Top 8 CT_ID as ID, CT_NAME AS NAME  FROM TBL_CLIENT WHERE CT_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                aSQL &= " Union Select Top 8 OR_ID as ID, OR_NAME AS NAME  FROM TBL_OWNER  WHERE OR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                aSQL &= " Union Select Top 8 PO_ID as ID, PO_NAME AS NAME  FROM TBL_PotentialOWNER  WHERE PO_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                aSQL &= " Union Select Top 8 UR_ID as ID, UR_NAME AS NAME  FROM TBL_USER  WHERE UR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                aSQL &= "Order By NAME"
            Else
                aSQL = "Select Top 8 CT_ID as ID, CT_NAME AS NAME  FROM TBL_CLIENT WHERE CT_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                aSQL &= " Union Select Top 8 OR_ID as ID, OR_NAME AS NAME  FROM TBL_OWNER  WHERE OR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (OR_AGENT=" & aUserId & " OR OR_AGENT=0 OR OR_ID IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) "
                aSQL &= " Union Select Top 8 PO_ID as ID, PO_NAME AS NAME  FROM TBL_PotentialOWNER  WHERE PO_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (PO_AGENT=" & aUserId & " OR PO_AGENT=0) "
                aSQL &= " Union Select Top 8 UR_ID as ID, UR_NAME AS NAME  FROM TBL_USER  WHERE UR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                aSQL &= "Order By NAME"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerString (aDRow("ID"), aDRow("NAME")))
            Next

            Return aResult
        End Function


        Public Shared Function SearchByName(name As string, aTagsIds As String, aTagsAnd As Boolean, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringStringStringIntegerStringString) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringStringStringIntegerStringString)
            Dim aTagsTitles As String=""
            Dim aTagsArr As String()

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If aUserId = 0 Then 
                aSQL = "Select 'Client' As Type, CT_ID as ID, CT_NAME AS NAME, CT_NAME AS CONAME, CT_CELL AS CELL, CT_PHONE AS PHONE, CT_EMAIL AS EMAIL, CT_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_CLIENTTAG T INNER JOIN TBL_TAG TG ON T.CT_TAG = TG.TG_ID WHERE T1.CT_ID = T.CT_CLIENT ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_CLIENT T1 WHERE CT_NAME Like N'" & Utils.Utils.FixQuotes(name) & "%' "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND CT_ID In (Select CT_CLIENT FROM TBL_CLIENTTAG WHERE CT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND CT_ID In (Select CT_CLIENT FROM TBL_CLIENTTAG WHERE CT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'Owner' As Type, OR_ID as ID, OR_NAME AS NAME, OR_CONAME AS CONAME, OR_CELL AS CELL, OR_PHONE AS PHONE, OR_EMAIL AS EMAIL, OR_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_OWNERTAG T INNER JOIN TBL_TAG TG ON T.OT_TAG = TG.TG_ID WHERE T1.OR_ID = T.OT_OWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &=" FROM TBL_OWNER T1 WHERE OR_NAME Like N'" & Utils.Utils.FixQuotes(name) & "%' "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'P. Owner' As Type, PO_ID as ID, PO_NAME AS NAME, PO_CONAME AS CONAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_POTENTIALOWNERTAG T INNER JOIN TBL_TAG TG ON T.PT_TAG = TG.TG_ID WHERE T1.PO_ID = T.PT_POTENTIALOWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_PotentialOWNER T1 WHERE PO_NAME Like N'" & Utils.Utils.FixQuotes(name) & "%' "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'User' As Type, UR_ID as ID, UR_NAME AS NAME, '' AS CONAME, UR_CELL AS CELL, UR_PHONE AS PHONE, UR_EMAIL AS EMAIL, UR_ISACTIVE AS ISACTIVE, '' As TagsTitles  FROM TBL_USER  WHERE UR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                aSQL &= " Order By NAME"
            Else
                aSQL = "Select 'Client' As Type, CT_ID as ID, CT_NAME AS NAME, CT_NAME AS CONAME, CT_CELL AS CELL, CT_PHONE AS PHONE, CT_EMAIL AS EMAIL, CT_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_CLIENTTAG T INNER JOIN TBL_TAG TG ON T.CT_TAG = TG.TG_ID WHERE T1.CT_ID = T.CT_CLIENT ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_CLIENT T1 WHERE CT_NAME Like N'" & Utils.Utils.FixQuotes(name) & "%' "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND CT_ID In (Select CT_CLIENT FROM TBL_CLIENTTAG WHERE CT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND CT_ID In (Select CT_CLIENT FROM TBL_CLIENTTAG WHERE CT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'Owner' As Type, OR_ID as ID, OR_NAME AS NAME, OR_CONAME AS CONAME, OR_CELL AS CELL, OR_PHONE AS PHONE, OR_EMAIL AS EMAIL, OR_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_OWNERTAG T INNER JOIN TBL_TAG TG ON T.OT_TAG = TG.TG_ID WHERE T1.OR_ID = T.OT_OWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_OWNER T1 WHERE OR_NAME Like N'" & Utils.Utils.FixQuotes(name) & "%' AND (OR_AGENT=" & aUserId & " OR OR_AGENT=0 OR OR_ID IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'P. Owner' As Type, PO_ID as ID, PO_NAME AS NAME, PO_CONAME AS CONAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_POTENTIALOWNERTAG T INNER JOIN TBL_TAG TG ON T.PT_TAG = TG.TG_ID WHERE T1.PO_ID = T.PT_POTENTIALOWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_PotentialOWNER T1 WHERE PO_NAME Like N'" & Utils.Utils.FixQuotes(name) & "%' AND (PO_AGENT=" & aUserId & " OR PO_AGENT=0) "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'User' As Type, UR_ID as ID, UR_NAME AS NAME, '' AS CONAME, UR_CELL AS CELL, UR_PHONE AS PHONE, UR_EMAIL AS EMAIL, UR_ISACTIVE AS ISACTIVE, '' As TagsTitles  FROM TBL_USER  WHERE UR_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' "
                aSQL &= " Order By NAME"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)


            For Each aDRow As DataRow In aDT.Rows 
                If IsDbNull(aDRow("TagsTitles")) Then
                    aTagsTitles = ""
                ElseIf aDRow("TagsTitles").ToString().Length>35 Then
                    aTagsTitles = aDRow("TagsTitles").ToString().Substring(0,35)
                Else
                    aTagsTitles = aDRow("TagsTitles")
                End If

                aResult.Add(New Utils.IntegerStringStringStringStringStringIntegerStringString (aDRow("ID"), aDRow("NAME"),aDRow("CONAME"), aDRow("CELL"), aDRow("Phone"),aDRow("EMAIL"), aDRow("ISACTIVE"), aDRow("Type"), aTagsTitles))
            Next


            Return aResult
        End Function


        Public Shared Function SearchByPhone(phone As string, aTagsIds As String, aTagsAnd As String, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringStringStringIntegerStringString) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aTagsTitles As String = ""
            Dim aTagsArr As String()
            Dim aResult As New List(Of Utils.IntegerStringStringStringStringStringIntegerStringString)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If aUserId = 0 Then 
                aSQL = "Select 'Client' As Type, CT_ID as ID, CT_NAME AS NAME, CT_NAME AS CONAME, CT_CELL AS CELL, CT_PHONE AS PHONE, CT_EMAIL AS EMAIL, CT_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_CLIENTTAG T INNER JOIN TBL_TAG TG ON T.CT_TAG = TG.TG_ID WHERE T1.CT_ID = T.CT_CLIENT ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_CLIENT T1 WHERE (CT_CELL Like N'" & Utils.Utils.FixQuotes(phone) & "' OR CT_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND CT_ID In (Select CT_CLIENT FROM TBL_CLIENTTAG WHERE CT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND CT_ID In (Select CT_CLIENT FROM TBL_CLIENTTAG WHERE CT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'Owner' As Type, OR_ID as ID, OR_NAME AS NAME, OR_CONAME AS CONAME, OR_CELL AS CELL, OR_PHONE AS PHONE, OR_EMAIL AS EMAIL, OR_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_OWNERTAG T INNER JOIN TBL_TAG TG ON T.OT_TAG = TG.TG_ID WHERE T1.OR_ID = T.OT_OWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_OWNER T1 WHERE (OR_CELL Like N'" & Utils.Utils.FixQuotes(phone) & "' OR OR_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'P. Owner' As Type, PO_ID as ID, PO_NAME AS NAME, PO_CONAME AS CONAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_POTENTIALOWNERTAG T INNER JOIN TBL_TAG TG ON T.PT_TAG = TG.TG_ID WHERE T1.PO_ID = T.PT_POTENTIALOWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_PotentialOWNER T1 WHERE (PO_CELL Like N'" & Utils.Utils.FixQuotes(phone) & "' OR PO_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'User' As Type, UR_ID as ID, UR_NAME AS NAME, '' AS CONAME, UR_CELL AS CELL, UR_PHONE AS PHONE, UR_EMAIL AS EMAIL, UR_ISACTIVE AS ISACTIVE, '' As TagsTitles  FROM TBL_USER  WHERE UR_CELL LIKE N'" & Utils.Utils.FixQuotes(phone) & "' OR UR_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "' "
                aSQL &= "Order By NAME"
            Else
                aSQL = "Select 'Client' As Type, CT_ID as ID, CT_NAME AS NAME, CT_NAME AS CONAME, CT_CELL AS CELL, CT_PHONE AS PHONE, CT_EMAIL AS EMAIL, CT_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_CLIENTTAG T INNER JOIN TBL_TAG TG ON T.CT_TAG = TG.TG_ID WHERE T1.CT_ID = T.CT_CLIENT ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_CLIENT T1 WHERE (CT_CELL Like N'" & Utils.Utils.FixQuotes(phone) & "' OR CT_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND CT_ID In (Select CT_CLIENT FROM TBL_CLIENTTAG WHERE CT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND CT_ID In (Select CT_CLIENT FROM TBL_CLIENTTAG WHERE CT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'Owner' As Type, OR_ID as ID, OR_NAME AS NAME, OR_CONAME AS CONAME, OR_CELL AS CELL, OR_PHONE AS PHONE, OR_EMAIL AS EMAIL, OR_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_OWNERTAG T INNER JOIN TBL_TAG TG ON T.OT_TAG = TG.TG_ID WHERE T1.OR_ID = T.OT_OWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_OWNER T1 WHERE (OR_CELL Like N'" & Utils.Utils.FixQuotes(phone) & "' OR OR_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') AND (OR_AGENT=" & aUserId & " OR OR_AGENT=0 OR OR_ID IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'Owner' As Type, 0 as ID, '' AS NAME, '' AS CONAME, '' AS CELL, '' AS PHONE, '' AS EMAIL, OR_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_OWNERTAG T INNER JOIN TBL_TAG TG ON T.OT_TAG = TG.TG_ID WHERE T1.OR_ID = T.OT_OWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_OWNER T1 WHERE (OR_CELL Like N'" & Utils.Utils.FixQuotes(phone) & "' OR OR_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') AND (OR_AGENT<>" & aUserId & " AND OR_AGENT<>0 AND OR_ID NOT IN (Select Distinct PR_OWNER From TBL_Property Where PR_AGENTID=" & aUserId & ")) "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND OR_ID In (Select OT_OWNER FROM TBL_OWNERTAG WHERE OT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'P. Owner' As Type, PO_ID as ID, PO_NAME AS NAME, PO_CONAME AS CONAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_POTENTIALOWNERTAG T INNER JOIN TBL_TAG TG ON T.PT_TAG = TG.TG_ID WHERE T1.PO_ID = T.PT_POTENTIALOWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_PotentialOWNER T1 WHERE (PO_CELL Like N'" & Utils.Utils.FixQuotes(phone) & "' OR PO_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') AND (PO_AGENT=" & aUserId & " OR PO_AGENT=0) "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'P. Owner' As Type, 0 as ID, '' AS NAME, '' AS CONAME, '' AS CELL, '' AS PHONE, '' AS EMAIL, PO_ISACTIVE AS ISACTIVE "
                aSQL &= ", TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_POTENTIALOWNERTAG T INNER JOIN TBL_TAG TG ON T.PT_TAG = TG.TG_ID WHERE T1.PO_ID = T.PT_POTENTIALOWNER ORDER BY TG.TG_NAME FOR XML PATH ('')), 1, 1, '') "
                aSQL &= " FROM TBL_PotentialOWNER T1 WHERE (PO_CELL Like N'" & Utils.Utils.FixQuotes(phone) & "' OR PO_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') AND (PO_AGENT<>" & aUserId & " AND PO_AGENT<>0) "
                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then 
                    If aTagsAnd = False Then
                        aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG IN (" & aTagsIds & ")) "
                    Else
                        aTagsArr = aTagsIds.Split(",")
                        If aTagsArr IsNot Nothing AndAlso aTagsArr.Length > 0 Then
                            For Each aStr As String In aTagsArr 
                                aSQL &= " AND PO_ID In (Select PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG =" & aStr & ") "
                            Next
                        End If
                    End If
                End If

                aSQL &= " Union Select 'User' As Type, UR_ID as ID, UR_NAME AS NAME, '' AS CONAME, UR_CELL AS CELL, UR_PHONE AS PHONE, UR_EMAIL AS EMAIL, UR_ISACTIVE AS ISACTIVE, '' As TagsTitles  FROM TBL_USER  WHERE (UR_CELL LIKE N'" & Utils.Utils.FixQuotes(phone) & "' OR UR_PHONE LIKE N'" & Utils.Utils.FixQuotes(phone) & "') "

                aSQL &= "Order By NAME"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                If IsDbNull(aDRow("TagsTitles")) Then
                    aTagsTitles = ""
                ElseIf aDRow("TagsTitles").ToString().Length>35 Then
                    aTagsTitles = aDRow("TagsTitles").ToString().Substring(0,35)
                Else
                    aTagsTitles = aDRow("TagsTitles")
                End If

                aResult.Add(New Utils.IntegerStringStringStringStringStringIntegerStringString (aDRow("ID"), aDRow("NAME"),aDRow("CONAME"), aDRow("CELL"), aDRow("Phone"),aDRow("EMAIL"), aDRow("ISACTIVE"), aDRow("Type"), aTagsTitles))
            Next

            Return aResult
        End Function

    End Class

End Namespace 
