﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports PDF.DAL.MSSQL
Imports Utils
Imports System.Collections.Generic

Namespace BackEnd
    Public Class PotentialOwner2

        Public Id As Integer
        Public Name As String
        Public CoName As String
        Public Cell As String
        Public Phone As String
        Public Email As String
        Public Address As String
        Public IsActive As Boolean
        Public Agent As Integer 
        Public Notes As String
        Public Info As String 
        Public CreatedOn As DateTime
        Public CreatedBy As Integer

        Public Shared Function Load(ByVal aId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As PotentialOwner2
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable , aDRow As DataRow
            Dim aSQL As String = ""   
            Dim aResult As New PotentialOwner2 
            
            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            'Get Source Name and Property Type Name
            aSQL = "Select * From Tbl_PotentialOwner Where PO_ID=" & aId

            aParams = New List(Of SqlClient.SqlParameter)

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

            If (aDT.Rows.Count = 0) Then Throw New Exception("Invalid potential owner specified.")

            aDRow = aDT.Rows(0)

            With aResult
                .Id = aDRow("PO_ID")
                .Name = aDRow("PO_Name")
                .CoName = aDRow("PO_CoName")
                .Cell = aDRow("PO_Cell")
                .Phone=aDRow("PO_Phone")
                .Email=aDRow("PO_Email")
                .Address=aDRow("PO_Address")
                .IsActive=aDRow("PO_IsActive")
                .Agent=aDRow("PO_Agent")
                .Notes=aDRow("PO_Notes")
                .Info=aDRow("PO_Info")
                .CreatedOn = aDRow("PO_PostDate")
                .CreatedBy = aDRow("PO_CreatedBy")
            End With                 

            Return aResult 
        End Function 

        Public Shared Function LoadApi(ByVal aId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As ApiResultPotentialOwnerData 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet, aDT As DataTable , aDRow As DataRow, aDRow2 As DataRow 
            Dim aSQL As String = ""   
            Dim aResult As New ApiResultPotentialOwnerData ()
            
            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            'Get Source Name and Property Type Name
            aSQL = "Select * From Tbl_PotentialOwner Where PO_ID=" & aId & "; "

            aSQL &= "Select TG_ID As Id, TG_NAME As Name From Tbl_PotentialOwnerTag T1 Inner Join Tbl_Tag T2 on T1.PT_TAG=T2.TG_ID Where T1.PT_POTENTIALOWNER=" & aId & "; "

            aParams = New List(Of SqlClient.SqlParameter)

            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

            aDT = aDS.Tables(0)

            If (aDT is Nothing OrElse  aDT.Rows.Count < 1) Then Throw New Exception("Invalid potential owner specified.")

            aDRow = aDT.Rows(0)
            
            aResult.Data = New PotentialOwnerData(aDRow("PO_ID"), aDRow("PO_NAME"),aDRow("PO_CONAME"), aDRow("PO_CELL"), aDRow("PO_PHONE"), aDRow("PO_EMAIL"), aDRow("PO_ADDRESS"), aDRow("PO_ISACTIVE"), aDRow("PO_AGENT"),aDRow("PO_NOTES"), aDRow("PO_INFO"), aDRow("PO_CreatedBy"), aDRow("PO_PostDate"), "", "")
            
            'Tags
            Dim aTagsIds As String = ""
            Dim aTagsTitles As String = ""

            aDT = aDS.Tables(1)
            If aDT.Rows.Count > 0 Then
                For Each aDRow In aDT.Rows
                    aTagsIds &= "," & aDRow("ID")
                    aTagsTitles &= "," & aDRow("NAME")
                Next

                aTagsIds = aTagsIds.Substring(1)
                aTagsTitles = aTagsTitles.Substring(1)
            End if

            aResult.Data.TagsIds = aTagsIds
            aResult.Data.TagsTitles = aTagsTitles 

            Return aResult 
        End Function 


        Public Shared Sub Create (ByRef aObj As PotentialOwner2, aUser As FrontEnd.User, Optional ByRef  aConContext As ConnectionContext = Nothing)
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aUseTransaction As Boolean, aCommitTransactionWhenTerminates As Boolean, aCloseConnectionWhenTerminates As Boolean 
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable 
            Dim aSQL As String = ""   

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aUseTransaction = aConContext.UseTransaction
                aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates
                aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates 

                aConContext.UseTransaction = aUseTransaction Or False 'Or My Setting 
                aConContext.CommitTransactionWhenTerminates = False 'My Setting
                aConContext.CloseConnectionWhenTerminates = False 'My Setting
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            'Clean Phone and cell
            aObj.Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)
            if aObj.Phone IsNot Nothing Then aObj.Phone = Utils.Utils.CleanPhoneNumber(aObj.Phone)

            'Make sure that if phone exists, it is different than cell
            If aObj.Cell = aObj.Phone Then Throw New Exception("The phone must be different than the cell.")

            'Make sure no other owner nor p. owner has the same phone nor cell
            '[Start With P.O]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone <> "" Then
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("PO_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The potential owner that you specified is already registered.")
                ElseIf aDT.Rows(0)("PO_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("PO_AGENT") = aUser.ID Then
                   Throw New Exception("A potential owner ( " & aDT.Rows(0)("PO_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Throw New Exception("A potential owner with the same cell/phone is already registered.")
                End If
            End If

            '[Now Owners]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("OR_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The potential owner that you specified is already registered as an owner.")
                ElseIf aDT.Rows(0)("OR_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("OR_AGENT") = aUser.ID Then
                   Throw New Exception("An owner ( " & aDT.Rows(0)("OR_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Throw New Exception("An owner with the same cell/phone is already registered.")
                End If
            End If

            With aObj 
                'Update Phase       
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Insert Into Tbl_PotentialOwner (PO_Name, PO_COName, PO_Cell, PO_Email, PO_Phone, PO_Address, PO_Agent, PO_PostDate, PO_Notes, PO_Info, PO_ISActive, PO_CreatedBy) Values(N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "',N'" & Utils.Utils.FixQuotes(.CoName.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Cell.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Email) & "', N'" & Utils.Utils.FixQuotes(.Phone) & "', N'" & Utils.Utils.FixQuotes(.Address) & "', " & .Agent & ",'" & .CreatedOn & "',N'" & Utils.Utils.FixQuotes(.Notes) & "',N'" & Utils.Utils.FixQuotes(.Info) & "', '" & .IsActive & "'," & .CreatedBy & ")"
                DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

                'Last DB Operation
                'My Settings
                aConContext.CommitTransactionWhenTerminates = False 
                aConContext.CloseConnectionWhenTerminates = True

                If aIsConnectionPassed = True Then
                    If aUseTransaction = False Then
                        aConContext.CommitTransactionWhenTerminates = False 'My Setting
                    Else
                        aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates 
                    End If

                    aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                End If 

                'Read the Potential Owner Id 
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 PO_ID From Tbl_PotentialOwner Where PO_Name Like N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "' Order By PO_ID DESC"
                .Id = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
            End With
        End Sub

        Public Shared Function CreateApi (ByRef aObj As PotentialOwnerData , aUser As FrontEnd.User, Optional ByRef  aConContext As ConnectionContext = Nothing) As ApiResponse
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aUseTransaction As Boolean, aCommitTransactionWhenTerminates As Boolean, aCloseConnectionWhenTerminates As Boolean 
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable 
            Dim aSQL As String = ""   

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aUseTransaction = aConContext.UseTransaction
                aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates
                aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates 

                aConContext.UseTransaction = aUseTransaction Or False 'Or My Setting 
                aConContext.CommitTransactionWhenTerminates = False 'My Setting
                aConContext.CloseConnectionWhenTerminates = False 'My Setting
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            'Clean Phone and cell
            aObj.Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)
            if aObj.Phone IsNot Nothing Then aObj.Phone = Utils.Utils.CleanPhoneNumber(aObj.Phone)

            'Make sure name and cell are provided
            If aObj.Name.Trim() = "" Then Return New ApiResponse (False, 0, "The name must be provided.")

            If aObj.Cell.Trim() = "" Then Return New ApiResponse (False, 0, "The cell must be provided.")


            'Make sure that if phone exists, it is different than cell
            If aObj.Cell = aObj.Phone Then Return New ApiResponse (False, 0, "The phone must be different than the cell.")

            'Make sure no other owner nor p. owner has the same phone nor cell
            '[Start With P.O]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone <> "" Then
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("PO_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Return New ApiResponse (False, 0, "The potential owner that you specified is already registered.")
                ElseIf aDT.Rows(0)("PO_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("PO_AGENT") = aUser.ID Then
                   Return New ApiResponse (False, 0, "A potential owner ( " & aDT.Rows(0)("PO_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Return New ApiResponse (False, 0, "A potential owner with the same cell/phone is already registered.")
                End If
            End If

            '[Now Owners]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("OR_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Return New ApiResponse (False, 0, "The potential owner that you specified is already registered as an owner.")
                ElseIf aDT.Rows(0)("OR_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("OR_AGENT") = aUser.ID Then
                   Return New ApiResponse (False, 0, "An owner ( " & aDT.Rows(0)("OR_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Return New ApiResponse (False, 0, "An owner with the same cell/phone is already registered.")
                End If
            End If

            With aObj 
                'Update Phase       
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Insert Into Tbl_PotentialOwner (PO_Name, PO_COName, PO_Cell, PO_Email, PO_Phone, PO_Address, PO_Agent, PO_PostDate, PO_Notes, PO_Info, PO_ISActive, PO_CreatedBy) Values(N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "',N'" & Utils.Utils.FixQuotes(.CoName.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Cell.Trim()) & "', N'" & Utils.Utils.FixQuotes(.Email) & "', N'" & Utils.Utils.FixQuotes(.Phone) & "', N'" & Utils.Utils.FixQuotes(.Address) & "', " & .AgentId & ",'" & .CreatedOn & "',N'" & Utils.Utils.FixQuotes(.Notes) & "',N'" & Utils.Utils.FixQuotes(.Info) & "', '" & .IsActive & "'," & .CreatedBy & ")"
                DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

                'Read the Potential Owner Id 
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 PO_ID From Tbl_PotentialOwner Where PO_Name Like N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "' Order By PO_ID DESC"
                .Id = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            


                'Handle the tags
                Dim aTagsIds As String = .TagsIds
                Dim aTagsTitles As String = .TagsTitles

                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim().Length > 0 AndAlso aTagsTitles IsNot Nothing AndAlso aTagsTitles.Trim().Length > 0 Then
                    Dim aTagsIdsArr As String () = aTagsIds.Split(",")
                    Dim aTagsTitlesArr As String() = aTagsTitles.Split(",")
                    Dim aStrId, aStrTitle As String
                    Dim aTagId As Object

                    If aTagsIdsArr.Length > 0 Then
                        For i As Integer = 0 To aTagsIdsArr.Length - 1
                            aStrId = aTagsIds(i)
                            aStrTitle = aTagsTitlesArr(i).Trim()

                            'Check if there exists a tag with that title after trimming and case insensitive
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE LTRIM(RTRIM(LOWER(TG_NAME))) LIKE N'" & Utils.Utils.FixQuotes(aStrTitle.ToLower()) & "';"
                            aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                            If aTagId Is Nothing Then
                                'Create the tag and get its id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Insert Into TBL_Tag(TG_NAME) VALUES(N'" & Utils.Utils.FixQuotes(aStrTitle) & "') ;"
                                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                                'Read id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE TG_NAME LIKE N'" & Utils.Utils.FixQuotes(aStrTitle) & "';"
                                aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                            End If

                            'Insert Into Tbl_ClientRequestTag
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Insert Into TBL_PotentialOwnerTag(PT_POTENTIALOWNER, PT_TAG) VALUES(" & aObj.Id & "," & CInt(aTagId) & ") ;"
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        Next
                    End If
                End If

                'Last DB Operation
                'My Settings
                aConContext.CommitTransactionWhenTerminates = False 
                aConContext.CloseConnectionWhenTerminates = True

                If aIsConnectionPassed = True Then
                    If aUseTransaction = False Then
                        aConContext.CommitTransactionWhenTerminates = False 'My Setting
                    Else
                        aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates 
                    End If

                    aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                End If 

                'Read the Potential Owner Id 
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 PO_ID From Tbl_PotentialOwner Where PO_ID=" & .Id 
                DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
            End With

            Return New ApiResultPotentialOwnerData(True, New PotentialOwnerData (aObj.Id), 0, "")
        End Function


        Public Shared Sub Update (ByRef aObj As PotentialOwner2, aUser As FrontEnd.User, Optional ByRef  aConContext As ConnectionContext = Nothing)
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aUseTransaction As Boolean, aCommitTransactionWhenTerminates As Boolean, aCloseConnectionWhenTerminates As Boolean 
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable 
            Dim aSQL As String = ""   

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aUseTransaction = aConContext.UseTransaction
                aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates
                aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates 

                aConContext.UseTransaction = aUseTransaction Or False 'Or My Setting 
                aConContext.CommitTransactionWhenTerminates = False 'My Setting
                aConContext.CloseConnectionWhenTerminates = False 'My Setting
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            'Clean Phone and cell
            aObj.Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)
            if aObj.Phone IsNot Nothing Then aObj.Phone = Utils.Utils.CleanPhoneNumber(aObj.Phone)

            'Make sure that if phone exists, it is different than cell
            If aObj.Cell = aObj.Phone Then Throw New Exception("The phone must be different than the cell.")

            'Make sure no other owner nor p. owner has the same phone nor cell
            '[Start With P.O]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_ID<>" & aObj.Id & " AND (PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "')"
            Else
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_ID<>" & aObj.Id & " AND (PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "')"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("PO_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The potential owner that you specified is already registered.")
                ElseIf aDT.Rows(0)("PO_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("PO_AGENT") = aUser.ID Then
                   Throw New Exception("A potential owner ( " & aDT.Rows(0)("PO_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Throw New Exception("A potential owner with the same cell/phone is already registered.")
                End If
            End If

            '[Now Owners]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("OR_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Throw New Exception("The potential owner that you specified is already registered as an owner.")
                ElseIf aDT.Rows(0)("OR_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("OR_AGENT") = aUser.ID Then
                   Throw New Exception("An owner ( " & aDT.Rows(0)("OR_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Throw New Exception("An owner with the same cell/phone is already registered.")
                End If
            End If


            With aObj 
                'Update Phase
                'Last DB Operation
                'My Settings
                aConContext.CommitTransactionWhenTerminates = False 
                aConContext.CloseConnectionWhenTerminates = True

                If aIsConnectionPassed = True Then
                   If aUseTransaction = False Then
                      aConContext.CommitTransactionWhenTerminates = False 'My Setting
                   Else
                      aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates 
                   End If

                   aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                End If 
        
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Update Tbl_PotentialOwner Set PO_Name=N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "', PO_COName=N'" & Utils.Utils.FixQuotes(.CoName) & "', PO_Cell=N'" & Utils.Utils.FixQuotes(.Cell) & "', PO_Email=N'" & Utils.Utils.FixQuotes(.Email) & "', PO_Phone=N'" & Utils.Utils.FixQuotes(.Phone) & "',"
                aSQL &="PO_Address=N'" & Utils.Utils.FixQuotes(.Address) & "', PO_Agent=" & .Agent & ", PO_PostDate='" & .CreatedOn & "', PO_Notes=N'" & Utils.Utils.FixQuotes(.Notes) & "', PO_Info=N'" & Utils.Utils.FixQuotes(.Info) & "', PO_ISActive='" & .IsActive & "', PO_CreatedBy=" & .CreatedBy & " Where PO_ID=" & .id
                DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            End With
        End Sub

        Public Shared Function UpdateApi (ByRef aObj As PotentialOwnerData, aUser As FrontEnd.User, Optional ByRef  aConContext As ConnectionContext = Nothing) As ApiResponse 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aUseTransaction As Boolean, aCommitTransactionWhenTerminates As Boolean, aCloseConnectionWhenTerminates As Boolean 
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable 
            Dim aSQL As String = ""   

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aUseTransaction = aConContext.UseTransaction
                aCommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates
                aCloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates 

                aConContext.UseTransaction = aUseTransaction Or False 'Or My Setting 
                aConContext.CommitTransactionWhenTerminates = False 'My Setting
                aConContext.CloseConnectionWhenTerminates = False 'My Setting
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            'Clean Phone and cell
            aObj.Cell = Utils.Utils.CleanPhoneNumber(aObj.Cell)
            if aObj.Phone IsNot Nothing Then aObj.Phone = Utils.Utils.CleanPhoneNumber(aObj.Phone)

            'Make sure name and cell are provided
            If aObj.Name.Trim() = "" Then Return New ApiResponse (False, 0, "The name must be provided.")

            If aObj.Cell.Trim() = "" Then Return New ApiResponse (False, 0, "The cell must be provided.")

            'Make sure that if phone exists, it is different than cell
            If aObj.Cell = aObj.Phone Then Return New ApiResponse (False, 0, "The phone must be different than the cell.")

            'Make sure no other owner nor p. owner has the same phone nor cell
            '[Start With P.O]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_ID<>" & aObj.Id & " AND (PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "')"
            Else
                aSQL = "Select PO_ID, PO_NAME, PO_Agent From Tbl_PotentialOwner Where PO_ID<>" & aObj.Id & " AND (PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or PO_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "')"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("PO_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Return New ApiResponse (False, 0, "The potential owner that you specified is already registered.")
                ElseIf aDT.Rows(0)("PO_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("PO_AGENT") = aUser.ID Then
                   Return New ApiResponse (False, 0, "A potential owner ( " & aDT.Rows(0)("PO_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Return New ApiResponse (False, 0, "A potential owner with the same cell/phone is already registered.")
                End If
            End If

            '[Now Owners]
            aParams = New List(Of SqlClient.SqlParameter)

            If aObj.Phone.Trim() <> "" Then
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' OR OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Phone) & "'"
            Else
                aSQL = "Select OR_ID, OR_NAME, OR_Agent From Tbl_Owner Where OR_CELL LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "' Or OR_Phone LIKE N'" & Utils.Utils.FixQuotes(aObj.Cell) & "'"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
            If aDT.Rows.Count > 0 Then
                aConContext.CloseConnections()

                If aDT.Rows(0)("OR_NAME").ToString().Trim().ToLower() = aObj.Name.Trim().ToLower() Then
                    Return New ApiResponse (False, 0, "The potential owner that you specified is already registered as an owner.")
                ElseIf aDT.Rows(0)("OR_AGENT") = 0 OrElse aUser.IsAdmin = True OrElse aUser.IsSuperUser =True OrElse aDT.Rows(0)("OR_AGENT") = aUser.ID Then
                   Return New ApiResponse (False, 0, "An owner ( " & aDT.Rows(0)("OR_NAME").ToString().Trim() & " ) with the same cell/phone is already registered.")
                Else
                   Return New ApiResponse (False, 0, "An owner with the same cell/phone is already registered.")
                End If
            End If


            With aObj 
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Update Tbl_PotentialOwner Set PO_Name=N'" & Utils.Utils.FixQuotes(.Name.Trim()) & "', PO_COName=N'" & Utils.Utils.FixQuotes(.CoName) & "', PO_Cell=N'" & Utils.Utils.FixQuotes(.Cell) & "', PO_Email=N'" & Utils.Utils.FixQuotes(.Email) & "', PO_Phone=N'" & Utils.Utils.FixQuotes(.Phone) & "',"
                aSQL &="PO_Address=N'" & Utils.Utils.FixQuotes(.Address) & "', PO_Agent=" & .AgentId & ", PO_PostDate='" & .CreatedOn & "', PO_Notes=N'" & Utils.Utils.FixQuotes(.Notes) & "', PO_Info=N'" & Utils.Utils.FixQuotes(.Info) & "', PO_ISActive='" & .IsActive & "', PO_CreatedBy=" & .CreatedBy & " Where PO_ID=" & .Id
                DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)


                'Handle the tags
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Delete From Tbl_PotentialOwnerTag Where PT_PotentialOwner=" & aObj.Id & ";"
                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                Dim aTagsIds As String = .TagsIds
                Dim aTagsTitles As String = .TagsTitles

                If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim().Length > 0 AndAlso aTagsTitles IsNot Nothing AndAlso aTagsTitles.Trim().Length > 0 Then
                    Dim aTagsIdsArr As String () = aTagsIds.Split(",")
                    Dim aTagsTitlesArr As String() = aTagsTitles.Split(",")
                    Dim aStrId, aStrTitle As String
                    Dim aTagId As Object

                    If aTagsIdsArr.Length > 0 Then
                        For i As Integer = 0 To aTagsIdsArr.Length - 1
                            aStrId = aTagsIds(i)
                            aStrTitle = aTagsTitlesArr(i).Trim()

                            'Check if there exists a tag with that title after trimming and case insensitive
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE LTRIM(RTRIM(LOWER(TG_NAME))) LIKE N'" & Utils.Utils.FixQuotes(aStrTitle.ToLower()) & "';"
                            aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                            If aTagId Is Nothing Then
                                'Create the tag and get its id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Insert Into TBL_Tag(TG_NAME) VALUES(N'" & Utils.Utils.FixQuotes(aStrTitle) & "') ;"
                                DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            

                                'Read id
                                aParams = New List(Of SqlClient.SqlParameter)
                                aSQL = "Select TOP 1 TG_ID FROM TBL_TAG WHERE TG_NAME LIKE N'" & Utils.Utils.FixQuotes(aStrTitle) & "';"
                                aTagId = DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                            End If

                            'Insert Into Tbl_ClientRequestTag
                            aParams = New List(Of SqlClient.SqlParameter)
                            aSQL = "Insert Into TBL_PotentialOwnerTag(PT_POTENTIALOWNER, PT_TAG) VALUES(" & aObj.Id & "," & CInt(aTagId) & ") ;"
                            DB.CUD_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)            
                        Next
                    End If
                End If

                'Update Phase
                'Last DB Operation
                'My Settings
                aConContext.CommitTransactionWhenTerminates = False 
                aConContext.CloseConnectionWhenTerminates = True

                If aIsConnectionPassed = True Then
                   If aUseTransaction = False Then
                      aConContext.CommitTransactionWhenTerminates = False 'My Setting
                   Else
                      aConContext.CommitTransactionWhenTerminates = aCommitTransactionWhenTerminates 
                   End If

                   aConContext.CloseConnectionWhenTerminates = aCloseConnectionWhenTerminates
                End If 

                'Read the Potential Owner Id 
                aParams = New List(Of SqlClient.SqlParameter)
                aSQL = "Select Top 1 PO_ID From Tbl_PotentialOwner Where PO_ID=" & .Id 
                DB.ReadValue_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)                    
            End With

            Return New ApiResponse ()
        End Function


        Public Shared Function Activate (aId As Integer, aIsActive As Boolean ) As ApiResponse 
            Dim aConContext As ConnectionContext = Nothing 
            Dim aIsConnectionPassed As Boolean = false
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aSQL As String = ""   

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")                        

            aParams = New List(Of SqlClient.SqlParameter)

            aSQL = "Update Tbl_PotentialOwner Set PO_IsActive='" & aIsActive & "' Where PO_ID=" & aId 
            DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)      

            Return New ApiResponse()
        End Function

        Public Shared Function Delete (aId As Integer ) As ApiResponse 
            Dim aConContext As ConnectionContext = Nothing 
            Dim aIsConnectionPassed As Boolean = false
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aSQL As String = ""   

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")                       

            'Make sure no activity is created for the P.O. if so, throw exception
            aParams = New List(Of SqlClient.SqlParameter)
            aSQL = "Select Top 1 AC_ID From TBL_ACTIVITY WHERE AC_POTENTIALOWNERID=" & aId 
            Dim aDT As DataTable = DB.ReadDT_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)      
            If aDT IsNot Nothing AndAlso aDT.Rows.Count >= 1 Then
                aConContext.CloseConnections()
                Return New ApiResponse (False, 0, "Cannot delete the specified potential owner as one or more tasks are assigned to him/her.")
            End If

            'Do the deletion
            aParams = New List(Of SqlClient.SqlParameter)
            aSQL = "Delete From Tbl_PotentialOwner Where PO_ID=" & aId 
            DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)      

            Return New ApiResponse()
        End Function

        Public Shared Function TransformIntoOwner (aId As Integer ) As ApiResponse 
            Dim aConContext As ConnectionContext = Nothing 
            Dim aIsConnectionPassed As Boolean = false
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aSQL As String = ""   

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = True
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = False                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")                        


            'Do the Insert
            aParams = New List(Of SqlClient.SqlParameter)
            aSQL  = "INSERT INTO TBL_OWNER(OR_NAME, OR_CONAME, OR_CELL, OR_PHONE, OR_AGENT, OR_ADDRESS, OR_EMAIL, OR_NOTES, OR_INFO, OR_ISACTIVE, OR_POSTDATE, OR_CREATEDBY) "
		    aSQL &= "SELECT PO_NAME, PO_CONAME, PO_CELL, PO_PHONE, PO_AGENT, PO_ADDRESS, PO_EMAIL, PO_NOTES, PO_INFO, PO_ISACTIVE, PO_POSTDATE, PO_CREATEDBY FROM TBL_POTENTIALOWNER WHERE PO_ID = " & aId & "; "
            DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)      
            
            aParams = New List(Of SqlClient.SqlParameter)
            aSQL = "Select Top 1 OR_ID FROM TBL_OWNER ORDER BY OR_ID DESC; "
            Dim aOwnerId As Integer = DB.ReadValue_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)      

            'COPY THE TAGS
            aParams = New List(Of SqlClient.SqlParameter)
			aSQL = "INSERT INTO TBL_OWNERTAG (OT_OWNER, OT_TAG) SELECT " & aOwnerId & ", PT_TAG FROM TBL_POTENTIALOWNERTAG WHERE PT_POTENTIALOWNER=" & aId 
            DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            'TBL_ACTIVITY
            aParams = New List(Of SqlClient.SqlParameter)
            aSQL &= "UPDATE TBL_ACTIVITY SET AC_POTENTIALOWNERID=NULL, AC_OWNERID=" & aOwnerId & " WHERE AC_POTENTIALOWNERID=" & aId & "; "
            DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            'Terminate
            aConContext.CommitTransactionWhenTerminates = True
            aConContext.CloseConnectionWhenTerminates = True

            aParams = New List(Of SqlClient.SqlParameter)
            aSQL = "DELETE FROM TBL_POTENTIALOWNER WHERE PO_ID=" & aId 
            DB.CUD_Text (aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)      

            Return New ApiResponse()
        End Function


        Public Shared Function GetFormLookups(Optional ByRef aConContext As ConnectionContext = Nothing) As DataSet
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            Dim aSQL As String = "Select UR_ID As ID, UR_Name As Title From Tbl_USER Where UR_ISAGENT='True' Order By UR_Name;"

            aParams = New List(Of SqlClient.SqlParameter)
            aDS = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            Return aDS
        End Function

        Public Shared Function GetPotentialOwnersWhoseNamesStartWith(name As string, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringBoolean) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringBoolean)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If


            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            If aUserId = 0 Then 
                aSQL = "Select Top 15 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE PO_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' Order By PO_NAME, PO_POSTDATE"
            Else
                aSQL = "Select Top 15 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE PO_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (PO_AGENT=" & aUserId & " OR PO_AGENT=0) Order By PO_NAME, PO_POSTDATE"
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerStringStringStringBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("AGENT"), aDRow("ISACTIVE")))
            Next

            Return aResult
        End Function

        Public Shared Function GetPotentialOwnersWhoseNamesOrPhonesStartWith(name As string, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringBoolean) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringBoolean)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If


            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            Dim aPhone As String = Utils.Utils.CleanPhoneNumber(name)

            If IsNumeric(aPhone) = True Then
                If aUserId = 0 Then 
                    aSQL = "Select Top 15 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR PO_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' Order By PO_NAME, PO_POSTDATE"
                Else
                    aSQL = "Select Top 15 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE (PO_CELL LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%' OR PO_PHONE LIKE N'" & Utils.Utils.FixQuotes(aPhone) & "%') AND (PO_AGENT=" & aUserId & " OR PO_AGENT=0) Order By PO_NAME, PO_POSTDATE"
                End If
            Else
                If aUserId = 0 Then 
                    aSQL = "Select Top 15 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE PO_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' Order By PO_NAME, PO_POSTDATE"
                Else
                    aSQL = "Select Top 15 PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE PO_NAME LIKE N'" & Utils.Utils.FixQuotes(name) & "%' AND (PO_AGENT=" & aUserId & " OR PO_AGENT=0) Order By PO_NAME, PO_POSTDATE"
                End If
            End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                aResult.Add(New Utils.IntegerStringStringStringBoolean (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("AGENT"), aDRow("ISACTIVE")))
            Next

            Return aResult
        End Function

        Public Shared Function Search(aIsActive As integer, aTagsIds As String, aTagsAnd As Boolean, aAgentId As integer, aUserId As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Utils.IntegerStringStringStringStringStringIntegerString) 
            Dim aIsConnectionPassed As Boolean = aConContext IsNot Nothing
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = "", aWhere As String = ""
            Dim aResult As New List(Of Utils.IntegerStringStringStringStringStringIntegerString)

            If aUserId =- 1 Then Return aResult 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                'My settings
                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True                 
            Else
                aConContext.UseTransaction = aConContext.UseTransaction Or False 'Or My Setting 

                If aConContext.UseTransaction = False Then
                  aConContext.CommitTransactionWhenTerminates = False 'My Setting
               Else
                  aConContext.CommitTransactionWhenTerminates = aConContext.CommitTransactionWhenTerminates 
               End If

               aConContext.CloseConnectionWhenTerminates = aConContext.CloseConnectionWhenTerminates
            End If


            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")
            
            aParams = New List(Of SqlClient.SqlParameter)

            
            aSQL = "SELECT DISTINCT PO_ID AS ID, PO_NAME AS NAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_INFO AS INFO, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE,"
            aSQL &= "TagsTitles = STUFF((SELECT ', ' +  TG.TG_NAME FROM TBL_POTENTIALOWNERTAG T INNER JOIN TBL_TAG TG ON T.PT_TAG = TG.TG_ID  WHERE T1.PO_ID=T.PT_POTENTIALOWNER ORDER BY T.PT_TAG FOR XML PATH ('')), 1, 1, '') FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID "

            If aUserId > 0 Then aWhere &= " AND (PO_Agent=0 Or PO_Agent=" & aUserId & ") "

            If aAgentId > 0 Then aWhere &= " AND (PO_Agent=0 Or PO_Agent=" & aAgentid & ") "

            If aIsActive = 0 Then
                aWhere &=  " AND (PO_IsActive='False') "
            ElseIf aIsActive = 1 Then
                aWhere &=  " AND (PO_IsActive='True') "
            End If

            If aTagsIds IsNot Nothing AndAlso aTagsIds.Trim() <> "" Then
                If aTagsAnd = False Then 
                    aWhere &= " AND PO_ID IN (SELECT PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG IN (" & aTagsIds & ")) "
                Else
                    Dim aTagsAndArr As String() = aTagsIds.Split(",")

                    If aTagsAndArr IsNot Nothing AndAlso aTagsAndArr.Length > 0 Then
                        For Each aStr As String In aTagsAndArr
                            aWhere &= " AND PO_ID IN (SELECT PT_POTENTIALOWNER FROM TBL_POTENTIALOWNERTAG WHERE PT_TAG=" & CInt(aStr) & ") "
                        Next
                    End If
                End If
            End If

            If aWhere <> "" Then 
                aSQL &= " WHERE " & aWhere.Substring(4)
            End If

            aSQL &= " Order By PO_NAME "
              

            'If aUserId = 0 Then 
            '    If aWhere <> "" Then
            '        aSQL = "Select PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_INFO AS INFO, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID Where " & aWhere.Substring(4) & " Order By PO_NAME"
            '    Else
            '        aSQL = "Select PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_INFO AS INFO, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID Order By PO_NAME"
            '    End If
            'Else
            '    If aWhere <> "" Then 
            '        aSQL = "Select PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_INFO AS INFO, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE (PO_AGENT=" & aUserId & " OR PO_AGENT=0) AND " & aWhere.Substring(4) & " Order By PO_NAME"
            '    Else
            '        aSQL = "Select PO_ID as ID, PO_NAME AS NAME, PO_CELL AS CELL, PO_PHONE AS PHONE, PO_EMAIL AS EMAIL, PO_INFO AS INFO, IIF(UR_NAME IS NULL,'', UR_NAME) AS AGENT, PO_IsActive As ISACTIVE FROM TBL_POTENTIALOWNER T1 LEFT OUTER JOIN TBL_USER T2 ON T1.PO_AGENT=T2.UR_ID WHERE (PO_AGENT=" & aUserId & " OR PO_AGENT=0) Order By PO_NAME"
            '    End If
            'End If

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            For Each aDRow As DataRow In aDT.Rows 
                If IsDBNull(aDRow("TagsTitles")) Then
                    aResult.Add(New Utils.IntegerStringStringStringStringStringIntegerString (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("Phone"), aDRow("Email"), "" , aDRow("ISACTIVE"), aDRow("AGENT")))
                Else
                    Dim aTagsTitle As String = ""
                    If aDRow("TagsTitles").ToString().Length >= 35 Then
                        aTagsTitle = aDRow("TagsTitles").ToString().Substring(0, 35)
                    Else
                        aTagsTitle = aDRow("TagsTitles")
                    End If

                    aResult.Add(New Utils.IntegerStringStringStringStringStringIntegerString (aDRow("ID"), aDRow("NAME"), aDRow("CELL"), aDRow("Phone"), aDRow("Email") , aTagsTitle, aDRow("ISACTIVE"), aDRow("AGENT")))
                End If

            Next

            Return aResult
        End Function

    End Class

    Public Class ApiResultPotentialOwnerData
        Inherits Utils.ApiResponse 

        Public Data As PotentialOwnerData 

        Public Sub New (Optional aSucceeded As Boolean=True, Optional aData As PotentialOwnerData = Nothing, Optional aErrorNumber As Integer = 0, Optional aErrorMessage As string="")
            Me.Succeeded= aSucceeded
            Me.Data = aData
            Me.ErrorNumber = aErrorNumber
            Me.ErrorMessage = aErrorMessage 
        End Sub
    End Class

    Public Class PotentialOwnerData
        Public Id As Integer
        Public Name As String
        Public CoName As String
        Public Cell As String
        Public Phone As String
        Public Email As String
        Public Address As String
        Public IsActive As Boolean
        Public AgentId As Integer 
        Public Notes As String
        Public Info As String 
        Public CreatedOn As DateTime
        Public CreatedBy As Integer
        Public TagsIds As String
        Public TagsTitles As String

        Public sub New (Optional aId As Integer = 0, Optional aName As String = "", Optional aCoName As String ="", Optional aCell As String = "", Optional aPhone As String = "", Optional aEmail As String = "", Optional aAddress As String = "", Optional aIsActive As Boolean = True, Optional aAgentId As Integer = 0, Optional aNotes As string = "", Optional aInfo As String = "", Optional aCreatedBy As Integer = 0, Optional aCreatedOn As DateTime = #1/1/2000#, Optional aTagsIds As String = "", Optional aTagsTitles As String= "")
            Id = aId
            Name = aName
            CoName = aCoName
            Cell = aCell
            Phone = aPhone
            Email = aEmail
            Address = aAddress
            IsActive = aIsActive
            AgentId = aAgentId
            Notes = aNotes
            Info = aInfo
            CreatedOn = aCreatedOn
            CreatedBy = aCreatedBy    
            TagsIds = aTagsIds
            TagsTitles = aTagsTitles 
        End sub
    End Class
End Namespace

