﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports PDF, PDF.DAL.MSSQL
Imports System.Collections.Generic

Namespace Backend 
    
    Public Class Stats1Result
        Public Data As  New Stats1Data()
        Public Children As new List(Of Stats1Result)

        Public Sub New (Optional aData As Stats1Data = Nothing, Optional aChildren As List(Of Stats1Result)=Nothing)
            Data = aData
            Children = aChildren
        End Sub

    End Class

    Public Class Stats1Data
        Public Val1 As String = ""
        Public Val2 As String = ""

        Public Sub New (Optional aVal1 As String = "", Optional aVal2 As String = "")
            Val1 = aVal1
            Val2 = aVal2
        End Sub
    End Class


    Public Class Reporting

        Public Shared Function GetAdminDailyTasksLookups(Optional ByRef aConContext As ConnectionContext = Nothing) As DataTable  
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable 
            Dim aSQL As String = ""

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            aSQL = "SELECT UR_ID AS ID, UR_NAME AS NAME FROM TBL_USER WHERE UR_ISAGENT='TRUE' OR UR_ISADMIN='TRUE' OR UR_ISSUPERUSER='TRUE' ORDER BY UR_NAME;"
          
            aParams = New List(Of SqlClient.SqlParameter)

            aDT = DB.ReadDT_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            Return aDT
        End Function

        Public Shared Function GetAdminDailyTasks(aUserId As Integer, sDate As String, eDate As String, ByRef aTotalCreated As Integer, byref aTotalPublished As Integer, byref aTotalErrors As Integer, byref aTotalErrorsRate As String, byref aTotalRequests As Integer, Optional aConContext As ConnectionContext = Nothing) As DataTable 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDS As DataSet, aDT1 As DataTable, aDT2 As DataTable, aDT3 As DataTable, aDT4 As DataTable 
            Dim aSQL As String = "", aSQLWhere As String = ""
            Dim aDay As string
            Dim aRowsFilter As DataRow()
            Dim aPeriod As New List(Of Date)
            Dim aResult As New DataTable()

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            If eDate = "" Then eDate="12/31/2050"

            'Create the result
            aResult.Columns.Add("Day", GetType(string))
            aResult.Columns.Add("Created", GetType(integer))
            aResult.Columns.Add("Published", GetType(integer))
            aResult.Columns.Add("Errors", GetType(integer))
            aResult.Columns.Add("ErrorsRate", GetType(string))
            aResult.Columns.Add("Requests", GetType(integer))


            'Get the data
            'Created
            aSQL &= "SELECT CONVERT(NVARCHAR(20), PR_CREATEDON, 101) AS DAY, COUNT(PR_ID) AS CREATED FROM TBL_PROPERTY T1"
            aSQL &= " WHERE PR_CREATEDON >= '" & sDate & " 00:00:00' AND PR_CREATEDON <= '" & eDate & " 23:59:59' "
            If aUserId > 0 Then  aSQL &= " AND PR_CREATEDBY=" & aUserID & " "
            aSQL &= " GROUP BY CONVERT(NVARCHAR(20), PR_CREATEDON, 101) "
            aSQL &= " ORDER BY DAY; "


            aSQL &= "SELECT CONVERT(NVARCHAR(20), PM_CREATEDON, 101) AS DAY, COUNT(PM_ID) AS PUBLISHED FROM TBL_PROPERTYMARKETING T1 INNER JOIN  TBL_PROPERTY T2 ON T1.PM_PROPERTYID=T2.PR_ID "
            aSQL &= " WHERE PM_CREATEDON >= '" & sDate & " 00:00:00' AND PM_CREATEDON <= '" & eDate & " 23:59:59' "
            If aUserId > 0 Then  aSQL &= " AND PM_PUBLISHEDBY=" & aUserId & " "
            aSQL &= " GROUP BY CONVERT(NVARCHAR(20), PM_CREATEDON, 101) "
            aSQL &= " ORDER BY DAY; "


            aSQL &= "SELECT CONVERT(NVARCHAR(20), PR_CREATEDON, 101) AS DAY, COUNT(RP_ID) AS ERRORS FROM TBL_REVIEWEDPROPERTY T1 INNER JOIN TBL_PROPERTY T2 ON T1.RP_PROPERTYID=T2.PR_ID "
            aSQL &= " WHERE PR_CREATEDON >= '" & sDate & " 00:00:00' AND PR_CREATEDON <= '" & eDate & " 23:59:59' AND LTRIM(RTRIM(RP_ERRORS)) <> ''"
            If aUserId > 0 Then  aSQL &= " AND PR_CREATEDBY=" & aUserID & " "
            aSQL &= " GROUP BY CONVERT(NVARCHAR(20), PR_CREATEDON, 101) "
            aSQL &= " ORDER BY DAY; "


            aSQL &= "SELECT CONVERT(NVARCHAR(20), CR_CREATEDON, 101) AS DAY, COUNT(CR_ID) AS REQUESTS FROM TBL_CLIENTREQUESTLIST "
            aSQL &= " WHERE CR_CREATEDON >= '" & sDate & " 00:00:00' AND CR_CREATEDON <= '" & eDate & " 23:59:59' "
            If aUserId > 0 Then  aSQL &= " AND CR_CREATEDBY=" & aUserID & " "
            aSQL &= " GROUP BY CONVERT(NVARCHAR(20), CR_CREATEDON, 101) "
            aSQL &= " ORDER BY DAY; "

            aDS = DB.ReadDS_Text(aSQL, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, False, true)

            aDT1 = aDS.Tables(0)
            aDT2 = aDS.Tables(1)
            aDT3 = aDS.Tables(2)
            aDT4 = aDS.Tables(3)

            aPeriod = Utils.Utils.GetDatesBetweenTwoDates(sDate, eDate)
            Dim aCreated As Integer, aPublished As Integer, aErrors As Integer, aErrorsRate As Integer, aRequests As Integer 
            aTotalCreated = 0
            aTotalPublished = 0
            aTotalErrors = 0
            aTotalErrorsRate = "0%"
            aTotalRequests = 0

            For Each aDay In aPeriod
                aCreated = 0 : aPublished = 0 : aErrors = 0 : aErrorsRate = 0 : aRequests = 0

                aRowsFilter = aDT1.Select("Day=#" & aDay & " 12:00:00 AM#")
                If aRowsFilter IsNot Nothing Andalso aRowsFilter.Length >0 Then aCreated = aRowsFilter(0)("Created")

                aRowsFilter = aDT2.Select("Day=#" & aDay & " 12:00:00 AM#")
                If aRowsFilter IsNot Nothing Andalso aRowsFilter.Length >0 Then aPublished = aRowsFilter(0)("Published")

                aRowsFilter = aDT3.Select("Day=#" & aDay & " 12:00:00 AM#")
                If aRowsFilter IsNot Nothing Andalso aRowsFilter.Length >0 Then aErrors = aRowsFilter(0)("Errors")

                If aCreated >0 Then aErrorsRate = CInt(100*aErrors/aCreated)

                aRowsFilter = aDT4.Select("Day=#" & aDay & " 12:00:00 AM#")
                If aRowsFilter IsNot Nothing Andalso aRowsFilter.Length >0 Then aRequests = aRowsFilter(0)("Requests")

                aResult.Rows.Add(aDay, aCreated, aPublished, aErrors, aErrorsRate & "%", aRequests)

                aTotalCreated += aCreated
                aTotalPublished += aPublished
                aTotalErrors += aErrors
                aTotalRequests += aRequests 
            Next

            If aTotalCreated > 0 Then aTotalErrorsRate = CInt(aTotalErrors*100/aTotalCreated)  & "%"

            Return aResult
        End Function

        Public Shared Function GetReviewedPublishedDelay(adminId As Integer, sDate As String, eDate As String, agentId As Integer, Optional aConContext As ConnectionContext = Nothing) As DataTable 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New DataTable()

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            If eDate = "" Then eDate="12/31/2050"

            aSQL = "SELECT T3.UR_NAME AS ADMINNAME, PR_PROPERTYKEY AS PROPERTYKEY, DBO.GETDATETIME1(PR_CREATEDON) AS CREATEDON, DBO.GETDATETIME1(RP_REVIEWEDON) AS REVIEWEDON, DBO.GETDATETIME1(RP_LASTUPDATEDON) AS LASTUPDATEDON "
            aSQL &= " FROM TBL_PROPERTY T1 INNER JOIN TBL_REVIEWEDPROPERTY T2 ON T1.PR_ID=T2.RP_PROPERTYID INNER JOIN TBL_USER T3 ON T2.RP_LASTUPDATEDBY=T3.UR_ID "
            aSQL &= " WHERE RP_REVIEWEDON >= '" & sDate & " 00:00:00' AND RP_REVIEWEDON <= '" & eDate & " 23:59:59' AND RP_STATUS=2 "
            If adminId > 0 Then  aSQL &= " AND RP_LASTUPDATEDBY=" & adminId & " "
            If agentId > 0 Then aSQL &= " AND PR_AGENTID=" & agentId  & " "
            aSQL &= " ORDER BY UR_NAME, RP_REVIEWEDON"

            aDT = DB.ReadDT_Text(aSQL, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, False, true)

            Return aDT
        End Function 

        Public Shared Function GetReviewedUnpublished(sDate As String, eDate As String, agentId As Integer, Optional aConContext As ConnectionContext = Nothing) As DataTable 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = ""
            Dim aResult As New DataTable()

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            If eDate = "" Then eDate="12/31/2050"

            aSQL = "SELECT PR_PROPERTYKEY AS PROPERTYKEY, DBO.GETDATETIME1(PR_CREATEDON) AS CREATEDON, DBO.GETDATETIME1(RP_REVIEWEDON) AS REVIEWEDON "
            aSQL &= " FROM TBL_PROPERTY T1 INNER JOIN TBL_REVIEWEDPROPERTY T2 ON T1.PR_ID=T2.RP_PROPERTYID "
            aSQL &= " WHERE RP_REVIEWEDON >= '" & sDate & " 00:00:00' AND RP_REVIEWEDON <= '" & eDate & " 23:59:59' AND RP_STATUS<>2 "
            If agentId > 0 Then aSQL &= " AND PR_AGENTID=" & agentId  & " "
            aSQL &= " ORDER BY RP_REVIEWEDON"

            aDT = DB.ReadDT_Text(aSQL, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, False, true)

            Return aDT
        End Function 

        Public Shared Function GetReceivedCreated(adminId As Integer, sDate As String, agentId As Integer, Optional aConContext As ConnectionContext = Nothing) As DataTable 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable
            Dim aSQL As String = "", aSQLWhere As String = ""
            Dim aCurrentAdmin As String, aCurrentAgent As string 
            Dim aDR As DataRow, aCurrentRow As DataRow = Nothing 
            Dim aResult As New DataTable()

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            'Create the result
            aResult.Columns.Add("AdminName", GetType(string))
            aResult.Columns.Add("Agent", GetType(string))
            aResult.Columns.Add("Received", GetType(integer))
            aResult.Columns.Add("Created", GetType(integer))

            'Get the data
            aSQL = "SELECT T2.UR_NAME AS AGENTNAME, T3.UR_NAME AS [ADMINNAME], COUNT(T1.PR_ID) AS PROPS, 2 As Type FROM "
            aSQL &= " TBL_PROPERTY T1 INNER JOIN TBL_USER T2 ON T1.PR_AGENTID=T2.UR_ID INNER JOIN TBL_USER T3 ON T1.PR_CREATEDBY=T3.UR_ID "
            aSQL &= " WHERE PR_CREATEDON >='" & sDate & " 00:00:00' "
            aSQL &= " GROUP BY T2.UR_NAME, T3.UR_NAME "

            aSQL &= " UNION "

            aSQL &= "SELECT T2.UR_NAME AS AGENTNAME, T3.UR_NAME AS [ADMINNAME], SUM(T1.PR_COUNT) AS PROPS, 1 As Type FROM "
            aSQL &= " TBL_PROPERTYRECEIVED T1 INNER JOIN TBL_USER T2 ON T1.PR_AGENTID=T2.UR_ID INNER JOIN TBL_USER T3 ON T1.PR_RECEIVEDBY=T3.UR_ID "
            aSQL &= " WHERE PR_RECEIVEDON >='" & sDate & " 00:00:00' "
            aSQL &= " GROUP BY T2.UR_NAME, T3.UR_NAME "

            aSQL &= " ORDER BY T3.UR_NAME, T2.UR_NAME"

            aDT = DB.ReadDT_Text(aSQL, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, False, true)

            If aDT.Rows.Count > 0 Then
                aCurrentAdmin=aDT.Rows(0)("AdminName")
                aCurrentAgent = aDT.Rows(0)("AgentName")
                aCurrentRow = aResult.Rows.Add(aCurrentAdmin, aCurrentAgent, 0, 0)
            End If

            For Each aDR In aDT.Rows
                If aCurrentAdmin <> aDR("AdminName") OrElse aCurrentAgent <> aDR("AgentName") Then
                    aCurrentAdmin=aDR("AdminName")
                    aCurrentAgent = aDR("AgentName")
                    aCurrentRow = aResult.Rows.Add(aCurrentAdmin, aCurrentAgent, 0, 0)
                End If

                If aDR("TYPE") = 1
                    aCurrentRow("Received") = aDR("PROPS")
                ElseIf aDR("TYPE") = 2
                    aCurrentRow("Created") = aDR("PROPS")
                End If            
            Next

            Return aResult
        End Function

        Public Shared Function GetMarketingExpiry(agentId As Integer, notifyIn As Integer, Optional aConContext As ConnectionContext = Nothing) As DataTable 
            Dim aParams As New List(Of SqlClient.SqlParameter)
            Dim aDB As ConnectionContextConnection
            Dim aDT As DataTable 

            If aConContext Is Nothing Then
                aConContext = New ConnectionContext

                aConContext.UseTransaction = False
                aConContext.CommitTransactionWhenTerminates = False
                aConContext.CloseConnectionWhenTerminates = True
            End If

            aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

            aParams.Add(DB.CreateParameter("@AGENTID", SqlDbType.Int, -1, ParameterDirection.Input, agentId))
            aParams.Add(DB.CreateParameter("@NOTIFYIN", SqlDbType.Int, -1, ParameterDirection.Input, notifyIn))
            aDT = DB.ReadDT_SP("SP_GET_PROPERTYMARKETINGEXPIRY", aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)

            Return aDT
        End Function


        'Public Shared Function GetStats1SQL(aUserId As Integer, aSearchIn As Integer, aSearchInDetail As Integer, aSDate As String, aEDate As String, aAgentId As integer, aIncludeActiveProperties As Boolean, aCriterion As Integer, ByRef aColumns As List(Of  List(Of String)), ByRef aColumnsWithAs As List(Of List(Of String)), Optional ByRef aConContext As ConnectionContext = Nothing) As String
        '    Dim aSQL As String = "", aSQL1 As String ="", aSQL2 As String = ""
        '    Dim aPreviousColumnNames as string = "", aPreviousColumnNamesWithAs as string = ""
        '    Dim aFrom As String  = "", aWhere As String = ""
        '    Dim aAdded As new List(Of String), aAddedAs As New List(Of String)

        '    If aColumns IsNot Nothing AndAlso aColumns.Count>0 Then 
        '        For Each l As List(Of String) In aColumns 
        '            For Each s As String In l 
        '                aPreviousColumnNames &= "," & s
        '            Next
        '        Next

        '        aPreviousColumnNames = aPreviousColumnNames.Substring(1)

        '        For Each l As List(Of String) In aColumnsWithAs 
        '            For Each s As String In l 
        '                aPreviousColumnNamesWithAs &= "," & s
        '            Next
        '        Next

        '        aPreviousColumnNamesWithAs = aPreviousColumnNamesWithAs.Substring(1)
        '    End If


        '    If aSearchIn = 1 Then
        '       aFrom = " From Tbl_Property T1 Inner Join Tbl_PropertyType T2 On T1.PR_PropertyType=T2.PT_ID Inner Join Tbl_Country T3 On T1.PR_Country=T3.CO_ID Inner Join Tbl_City T4 On T1.PR_City=T4.CI_ID "
               
        '       If aSDate <> "" Then aWhere &= " AND PR_CREATEDON >= '" & aSDate & " 00:00:00'"
        '       If aEDate <> "" Then aWhere &= " AND PR_CREATEDON <= '" & aEDate & " 23:59:59'"

        '    Else
        '        aFrom = " From Tbl_Property T1 Inner Join Tbl_PropertyType T2 On T1.PR_PropertyType=T2.PT_ID Inner Join Tbl_Country T3 On T1.PR_Country=T3.CO_ID Inner Join Tbl_City T4 On T1.PR_City=T4.CI_ID Inner Join Tbl_PropertyMarketing T5 On T1.PR_ID=T5.PM_PropertyID Inner Join Tbl_MarketingChannel T6 On T5.PM_ChannelID=T6.MC_ID "

        '        If aSDate <> "" Then aWhere &= " AND PM_SDATE >= '" & aSDate & " 00:00:00'"
        '        If aEDate <> "" Then aWhere &= " AND PM_EDATE <= '" & aEDate & " 00:00:00'"
        '        If aSearchInDetail > 0 Then aWhere &= " AND MC_ID =" & aSearchInDetail 
        '    End If

        '    If aAgentId >0 Then aWhere &= " AND PR_AGENTID=" & aAgentId
        '    If aIncludeActiveProperties = True Then aWhere &= " AND PR_ISACTIVE='TRUE'"


        '    If aCriterion = 1 Then
        '        'PropertyType
        '        aSQL &= "Select " & IIf(aPreviousColumnNamesWithAs ="", "", aPreviousColumnNamesWithAs & ", ") &  "PT_ID, PT_NAME AS Name, Count(PR_ID) As Nb "
        '        aSQL &= aFrom 
        '        If aWhere <> "" Then aSQL &= " WHERE " & aWhere.Substring(4)
        '        aSQL &= " Group By " & IIf(aPreviousColumnNames ="", "", aPreviousColumnNames & ", ") &  "PT_ID, PT_NAME"

        '        aAdded.Add("PT_ID")
        '        aAddedAs.Add("PT_ID")
        '        aColumns.Add(aAdded)
        '        aColumnsWithAs.Add(aAddedAs)
        '    ElseIf aCriterion = 2 Then
        '        'District
        '        aSQL &= "Select " & IIf(aPreviousColumnNamesWithAs ="", "", aPreviousColumnNamesWithAs & ", ") &  "CO_ID, CO_NAME AS Name, Count(PR_ID) As Nb "
        '        aSQL &= aFrom 
        '        If aWhere <> "" Then aSQL &= " WHERE " & aWhere.Substring(4)
        '        aSQL &= " Group By " & IIf(aPreviousColumnNames ="", "", aPreviousColumnNames & ", ") &  "CO_ID, CO_NAME"

        '        aAdded.Add("CO_ID")
        '        aAddedAs.Add("CO_ID")
        '        aColumns.Add(aAdded)
        '        aColumnsWithAs.Add(aAddedAs)
        '    ElseIf aCriterion = 3 Then
        '        'City
        '        aSQL &= "Select " & IIf(aPreviousColumnNamesWithAs ="", "", aPreviousColumnNamesWithAs & ", ") &  "CI_ID, CI_NAME AS Name, Count(PR_ID) As Nb "
        '        aSQL &= aFrom 
        '        If aWhere <> "" Then aSQL &= " WHERE " & aWhere.Substring(4)
        '        aSQL &= " Group By " & IIf(aPreviousColumnNames ="", "", aPreviousColumnNames & ", ") &  "CI_ID, CI_NAME"

        '        aAdded.Add("CI_ID")
        '        aAddedAs.Add("CI_ID")
        '        aColumns.Add(aAdded)
        '        aColumnsWithAs.Add(aAddedAs)
        '    ElseIf aCriterion = 4 Then
        '        'Purpose
        '        aSQL &= "Select " & IIf(aPreviousColumnNamesWithAs ="", "", aPreviousColumnNamesWithAs & ", ") &  "1 As Purpose, Count(PR_ID) As Nb "
        '        aSQL &= aFrom 
        '        aSQL &= " WHERE PR_FORSALE='TRUE' "
        '        If aWhere <> "" Then aSQL &= " AND " & aWhere.Substring(4)
        '        aSQL &= " Group By " & IIf(aPreviousColumnNames ="", "", aPreviousColumnNames & ", ")

        '        aSQL &= " UNION "

        '        aSQL &= "Select " & IIf(aPreviousColumnNamesWithAs ="", "", aPreviousColumnNamesWithAs & ", ") &  "2 As Purpose, Count(PR_ID) As Nb "
        '        aSQL &= aFrom 
        '        aSQL &= " WHERE PR_FORRENT='TRUE' "
        '        If aWhere <> "" Then aSQL &= " AND " & aWhere.Substring(4)
        '        aSQL &= " Group By " & IIf(aPreviousColumnNames ="", "", aPreviousColumnNames & ", ")

        '        aAdded.Add("")
        '        aAddedAs.Add("CI_ID")
        '        aColumns.Add(aAdded)
        '        aColumnsWithAs.Add(aAddedAs)

        '        aAddedColumns.Add("PR_ForSale, PR_ForRent")
        '        aAddedColumnsWithAs.Add("PR_ForSale, PR_ForRent")
        '    ElseIf aCriterion = 5 Then
        '        'Price Range
        '        aSQL &= "Select " & IIf(aPreviousColumnNamesWithAs ="", "", aPreviousColumnNamesWithAs & ", ")
        '        aSQL &= "CASE WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 150000 THEN 1 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 250000 THEN 2 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 350000 THEN 3 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 500000 THEN 4 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 1000000 THEN 5 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 200000 THEN 6 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 500000 THEN 7 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 1000000 THEN 8 ELSE 0  END AS SALERANGE, "
        '        aSQL &= "CASE WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 800 THEN 1 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 1200 THEN 2 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 1800 THEN 3 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 2500 THEN 4 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 3500 THEN 5 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 5000 THEN 6 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 10000 THEN 7 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 20000 THEN 8 ELSE 0  END AS RENTRANGE, "
        '        aSQL &= "Count(PR_ID) As Nb "

        '        aSQL &= aFrom 
        '        If aWhere <> "" Then aSQL &= " WHERE " & aWhere.Substring(4)
        '        aSQL &= " Group By " & IIf(aPreviousColumnNames ="", "", aPreviousColumnNames & ", ") &  "CASE WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 150000 THEN 1 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 250000 THEN 2 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 350000 THEN 3 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 500000 THEN 4 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 1000000 THEN 5 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 200000 THEN 6 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 500000 THEN 7 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 1000000 THEN 8 ELSE 0  END, CASE WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 800 THEN 1 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 1200 THEN 2 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 1800 THEN 3 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 2500 THEN 4 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 3500 THEN 5 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 5000 THEN 6 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 10000 THEN 7 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 20000 THEN 8 ELSE 0  END"

        '        aAddedColumns.Add("CASE WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 150000 THEN 1 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 250000 THEN 2 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 350000 THEN 3 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 500000 THEN 4 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 1000000 THEN 5 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 200000 THEN 6 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 500000 THEN 7 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 1000000 THEN 8 ELSE 0  END, CASE WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 800 THEN 1 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 1200 THEN 2 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 1800 THEN 3 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 2500 THEN 4 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 3500 THEN 5 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 5000 THEN 6 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 10000 THEN 7 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 20000 THEN 8 ELSE 0  END")
        '        aAddedColumnsWithAs.Add("CASE WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 150000 THEN 1 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 250000 THEN 2 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 350000 THEN 3 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 500000 THEN 4 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 1000000 THEN 5 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 200000 THEN 6 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 500000 THEN 7 WHEN PR_FORSALE='TRUE' AND PR_SALEAMOUNT < 1000000 THEN 8 ELSE 0  END AS SALERANGE, CASE WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 800 THEN 1 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 1200 THEN 2 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 1800 THEN 3 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 2500 THEN 4 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 3500 THEN 5 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 5000 THEN 6 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 10000 THEN 7 WHEN PR_FORRENT='TRUE' AND PR_RENTAMOUNT < 20000 THEN 8 ELSE 0  END AS RENTRANGE")
        '    End If

        '    Return aSQL 
        'End Function

        'Public Shared Function Stats1(aUserId As Integer, aSearchIn As Integer, aSearchInDetail As Integer, aSDate As String, aEDate As String, aAgentId As integer, aIncludeActiveProperties As Boolean, aCriterion1 As Integer, aCriterion2 As Integer, aCriterion3 As Integer, aCriterion4 As Integer, aCriterion5 As Integer, Optional ByRef aConContext As ConnectionContext = Nothing) As List(Of Stats1Result)  
        '    Dim aParams As New List(Of SqlClient.SqlParameter)
        '    Dim aDB As ConnectionContextConnection
        '    Dim aResult As New List(Of Stats1Result)
        '    Dim aAddedColumns1 As New List(Of String), aAddedColumns2 As New List(Of String), aAddedColumns3 As New List(Of String), aAddedColumns4 As New List(Of String), aAddedColumns5 As New List(Of String)
        '    Dim aAddedColumns1WithAs As New List(Of String), aAddedColumns2WithAs As New List(Of String), aAddedColumns3WithAs As New List(Of String), aAddedColumns4WithAs As New List(Of String), aAddedColumns5WithAs As New List(Of String)
        '    Dim aPreviousColumns As New List(Of String), aPreviousColumnsWithAs As New List(Of String)
        '    Dim aSQL As String = ""
        '    Dim aSQL1 As String = "", aSQL2 As String = "", aSQL3 As String = "", aSQL4 As String="", aSQL5 As String = ""
        '    Dim i As Integer = 0

        '    If aCriterion1 < 1 Then Return aResult 

        '    If aCriterion1 > 0 Then
        '        aSQL &= GetStats1SQL(aUserId, aSearchIn, aSearchInDetail, aSDate, aEDate, aAgentId, aIncludeActiveProperties, aCriterion1,aPreviousColumns, aPreviousColumnsWithAs, aAddedColumns1, aAddedColumns1WithAs) & ";"

        '        For i = 0 To aAddedColumns1.Count-1
        '            aPreviousColumns.Add(aAddedColumns1(i))
        '            aPreviousColumnsWithAs.Add(aAddedColumns1WithAs(i))
        '        Next
        '    End If

        '    If aCriterion2 > 0 Then
        '        aSQL &= GetStats1SQL(aUserId, aSearchIn, aSearchInDetail, aSDate, aEDate, aAgentId, aIncludeActiveProperties, aCriterion2,aPreviousColumns, aPreviousColumnsWithAs, aAddedColumns2, aAddedColumns2WithAs) & ";"

        '        For i = 0 To aAddedColumns2.Count-1
        '            aPreviousColumns.Add(aAddedColumns2(i))
        '            aPreviousColumnsWithAs.Add(aAddedColumns2WithAs(i))
        '        Next
        '    End If

        '    If aCriterion3 > 0 Then
        '        aSQL &= GetStats1SQL(aUserId, aSearchIn, aSearchInDetail, aSDate, aEDate, aAgentId, aIncludeActiveProperties, aCriterion3,aPreviousColumns, aPreviousColumnsWithAs, aAddedColumns3, aAddedColumns3WithAs) & ";"

        '        For i = 0 To aAddedColumns3.Count-1
        '            aPreviousColumns.Add(aAddedColumns3(i))
        '            aPreviousColumnsWithAs.Add(aAddedColumns3WithAs(i))
        '        Next
        '    End If

        '    If aCriterion4 > 0 Then
        '        aSQL &= GetStats1SQL(aUserId, aSearchIn, aSearchInDetail, aSDate, aEDate, aAgentId, aIncludeActiveProperties, aCriterion4,aPreviousColumns, aPreviousColumnsWithAs, aAddedColumns4, aAddedColumns4WithAs) & ";"

        '        For i = 0 To aAddedColumns4.Count-1
        '            aPreviousColumns.Add(aAddedColumns4(i))
        '            aPreviousColumnsWithAs.Add(aAddedColumns4WithAs(i))
        '        Next
        '    End If
                
        '    If aCriterion5 > 0 Then
        '        aSQL &= GetStats1SQL(aUserId, aSearchIn, aSearchInDetail, aSDate, aEDate, aAgentId, aIncludeActiveProperties, aCriterion5,aPreviousColumns, aPreviousColumnsWithAs, aAddedColumns5, aAddedColumns5WithAs) & ";"

        '        For i = 0 To aAddedColumns5.Count-1
        '            aPreviousColumns.Add(aAddedColumns5(i))
        '            aPreviousColumnsWithAs.Add(aAddedColumns5WithAs(i))
        '        Next
        '    End If

        '    'DB
        '    If aConContext Is Nothing Then
        '        aConContext = New ConnectionContext

        '        aConContext.UseTransaction = False
        '        aConContext.CommitTransactionWhenTerminates = False
        '        aConContext.CloseConnectionWhenTerminates = True
        '    End If

        '    aDB = aConContext.ConnectionEntryFromMapping("KSARE.First")

          
        '    aParams = New List(Of SqlClient.SqlParameter)

        '    Dim aDS As DataSet = DB.ReadDS_Text(aSQL, aParams, aDB.Connection, aDB.ConnectionString, aConContext.Trs, aConContext.UseTransaction, aConContext.CommitTransactionWhenTerminates, aConContext.CloseConnectionWhenTerminates)
        '    Dim aDT1 As DataTable, aDT2 As DataTable, aDT3 As DataTable, aDT4 As DataTable, aDT5 As DataTable 

        '    Dim aCriteria As New  List(Of Integer)
        '    If aCriterion1 > 0 Then
        '        aDT1 = aDS.Tables(0)
        '        aCriteria.Add(aCriterion1)
        '    End If
        '    If aCriterion2 > 0 Then
        '        aDT2 = aDS.Tables(1)
        '        aCriteria.Add(aCriterion2)
        '    End If

        '    If aCriterion1 > 0 Then
        '        aDT3 = aDS.Tables(2)
        '        aCriteria.Add(aCriterion3)
        '    End If

        '    If aCriterion1 > 0 Then
        '        aDT4 = aDS.Tables(3)
        '        aCriteria.Add(aCriterion4)
        '    End If

        '    If aCriterion1 > 0 Then
        '        aDT5 = aDS.Tables(4)
        '        aCriteria.Add(aCriterion5)
        '    End If

        '    i = 0
        '    For Each aDR1 As DataRow In aDS.Tables(0).Rows 
        '        Dim aObj1 As New Stats1Result()
        '        Stat1GetObj(aDR1, aCriteria(i))
        '    Next

        '    Return aResult 
        'End Function

        'Protected Shared Function Stat1GetObj(aDRow As DataRow, aCriterion As Integer) As Stats1Result 
        '    If aCriterion = 1 OrElse aCriterion = 2 OrElse aCriterion = 3 Then
        '        Return New Stats1Result(aDRow("Name"), aDRow("Nb"))
        '    ElseIf aCriterion = 4 Then
        '        Return New Stats1Result(aDRow("Name"), aDRow("Nb"))

        '    End If
        'End Function

    End Class

End Namespace 