﻿Imports System.Collections.Generic
Imports System.Data

Partial Class Backend_FrmAlerts
    Inherits System.Web.UI.Page


    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aError As String

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAgent = False AndAlso aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(True, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function
    
    Protected Function CreateEmptyTable() As DataTable
        Dim aResult As New DataTable

        aResult.Columns.Add("CreatedOn", GetType(String))
        aResult.Columns.Add("Type", GetType(String))
        aResult.Columns.Add("Title", GetType(String))
        aResult.Columns.Add("Info", GetType(String))

        aResult.Rows.Add()

        Return aResult 
    End Function

    Private Sub SelectInCombo(ByVal aItemID As String, ByVal aCombo As DropDownList)
        Dim i As Integer

        For i = 0 To aCombo.Items.Count - 1
            If aCombo.Items(i).Value = aItemID Then
                aCombo.SelectedIndex = i
                Return
            End If
        Next

    End Sub

    Private Sub Backend_FrmAlerts_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim aDT As DataTable = BackEnd.Alert.GetFormLookups()

        If ValidateUser = False Then Return

        aError = ""

        If Me.IsPostBack = False Then 
           'Bind grid to an empty table
            GV.DataSource = Me.CreateEmptyTable()
            GV.DataBind()

            'Fill Lookups
            Cmb_Type.Items.Clear()

            Cmb_Type.Items.Add(New ListItem("All","0"))

            For Each aDRow As DataRow In aDT.Rows
                Cmb_Type.Items.Add(New ListItem(aDRow("Title"), aDRow("ID")))
            Next

            Cmb_Type.SelectedIndex = 0


            Cmb_Status.Items.Clear()

            Cmb_Status.Items.Add(New ListItem("All", "2"))
            Cmb_Status.Items.Add(New ListItem("Viewed","1"))
            Cmb_Status.Items.Add(New ListItem("Not Viewed","0"))

            Cmb_Status.SelectedIndex = 0
        End If 
    End Sub

End Class
