﻿Imports System.Collections.Generic
Imports System.Data

Partial Class Backend_FrmPO2
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aError As String

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAgent = False AndAlso aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(True, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function
    
    Protected Function CreateEmptyTable() As DataTable
        Dim aResult As New DataTable

        aResult.Columns.Add("ID", GetType(Integer))
        aResult.Columns.Add("Name", GetType(String))
        aResult.Columns.Add("Agent", GetType(String))
        aResult.Columns.Add("Cell", GetType(String))
        aResult.Columns.Add("Phone", GetType(String))
        aResult.Columns.Add("Email", GetType(String))
        aResult.Columns.Add("Tags", GetType(String))

        aResult.Rows.Add()

        Return aResult 
    End Function

    Private Sub SelectInCombo(ByVal aItemID As String, ByVal aCombo As DropDownList)
        Dim i As Integer

        For i = 0 To aCombo.Items.Count - 1
            If aCombo.Items(i).Value = aItemID Then
                aCombo.SelectedIndex = i
                Return
            End If
        Next

    End Sub

    Private Sub Backend_frmPO2_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim aDS As DataSet = BackEnd.PotentialOwner2.GetFormLookups()

        If ValidateUser = False Then Return

        aError = ""

        If Me.IsPostBack = False Then 
           'Bind grid to an empty table
            GV.DataSource = Me.CreateEmptyTable()
            GV.DataBind()

            'Fill Lookups
            Cmb_Status.Items.Clear()

            Cmb_Status.Items.Add(New ListItem("All","2"))
            Cmb_Status.Items.Add(New ListItem("Active", "1"))
            Cmb_Status.Items.Add(New ListItem("Inactive", "0"))

            Cmb_Status.SelectedIndex = 1

            Cmb_Agent.Items.Clear()
            Cmb_Agent.Items.Add(New ListItem("N/A", "0"))

            If aCurrentUser IsNot Nothing AndAlso (aCurrentUser.IsAdmin=True OrElse aCurrentUser.IsSuperUser=true) Then
                Cmb_Agents.Items.Clear()
                Cmb_Agents.Items.Add(New ListItem("All", "0"))
            End If

            For Each aDRow As DataRow In aDS.Tables(0).Rows
                Cmb_Agent.Items.Add(New ListItem(aDRow("Title"), aDRow("ID")))

                If aCurrentUser IsNot Nothing AndAlso (aCurrentUser.IsAdmin=True OrElse aCurrentUser.IsSuperUser=true) Then Cmb_Agents.Items.Add(New ListItem(aDRow("Title"), aDRow("ID")))
            Next

            If aCurrentUser.IsAgent = True Then
                Me.SelectInCombo(aCurrentUser.ID, Cmb_Agent)

                If aCurrentUser IsNot Nothing AndAlso (aCurrentUser.IsAdmin=True OrElse aCurrentUser.IsSuperUser=true) Then Me.SelectInCombo(aCurrentUser.ID, Cmb_Agents)
            Else
                Cmb_Agent.SelectedIndex = 0

                If aCurrentUser IsNot Nothing AndAlso (aCurrentUser.IsAdmin=True OrElse aCurrentUser.IsSuperUser=true) Then Cmb_Agents.SelectedIndex = 0
            End If
        End If 
    End Sub

End Class
