﻿Imports System.Data
Imports PDF, PDF.DAL.MSSQL

Partial Class Backend_FrmReportsProperties
    Inherits System.Web.UI.Page

    Protected Sub AddGrandTotals(aDT As DataTable) 
        Dim aDR As DataRow
        Dim sum As Integer = 0
        Dim c As Integer, r As Integer, val As integer

        aDT.Columns.Add(New DataColumn("Total", GetType(Integer)))

        For Each aDR in aDT.Rows
            sum = 0
            For c=1 To aDT.Columns.Count -2
                If(Integer.TryParse(aDR.Item(c).ToString(), val) = true)
                    sum += val
                End If
            Next

            aDR.Item(aDT.Columns.Count -1) = sum
        Next

        Dim aLastRow As DataRow= aDT.Rows.Add()

        For c=1 To aDT.Columns.Count -1
           sum = 0
           For r=0 To aDT.Rows.Count - 2
                If(Integer.TryParse(aDT.Rows.Item(r).Item(c).ToString(), val) = true)
                    sum += val
                End If
           Next
           aLastRow.Item(c) = sum
        Next
    End Sub

    Protected Function GetLookups() As DataSet
        Dim aConContext As ConnectionContext = New ConnectionContext()
        Dim aDB As ConnectionContextConnection = aConContext.ConnectionEntryFromMapping("KSARE.First")
        Dim aDS As DataSet
        Dim aSQL As string = "Select UR_ID as Id, UR_NAME as Name from Tbl_User Order By UR_Name;"
        aSQL += "Select PT_ID as Id, PT_Name as Name from Tbl_PropertyType where PT_ID not in (11,14,19,20) Order By PT_Name;"
        aSQL += "Select CI_ID as Id, CI_Name as Name from Tbl_City Order By CI_Name;"
        aSQL += "Select SO_ID as Id, SO_Name as Name from Tbl_Source Order By SO_ID;"

        aDS = DB.ReadDS_Text(aSql, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, True, true)
        
        Return aDS
    End Function

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If(IsPostback)
            HF_IsFresh.Value="false"
        Else
            Dim currentMonth As Integer = Month(DateTime.Now)
            Dim currentMonthS As String = currentMonth.ToString()

            If(currentMonth.ToString().Length = 1)
               currentMonthS = "0" & currentMonth.ToString()
            End If 

            Dim today As Date = Now
            Dim lastDay As Integer = Date.DaysInMonth(today.Year, today.Month)

            txtSDate.Text = Year(Now) & "." & currentMonthS & ".01"
            txtEDate.Text = Year(Now) & "." & currentMonthS & "." & lastDay

            HF_IsFresh.Value="true"   
            
            cmbReports.Items.Add(New System.Web.UI.WebControls.ListItem("Details", 1))
            cmbReports.Items.Add(New System.Web.UI.WebControls.ListItem("Count Per Day & Type", 2))
            cmbReports.Items.Add(New System.Web.UI.WebControls.ListItem("Count Per Agent & Type", 3))
            cmbReports.Items.Add(New System.Web.UI.WebControls.ListItem("Count Per City & Agent", 4))

            cmbReports.SelectedIndex = 0
        End If
    End Sub

    Protected Sub GetReport1(sDate As String, eDate As string)
        'Details
        Dim aConContext As ConnectionContext = New ConnectionContext()
        Dim aDB As ConnectionContextConnection = aConContext.ConnectionEntryFromMapping("KSARE.First")

        Dim aSQL As String = "SELECT CONVERT(NVARCHAR(20), PR_CREATEDON, 102) AS CreatedOn, T1.PR_ID AS ID, PR_PROPERTYKEY AS [Key], IIF(PR_PROPERTYTYPE = 0, 'N/A', PT_NAME) AS Type, IIF(PR_CITY = 0, 'N/A', CI_NAME) AS City, "
        aSQL &= "PR_SALEAMOUNT AS [Sale $], PR_RENTAMOUNT AS [Rent $], IIF(PR_ISACTIVE=1, 'Yes', 'No') AS [?Active] FROM TBL_PROPERTY AS T1 LEFT OUTER JOIN TBL_PROPERTYTYPE ON PR_PROPERTYTYPE=PT_ID LEFT OUTER JOIN TBL_CITY ON PR_CITY=CI_ID "
        aSQL &= "WHERE PR_CREATEDON >= '" + sDate + "' AND PR_CREATEDON <= '" + eDate + "' ORDER BY PR_CREATEDON, PR_ISACTIVE"

        Dim aDT As DataTable = DB.ReadDT_Text(aSQL, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, False, true)

        tblData.CssClass = "grid grid2"
        tblData.DataSource = aDT
        tblData.DataBind()
    End Sub

    Protected Sub GetReport2(sDate As String, eDate As string)
        'Details
        Dim aConContext As ConnectionContext = New ConnectionContext()
        Dim aDB As ConnectionContextConnection = aConContext.ConnectionEntryFromMapping("KSARE.First")
        Dim aDR As DataRow 
        Dim aDS As DataSet = GetLookups()
        Dim aDTSource As DataTable = aDS.Tables.Item(1)

        Dim aSQL As string = "SELECT CreatedOn, "
        
        For Each aDR In aDTSource.Rows
            aSQL &= "[" & aDR("Id") & "] as [" & aDR("Name") & "], "
        Next

        aSQL = aSQL.Substring(0, aSQL.Length-2)

        aSQL &= " from "
        aSQL &= "( SELECT CONVERT(NVARCHAR(20), PR_CREATEDON, 102) as CreatedOn, TBL_PROPERTYTYPE.PT_ID as PTID, COUNT(PR_ID) AS Props FROM TBL_PROPERTY INNER JOIN TBL_PROPERTYTYPE ON TBL_PROPERTY.PR_PROPERTYTYPE=TBL_PROPERTYTYPE.PT_ID  "
        aSQL &= "WHERE PR_CREATEDON >= '" + sDate + "' AND PR_CREATEDON <= '" + eDate + "' GROUP BY PR_CREATEDON, PT_ID) x pivot (sum(Props) for PTID in ("

        For Each aDR In aDTSource.Rows
            aSQL &= "[" & aDR("Id") & "], "
        Next

        aSQL = aSQL.Substring(0, aSQL.Length-2)

        aSQL &= ")) p"

        Dim aDT As DataTable = DB.ReadDT_Text(aSQL, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, False, true)

        AddGrandTotals(aDT)

        tblData.CssClass = "grid grid2"
        tblData.DataSource = aDT
        tblData.DataBind()
    End Sub

    Protected Sub GetReport3(sDate As String, eDate As string)
        'Details
        Dim aConContext As ConnectionContext = New ConnectionContext()
        Dim aDB As ConnectionContextConnection = aConContext.ConnectionEntryFromMapping("KSARE.First")
        Dim aDR As DataRow 
        Dim aDS As DataSet = GetLookups()
        Dim aDTSource As DataTable = aDS.Tables.Item(1)

        Dim aSQL As string = "SELECT Agent, "
        
        For Each aDR In aDTSource.Rows
            aSQL &= "[" & aDR("Id") & "] as [" & aDR("Name") & "], "
        Next

        aSQL = aSQL.Substring(0, aSQL.Length-2)

        
        aSQL &= " from "
        aSQL &= "(SELECT IIF(PR_AGENTID = 0, 'N/A', UR_NAME) AS Agent, TBL_PROPERTYTYPE.PT_ID as PTID, COUNT(PR_ID) AS Props FROM TBL_PROPERTY INNER JOIN TBL_PROPERTYTYPE ON TBL_PROPERTY.PR_PROPERTYTYPE=TBL_PROPERTYTYPE.PT_ID "
        aSQL &= "LEFT OUTER JOIN TBL_USER ON TBL_PROPERTY.PR_AGENTID=TBL_USER.UR_ID "
        aSQL &= "WHERE PR_CREATEDON >= '" + sDate + "' AND PR_CREATEDON <= '" + eDate + "' GROUP BY PR_AGENTID, UR_NAME, PT_ID) x pivot (sum(Props) for PTID in ( "

       For Each aDR In aDTSource.Rows
            aSQL &= "[" & aDR("Id") & "], "
        Next

        aSQL = aSQL.Substring(0, aSQL.Length-2)

        aSQL &= ")) p"

        Dim aDT As DataTable = DB.ReadDT_Text(aSQL, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, False, true)

        AddGrandTotals(aDT)

        tblData.CssClass = "grid grid3"
        tblData.DataSource = aDT
        tblData.DataBind()
    End Sub

    Protected Sub GetReport4(sDate As String, eDate As string)
        'Details
        Dim aConContext As ConnectionContext = New ConnectionContext()
        Dim aDB As ConnectionContextConnection = aConContext.ConnectionEntryFromMapping("KSARE.First")
        Dim aDR As DataRow 
        Dim aDS As DataSet = GetLookups()
        Dim aDTSource As DataTable = DB.ReadDT_Text("Select Distinct UR_ID as Id, UR_Name as Name from Tbl_User Where UR_ID in (Select PR_AgentId from Tbl_Property where PR_CreatedON >='" & sDate & "' and PR_CREATEDON <='" & eDate & "')", Nothing, aDB.Connection, aDB.ConnectionString, Nothing, false, false, false)

        Dim aSQL As string = "SELECT City, "
        
        For Each aDR In aDTSource.Rows
            aSQL &= "[" & aDR("Id") & "] as [" & aDR("Name") & "], "
        Next

        aSQL = aSQL.Substring(0, aSQL.Length-2)

        
        aSQL &= " from "
        aSQL &= "(SELECT IIF(PR_CITY = 0, 'N/A', CI_NAME) AS CITY, PR_AGENTID AS AGENT, COUNT(PR_ID) AS Props FROM TBL_PROPERTY LEFT OUTER JOIN TBL_CITY ON TBL_PROPERTY.PR_CITY=TBL_CITY.CI_ID  LEFT OUTER JOIN TBL_USER ON TBL_PROPERTY.PR_AGENTID=TBL_USER.UR_ID "
        aSQL &= "WHERE PR_CREATEDON >= '" + sDate + "' AND PR_CREATEDON <= '" + eDate + "' GROUP BY PR_CITY, CI_NAME, PR_AGENTID) x  pivot (sum(Props) for AGENT in ("

       For Each aDR In aDTSource.Rows
            aSQL &= "[" & aDR("Id") & "], "
        Next

        aSQL = aSQL.Substring(0, aSQL.Length-2)

        aSQL &= ")) p"

        Dim aDT As DataTable = DB.ReadDT_Text(aSQL, Nothing, aDB.Connection, aDB.ConnectionString, Nothing, False, True, true)

        AddGrandTotals(aDT)

        tblData.CssClass = "grid grid4"
        tblData.DataSource = aDT
        tblData.DataBind()
    End Sub

    Private Sub cmdGo_Click(sender As Object, e As EventArgs) Handles cmdGo.Click
       If(cmbReports.SelectedIndex = 0)
            GetReport1(txtSDate.Text, txtEDate.Text)
       elseIf(cmbReports.SelectedIndex = 1)
            GetReport2(txtSDate.Text, txtEDate.Text)
       elseIf(cmbReports.SelectedIndex = 2)
            GetReport3(txtSDate.Text, txtEDate.Text)
       elseIf(cmbReports.SelectedIndex = 3)
            GetReport4(txtSDate.Text, txtEDate.Text)
       End If
    End Sub

End Class
