﻿Imports System.Data

Partial Class Backend_FrmSearchClientRequests
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aError As String

    Protected Sub Page_Error(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Error
        Dim aTicketNumber As Integer
        Dim aErrorPath As String = Request.Path
        Dim aErrorDescription As String = Server.GetLastError.GetBaseException.ToString
        Dim aObj As LOG

        Context.ClearError()

        Try
            aObj = LOG.Create()

            aObj.ErrorPath = aErrorPath
            aObj.ErrorDescription = aErrorDescription

            aObj.Persist(True)

            aTicketNumber = aObj.ID
        Catch Ex As Exception
            aTicketNumber = -1
        End Try

        Cache("LastErrorPath") = aErrorPath
        Cache("LastErrorDescription") = aErrorDescription
        Cache("LastErrorTicketNumber") = aTicketNumber.ToString

        'If Me.aRedirectOption = RedirectOptionEnum.Transfer Then
        '    Server.Transfer("frmLogin.aspx", False)
        'Else
        Response.Redirect("frmLogin.aspx", False)
        'End If
    End Sub

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAgent = False AndAlso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(true, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function

    Private Sub FillLookups()
        Dim aDS As DataSet
        Dim aDR As DataRow

        aDS = BackEnd.ClientRequest2.GetSearchFormLookups()

        'Importance
        With Cmb_Importance
            .Items.Add(New System.Web.UI.WebControls.ListItem("Any", 0))

            For Each aDR In aDS.Tables(0).Rows
                .Items.Add(New System.Web.UI.WebControls.ListItem(aDR("Name"), aDR("ID")))
            Next
        End With

        'Urgency
        With Cmb_Urgency
            .Items.Clear()

            .Items.Add(New System.Web.UI.WebControls.ListItem("Any", "0"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Normal", "1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Urgent", "2"))
        End With
    End Sub

    Private Sub SelectInCombo(ByVal aItemID As String, ByVal aCombo As DropDownList)
        Dim i As Integer

        For i = 0 To aCombo.Items.Count - 1
            If aCombo.Items(i).Value = aItemID Then
                aCombo.SelectedIndex = i
                Return
            End If
        Next
    End Sub

    Protected Function CreateEmptySearchDT() As DataTable
        Dim aResult As New DataTable

        With aResult
            .Columns.Add("Id", GetType(Integer))
            .Columns.Add("IsChecked", GetType(Boolean))
            .Columns.Add("RequestKey", GetType(String))
            .Columns.Add("Client", GetType(String))
            .Columns.Add("Cell", GetType(String))
            .Columns.Add("PrimaryAgent", GetType(String))
            .Columns.Add("Status", GetType(String))
            .Columns.Add("CreatedOn", GetType(String))
            .Columns.Add("Tags", GetType(String))

            .Rows.Add()
        End With

        
        Return aResult
    End Function

    Private Sub Backend_frmSearch_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.Img_Status.Visible = False

        If ValidateUser = False Then Return

        aError = ""

        If Me.IsPostBack = False
            Me.FillLookups()

            GV.DataSource = Me.CreateEmptySearchDT()
            GV.DataBind()

            GV.UseAccessibleHeader = true
            GV.HeaderRow.TableSection = TableRowSection.TableHeader
        End If
    End Sub


End Class
