﻿Imports System.Data

Partial Class Backend_frmClients2
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aError As String

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsAgent = False Andalso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(True, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function

    Private Sub Backend_frmClientsRequests2_Load(sender As Object, e As EventArgs) Handles Me.Load
        If ValidateUser = False Then Return

        Me.Img_Status.Visible=false

        If Me.IsPostBack = False
            Me.FillLookups()

            GotoNewMode()
        End If
    End Sub

    Private Sub FillLookups()
        Dim aDS As DataSet
        Dim aDR As DataRow 

        aDS = BackEnd.Client2.GetFormLookups()

        'Source
        With Cmb_Source 
            .Items.Add(New System.Web.UI.WebControls.ListItem("Other", 0))

            For Each aDR In aDS.Tables(0).Rows
                .Items.Add(New System.Web.UI.WebControls.ListItem(aDR("Title"), aDR("ID")))
            Next
        End With
    End Sub

    Private Sub SelectInCombo(ByVal aItemID As String, ByVal aCombo As DropDownList)
        Dim i As Integer

        For i = 0 To aCombo.Items.Count - 1
            If aCombo.Items(i).Value = aItemID Then
                aCombo.SelectedIndex = i
                Return
            End If
        Next
    End Sub

    Private Sub ClearControls()
        Txt_Name.Text=""
        Txt_Cell.Text=""
        Txt_Phone.Text=""
        Txt_Email.Text=""
        Txt_Address.Text=""
        Cmb_Source.SelectedIndex = 0
        Txt_CreatedOn.Text=Month(Now) & "/" & Day(Now) & "/" & Year(Now) & " " & Hour(Now) & ":" & IIF(Minute(Now) < 10, "0" & Minute(Now).ToString(), Minute(Now).ToString())
        Chk_IsActive.Checked=True 
        'Txt_Notes.Text=""
        Txt_Info.Text=""
    End Sub

    Private Sub GotoNewMode()
        Me.ClearControls()

        'Annulate Client
        Me.HF_ClientId.Value = ""
        Txt_Client.Text = ""

        Me.HF_Mode.Value=1
        Cmd_Save.Text = "Save"

        Txt_Name.Focus()
    End Sub

    Private sub GotoEditMode(id As integer)
        Dim aObj As BackEnd.Client2
        Dim aTagsIds As String = "", aTagsTitles As String = ""

        Try
            'Load CR with ID=id
            aObj = BackEnd.Client2.Load(id, aTagsIds, aTagsTitles)

            'Handle Security
            If aObj Is Nothing Then
                GotoNewMode()
                return
            End If

            'Clear Controls
            Me.ClearControls()

            'Bind Controls
            With aObj
                HF_ClientId.Value = .Id
                Txt_Client.Text = .Name '& " - " & .Cell 

                Txt_Name.Text = .Name 
                Txt_Cell.Text = .Cell
                Txt_Phone.Text= .Phone
                Txt_Email.Text = .Email 
                Txt_Address.Text = .Address
                SelectInCombo(.Source, Cmb_Source)
                Txt_CreatedOn.Text=Month(.CreatedOn) & "/" & Day(.CreatedOn) & "/" & Year(.CreatedOn) & " " & .CreatedOn.Hour.ToString("00") & ":" & .CreatedOn.Minute.ToString("00")
                Chk_IsActive.Checked = .IsActive 
                'Txt_Notes.Text=.Notes
                Txt_Info.Text = .Info

                'Tags
                HF_TagsIds.Value = aTagsIds
                HF_TagsTitles.Value = aTagsTitles 
            End With

            Me.HF_Mode.Value=2
            Cmd_Save.Text = "Save"

            Txt_Name.Focus()
        Catch ex As Exception
            aError = ex.Message 
            GotoNewMode()
        End Try
    End sub

    Protected Sub Cmd_Go_Click(sender As Object, e As EventArgs)
        Dim aId As String = HF_ClientId.Value

        If aId Is Nothing OrElse IsNumeric(aId) = False OrElse CInt(aId<1) Then
            aError="Invalid client."
            Return
        End If

        GotoEditMode(CInt(aId))
    End Sub

    Protected Sub Cmd_New_Click(sender As Object, e As EventArgs)
        Me.GotoNewMode()
    End Sub
   
    Protected Function  PackObject () As BackEnd.Client2 
        Dim aResult As New BackEnd.Client2 

        With aResult 
            If HF_ClientId.Value IsNot Nothing AndAlso IsNumeric(HF_ClientId.Value) Then
                .Id = CInt(HF_ClientId.Value)
            Else
                .Id = 0
            End If

            .Name = Txt_Name.Text
            .Cell=Txt_Cell.Text
            .Phone = Txt_Phone.Text 
            .Email = Txt_Email.Text 
            .Address  = Txt_Address.Text 
            .Source = Cmb_Source.SelectedValue
            .CreatedBy = 0 : If aCurrentUser IsNot Nothing Then .CreatedBy = aCurrentUser.ID 
            .IsActive = Chk_IsActive.Checked 
            .CreatedOn = Txt_CreatedOn.Text 
            '.Notes = Txt_Notes.Text 
            .Info = Txt_Info.Text
        End With

        Return aResult 
    End Function

    Protected Sub Cmd_Save_Click(sender As Object, e As EventArgs)
        If Me.ValidateUser() = False Then Return

        Try
            If HF_Mode.Value = 1 Then
                Me.Insert()
            ElseIf HF_Mode.Value = 2 Then
                Me.Update()
            End If

            Me.Img_Status.Visible=True 
        Catch ex As Exception
            aError = ex.Message 
        End Try

    End Sub

    Protected Sub Insert()
        Dim aObj As BackEnd.Client2
        Dim aTagsIds As String = ""
        Dim aTagsTitles As String = ""

        aObj = Me.PackObject()

        'Fill Tags
        If HF_TagsIds.Value IsNot Nothing AndAlso HF_TagsIds.Value.Trim() <> "" AndAlso HF_TagsTitles.Value IsNot Nothing AndAlso HF_TagsTitles.Value.Trim() <> "" Then
            aTagsIds = HF_TagsIds.Value.Trim()
            aTagsTitles = HF_TagsTitles.Value.Trim()
        End If

        BackEnd.Client2.Create(aObj, aTagsIds, aTagsTitles)

        Me.GotoEditMode(aObj.Id)
    End Sub

    Protected Sub Update()
        Dim aObj As BackEnd.Client2
        Dim aTagsIds As String = ""
        Dim aTagsTitles As String = ""

        aObj = Me.PackObject()

        'Fill Tags
        If HF_TagsIds.Value IsNot Nothing AndAlso HF_TagsIds.Value.Trim() <> "" AndAlso HF_TagsTitles.Value IsNot Nothing AndAlso HF_TagsTitles.Value.Trim() <> "" Then
            aTagsIds = HF_TagsIds.Value.Trim()
            aTagsTitles = HF_TagsTitles.Value.Trim()
        End If


        BackEnd.Client2.Update(aObj, aTagsIds, aTagsTitles)

        Txt_Client.Text = Txt_Name.Text.Trim() 
    End Sub

End Class
