﻿Imports System.Data

Partial Class Backend_frmClientsRequests2
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aError As String
    Public aSearchError As String

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsAgent = False Andalso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(True, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function

    Private Sub ReconstructLists()
        Dim propertiesIds As String = HF_PropertiesIds.Value
        Dim propertiesTitles As String = HF_PropertiesTitles.Value
        Dim districtsIds As String = HF_DistrictsIds.Value
        Dim districtsTitles As String = HF_DistrictsTitles.Value
        Dim citiesIds As String = HF_CitiesIds.Value
        Dim citiesTitles As String = HF_CitiesTitles.Value
        Dim citiesGroupsIds As String = HF_CitiesGroupsIds.Value
        Dim citiesGroupsTitles As String = HF_CitiesGroupsTitles.Value
        Dim notCitiesIds As String = HF_NotCitiesIds.Value
        Dim notCitiesTitles As String = HF_NotCitiesTitles.Value
        Dim propertyTypesIds As String = HF_PropertyTypesIds.Value
        Dim propertyTypesTitles As String = HF_PropertyTypesTitles.Value

        Dim arrIds As String()
        Dim arrTitles As String()
        Dim i As Integer

        Lst_Properties.Items.Clear()
        If propertiesIds <> "" Then
            arrIds = propertiesIds.Split(",")
            arrTitles = propertiesTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_Properties.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_Districts.Items.Clear()
        If districtsIds <> "" Then
            arrIds = districtsIds.Split(",")
            arrTitles = districtsTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_Districts.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_CitiesGroups.Items.Clear()
        If citiesGroupsIds <> "" Then
            arrIds = citiesGroupsIds.Split(",")
            arrTitles = citiesGroupsTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_CitiesGroups.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_Cities.Items.Clear()
        If citiesIds <> "" Then
            arrIds = citiesIds.Split(",")
            arrTitles = citiesTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_Cities.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_NotCities.Items.Clear()
        If notCitiesIds <> "" Then
            arrIds = notCitiesIds.Split(",")
            arrTitles = notCitiesTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_NotCities.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_PropertyTypes.Items.Clear()
        If propertyTypesIds <> "" Then
            arrIds = propertyTypesIds.Split(",")
            arrTitles = propertyTypesTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_PropertyTypes.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

    End Sub

    Private Sub FillLookups()
        Dim aDS As DataSet
        Dim aDR As DataRow

        aDS = BackEnd.ClientRequest2.GetFormLookups()

        'Created By
        With Cmb_CreatedBy
            .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", 0))

            For Each aDR In aDS.Tables(0).Rows
                .Items.Add(New System.Web.UI.WebControls.ListItem(aDR("Name"), aDR("ID")))
            Next
        End With

        'Source
        With Cmb_Source
            .Items.Add(New System.Web.UI.WebControls.ListItem("Other", 0))

            For Each aDR In aDS.Tables(1).Rows
                .Items.Add(New System.Web.UI.WebControls.ListItem(aDR("Title"), aDR("ID")))
            Next
        End With

        'Age
        With Cmb_Age
            .Items.Clear()

            .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", "0"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("<= 5 Years", "-1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("<= 10 Years", "-2"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("<= 15 Years", "-3"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("<= 20 Years", "-4"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("New", "1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Under C.", "2"))
        End With

        'Urgency
        With Cmb_Urgency
            .Items.Clear()

            .Items.Add(New System.Web.UI.WebControls.ListItem("Normal", "1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Urgent", "2"))
        End With

        'Importance
        With Cmb_Importance
            For Each aDR In aDS.Tables(3).Rows
                .Items.Add(New System.Web.UI.WebControls.ListItem(aDR("Name"), aDR("ID")))
            Next
        End With


        'View
        With Cmb_View
            .Items.Clear

            .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", "0"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Any View", "1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("City", "2"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Mountain", "3"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Sea View", "4"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("City + Mountain", "5"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("City + Sea", "6"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Mountain + Sea", "7"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("All", "8"))
        End With

        'Parking
        With Cmb_Parking
            .Items.Clear

            .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", "0"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Any", "1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Uncovered", "2"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Covered", "3"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Underground", "4"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Cov. Or Un.", "5"))
        End With
    End Sub

    Private Sub SelectInCombo(ByVal aItemID As String, ByVal aCombo As DropDownList)
        Dim i As Integer

        For i = 0 To aCombo.Items.Count - 1
            If aCombo.Items(i).Value = aItemID Then
                aCombo.SelectedIndex = i
                Return
            End If
        Next
    End Sub

    Private Sub Backend_frmClientsRequests2_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim aQSID As String

        If ValidateUser = False Then Return

        aError = ""
        aSearchError = ""

        'Success Status
        Me.Img_Status.Visible = False

        If Me.IsPostBack = False
            Me.FillLookups()

            'Handle Opening CR from outside
            aQSID = Request.QueryString("id")
            If (IsNumeric(aQSID) AndAlso CInt(aQSID) > 0) Then
                GotoEditMode(CInt(aQSID))
            Else
                GotoNewMode()
                If Session("CreateSearchRequest") IsNot Nothing Then
                    FillControlsFromSession()
                    Session("CreateSearchRequest") = Nothing 
                End If
            End If

            HF_TagsIds.Value = ""
            HF_TagsTitles .Value =""
        Else
            Me.ReconstructLists()
        End If
    End Sub

    Protected Sub FillControlsFromSession()
        Dim arr1 As String(), arr2 As String()
        Dim aObj As BackEnd.ClientRequest2 = Session("CreateSearchRequest")

        Try
            With aObj
                Opt_Surface.Checked = .AreaType = 1
                Opt_Sellable.Checked = .AreaType = 2
                Txt_AreaMin.Text = .AreaMin 
                Txt_AreaMax.Text = .AreaMax 
                Chk_ForSale.Checked = .ForSale 
                Txt_SaleMin.Text = .SaleMin
                Txt_SaleMax.Text = .SaleMax
                Chk_ForRent.Checked = .ForRent
                Txt_RentMin.Text = .RentMin
                Txt_RentMax.Text = .RentMax
                Txt_BedroomsMin.Text = .BedroomsMin
                Txt_BedroomsMax.Text = .BedroomsMax
                SelectInCombo(.View, Cmb_View)
                SelectInCombo(.Age, Cmb_Age)

                'Properties
                HF_PropertiesIds.Value = .PropertiesIds 
                HF_PropertiesTitles.Value = .PropertiesTitles 
                Lst_Properties.Items.Clear()

                If .PropertiesIds <> "" Then
                    arr1 = .PropertiesIds.Split(",")
                    arr2 = .PropertiesTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_Properties.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'Districts
                HF_DistrictsIds.Value = .DistrictsIds 
                HF_DistrictsTitles.Value = .DistrictsTitles 
                Lst_Districts.Items.Clear()

                If .DistrictsIds <> "" Then
                    arr1 = .DistrictsIds.Split(",")
                    arr2 = .DistrictsTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_Districts.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'CitiesGroups
                HF_CitiesGroupsIds.Value = .CitiesGroupsIds 
                HF_CitiesGroupsTitles.Value = .CitiesGroupsTitles 
                Lst_CitiesGroups.Items.Clear()

                If .CitiesGroupsIds <> "" Then
                    arr1 = .CitiesGroupsIds.Split(",")
                    arr2 = .CitiesGroupsTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_CitiesGroups.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'Cities
                HF_CitiesIds.Value = .CitiesIds 
                HF_CitiesTitles.Value = .CitiesTitles 
                Lst_Cities.Items.Clear()

                If .CitiesIds <> "" Then
                    arr1 = .CitiesIds.Split(",")
                    arr2 = .CitiesTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_Cities.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'NotCities
                HF_NotCitiesIds.Value = .NotCitiesIds 
                HF_NotCitiesTitles.Value = .NotCitiesTitles 
                Lst_NotCities.Items.Clear()

                If .NotCitiesIds <> "" Then
                    arr1 = .NotCitiesIds.Split(",")
                    arr2 = .NotCitiesTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_NotCities.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'PropertyTypes
                HF_PropertyTypesIds.Value = .PropertyTypesIds
                HF_PropertyTypesTitles.Value = .PropertyTypesTitles
                Lst_PropertyTypes.Items.Clear()

                If .PropertyTypesIds <> "" Then
                    arr1 = .PropertyTypesIds.Split(",")
                    arr2 = .PropertyTypesTitles.Split(",")

                    For i As Integer = 0 To arr1.Length - 1
                        Lst_PropertyTypes.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If


                SelectInCombo(.ParkingType, Cmb_Parking)
                Txt_Parking.Text = .ParkingCount 

                'Checkboxes
                Chk_Balcony.Checked = .Balcony
                Chk_BIW.Checked = .BIW
                Chk_CentralAC.Checked = .CentralAC
                Chk_Commercial.Checked = .Commercial
                Chk_Concierge.Checked = .Concierge
                Chk_Decorated.Checked = .Decorated
                Chk_DoubleGlazing.Checked = .DoubleG
                Chk_Duplex.Checked = .Duplex
                Chk_FirstFloor.Checked = .FirstFloor
                Chk_ForRent.Checked = .ForRent
                Chk_ForSale.Checked = .ForSale
                Chk_Furnished.Checked = .Furnished
                Chk_Garden.Checked = .Garden
                Chk_GF.Checked = .GF
                Chk_Heating.Checked = .Heating
                Chk_Interphone.Checked = .Interphone
                Chk_NotGF.Checked = .NotGF 
                Chk_LTB.Checked = .LTB
                Chk_Lux.Checked = .Lux
                Chk_MaidBath.Checked = .MaidBath
                Chk_MaidRoom.Checked = .MaidRoom
                Chk_NoSlope.Checked = .NoSlope
                Chk_NotFirstFloor.Checked = .NotFirstFloor
                Chk_NotLastFloor.Checked = .NotLastFloor
                Chk_PetsAllowed.Checked = .Pets
                Chk_Pool.Checked = .Pool
                Chk_Roof.Checked = .Roof
                Chk_Security.Checked=.Security
                Chk_Solar.Checked = .Solar
                Chk_Storage.Checked = .Storage
                Chk_Terrace.Checked = .Terrace
                Chk_NotUsed.Checked = .NotUsed
                Chk_VideoPhone.Checked = .Videophone
                Chk_WillExchange.Checked=.Exchange 

                Txt_ClientNotes.Text = .ClientNotes
                'Txt_AgentNotes.Text = .AgentNotes
                SelectInCombo(.Urgency, Cmb_Urgency)
                SelectInCombo(.CreatedBy, Cmb_CreatedBy)
                Txt_CreatedOn.Text = Month(.CreatedOn) & "/" & Day(.CreatedOn) & "/" & Year(.CreatedOn) & " " & .CreatedOn.Hour.ToString("00") & ":" & .CreatedOn.Minute.ToString("00")

                Txt_Client.Focus()
            End With

        Catch ex As Exception
            aError = ex.Message 
        End Try
      End Sub

    Private Sub ClearControls()
        HF_ClientId.Value = ""
        HF_PropertiesIds.Value = ""
        HF_PropertiesTitles.Value = ""
        HF_DistrictsIds.Value = ""
        HF_DistrictsTitles.Value = ""
        HF_CitiesGroupsIds.Value = ""
        HF_CitiesGroupsTitles.Value = ""
        HF_CitiesIds.Value = ""
        HF_CitiesTitles.Value=""
        HF_NotCitiesIds.Value = ""
        HF_NotCitiesTitles.Value=""
        HF_StatusId.Value = ""
        HF_SubstatusId.Value = ""

        Txt_Client.Text = ""
        Txt_Cell.Text = ""
        Txt_Email.Text = ""
        Cmb_Source.SelectedIndex = 0
        'Cmb_PropertyType.SelectedIndex = 0

        Opt_Surface.Checked=False :Opt_Sellable.Checked=True
        Txt_AreaMin.Text = "0" : Txt_AreaMax.Text = "0" : Txt_AreaMin.Text = "0"
        Chk_ForSale.Checked = False : Txt_SaleMin.Text = "0" : Txt_SaleMax.Text = "0"
        Chk_ForRent.Checked = False : Txt_RentMin.Text = "0" : Txt_RentMax.Text = "0"
        Txt_BedroomsMin.Text = "0" : Txt_BedroomsMax.Text = "" : Txt_BedroomsMax.Text = "0"
        Cmb_View.SelectedIndex = 0
        Cmb_Age.SelectedIndex = 0

        Txt_Properties.Text="" : Lst_Properties.Items.Clear()
        Txt_Districts.Text="" : Lst_Districts.Items.Clear()
        Txt_CitiesGroups.Text="" : Lst_CitiesGroups.Items.Clear()
        Txt_Cities.Text="" : Lst_Cities.Items.Clear()
        Txt_NotCities.Text="" : Lst_NotCities.Items.Clear()
        Txt_PropertyTypes.Text="" : Lst_PropertyTypes.Items.Clear()

        Cmb_Parking.SelectedIndex = 0: Txt_Parking.Text="0"

        Chk_BIW.Checked=False
        Chk_CentralAC.Checked=False
        Chk_Commercial.Checked=False
        Chk_Concierge.Checked=False
        Chk_Decorated.Checked=False
        Chk_DoubleGlazing.Checked=False
        Chk_Duplex.Checked=False
        Chk_LTB.Checked=False        
        Chk_Furnished.Checked=False
        Chk_Heating.Checked=False
        Chk_Interphone.Checked=False
        Chk_NotGF.Checked=False
        Chk_Lux.Checked=False
        Chk_MaidRoom.Checked=False
        Chk_MaidBath.Checked=False
        Chk_NoSlope.Checked=False
        Chk_PetsAllowed.Checked=False
        Chk_Pool.Checked=False
        Chk_Roof.Checked=False
        Chk_Security.Checked=False
        Chk_Solar.Checked=False
        Chk_Storage.Checked=False
        Chk_NotUsed.Checked=False
        Chk_VideoPhone.Checked=False
        Chk_WillExchange.Checked=False   
        Chk_GF.Checked = False 
        Chk_FirstFloor.Checked=False
        Chk_NotFirstFloor.Checked=False
        Chk_NotLastFloor.Checked=False
        Chk_Garden.Checked=False
        Chk_Terrace.Checked=False   
        Chk_Balcony.Checked = False

        Txt_ClientNotes.Text = ""
        'Txt_AgentNotes.Text = ""
        Txt_Tags.Text = ""
        If aCurrentUser IsNot Nothing Then SelectInCombo(aCurrentUser.ID, Cmb_CreatedBy)
        Chk_MatchNotify.Checked = true

        Txt_CreatedOn.Text = Month(Now) & "/" & Day(Now) & "/" & Year(Now) & " " & Hour(Now) & ":" & Minute(Now)
        Cmb_Urgency.SelectedIndex = 0
        Txt_Status.Text = ""
        Cmb_Importance.SelectedIndex = 0

        HF_StatusId.Value = BackEnd.ClientRequestStatuses.[New]
        HF_SubstatusId.Value = BackEnd.ClientRequestSubstatuses.ClientNotContactedYet     
        Txt_Status.Text = "New - Client Not Contacted Yet"
    End Sub

    Private Sub GotoNewMode()
        Me.ClearControls()

        Txt_Client.Enabled = True

        'Annulate Request
        Me.HF_RequestId.Value = ""
        Txt_Request.Text = ""

        Me.HF_Mode.Value = 1
        Cmd_Save.Text = "Save"

        Txt_Client.Focus()
    End Sub

    Private sub GotoEditMode(id As integer)
        Dim aObj As BackEnd.ClientRequest2
        Dim arr1 As String(), arr2 As String()
        Dim aTagsIds As String = "", aTagsTitles As String = ""

        Try
            'Load CR with ID=id
            aObj = BackEnd.ClientRequest2.Load(id, aCurrentUser.ID, aCurrentUser.IsAdmin = False Andalso aCurrentUser.IsSuperUser = False, aTagsIds, aTagsTitles)

            'Handle Security
            If aObj Is Nothing Then
                GotoNewMode()
                return
            End If

            'Clear Controls
            Me.ClearControls()

            'Bind Controls
            With aObj
                HF_RequestId.Value = .Id
                Txt_Request.Text = "CR-" & .Id

                HF_ClientId.Value = .ClientID
                Txt_Client.Text = .ClientName
                Txt_Cell.Text = .Cell
                Txt_Email.Text = .Email
                SelectInCombo(.Source, Cmb_Source)
                'SelectInCombo(.PropertyType, Cmb_PropertyType) 

                Opt_Surface.Checked = .AreaType = 1
                Opt_Sellable.Checked = .AreaType = 2
                Txt_AreaMin.Text = .AreaMin 
                Txt_AreaMax.Text = .AreaMax 
                Chk_ForSale.Checked = .ForSale 
                Txt_SaleMin.Text = .SaleMin
                Txt_SaleMax.Text = .SaleMax
                Chk_ForRent.Checked = .ForRent
                Txt_RentMin.Text = .RentMin
                Txt_RentMax.Text = .RentMax
                Txt_BedroomsMin.Text = .BedroomsMin
                Txt_BedroomsMax.Text = .BedroomsMax
                SelectInCombo(.View, Cmb_View)
                SelectInCombo(.Age, Cmb_Age)

                'Properties
                HF_PropertiesIds.Value = .PropertiesIds 
                HF_PropertiesTitles.Value = .PropertiesTitles 
                Lst_Properties.Items.Clear()

                If .PropertiesIds <> "" Then
                    arr1 = .PropertiesIds.Split(",")
                    arr2 = .PropertiesTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_Properties.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'Districts
                HF_DistrictsIds.Value = .DistrictsIds 
                HF_DistrictsTitles.Value = .DistrictsTitles 
                Lst_Districts.Items.Clear()

                If .DistrictsIds <> "" Then
                    arr1 = .DistrictsIds.Split(",")
                    arr2 = .DistrictsTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_Districts.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'CitiesGroups
                HF_CitiesGroupsIds.Value = .CitiesGroupsIds 
                HF_CitiesGroupsTitles.Value = .CitiesGroupsTitles 
                Lst_CitiesGroups.Items.Clear()

                If .CitiesGroupsIds <> "" Then
                    arr1 = .CitiesGroupsIds.Split(",")
                    arr2 = .CitiesGroupsTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_CitiesGroups.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'Cities
                HF_CitiesIds.Value = .CitiesIds 
                HF_CitiesTitles.Value = .CitiesTitles 
                Lst_Cities.Items.Clear()

                If .CitiesIds <> "" Then
                    arr1 = .CitiesIds.Split(",")
                    arr2 = .CitiesTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_Cities.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'NotCities
                HF_NotCitiesIds.Value = .NotCitiesIds 
                HF_NotCitiesTitles.Value = .NotCitiesTitles 
                Lst_NotCities.Items.Clear()

                If .NotCitiesIds <> "" Then
                    arr1 = .NotCitiesIds.Split(",")
                    arr2 = .NotCitiesTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_NotCities.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                'PropertyTypes
                HF_PropertyTypesIds.Value = .PropertyTypesIds  
                HF_PropertyTypesTitles.Value = .PropertyTypesTitles  
                Lst_PropertyTypes.Items.Clear()

                If .PropertyTypesIds <> "" Then
                    arr1 = .PropertyTypesIds.Split(",")
                    arr2 = .PropertyTypesTitles.Split(",")

                    For i As Integer = 0 To arr1.Length-1
                        Lst_PropertyTypes.Items.Add(New ListItem(arr2(i), arr1(i)))
                    Next
                End If

                SelectInCombo(.ParkingType, Cmb_Parking)
                Txt_Parking.Text = .ParkingCount 

                'Checkboxes
                Chk_Balcony.Checked = .Balcony
                Chk_BIW.Checked = .BIW
                Chk_CentralAC.Checked = .CentralAC
                Chk_Commercial.Checked = .Commercial
                Chk_Concierge.Checked = .Concierge
                Chk_Decorated.Checked = .Decorated
                Chk_DoubleGlazing.Checked = .DoubleG
                Chk_Duplex.Checked = .Duplex
                Chk_FirstFloor.Checked = .FirstFloor
                Chk_ForRent.Checked = .ForRent
                Chk_ForSale.Checked = .ForSale
                Chk_Furnished.Checked = .Furnished
                Chk_Garden.Checked = .Garden
                Chk_GF.Checked = .GF
                Chk_Heating.Checked = .Heating
                Chk_Interphone.Checked = .Interphone
                Chk_NotGF.Checked = .NotGF 
                Chk_LTB.Checked = .LTB
                Chk_Lux.Checked = .Lux
                Chk_MaidBath.Checked = .MaidBath
                Chk_MaidRoom.Checked = .MaidRoom
                Chk_NoSlope.Checked = .NoSlope
                Chk_NotFirstFloor.Checked = .NotFirstFloor
                Chk_NotLastFloor.Checked = .NotLastFloor
                Chk_PetsAllowed.Checked = .Pets
                Chk_Pool.Checked = .Pool
                Chk_Roof.Checked = .Roof
                Chk_Security.Checked=.Security
                Chk_Solar.Checked = .Solar
                Chk_Storage.Checked = .Storage
                Chk_Terrace.Checked = .Terrace
                Chk_NotUsed.Checked = .NotUsed
                Chk_VideoPhone.Checked = .Videophone
                Chk_WillExchange.Checked=.Exchange 

                Txt_ClientNotes.Text = .ClientNotes
                'Txt_AgentNotes.Text = .AgentNotes
                SelectInCombo(.Urgency, Cmb_Urgency)

                'Tags
                HF_TagsIds.Value = aTagsIds
                HF_TagsTitles.Value = aTagsTitles 

                'Importance
                SelectInCombo(.Importance, Cmb_Importance)

                Chk_MatchNotify.Checked = .MatchNotify

                'Status
                HF_StatusId.Value = .Status 
                HF_SubstatusId.Value = .Substatus
                Txt_Status.Text = .StatusText 

                SelectInCombo(.CreatedBy, Cmb_CreatedBy)
                Txt_CreatedOn.Text = Month(.CreatedOn) & "/" & Day(.CreatedOn) & "/" & Year(.CreatedOn) & " " & .CreatedOn.Hour.ToString("00") & ":" & .CreatedOn.Minute.ToString("00")

                'Request AutoComplete
                HF_RequestId.Value = .Id
                Txt_Request.Text = "CR-" & .Id
            End With

            Txt_Client.Enabled = False

            Me.HF_Mode.Value = 2
            Cmd_Save.Text = "Save"


            If aCurrentUser.IsAgent = True Then
                Txt_Cell.Focus()
            Else
                Txt_ClientNotes.Focus()
            End If
        Catch ex As Exception
            aError = ex.Message
            GotoNewMode()
        End Try
    End sub


    Protected Sub Cmd_Go_Click(sender As Object, e As EventArgs)
        Dim aId As String = HF_RequestId.Value

        'Security
        If aCurrentUser Is Nothing Then Return

        If aId Is Nothing OrElse IsNumeric(aId) = False OrElse CInt(aId < 1) Then
            aError = "Invalid request."
            Return
        End If

        GotoEditMode(CInt(aId))
    End Sub


    Protected Sub Cmd_New_Click(sender As Object, e As EventArgs)
        'Security
        If aCurrentUser Is Nothing Then Return

        Me.GotoNewMode()
    End Sub

    Protected Function  PackObject () As BackEnd.ClientRequest2 
        Dim aResult As New BackEnd.ClientRequest2

        With aResult
            If HF_RequestId.Value IsNot Nothing AndAlso IsNumeric(HF_RequestId.Value) Then
                .Id = CInt(HF_RequestId.Value)
            Else
                .Id = 0
            End If

            .ClientId = 0
            If HF_ClientId.Value IsNot Nothing AndAlso IsNumeric(HF_ClientId.Value) Then .ClientId = CInt(HF_ClientId.Value)
            .ClientName = Txt_Client.Text
            .Cell = Txt_Cell.Text
            .Email = Txt_Email.Text
            .Source = Cmb_Source.SelectedValue
            '.PropertyType = Cmb_PropertyType.SelectedValue

            If Opt_Sellable.Checked = True Then
                .AreaType = 2
            Else
                .AreaType = 1
            End If
            .AreaMin = Txt_AreaMin.Text : .AreaMax=Txt_AreaMax.Text
            .ForSale = Chk_ForSale.Checked : .SaleMin = Txt_SaleMin.Text : .SaleMax = Txt_SaleMax.Text
            .ForRent = Chk_ForRent.Checked : .RentMin = Txt_RentMin.Text : .RentMax = Txt_RentMax.Text
            .BedroomsMin = Txt_BedroomsMin.Text : .BedroomsMax = Txt_BedroomsMax.Text
            .View = Cmb_View.SelectedValue
            .Age = Cmb_Age.SelectedValue

            .PropertiesIds = iif(HF_PropertiesIds.Value Is Nothing, "", HF_PropertiesIds.Value)
            .DistrictsIds = iif(HF_DistrictsIds.Value Is Nothing, "", HF_DistrictsIds.Value)
            .CitiesGroupsIds = iif(HF_CitiesGroupsIds.Value Is Nothing, "", HF_CitiesGroupsIds.Value)
            .CitiesIds = iif(HF_CitiesIds.Value Is Nothing, "", HF_CitiesIds.Value)
            .NotCitiesIds = iif(HF_NotCitiesIds.Value Is Nothing, "", HF_NotCitiesIds.Value)
            .PropertyTypesIds = iif(HF_PropertyTypesIds.Value Is Nothing, "", HF_PropertyTypesIds.Value)

            .ParkingType = Cmb_Parking.SelectedValue
            .ParkingCount = Txt_Parking.Text

            .LTB = Chk_LTB.Checked 
            .Furnished = Chk_Furnished.Checked
            .Decorated = Chk_Decorated.Checked
            .NotUsed = Chk_NotUsed.Checked
            .Lux = Chk_Lux.Checked
            .Duplex = Chk_Duplex.Checked
            .Commercial = Chk_Commercial.Checked
            .Exchange = Chk_WillExchange.Checked
            .NoSlope = Chk_NoSlope.Checked
            .GF = Chk_GF.Checked
            .FirstFloor = Chk_FirstFloor.Checked
            .NotGF = Chk_NotGF.Checked
            .NotFirstFloor = Chk_NotFirstFloor.Checked
            .NotLastFloor = Chk_NotLastFloor.Checked
            .Garden = Chk_Garden.Checked
            .Terrace = Chk_Terrace.Checked
            .Balcony = Chk_Balcony.Checked
            .MaidRoom = Chk_MaidRoom.Checked
            .MaidBath = Chk_MaidBath.Checked
            .Heating = Chk_Heating.Checked
            .Solar = Chk_Solar.Checked
            .CentralAC = Chk_CentralAC.Checked
            .Storage = Chk_Storage.Checked
            .DoubleG = Chk_DoubleGlazing.Checked
            .Interphone = Chk_Interphone.Checked
            .Videophone = Chk_Videophone.Checked
            .BIW = Chk_BIW.Checked
            .Concierge = Chk_Concierge.Checked
            .Security = Chk_Security.Checked
            .Pool = Chk_Pool.Checked
            .Pets = Chk_PetsAllowed.Checked
            .Roof = Chk_Roof.Checked

            .ClientNotes = Txt_ClientNotes.Text
            '.AgentNotes = Txt_AgentNotes.Text
            .CreatedOn = Txt_CreatedOn.Text
            .CreatedBy = Cmb_CreatedBy.SelectedValue
            .Urgency = Cmb_Urgency.SelectedValue
            .Importance = Cmb_Importance.SelectedValue
            .MatchNotify = Chk_MatchNotify.Checked

            .Status = HF_StatusId.Value
            .Substatus = HF_SubstatusId.Value 

            .PrimaryAgent = 0
        End With

        Return aResult 
    End Function

    Protected Sub Cmd_Save_Click(sender As Object, e As EventArgs)
        'Security
        If aCurrentUser Is Nothing Then Return

        Try
            If HF_Mode.Value = 1 Then
                Me.Insert()
            ElseIf HF_Mode.Value = 2 Then
                Me.Update()
            End If

            Img_Status.Visible = True
        Catch ex As Exception
            aError = ex.Message
        End Try

    End Sub

    Protected Sub Insert()
        Dim aObj As BackEnd.ClientRequest2
        Dim aMessageTitle As String = "", aMessage As String = ""
        Dim aTagsIds As String = ""
        Dim aTagsTitles As String = ""

        aObj = Me.PackObject()

        'Fill Tags
        If HF_TagsIds.Value IsNot Nothing AndAlso HF_TagsIds.Value.Trim() <> "" AndAlso HF_TagsTitles.Value IsNot Nothing AndAlso HF_TagsTitles.Value.Trim() <> "" Then
            aTagsIds = HF_TagsIds.Value.Trim()
            aTagsTitles = HF_TagsTitles.Value.Trim()
        End If

        BackEnd.ClientRequest2.Create(aObj, aMessageTitle, aTagsIds, aTagsTitles, aMessage)

        Me.GotoEditMode(aObj.Id)

        'Display the message
        HF_ShowPopup.Value = "True"
        Lbl_MessageTitle.Text = aMessageTitle
        Txt_Message.Text = aMessage
    End Sub

    Protected Sub Update()
        Dim aObj As BackEnd.ClientRequest2
        Dim aTagsIds As String = ""
        Dim aTagsTitles As String = ""

        aObj = Me.PackObject()

        'Fill Tags
        If HF_TagsIds.Value IsNot Nothing AndAlso HF_TagsIds.Value.Trim() <> "" AndAlso HF_TagsTitles.Value IsNot Nothing AndAlso HF_TagsTitles.Value.Trim() <> "" Then
            aTagsIds = HF_TagsIds.Value.Trim()
            aTagsTitles = HF_TagsTitles.Value.Trim()
        End If

        BackEnd.ClientRequest2.Update(aObj, aTagsIds, aTagsTitles)
    End Sub

End Class
