﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="frmNotifications.aspx.vb" Inherits="Backend_frmNotifications" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    
     <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous" />
    <link rel="stylesheet" href="fontawesome/css/font-awesome.min.css" />

    <!--My Every Page -->
    <link rel="Stylesheet" href="css/page.css" />


    <style>
        .toolbar{
            justify-content:space-between !important;
            padding-top:4px !important;
            padding-bottom:4px !important;
        }

        .cell{
            display: flex;
            flex-direction:column;
            margin-left:8px;
        }

        .cmbStatus{
            width:100px !important;
        }

        .cmbType{
            width:150px !important;
        }

        .cmbUser{
            width:150px !important;
        }
        
        .ig_ClaymationControl, #GV{
            color:rgba(0,0,0,0.4);     
            border-color:rgba(0,0,0,0.1) !important ;    
        }

        .ig_ClaymationControl td, .ig_ClaymationControl th, #GV td, #GV th{
            color:black !important;   
            border-color:rgba(0,0,0,0.1) !important ;    
            font-weight:400 !important;
            border-left:none !important;
            border-right:none !important;
        }   

        #GV tbody > tr:first-of-type{
            background-color:#f7f8fa !important;
        }

        #GV th {
            font-weight: 700 !important;
        }
    </style>
</head>

<body onload="loadMe()">
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" LoadScriptsBeforeUI="false">
        </asp:ScriptManager>

        <asp:HiddenField ID="HF_Exit" runat="server" />
        <asp:HiddenField ID="HF_ExitTo" runat="server" />        
        <asp:HiddenField ID="HF_ExitMessage" runat="server" />

        <div class="root">
            <div class="toolbar">
                <div style="color:#008ef2 !important; font-weight:700;">
                    Notifications
                </div>

                <div style="display:flex;">
                    <div class="cell">
                        <asp:Label ID="Lbl_Status" runat="server" Text="Status" CssClass="lbl" />
                        <asp:DropDownList ID="Cmb_Status" runat="server"  CssClass="form-control dropDown cmbStatus" />
                    </div>
                    <div class="cell">
                        <asp:Label ID="Lbl_Type" runat="server" Text="Type" CssClass="lbl" />
                        <asp:DropDownList ID="Cmb_Type" runat="server"  CssClass="form-control dropDown cmbType" />
                    </div>                 
                    <div class="cell">
                        <asp:Label ID="Lbl_User" runat="server" Text="User" CssClass="lbl" />
                        <asp:DropDownList ID="Cmb_User" runat="server" CssClass="form-control dropDown cmbUser" />
                    </div>
                    <div class="cell">
                        <asp:Label ID="Lbl_SDate" runat="server" Text="S. Date" CssClass="lbl" />
                        <asp:TextBox ID="Txt_SDate" runat="server" CssClass="form-control txt" />
                    </div>                 
                    <div class="cell">
                        <asp:Label ID="Lbl_EDate" runat="server" Text="E. Date" CssClass="lbl" />
                        <asp:TextBox ID="Txt_EDate" runat="server" CssClass="form-control txt" />
                    </div>

                    <div class="cell" style="justify-content:flex-end">
                        <asp:Button ID="Cmd_Search" runat="server" Text="Search" CssClass="btn btnToolbar" OnClientClick="return onSearchClick();" OnClick="Cmd_Search_Click" />
                    </div>
                </div>
            </div>

            <% If aError IsNot Nothing AndAlso aError <> "" %>
                <div class="errorDiv">
                    <%= aError %>
                </div>
            <%End If %>

            <div class="content">
                <asp:GridView ID="GV" runat="server" DataKeyNames="ID" AutoGenerateColumns="false"  Width="100%" PageSize="9999">
                    <Columns>                         
                        <asp:BoundField DataField="ID" ItemStyle-CssClass="hidden" HeaderStyle-CssClass="hidden" />  

                        <asp:BoundField DataField="CreatedOn" HeaderText="Date" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="marginLeft10" ItemStyle-CssClass="marginLeft10" HeaderStyle-Width="95px" ItemStyle-Width="95px" />  
                        <asp:BoundField DataField="Category" HeaderText="Type" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="marginLeft10" ItemStyle-CssClass="marginLeft10" HeaderStyle-Width="95px" ItemStyle-Width="95px"  />  
                        <asp:BoundField DataField="User" HeaderText="User" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="marginLeft10" ItemStyle-CssClass="marginLeft10" HeaderStyle-Width="95px" ItemStyle-Width="95px" />  
                        <asp:BoundField DataField="Title" HeaderText="Info" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="marginLeft10" ItemStyle-CssClass="marginLeft10"  />  
                    </Columns>

                    <RowStyle Height="26px" />
                    <HeaderStyle BackColor="LightGray"  Height="26px" />
                    <EditRowStyle Height="26px" />
                    <AlternatingRowStyle BackColor="White" />
                </asp:GridView>

            </div>
        </div>
    </form>

    <script type="text/javascript">

      function loadMe()
      {
           if (document.getElementById("HF_Exit").value == "exit")
             {      
               if (document.getElementById("HF_ExitMessage").value != "")
                  alert(document.getElementById("HF_ExitMessage").value);
           
               var aExitTo = document.getElementById("HF_ExitTo").value;
           
               if (aExitTo.substring(0,1) == "1")
                  {
                    if (window.parent.parent)
                       window.parent.parent.location = aExitTo.substring(1);
                    else if (window.parent)
                       window.parent.location = aExitTo.substring(1); 
                  }
                 
               else
                 {
                    if (window.parent.document.getElementById('myIframe'))
                        window.parent.document.getElementById('myIframe').src= aExitTo.substring(1);            
                    else if (window.parent)
                       window.parent.location = aExitTo.substring(1);
                 } 
              }
        } 


        function isDate(value) {            
             return !isNaN(Date.parse(value));
        }

        function onSearchClick() {
            var txtSDate = document.getElementById("<%= Txt_SDate.ClientID %>");
            var txtEDate = document.getElementById("<%= Txt_EDate.ClientID %>");

            if (txtSDate.value != "" && !isDate(txtSDate.value)) {
                alert("Invalid starting date.");
                txtSDate.focus();
                return false;
            }

            if (txtEDate.value != "" && !isDate(txtEDate.value)) {
                alert("Invalid ending date.");
                txtEDate.focus();
                return false;
            }

            if (txtSDate.value != "" && txtEDate.value !=""  ) {
               var sDate = new Date(txtSDate.value);
               var eDate = new Date(txtEDate.value);

               if (sDate > eDate) {
                    alert("Start date must be before end date.");
                    txtSDate.focus();
                    return false;
                }
            }

            return true;
        }
    </script>
</body>
</html>
