﻿Imports System.Collections.Generic
Imports System.Data

Partial Class Backend_frmNotifications
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aDataSource As DataTable 
    Public aError As String

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAgent = False AndAlso aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(True, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function
    
    Private Sub Backend_frmNotifications_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim aDSLookups As DataSet

        If ValidateUser = False Then Return

        aError = ""

        If Me.IsPostBack = False Then 
            Try
                aDSLookups = BackEnd.Notification.GetSearchLookups()

                With Cmb_Status 
                    .Items.Clear()

                    .Items.Add(New ListItem("All", 0))
                    .Items.Add(New ListItem("Viewed", 1))
                    .Items.Add(New ListItem("Not Viewed", 2))

                    .SelectedIndex=0
                End With

                With Cmb_Type
                    .Items.Clear

                    .Items.Add(New ListItem("All", 0))

                    For Each aDRow As DataRow In aDSLookups.Tables(0).Rows
                        .Items.Add(New ListItem(aDRow("TITLE"), aDRow("ID")))
                    Next

                    .SelectedIndex=0
                End With

                With Cmb_User 
                    .Items.Clear

                    .Items.Add(New ListItem("All", 0))

                    For Each aDRow As DataRow In aDSLookups.Tables(1).Rows
                        .Items.Add(New ListItem(aDRow("NAME"), aDRow("ID")))
                    Next

                    .SelectedIndex=0
                End With

                aDataSource = BackEnd.Notification.Search(aCurrentUser.ID, 2, 0, 0, Now.Date.AddDays(-7).ToString(), Now.Date.ToString())
                Me.GV.DataSource = aDataSource
                Me.GV.DataBind()

            Catch ex As Exception
                aError = ex.Message
            End Try

            Try
                'Make all notifications of me viewed
                BackEnd.Notification.MarkAsViewed(aCurrentUser.ID)

            Catch ex As Exception

            End Try
        End If 
    End Sub

    Protected Sub Cmd_Search_Click(sender As Object, e As EventArgs)
        Dim aStatus As Integer = Cmb_Status.SelectedValue
        Dim aType As Integer = Cmb_Type.SelectedValue 
        Dim aUser As Integer = Cmb_User.SelectedValue

        Dim aSDate As String = Txt_SDate.Text
        Dim aEDate As String = Txt_EDate.Text

        Try 
            aDataSource = BackEnd.Notification.Search(aCurrentUser.ID, aStatus, aType, aUser, aSDate, aEDate)
            Me.GV.DataSource = aDataSource
            Me.GV.DataBind()

        Catch ex As Exception
            aError = ex.Message
        End Try
    End Sub
End Class
