﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="frmPhoneBook.aspx.vb" Inherits="Backend_frmPhoneBook" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    
    <!-- CSS -->    
    <!-- Bootstrap 4.3.1  -->
    <link rel="stylesheet" href="css/bootstrap.min.css"/>

    <!-- Fontawesome -->
    <link rel="stylesheet" href="fontawesome/css/font-awesome.min.css" />

    <!-- Context Menu 2.7.1 -->
    <link rel="stylesheet" href="css/contextmenu-2-7-1/jquery.contextMenu.min.css" />

    <!-- jQuery-UI -->
    <link rel="stylesheet" href="css/jquery-ui1.11.2.css"/>

    <link href="js/tag/tagsinput.css" rel="stylesheet" type="text/css" />

    <!-- Spinner -->
    <link rel="stylesheet" href="css/spinner.css" />

    <!--My Every Page -->
    <link rel="Stylesheet" href="css/page.css" />


    <!-- JS --> 
    <!-- jQuery library -->
    <script src="js/jquery1.11.1.min.js"></script>

    <!-- Bootstrap 4.3.1 -->
    <script src="js/bootstrap.min.js"></script> 

    <!-- jQuery-UI -->
    <script src="js/jquery-ui1.11.2.min.js"></script>

	<script src="js/tag/tagsinput.js"></script>

    <!-- My Utils -->
    <script src="js/utils.js"></script>


    <style>
        .toolbar{
            justify-content:space-between !important;
            padding-top:6px !important;
            padding-bottom:8px !important;
        }

        .cell{
            display: flex;
            flex-direction:column;
            margin-left:8px;
            justify-content:space-between;
        }
        
        .ig_ClaymationControl, #GV{
            color:rgba(0,0,0,0.4);     
            border-color:rgba(0,0,0,0.1) !important ;    
        }

        .ig_ClaymationControl td, .ig_ClaymationControl th, #GV td, #GV th{
            color:black !important;   
            border-color:rgba(0,0,0,0.1) !important ;    
            font-weight:400 !important;
            border-left:none !important;
            border-right:none !important;
        }   

        #GV tbody > tr:first-of-type{
            background-color:#f7f8fa !important;
        }

        #GV th {
            font-weight: 700 !important;
        }

        #GV td, #GV th{
            padding-left:4px;
            padding-right:4px;
        }

        #GV tr{
            height: 30px !important;
        }
        th{
            font-weight:400 !important;
        }

    </style>

    <!-- Style for Tags -->
    <style>
        .toolbar .bootstrap-tagsinput{
            margin-top: 6px !important;
        }

        .toolbar .bootstrap-tagsinput > input{
            min-height:30px !important;
        }
    </style>
</head>

<body onload="loadMe()">
    <div class="spinnerOuterContainer">
        <div class="spinnerInnerContainer">
            <div class="spinner-grow text-muted spinner-grow-sm"></div>
            <div class="spinner-grow text-primary spinner-grow-sm"></div>
            <div class="spinner-grow text-success spinner-grow-sm"></div>
            <div class="spinner-grow text-info spinner-grow-sm"></div>
        </div>
    </div>

    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" LoadScriptsBeforeUI="false">
        </asp:ScriptManager>

        <asp:HiddenField ID="HF_Exit" runat="server" />
        <asp:HiddenField ID="HF_ExitTo" runat="server" />        
        <asp:HiddenField ID="HF_ExitMessage" runat="server" />

        <div class="root">
            <div class="toolbar" style="justify-content:space-between !important;">
                <div style="color:#008ef2 !important; font-weight:700;">
                    Phone Book
                </div>

                <div style="display:flex; flex-direction:column;">
                        <div style="display:flex;justify-content:flex-end;">
                            <div class="cell">
                                <span class="" style="display:inline-block;">Name</span>
                                <asp:TextBox ID="Txt_Name" runat="server" CssClass="form-control txt" Width="150px" ></asp:TextBox>
                            </div>

                            <div class="cell" style="justify-content:flex-end">
                                <asp:Button ID="Cmd_SearchName" runat="server" Text="Search" CssClass="btn btnToolbar" OnClientClick="searchByName(); return false;"  />
                            </div>

                            <div class="cell" style="margin-left:30px;">
                                <span class="" style="display:inline-block;">Cell/Phone</span>
                                <asp:TextBox ID="Txt_Phone" runat="server" CssClass="form-control txt" Width="130px" ></asp:TextBox>
                            </div>                 

                            <div class="cell" style="justify-content:flex-end">
                                <asp:Button ID="Cmd_SearchPhone" runat="server" Text="Search" CssClass="btn btnToolbar" OnClientClick="searchByPhone(); return false;" />
                            </div>

                            <div class="cell" style="margin-left:30px;">
                                <div style="display:flex;justify-content:space-between;">
                                    <span class="lbl" >Tags</span>
                                    <asp:CheckBox ID="Chk_TagsAnd" runat="server" Text="AND" style="margin-bottom:2px;" CssClass="custom-control custom-checkbox"></asp:CheckBox>
                                </div>
                                <asp:TextBox ID="Txt_TagsSearch" style="min-height:30px !important;margin-top:-3px;" runat="server" CssClass="form-control txt"></asp:TextBox>
                            </div>
                        </div>

                        <div class="cell" style="flex:1;">
                            <input id="Tg_TagsSearch" data-role="tagsinput " class="form-control txt tagHeight" style="margin-top:3px;" />
                        </div>
                </div>
            </div>

            <% If aError IsNot Nothing AndAlso aError <> "" %>
                <div class="errorDiv">
                    <%= aError %>
                </div>
            <%End If %>

            <div class="content">
                <asp:GridView ID="GV" runat="server" AutoGenerateColumns="false"  Width="100%" PageSize="9999" ShowHeader="true" CssClass="grid">
                    <Columns>       
                        <asp:TemplateField HeaderText="Type">
                            <ItemTemplate> 
                                <asp:Label ID="Txt_Type" runat="server" Visible="true" CssClass="TextBox hPadding" Width="100%" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        
                        <asp:TemplateField HeaderText="Name">
                            <ItemTemplate> 
                                <asp:Label ID="Txt_EntryName" runat="server" Visible="true" CssClass="TextBox hPadding" Width="100%" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>  

                        <asp:TemplateField HeaderText="Company">
                            <ItemTemplate> 
                                <asp:Label ID="Txt_Company" runat="server" Visible="true" CssClass="TextBox hPadding" Width="100%" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>

                        <asp:TemplateField HeaderText="Cell">
                            <ItemTemplate> 
                                <asp:Label ID="Txt_Cell" runat="server" Visible="true" CssClass="TextBox hPadding" Width="100%" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>

                        <asp:TemplateField HeaderText="Phone">
                            <ItemTemplate> 
                                <asp:Label ID="Txt_Phone" runat="server" Visible="true" CssClass="TextBox hPadding" Width="100%" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>

                        <asp:TemplateField HeaderText="Email">
                            <ItemTemplate> 
                                <asp:Label ID="Txt_Email" runat="server" Visible="true" CssClass="TextBox hPadding" Width="100%" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>

                        <asp:TemplateField HeaderText="Tags">
                            <ItemTemplate> 
                                <asp:Label ID="Txt_Tags" runat="server" Visible="true" CssClass="TextBox hPadding" Width="100%" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center"></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>

                    </Columns>

                    <RowStyle Height="26px" />
                    <HeaderStyle BackColor="LightGray"  Height="26px" />
                    <EditRowStyle Height="26px" />
                    <AlternatingRowStyle BackColor="White" />
                </asp:GridView>

            </div>
        </div>
    </form>

    <script id="jsGeneric" type="text/javascript">

      function loadMe()
      {
          //Handle checkboxes look
          $(".custom-checkbox input").addClass("custom-control-input");
          $(".custom-checkbox label").addClass("custom-control-label");


          if (document.getElementById("HF_Exit").value == "exit") {
              if (document.getElementById("HF_ExitMessage").value != "")
                  alert(document.getElementById("HF_ExitMessage").value);

              var aExitTo = document.getElementById("HF_ExitTo").value;

              if (aExitTo.substring(0, 1) == "1") {
                  if (window.parent.parent)
                      window.parent.parent.location = aExitTo.substring(1);
                  else if (window.parent)
                      window.parent.location = aExitTo.substring(1);
              }

              else {
                  if (window.parent.document.getElementById('myIframe'))
                      window.parent.document.getElementById('myIframe').src = aExitTo.substring(1);
                  else if (window.parent)
                      window.parent.location = aExitTo.substring(1);
              }
          }
          else {
              makeTxtNameAutoComplete();

              //Initialize Tag
              $(".tagHeight").tagsinput({
                allowDuplicates: false,
                itemValue: 'id',  // this will be used to set id of tag
                itemText: 'title' // this will be used to set text of tag
              });

              $(".bootstrap-tagsinput > input").prop("readonly", true);

              makeTxtTagsSearchAutoComplete();
          }
        } 

    </script>

    <script>
        function showSpinner() {
            $(".spinnerOuterContainer").css("visibility", "visible");
        }

        function hideSpinner(){
            $(".spinnerOuterContainer").css("visibility", "hidden");
        }
    </script>

    <script type="text/javascript">
        function makeTxtNameAutoComplete() {
            $("#<%= Txt_Name.ClientID %>").autocomplete({               
                source: function (request, response) {
                    var aCurrentUserId = 0;

                    <% If aCurrentUser Is Nothing Then %>
                          aCurrentUserId = -1; 
                    <%ElseIf aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsSuperUser=False%>
                          aCurrentUserId = <%=aCurrentUser.ID %>;
                    <%End If%>

                    $.ajax({
                        url: "WSPhoneBook.asmx/GetNamesStartingWith",
                        data: JSON.stringify({ 'name': request.term, 'userId': aCurrentUserId }),
                        dataType: "json",
                        type: "POST",
                        contentType: "application/json; charset=utf-8",
                        success: function (data) {
                            response($.map(data, function(item) {
                                return {
                                    label: item.Val2,
                                    value: item.Val2,//Appears in text box => just the name
                                    val1: item.Val1,
                                    val2: item.Val2,
                                }
                            }))
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            console.log("Error");
                            console.log(textStatus, errorThrown);
                            console.log(XMLHttpRequest);
                        }
                    });
                },
                minLength: 1,
                select: function (event, ui) {
                }
            }).data("ui-autocomplete")._renderItem = function (ul, item) {

            var li = "<li style='display:flex;'></li>";
            return $(li)
                .attr("data-value", item.val2)
                .append("<span style='display:flex;'>" + item.val2 + "</span>")
                .appendTo(ul);
            };
        }

        function makeTxtTagsSearchAutoComplete() {
            $("#<%= Txt_TagsSearch.ClientID %>").autocomplete({               
                source: function(request, response) {
                    $.ajax({
                        url: "WSTag.asmx/GetTagsStartingWith",
                        data: JSON.stringify({ 'name': request.term }),
                        dataType: "json",
                        type: "POST",
                        contentType: "application/json; charset=utf-8",
                        success: function (data) {
                            response($.map(data, function (item) {
                                return {
                                    label: item.Val2,
                                    value: item.Val2,//Appears in text box => just the name
                                    val1: item.Val1,
                                    val2: item.Val2
                                }
                            }))
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            console.log("Error");
                            console.log(textStatus, errorThrown);
                            console.log(XMLHttpRequest);
                        }
                    });
                },
                minLength: 1,
                select: function (event, ui) {
                    addToTag("Tg_TagsSearch", ui.item.val1 , ui.item.val2);
                    window.setTimeout(function () { document.getElementById("<%=Txt_TagsSearch.ClientID%>").value = ""; }, 100);
                }
            }).data("ui-autocomplete")._renderItem = function (ul, item) {

            var li = "<li style='display:flex;'></li>";

            return $(li)
                .attr("data-value", item.val2)
                .append("<span style='display:flex;'>" + item.val2 + "</span>")
                .appendTo(ul);
            };
        }


        function searchByName() {
            var name = document.getElementById("<%=Txt_Name.ClientID%>").value;
            var aCurrentUserId = 0;
            var aTagsIds = getIdsAsString("Tg_TagsSearch");
            var aTagsAnd = document.getElementById("<%=Chk_TagsAnd.ClientID%>").checked;

            <% If aCurrentUser Is Nothing Then %>
                aCurrentUserId = -1;
            <%ElseIf aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsSuperUser=False%>
                aCurrentUserId = <%=aCurrentUser.ID %>;
            <%End If%>

            //Make sure name is selected            
            //if (!name || name.trim() == "") {
            //    alert("Please, specify a name.");
            //    return false;
            //}

            if (!name)
                name = "";

            //Show spinner
            showSpinner();

            //Clear Grid
            $("#<%=GV.ClientID%>").empty();

            //Clear Phone
            document.getElementById("<%=Txt_Phone.ClientID%>").value = "";

            //Call API
            $.ajax({
                url: "WSPhoneBook.asmx/SearchByName",
                data: JSON.stringify({ 'name': name, 'tagsIds': aTagsIds, 'tagsAnd': aTagsAnd, 'userId': aCurrentUserId }),
                dataType: "json",
                type: "POST",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    bindGrid(data);

                    hideSpinner();

                    if (data.length < 1) {
                        alert("No matches found.");
                        return;
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    hideSpinner();

                    alert("Error fetching data.");
                }
            });


            return false;
        }

        function searchByPhone() {
            var phone = document.getElementById("<%=Txt_Phone.ClientID%>").value;
            var aTagsIds = getIdsAsString("Tg_TagsSearch");
            var aTagsAnd = document.getElementById("<%=Chk_TagsAnd.ClientID%>").checked;

            var aCurrentUserId = 0;

            <% If aCurrentUser Is Nothing Then %>
                aCurrentUserId = -1;
            <%ElseIf aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsSuperUser=False%>
                aCurrentUserId = <%=aCurrentUser.ID %>;
            <%End If%>

            //Make sure name is selected
            phone = clearPhoneNumber(phone.trim());

            document.getElementById("<%=Txt_Phone.ClientID%>").value = phone;

            if (!phone || phone.trim() == "") {
                alert("Please, specify a phone/cell.");
                return false;
            }

            //Show spinner
            showSpinner();

            //Clear Grid
            $("#<%=GV.ClientID%>").empty();

            //Clear Name
            document.getElementById("<%=Txt_Name.ClientID%>").value = "";

            //Call API
            $.ajax({
                url: "WSPhoneBook.asmx/SearchByPhone",
                data: JSON.stringify({ 'phone': phone, 'tagsIds': aTagsIds, 'tagsAnd': aTagsAnd, 'userId': aCurrentUserId }),
                dataType: "json",
                type: "POST",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    bindGrid(data);

                    hideSpinner();

                    //if (data.length < 1) {
                    //    alert("No matches found.");
                    //    return;
                    //}
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    hideSpinner();

                    alert("Error fetching data.");
                }
            });


            return false;
        }

        function bindGrid(arr) {
            $("#<%=GV.ClientID%>").empty();

            $("#<%=GV.ClientID%>").append("<tr><th>Type</th><th>Name</th><th>Company</th><th>Cell</th><th>Phone</th><th>Email</th><th>Tags</th></tr>");


            if (arr.length > 0) {
                for (var i = 0; i < arr.length; i++) {
                    if (arr[i].Val7.toString() == "0")
                        $("#<%=GV.ClientID%>").append("<tr style='color:red !important'><td style='color:red !important'>" + arr[i].Val8 + "</td><td style='color:red !important'>" + arr[i].Val2 + "</td><td style='color:red !important'>" + arr[i].Val3 + "</td><td style='color:red !important'>" + arr[i].Val4 + "</td><td style='color:red !important'>" + arr[i].Val5 + "</td><td style='color:red !important'>" + arr[i].Val6 + "</td><td>" + arr[i].Val9 + "</td></tr>");
                    else
                        $("#<%=GV.ClientID%>").append("<tr><td>" + arr[i].Val8 + "</td><td>" + arr[i].Val2 + "</td><td>" + arr[i].Val3 + "</td><td>" + arr[i].Val4 + "</td><td>" + arr[i].Val5 + "</td><td>" + arr[i].Val6 + "</td><td>" + arr[i].Val9 + "</td></tr>");
                }

                window.parent.postMessage({message: 'refreshIFrameHeight'}, 'http://localhost:56038');
            }
        }
    </script>

    <script type="text/javascript" id="jsTags">
        function getIdsAsString(controlId) {
            var result = "";
            var resultArr = $("#" + controlId).val().split(",");

            if (resultArr && resultArr.length > 0) {
                for (var i = 0; i < resultArr.length; i++) 
                    result += resultArr[i] + ",";

                result = result.substr(0, result.length - 1);
            }

            return result;
        }

        function addToTag(controlId, id, title) {
            //If id or text (trimmed + insensitive) exists then return
            var items = $("#" + controlId).tagsinput('items');

            if (!items || items.length < 1) 
                $("#" + controlId).tagsinput("add", { "id": id , "title": title});    
            else {
                //Do NOT add if the id is there or a text (trimmed + insensitive)
                for (var i = 0; i < items.length; i++) {
                    if (items[i].title.trim().toLowerCase() == title.trim().toLowerCase() || items[i].id == id)
                        return;
                }

                $("#" + controlId).tagsinput("add", { "id": id , "title": title});    
            }
        }

        function clearTag(controlId) {
            $('#' + controlId).tagsinput('removeAll');
        }

        function getLowestNegativeTagId(controlId) {
            var result = 0;

            var items = $("#" + controlId).tagsinput('items');

            if (!items || items.length < 1)
                return result;

            for (var i = 0; i < items.length; i++) {
                if (items[i].id < 0) {
                    if (items[i].id < result)
                        result = parseInt(items[i].id);
                }
            }

            return result;
        }

        function addNewTag(controlId, title) {
            var items = $("#" + controlId).tagsinput('items');

            if (!items || items.length < 1) 
                addToTag(controlId, getLowestNegativeTagId(controlId) - 1, title);            
            else {
                //Check maybe the trimmed text is there
                for (var i = 0; i < items.length; i++) {
                    if (items[i].title.trim().toLowerCase() == title.trim().toLowerCase())
                        return;
                }

                addToTag(controlId, getLowestNegativeTagId(controlId) - 1, title);            
            }
        }
    </script>

</body>
</html>

