﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="frmReportingAdminDailyTasks.aspx.vb" Inherits="Backend_frmReportingAdminDailyTasks" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">

    <script type="text/javascript" src="Js/jquery1.11.1.min.js"></script>
    <script type="text/javascript" src="js/moment.min.js"></script>
    <script type="text/javascript" src="js/daterangepicker.min.js"></script>
    <link rel="stylesheet" type="text/css" href="css/daterangepicker.css" />

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="css/bootstrap.min.css"  />
    <link rel="stylesheet" href="fontawesome/css/font-awesome.min.css" />

    <!--My Every Page -->
    <link rel="Stylesheet" href="css/page.css" />


    <title></title>

    <style type="text/css">

        .content{
            margin-top:0px;
            display: flex;
            flex-direction:column;            
        }

        .cell{
            display:flex;
            flex-direction:column;
        }


        .summary{
            display:flex;
            justify-content:space-around;
            /*border: 1px solid rgba(0,0,0,0.1);*/
            padding: 10px 6px;
        }

        .summaryCreated, .summaryErrorsRate, .summaryPublished, .summaryRequests{
            display:flex;
            flex-direction:column;
            flex:1;
            max-width:20%;
            height:85px;
            justify-content:center;
            align-items:center;           
        }

        .circleSummary{
            display:flex;
            flex-direction:column;
            justify-content:center;
            align-items:center;
            flex:1;
            width:100%;
            border-radius:4px;
        }

        .circleSummary span{
            font-size:18px;
            font-weight:400;
            color:white;
        }

        .circleSummary .summaryNb{
            font-size:32px;
            font-weight:700;
        }

        .contentGrid{
            display:flex;
            flex-direction:column;
            margin-top:14px;
            padding:0 8px;
        }

        table{
            border-color:rgba(0,0,0,0.1) !important;
        }
        table th{
            font-weight:700;
            background-color:#F7F8FA !important;
            border-left:none !important;
            border-right:none !important;
            border-bottom:1px solid rgba(0,0,0,0.2);
            border-top:1px solid rgba(0,0,0,0.2);
        }

         table th a {
             font-weight: 700;
         }

        table td{
            border-left:none !important;
            border-right:none !important;
            border-bottom:1px solid rgba(0,0,0,0.2);
            border-top:1px solid rgba(0,0,0,0.2);
            padding-top:4px;
            padding-bottom:4px;
        }
    </style>


</head>
<body onload="loadMe()">

    <form id="frmPropertyReceived" runat="server" defaultbutton="Cmd_View">
        <asp:HiddenField ID="HF_Exit" runat="server" />
        <asp:HiddenField ID="HF_ExitTo" runat="server" />        
        <asp:HiddenField ID="HF_ExitMessage" runat="server" />

        <asp:HiddenField ID="HF_SDate" runat="server" />
        <asp:HiddenField ID="HF_EDate" runat="server" />

        <div class="root">
            <div class="toolbar">
                <div class="row" style="justify-content:center;">
                    <div class="cell">
                        <span>&nbsp;</span>
                        <asp:Image ID="Img_Status" runat="server" ImageUrl="~/BackEnd/App_Photos/Ico_Success.png" />
                    </div>

                    <div style="display:flex;flex-direction:column;margin-right:14px;">
                        <asp:Label ID="Lbl_User" runat="server" Text="Performed By" CssClass="lbl" />
                        <asp:DropdownList ID="Cmb_User" runat="server" CssClass="form-control dropDown" />
                    </div>  

                    <div class="cell" style="margin-right:14px;">
                        <span>Period</span>
                        <div id="reportrange" style="cursor: pointer; padding:0.6rem;width:245px !important; height: calc(1.5rem + .6rem + 2px);" class="form-control txt">
                            <i class="fa fa-calendar"></i>&nbsp;&nbsp;
                            <span></span>&nbsp;&nbsp;<i class="fa fa-caret-down"></i>
                        </div>
                    </div>

                    <div class="cell">
                        <span>&nbsp;</span>
                        <asp:Button ID="Cmd_View" runat="server" Text="View" CssClass="btn btnToolbar" OnClick="Cmd_View_Click" />
                    </div>

                </div>
            </div>

            <% If aError IsNot Nothing AndAlso aError <> "" %>
                <div class="errorDiv">
                    <%= aError %>
                </div>
            <%End If %>

            <div class="content">
                <div class="summary">
                    <div class="summaryCreated">
                        <div class="circleSummary" style="background-image: linear-gradient(rgba(0,142,255,1), rgb(0,142,255,0.4));color:#008ef2;">
                            <span class="summaryNb"><%= aTotalCreated %></span>
                            <span>Properties Created</span>
                        </div>
                    </div>

                    <div class="summaryErrorsRate">
                        <div class="circleSummary" style="background-image: linear-gradient(rgba(255,0,0,1), rgb(255,0,0,0.5)); color:red;">
                            <span class="summaryNb"><%= aTotalErrors %> &nbsp; - &nbsp;<%= aTotalErrorsRate %></span>
                            <span>Errors Committed</span>
                        </div>
                    </div>

                    <div class="summaryPublished">
                        <div class="circleSummary" style="background-image: linear-gradient(rgba(69,167,40,1), rgb(69,167,40,0.6)); color:#28a745;">
                            <span class="summaryNb"><%= aTotalPublished %></span>
                            <span>Publications</span>
                        </div>
                    </div>

                    <div class="summaryRequests">
                        <div class="circleSummary" style="background-image: linear-gradient(rgba(112,0,227,1), rgb(112,0,227,0.4)); color:#7000e3;">
                            <span class="summaryNb"><%= aTotalRequests %></span>
                            <span>Requests Received</span>
                        </div>
                    </div>

                </div>

                <div class="contentGrid">
                    <asp:GridView ID="GV" runat="server" AutoGenerateColumns="false"  Width="100%" Font-Size="10pt" PageSize="9999">
                        <Columns>                         
                            <asp:BoundField DataField="Day" HeaderText="Date" ItemStyle-HorizontalAlign="center" ControlStyle-CssClass="centerText" HeaderStyle-CssClass="centerText"  />  
                            <asp:BoundField DataField="Created" HeaderText="Properties Created" ItemStyle-HorizontalAlign="center"  ControlStyle-CssClass="centerText" HeaderStyle-CssClass="centerText" />  
                            <asp:BoundField DataField="Errors" HeaderText="Errors" ItemStyle-HorizontalAlign="center" ControlStyle-CssClass="centerText" HeaderStyle-CssClass="centerText" />  
                            <asp:BoundField DataField="ErrorsRate" HeaderText="Errors %" ItemStyle-HorizontalAlign="center" ControlStyle-CssClass="centerText" HeaderStyle-CssClass="centerText" />  
                            <asp:BoundField DataField="Published" HeaderText="Publications" ItemStyle-HorizontalAlign="center" ControlStyle-CssClass="centerText" HeaderStyle-CssClass="centerText" />                              
                            <asp:BoundField DataField="Requests" HeaderText="Requests Received" ItemStyle-HorizontalAlign="center" ControlStyle-CssClass="centerText" HeaderStyle-CssClass="centerText" />  
                        </Columns>

                        <RowStyle Height="28px" />
                        <HeaderStyle Height="28px" />
                        <EditRowStyle Height="28px" />
                        <AlternatingRowStyle BackColor="White" />
                    </asp:GridView>
                </div>
            </div>
        </div>        
    </form>
</body>

<script type="text/javascript">
    function fnHideSuccessIcon()
    {
        window.setTimeout(function(){
            var o = document.getElementById("<%= Img_Status.ClientID %>");
            if (o)
                o.style.display = "none";   
        }, 3000);
    }

  function loadMe()
  {
      fnHideSuccessIcon();

      if (document.getElementById("HF_Exit").value == "exit") {
          if (document.getElementById("HF_ExitMessage").value != "")
              alert(document.getElementById("HF_ExitMessage").value);

          var aExitTo = document.getElementById("HF_ExitTo").value;

          if (aExitTo.substring(0, 1) == "1") {
              if (window.parent.parent)
                  window.parent.parent.location = aExitTo.substring(1);
              else if (window.parent)
                  window.parent.location = aExitTo.substring(1);
          }

          else {
              if (window.parent.document.getElementById('myIframe'))
                  window.parent.document.getElementById('myIframe').src = aExitTo.substring(1);
              else if (window.parent)
                  window.parent.location = aExitTo.substring(1);
          }
      }
      else {
        var start = moment(document.getElementById("<%= HF_SDate.ClientID %>").value);
        var end = moment(document.getElementById("<%= HF_EDate.ClientID %>").value);

        function cb(start, end) {
            $('#reportrange span').html(start.format('MMMM D, YYYY') + ' - ' + end.format('MMMM D, YYYY'));

            document.getElementById("<%= HF_SDate.ClientID %>").value = start.format("MM/DD/YYYY");
            document.getElementById("<%= HF_EDate.ClientID %>").value = end.format("MM/DD/YYYY");
        }

        $('#reportrange').daterangepicker({
            startDate: start,
            endDate: end,
            ranges: {
                'Today': [moment(), moment()],
                'Yesterday': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
                'Last 7 Days': [moment().subtract(6, 'days'), moment()],
                'Last 30 Days': [moment().subtract(29, 'days'), moment()],
                'This Month': [moment().startOf('month'), moment().endOf('month')],
                'Last Month': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
            }
        }, cb);

          cb(start, end);
      }
    }      
    
</script>


</html>