﻿Imports System.Collections.Generic
Imports System.Data

Partial Class Backend_frmReportingAdminDailyTasks
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aDataSource As DataTable 
    Public aTotalCreated As Integer = 0, aTotalPublished As Integer = 0, aTotalErrors As Integer = 0, aTotalErrorsRate As String = "0%", aTotalRequests As Integer=0
    Public aError As String

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse aCurrentUser.IsSuperUser = False Then
            ClientTransferOrRedirect(True, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function
    
    Private Sub Backend_frm_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim aDTLookups As DataTable

        If ValidateUser = False Then Return

        Img_Status.Visible =False

        aError = ""

        If Me.IsPostBack = False Then 
            Try
                aDTLookups = BackEnd.Reporting.GetAdminDailyTasksLookups()

                With Cmb_User
                    .Items.Clear

                    .Items.Add(New ListItem("All", 0))

                    For Each aDRow As DataRow In aDTLookups.Rows
                        .Items.Add(New ListItem(aDRow("NAME"), aDRow("ID")))
                    Next

                    .SelectedIndex = 0
                End With

                HF_SDate.Value = Month(Now) & "/" & Day(Now) & "/" & Year(Now)
                HF_EDate.Value = Month(Now) & "/" & Day(Now) & "/" & Year(Now)

                'Search today/all
                Search()

            Catch ex As Exception
                aError = ex.Message
            End Try
        End If 
    End Sub

    Protected Sub Search()
        Dim aSDate As String = HF_SDate.Value
        Dim aEDate As String = HF_EDate.Value
        Dim aUserId As Integer = Cmb_User.SelectedValue

        Dim aDT As DataTable = BackEnd.Reporting.GetAdminDailyTasks(aUserId, aSDate, aEDate, aTotalCreated, aTotalPublished, aTotalErrors, aTotalErrorsRate, aTotalRequests)
        GV.DataSource = aDT
        GV.DataBind ()
    End Sub

    Protected Sub Cmd_View_Click(sender As Object, e As EventArgs)
        Me.Search()
    End Sub
End Class
