﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="frmReportingReviewedPublishedDelay.aspx.vb" Inherits="Backend_frmReportingReviewedPublishedDelay" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style>
        * {
            box-sizing: border-box;  
            font-family:Verdana !important;
        }

        body{
            margin:0 !important;
            padding:0 !important;
        }

        .hidden{
            display:none;
        }

        .header{
            display: flex;
            justify-content:space-between;
            padding:8px 6px;
            background-color:rgba(0, 0, 0, 0.1);
            margin-bottom:5px;
            border-bottom:1px solid red;/*rgba(0, 0, 0, 0.4);*/
        }

        .content{
            margin-top:0px;
            display: flex;
            flex-direction:column;            
            font-size:12px !important;
            padding:6px;
        }

        .cell{
            display: flex;
            flex-direction:column;
            margin-left:8px;
        }

        .btn{
            display: inline-flex;
            align-items:center;
            font-size:12px !important;
            font-weight:400 !important;
            height: 28px!important;
            padding: 2px 24px;
            background-color: white;
            border:1px solid rgba(0,0,0,0.4);
            border-radius: 4px;
            margin-left:6px;
            background-color:rgba(0, 0, 0, 0.01);
        }

        .btn:hover{
            background-color:white;
            cursor:pointer;
        }

        .marginTop8{
            margin-top:8px;
        }

        .marginTop12{
            margin-top:12px;
        }

        .paddingLeft4{
            padding-left:4px;
        }

        .lbl{
            font-size:12px;
            font-weight:400;
            margin-bottom:4px;
        }

        .cmbAdmin{
            width:150px !important;
        }

        .txt{
            border:1px solid rgba(0,0,0,0.4) !important;
            height:26px !important;
            width:90px;
            text-align:center;
        }
        
        .dropDown{
            border:1px solid rgba(0,0,0,0.4) !important;
            height:26px !important;
            width:120px;
        }
        
        .ig_ClaymationControl, #GV{
            color:rgba(0,0,0,0.4);            
        }

        .ig_ClaymationControl td, .ig_ClaymationControl th, #GV td, #GV th{
            color:black !important;   
            border-color:rgba(0,0,0,0.4) !important ;    
            font-weight:400 !important;
        }   
        #GV tbody > tr:first-of-type{
            background-color:rgba(0,0,0,0.1) !important;
        }
    </style>
</head>

<body onload="loadMe()">
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" LoadScriptsBeforeUI="false">
        </asp:ScriptManager>

        <asp:HiddenField ID="HF_Exit" runat="server" />
        <asp:HiddenField ID="HF_ExitTo" runat="server" />        
        <asp:HiddenField ID="HF_ExitMessage" runat="server" />

        <div class="root">
            <div class="header">    
                <div style="display:flex;align-items:center;">
                    Reviewed - Published Delay
                </div>
                <div style="display:flex;">
                    <div class="cell">
                        <asp:Label ID="Lbl_Admin" runat="server" Text="Admin" CssClass="lbl" />
                        <asp:DropDownList ID="Cmb_Admin" runat="server" CssClass="dropDown cmbAdmin" />
                    </div>
                    <div class="cell">
                        <asp:Label ID="Lbl_SDate" runat="server" Text="S. Date*" CssClass="lbl" />
                        <asp:TextBox ID="Txt_SDate" runat="server" CssClass="txt" />
                    </div>                 
                    <div class="cell">
                        <asp:Label ID="Lbl_EDate" runat="server" Text="E. Date" CssClass="lbl" />
                        <asp:TextBox ID="Txt_EDate" runat="server" CssClass="txt" />
                    </div>

                    <div class="cell" style="justify-content:flex-end">
                        <asp:Button ID="Cmd_Search" runat="server" Text="Search" CssClass="btn" OnClientClick="return onSearchClick();" OnClick="Cmd_Search_Click" />
                    </div>
                </div>
            </div>

            <% If aError IsNot Nothing AndAlso aError <> "" %>
                <div class="errorDiv">
                    <%= aError %>
                </div>
            <%End If %>

            <div class="content">
                <asp:GridView ID="GV" runat="server" AutoGenerateColumns="false"  Width="100%" Font-Names="Verdana" Font-Size="10pt" PageSize="9999">
                    <Columns>                         
                        <asp:BoundField DataField="AdminName" HeaderText="Admin" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="paddingLeft4" ItemStyle-CssClass="paddingLeft4"  />  
                        <asp:BoundField DataField="PropertyKey" HeaderText="Prop. Key" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="paddingLeft4" ItemStyle-CssClass="paddingLeft4"  />  
                        <asp:BoundField DataField="CreatedOn" HeaderText="Created On" ItemStyle-HorizontalAlign="center" HeaderStyle-HorizontalAlign="center" />  
                        <asp:BoundField DataField="ReviewedOn" HeaderText="Reviewed On" ItemStyle-HorizontalAlign="center" HeaderStyle-HorizontalAlign="center" />  
                        <asp:BoundField DataField="LastUpdatedOn" HeaderText="Published On" ItemStyle-HorizontalAlign="center" HeaderStyle-HorizontalAlign="center" />  
                    </Columns>

                    <RowStyle Height="26px" />
                    <HeaderStyle BackColor="LightGray"  Height="26px" />
                    <EditRowStyle Height="26px" />
                    <AlternatingRowStyle BackColor="White" />
                </asp:GridView>

            </div>
        </div>
    </form>

    <script type="text/javascript">

      function loadMe()
      {
           if (document.getElementById("HF_Exit").value == "exit")
             {      
               if (document.getElementById("HF_ExitMessage").value != "")
                  alert(document.getElementById("HF_ExitMessage").value);
           
               var aExitTo = document.getElementById("HF_ExitTo").value;
           
               if (aExitTo.substring(0,1) == "1")
                  {
                    if (window.parent.parent)
                       window.parent.parent.location = aExitTo.substring(1);
                    else if (window.parent)
                       window.parent.location = aExitTo.substring(1); 
                  }
                 
               else
                 {
                    if (window.parent.document.getElementById('myIframe'))
                        window.parent.document.getElementById('myIframe').src= aExitTo.substring(1);            
                    else if (window.parent)
                       window.parent.location = aExitTo.substring(1);
                 } 
              }
        } 


        function isDate(value) {            
             return !isNaN(Date.parse(value));
        }

        function onSearchClick() {
            var txtSDate = document.getElementById("<%= Txt_SDate.CLIENTID %>");
            var txtEDate = document.getElementById("<%= Txt_EDate.CLIENTID %>");

            if (!isDate(txtSDate.value)) {
                alert("Invalid starting date.");
                txtSDate.focus();
                return false;
            }

            if (txtEDate.value != "" && !isDate(txtEDate.value)) {
                alert("Invalid ending date.");
                txtEDate.focus();
                return false;
            }

            if (txtSDate.value != "" && txtEDdate.value !=""  ) {
               var sDate = new Date(txtSDate.value);
               var eDate = new Date(txtEDate.value);

               if (sDate > eDate) {
                    alert("Start date must be before end date.");
                    txtSDate.focus();
                    return false;
                }
            }

            return true;
        }
    </script>
</body>
</html>
