﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="frmReviewedProperties.aspx.vb" Inherits="Backend_frmReviewedProperties" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>

    <script src="Js/movablediv.js"></script>

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous" />
    <link rel="stylesheet" href="fontawesome/css/font-awesome.min.css" />

    <!--My Every Page -->
    <link rel="Stylesheet" href="css/page.css" />

    <style>
        .toolbar{
            justify-content:flex-start !important;
        }

        .btnGrid{
            padding:2px 8px !important;
        }

        #popupProcess, #popupUpdate{
            position:absolute;
            z-index:999;
            left:0;
            right:0;
            top:0;
            bottom:0;
            background-color:rgba(0,0,0,0.02);
            width:100%;
            height: 100%;
        }

        #popupProcessInner{
            display:flex;
            flex-direction:column;
            position:absolute;
            z-index:9999;
            left:200px;
            top:10px;
            width:540px;
            border: 5px solid #008fe2;
            border-radius:6px;
            background-color:white;
        }

        #popupProcess .header, #popupUpdate .header{
            display: flex;
            justify-content:flex-end;
            padding:8px;
            background-color: rgba(0, 0, 0, 0.1);
            margin-bottom:0px;
            border-bottom:1px solid rgba(0, 0, 0, 0.2);
        }

        #popupProcess .content, #popupUpdate .content{
            margin-top:0px;
            display: flex;
            flex-direction:column;
            margin: 0px 0 8px 8px;
            padding-right:8px;
            max-height:500px;
            overflow-y:auto;
        }

        #popupUpdateInner{
            display:flex;
            flex-direction:column;
            position:absolute;
            z-index:9999;
            left:200px;
            top:10px;
            width:540px;
            border: 5px solid #008fe2;
            border-radius:6px;
            background-color:white;
        }

        .ig_ClaymationControl, #GV, #Grid_Process, #Grid_Update{
            color:rgba(0,0,0,0.4);     
            border-color:rgba(0,0,0,0.1) !important ;    
        }

        .ig_ClaymationControl td, .ig_ClaymationControl th, #GV td, #GV th, #Grid_Process td, #Grid_Process th, #Grid_Update td, #Grid_Update th{
            color:black !important;   
            border-color:rgba(0,0,0,0.1) !important ;    
            font-weight:400 !important;
            border-left:none !important;
            border-right:none !important;
        }   
        
        #GV tbody > tr:first-of-type, #Grid_Update tbody > tr:first-of-type, #Grid_Process tbody > tr:first-of-type {
            background-color:#f7f8fa !important;
        }

        #GV th, #Grid_Process th, #Grid_Update th {
            font-weight: 700 !important;
        }

        #GV td, #Grid_Process td, #Grid_Update td {
            padding-top: 2px;
            padding-bottom: 2px;
        }

    </style>
</head>

<body onload="loadMe()">
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" LoadScriptsBeforeUI="false">
        </asp:ScriptManager>

        <asp:HiddenField ID="HF_Exit" runat="server" />
        <asp:HiddenField ID="HF_ExitTo" runat="server" />        
        <asp:HiddenField ID="HF_ExitMessage" runat="server" />

        <asp:HiddenField ID="HF_ShowPopupProcess" runat="server" />
        <asp:HiddenField ID="HF_ShowPopupUpdate" runat="server" />
        <asp:HiddenField ID="HF_EntryId" runat="server" />

        <div class="root">

            <div class="toolbar">
                <div style="font-weight:700 !important; color:#008ef2 !important;">
                    Reviewed Properties
                </div>
            </div>

            <div style="padding:6px">
                <% If aError IsNot Nothing AndAlso aError <> "" %>
                    <div class="errorDiv">
                        <%=aError %>
                    </div>
                <%End If %>

                <%If Me.IsPostBack = False AndAlso (aDataSource Is Nothing OrElse aDataSource.Rows.Count < 1) Then %>
                        <div style="display:flex; justify-content:center;align-items:center;height:400px">
                            <h2 style="color:gray;">There are no pending properties to review.</h2>
                        </div>
                <%Else %>
                    <asp:GridView ID="GV" runat="server" DataKeyNames="ID" AutoGenerateColumns="false"  Width="100%" PageSize="9999" >
                        <Columns>                         
                            <asp:BoundField DataField="ID" ItemStyle-CssClass="hidden" HeaderStyle-CssClass="hidden" />  

                            <asp:BoundField DataField="PropertyId" HeaderText="Prop. ID" ItemStyle-HorizontalAlign="center" HeaderStyle-HorizontalAlign="center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText" />  
                            <asp:BoundField DataField="PropertyKey" HeaderText="Prop. Key" ItemStyle-HorizontalAlign="center" HeaderStyle-HorizontalAlign="center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText" />  
                            <asp:BoundField DataField="Info" HeaderText="Info" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="paddingLeft4" ItemStyle-CssClass="paddingLeft4"  />  
                            <asp:BoundField DataField="Status" HeaderText="Status" ItemStyle-HorizontalAlign="center" HeaderStyle-HorizontalAlign="center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText" />  
                        
                            <asp:TemplateField HeaderText="" ItemStyle-Width="69"  HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                                <ItemTemplate> 
                                    <asp:Button ID="Cmd_Visit" runat="server" data-path='<%# DataBinder.Eval(Container.DataItem, "Url")%>' Text="Visit" OnClientClick="return visit(this);" CssClass="btn btnToolbar btnGrid btnOrange" Width="65"></asp:Button>
                                </ItemTemplate>
                            </asp:TemplateField> 

                            <asp:TemplateField HeaderText="" ItemStyle-Width="69"  HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center">
                                <ItemTemplate> 
                                    <asp:Button ID="Cmd_Process" runat="server" Text="Process" data-id='<%# DataBinder.Eval(Container.DataItem, "ID")%>' OnClientClick="return onProcessClick(this);" OnClick="Cmd_Process_Click" CssClass="btn btnToolbar btnGrid" Width="65"></asp:Button>
                                </ItemTemplate>
                            </asp:TemplateField> 
                            <asp:TemplateField HeaderText="" ItemStyle-Width="69"  HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center">
                                <ItemTemplate> 
                                    <asp:Button ID="Cmd_Update" runat="server" Text="Update" data-id='<%# DataBinder.Eval(Container.DataItem, "ID")%>' OnClientClick="return onUpdateClick(this);" OnClick="Cmd_Update_Click" CssClass="btn btnToolbar btnGrid" Width="65"></asp:Button>
                                </ItemTemplate>
                            </asp:TemplateField> 
                        </Columns>

                        <RowStyle Height="26px" />
                        <HeaderStyle BackColor="LightGray"  Height="26px" />
                        <EditRowStyle Height="26px" />
                        <AlternatingRowStyle BackColor="White" />
                    </asp:GridView>
                <%End If %>
            </div>

            <!--Popup Process-->
            <%If HF_ShowPopupProcess.Value = "True" Then %>
                <div id="popupProcess">
                    <div id="popupProcessInner" class="movableDiv">
                        <div id="popupProcessInnerheader" class="popupToolbar">
                            <asp:Image ID="Img_Status" runat="server" ImageUrl="~/BackEnd/App_Photos/Ico_Success.png" />
                            <asp:Button ID="Cmd_ProcessSave" runat="server" Text="Save" CssClass="btn btnToolbar" style="margin-right:12px;" OnClick="Cmd_Process_Save_Click" />
                            <asp:Button ID="Cmd_ProcessComplete" runat="server" Text="Complete" CssClass="btn btnToolbar" style="margin-right:12px;" OnClientClick="return onCompleteClicked(this);" OnClick="Cmd_Process_Complete_Click" />
                            <asp:Button ID="Cmd_ProcessClose" runat="server" Text="Close" CssClass="btn btnToolbar" OnClientClick="return onCloseProcessDialog();" />
                        </div>

                        <% If aProcessError IsNot Nothing AndAlso aProcessError <> "" %>
                            <div class="errorDiv">
                                <%= aProcessError %>
                            </div>
                        <%End If %>

                        <div class="content">
                            <asp:Label ID="Lbl_Process_Notes" runat="server" style="margin-top:8px;" Text="Notes" />
                            <asp:TextBox ID="Txt_Process_Notes" runat="server" TextMode="MultiLine" style="min-height:60px;"  Height="60" Width="100%" CssClass="form-control txt" Enabled="false" />

                            <asp:Label ID="Lbl_Process_Errors" runat="server" Text="Errors" CssClass="marginTop8" />
                            <asp:TextBox ID="Txt_Process_Errors" runat="server" TextMode="MultiLine" style="min-height:60px;" Height="60" Width="100%" CssClass="form-control txt" Enabled="false" />
                            <div style="margin-top:5px;display:flex; align-items:center;">
                                <asp:CheckBox ID="Chk_Process_ErrorsDone" runat="server" Text="Done" />
                            </div>

                            <asp:GridView ID="Grid_Process" runat="server" DataKeyNames="Id" AutoGenerateColumns="false"  Width="100%" PageSize="9999" BorderColor="gray" CssClass="marginTop12">
                                <Columns>                         
                                    <asp:BoundField DataField="Id" ItemStyle-CssClass="hidden" HeaderStyle-CssClass="hidden" />  

                                    <asp:BoundField DataField="ShortTitle" HeaderText="Channel" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="paddingLeft4" ItemStyle-CssClass="paddingLeft4" />  
                                        
                                    <asp:TemplateField HeaderText="Done" ItemStyle-Width="65" ControlStyle-Width="40" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                                        <ItemTemplate> 
                                            <asp:Checkbox ID="Chk_Process_Done" runat="server" Checked='<%# DataBinder.Eval(Container.DataItem, "Done")%>' ></asp:Checkbox>
                                        </ItemTemplate>
                                    </asp:TemplateField>                                  
                                </Columns>

                                <RowStyle Height="26px" />
                                <HeaderStyle Height="26px" />
                                <EditRowStyle Height="26px" />
                                <AlternatingRowStyle BackColor="White" />
                            </asp:GridView>

                        </div>

                    </div>
                </div>
            <%End If %>



            <!--Popup Update-->
            <%If HF_ShowPopupUpdate.Value = "True" Then %>
                <div id="popupUpdate">
                    <div id="popupUpdateInner" class="movableDiv">
                        <div id="popupUpdateInnerheader" class="popupToolbar">
                            <asp:Button ID="Cmd_Update_Save" runat="server" OnClick="Cmd_Update_Save_Click" Text="Update" CssClass="btn btnToolbar" style="margin-right:12px;" />
                            <asp:Button ID="Cmd_Update_Close" runat="server" Text="Close" CssClass="btn btnToolbar" OnClientClick="return onCloseUpdateDialog();" />
                        </div>

                        <% If aUpdateError IsNot Nothing AndAlso aUpdateError <> "" %>
                            <div class="errorDiv">
                                <%= aUpdateError %>
                            </div>
                        <%End If %>

                        <div class="content">
                            <asp:Label ID="Lbl_Notes" runat="server" style="margin-top:8px;" Text="Notes" />
                            <asp:TextBox ID="Txt_Notes" runat="server" TextMode="MultiLine" style="min-height:60px;" Height="60" Width="100%" CssClass="form-control txt"/>

                            <asp:Label ID="Lbl_Errors" runat="server" Text="Errors" CssClass="marginTop8" />
                            <asp:TextBox ID="Txt_Errors" runat="server" TextMode="MultiLine" style="min-height:60px;" Height="60" Width="100%" CssClass="form-control txt" />

                            <asp:GridView ID="Grid_Update" runat="server" DataKeyNames="Id" AutoGenerateColumns="false"  Width="100%" PageSize="9999" BorderColor="gray" CssClass="marginTop12">
                                <Columns>                         
                                    <asp:BoundField DataField="Id" ItemStyle-CssClass="hidden" HeaderStyle-CssClass="hidden" />  

                                    <asp:BoundField DataField="ShortTitle" HeaderText="Channel" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="paddingLeft4" ItemStyle-CssClass="paddingLeft4" />  
                                        
                                    <asp:TemplateField HeaderText="Yes" ItemStyle-Width="65" ControlStyle-Width="40" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                                        <ItemTemplate> 
                                            <asp:CheckBox ID="Chk_Yes" runat="server" onclick="return onActionChecked(this);" />
                                        </ItemTemplate>
                                    </asp:TemplateField>

                                    <asp:TemplateField HeaderText="No" ItemStyle-Width="65" ControlStyle-Width="40" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                                        <ItemTemplate> 
                                            <asp:CheckBox ID="Chk_No" runat="server" onclick="return onActionChecked(this);" />
                                        </ItemTemplate>
                                    </asp:TemplateField>

                                    <asp:TemplateField HeaderText="Maybe" ItemStyle-Width="65" ControlStyle-Width="40" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                                        <ItemTemplate> 
                                            <asp:CheckBox ID="Chk_Maybe" runat="server" onclick="return onActionChecked(this);" />
                                        </ItemTemplate>
                                    </asp:TemplateField>
                                </Columns>

                                <RowStyle Height="26px" />
                                <HeaderStyle Height="26px" />
                                <EditRowStyle Height="26px" />
                                <AlternatingRowStyle BackColor="White" />
                            </asp:GridView>

                        </div>
                    </div>
                </div>
            <%End If %>
        </div>
    </form>

    <script type="text/javascript">
      function fnHideSuccessIcon()
      {
          window.setTimeout(function(){
             var o = document.getElementById("<%= Img_Status.ClientID %>");
              if (o)
                  o.style.display = "none";   
          }, 3000);
      }

      function loadMe()
      {
          fnHideSuccessIcon();

           if (document.getElementById("HF_Exit").value == "exit")
             {      
               if (document.getElementById("HF_ExitMessage").value != "")
                  alert(document.getElementById("HF_ExitMessage").value);
           
               var aExitTo = document.getElementById("HF_ExitTo").value;
           
               if (aExitTo.substring(0,1) == "1")
                  {
                    if (window.parent.parent)
                       window.parent.parent.location = aExitTo.substring(1);
                    else if (window.parent)
                       window.parent.location = aExitTo.substring(1); 
                  }
                 
               else
                 {
                    if (window.parent.document.getElementById('myIframe'))
                        window.parent.document.getElementById('myIframe').src= aExitTo.substring(1);            
                    else if (window.parent)
                       window.parent.location = aExitTo.substring(1);
                 } 
          }
          else
          {
              try {
                  if(document.getElementById("popupProcessInner"))
                      makeElementMovable(document.getElementById("popupProcessInner"));

                  if (document.getElementById("popupUpdateInner"))
                     makeElementMovable(document.getElementById("popupUpdateInner"));

              }
              catch(ex) {

              }
          } 
        } 

        function visit(btn) {
            var path = btn.getAttribute("data-path");
            window.open(path);
            return false;
        }

        function onProcessClick(btn) {
            var id = btn.getAttribute("data-id");
            document.getElementById("<%= HF_EntryId.ClientID %>").value = id;

            return true;
        }

        function onCloseProcessDialog() {
            document.getElementById("popupProcess").style.display = "none";
            document.getElementById("<%= HF_ShowPopupProcess.ClientID %>").value = "False";
            return false;  
        }

        function onCompleteClicked(btn) {
            var grid = document.getElementById("<%= Grid_Process.ClientID %>");
            if (!grid) {
                alert("An unknown error occured.");
                return false;
            }

            var rows = grid.rows;
            var data = [];
            var done;

            var txtErrors = document.getElementById("<%= Txt_Process_Errors.ClientID %>");
            var chkErrorsDone = document.getElementById("<%= Chk_Process_ErrorsDone.ClientID %>");
            var showWarning = false;

            if (txtErrors.value != "" && chkErrorsDone.checked == false) 
                showWarning = true;

            for (var i = 1; i < rows.length; i++) {
                done = rows[i].cells[2].getElementsByTagName('INPUT')[0].checked;

                if (done == false) {
                    showWarning = true;
                    break;
                }
            }

            if (showWarning == true) {
                var answer = confirm("Some tasks are not done. Are you sure you want to mark the whole process as completed?");
                if (answer) 
                    return true;                
                else 
                    return false;                
            }

            return true;
        }


        function onUpdateClick(btn) {
            var id = btn.getAttribute("data-id");
            document.getElementById("<%= HF_EntryId.ClientID %>").value = id;

            return true;
        }

        function onActionChecked(chk) {
            var tr = chk.closest("tr");
            var descendants = tr.querySelectorAll("input");

            for (var child in descendants) {
                if (descendants[child].type == "checkbox" && child != chk)
                    descendants[child].checked = false;
            }

            chk.checked = true;
            return true;
        }

        function onCloseUpdateDialog() {
            document.getElementById("popupUpdate").style.display = "none";
            document.getElementById("<%= HF_ShowPopupUpdate.ClientID %>").value = "False";
            return false;  
        }

    </script>

</body>
</html>
