﻿Imports System.Collections.Generic
Imports System.Data
Imports Utils 

Partial Class Backend_frmReviewedProperties
    Inherits System.Web.UI.Page
    
    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aError As String = ""
    Public aProcessError As String = ""
    Public aUpdateError As String = ""
    Public aDataSource As DataTable 

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsAgent = False AndAlso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(True, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function
    
    Public ReadOnly Property IsAgent As Boolean
        Get
            Return aCurrentUser IsNot Nothing AndAlso aCurrentUser.IsAgent = true
        End Get
    End Property

    Public ReadOnly Property IsAdmin As Boolean
        Get
            Return aCurrentUser IsNot Nothing AndAlso aCurrentUser.IsAdmin = true
        End Get
    End Property

    Public ReadOnly Property IsSuperUser As Boolean
        Get
            Return aCurrentUser IsNot Nothing AndAlso aCurrentUser.IsSuperUser = true
        End Get
    End Property

    Private Sub Backend_frmReviewedProperties_Load(sender As Object, e As EventArgs) Handles Me.Load
        If ValidateUser = False Then Return

        aError = ""
        aProcessError = ""
        aUpdateError = ""

        Me.Img_Status.Visible = False 

        If Me.IsPostBack = False Then 
            Try
                aDataSource = BackEnd.Prop.GetNonCompletedReviewedProperties(aCurrentUser.ID)
                Me.GV.DataSource = aDataSource
                Me.GV.DataBind()

                Me.GV.Columns(7).Visible = Me.IsAgent = True OrElse Me.IsSuperUser = True 
                Me.GV.Columns(6).Visible = Me.IsAdmin = True OrElse Me.IsSuperUser = True

            Catch ex As Exception
                aError = ex.Message
            End Try
        End If 
    End Sub


    Protected Sub Cmd_Process_Click(sender As Object, e As EventArgs)
        Dim aErrors As String, aErrorsDone As Boolean, aNotes As String
        Dim aDT As DataTable 

        Try
             BackEnd.Prop.GetProcessReviewedPropertyData (HF_EntryId.Value, aErrors, aErrorsDone, aNotes, aDT)
           
            Me.Grid_Process.DataSource = aDT
            Me.Grid_Process.DataBind()
           
            Txt_Process_Errors.Text = aErrors
            Chk_Process_ErrorsDone.Checked=aErrorsDone 
            Chk_Process_ErrorsDone.Enabled = aErrors <> ""
            Txt_Process_Notes.Text = aNotes

            HF_ShowPopupProcess.Value = "True"
            
        Catch ex As Exception
            aError = ex.Message
        End Try   
    End Sub

    Protected Sub Cmd_Process_Save_Click(sender As Object, e As EventArgs)
        Dim aErrorsDone As Boolean = Chk_Process_ErrorsDone.Checked
        Dim channels As List(Of IntegerBool) = New List(Of IntegerBool)
        Dim chk As CheckBox
        Dim channelId As Integer, done As Boolean 

         For Each row As GridViewRow In Grid_Process.Rows
            channelId= row.Cells(0).Text
            
            chk = row.Cells(2).Controls.Item(1)
            done=chk.Checked 

            channels.Add (New IntegerBool(channelId, done))
        Next

        Try
            Dim isCompleted As Boolean  = BackEnd.Prop.ProcessReviewedProperty(HF_EntryId.Value, aErrorsDone, channels, aCurrentUser.ID, false)
            If isCompleted = True Then
                HF_ShowPopupProcess.Value = "False"
                Response.Redirect(Request.Url.AbsoluteUri)
            Else
                Img_Status.Visible = True 
            End If
        Catch ex As Exception
            aProcessError = ex.Message
        End Try
    End Sub
    Protected Sub Cmd_Process_Complete_Click(sender As Object, e As EventArgs)
        Dim aErrorsDone As Boolean = Chk_Process_ErrorsDone.Checked
        Dim channels As List(Of IntegerBool) = New List(Of IntegerBool)
        Dim chk As CheckBox
        Dim channelId As Integer, done As Boolean 

         For Each row As GridViewRow In Grid_Process.Rows
            channelId= row.Cells(0).Text
            
            chk = row.Cells(2).Controls.Item(1)
            done=chk.Checked 

            channels.Add (New IntegerBool(channelId, done))
        Next

        Try
            BackEnd.Prop.ProcessReviewedProperty(HF_EntryId.Value, aErrorsDone, channels, aCurrentUser.ID, true)
            HF_ShowPopupProcess.Value = "False"
            Response.Redirect(Request.Url.AbsoluteUri)
        Catch ex As Exception
            aProcessError = ex.Message
        End Try
    End Sub


    Protected Sub Cmd_Update_Click(sender As Object, e As EventArgs)
        Dim i As Integer = 0
        Dim chk As CheckBox
        Dim aErrors As String, aNotes As String
        Dim aErrorsDone As Boolean
        Dim aDT As DataTable 

        Try
            BackEnd.Prop.GetUpdateReviewedPropertyData(HF_EntryId.Value, aErrors,aErrorsDone , aNotes, aDT)

            Me.Grid_Update.DataSource = aDT
            Me.Grid_Update.DataBind()

            For Each aDRow As DataRow In aDT.Rows
                If aDRow("Action") = 1 Then
                    chk = Grid_Update.Rows(i).Cells(2).Controls.Item(1)
                    chk.Checked = True
                ElseIf aDRow("Action") = 0 Then
                    chk = Grid_Update.Rows(i).Cells(4).Controls.Item(1)
                    chk.Checked = True
                Else
                    chk = Grid_Update.Rows(i).Cells(3).Controls.Item(1)
                    chk.Checked = True
                End If

                i = i + 1
            Next

            Txt_Errors.Text = aErrors 
            Txt_Notes.Text = aNotes 

            HF_ShowPopupUpdate.Value = "True"

            Txt_Notes.Focus()
        Catch ex As Exception
            aError = ex.Message
        End Try   

    End Sub

    Protected Sub Cmd_Update_Save_Click(sender As Object, e As EventArgs)
        Dim channels As List(Of Backend.PairedInteger) = New List(Of Backend.PairedInteger)
        Dim chk As CheckBox
        Dim channelId As Integer, action As integer

         For Each row As GridViewRow In Grid_Update.Rows
            channelId= row.Cells(0).Text

            action = 0
            chk = row.Cells(2).Controls.Item(1)
            If chk.Checked = True Then 
                action=1
            Else
                chk = row.Cells(3).Controls.Item(1)
                If chk.Checked = True Then action = -1
            End If

            channels.Add (New BackEnd.PairedInteger(channelId, action))
        Next

        Try
            BackEnd.Prop.UpdateReviewedProperty(HF_EntryId.Value, Txt_Errors.Text.Trim(), Txt_Notes.Text.Trim(), channels, aCurrentUser.ID)

            HF_ShowPopupUpdate.Value = "False"
            Response.Redirect(Request.Url.AbsoluteUri)
        Catch ex As Exception
            aUpdateError = ex.Message
        End Try

    End Sub
End Class
