﻿
Imports System.Data

Partial Class Backend_frmSearch
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aError As String

    Protected Sub Page_Error(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Error
        Dim aTicketNumber As Integer
        Dim aErrorPath As String = Request.Path
        Dim aErrorDescription As String = Server.GetLastError.GetBaseException.ToString
        Dim aObj As LOG

        Context.ClearError()

        Try
            aObj = LOG.Create()

            aObj.ErrorPath = aErrorPath
            aObj.ErrorDescription = aErrorDescription

            aObj.Persist(True)

            aTicketNumber = aObj.ID
        Catch Ex As Exception
            aTicketNumber = -1
        End Try

        Cache("LastErrorPath") = aErrorPath
        Cache("LastErrorDescription") = aErrorDescription
        Cache("LastErrorTicketNumber") = aTicketNumber.ToString

        'If Me.aRedirectOption = RedirectOptionEnum.Transfer Then
        '    Server.Transfer("frmLogin.aspx", False)
        'Else
            Response.Redirect("frmLogin.aspx", False)
        'End If
    End Sub

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsAgent = False AndAlso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(true, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function

    Private Sub ReconstructLists()
        Dim propertiesIds As String = HF_PropertiesIds.Value
        Dim propertiesTitles As String = HF_PropertiesTitles.Value
        Dim districtsIds As String = HF_DistrictsIds.Value
        Dim districtsTitles As String = HF_DistrictsTitles.Value
        Dim citiesIds As String = HF_CitiesIds.Value
        Dim citiesTitles As String = HF_CitiesTitles.Value
        Dim PropertyTypesIds As String = HF_PropertyTypesIds.Value
        Dim PropertyTypesTitles As String = HF_PropertyTypesTitles.Value
        Dim notCitiesIds As String = HF_NotCitiesIds.Value
        Dim notCitiesTitles As String = HF_NotCitiesTitles.Value

        Dim arrIds As String()
        Dim arrTitles As String()
        Dim i As Integer

        Lst_Properties.Items.Clear()
        If propertiesIds <> "" Then
            arrIds = propertiesIds.Split(",")
            arrTitles = propertiesTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_Properties.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_Districts.Items.Clear()
        If districtsIds <> "" Then
            arrIds = districtsIds.Split(",")
            arrTitles = districtsTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_Districts.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_PropertyTypes.Items.Clear()
        If PropertyTypesIds <> "" Then
            arrIds = PropertyTypesIds.Split(",")
            arrTitles = PropertyTypesTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_PropertyTypes.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_Cities.Items.Clear()
        If citiesIds <> "" Then
            arrIds = citiesIds.Split(",")
            arrTitles = citiesTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_Cities.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If

        Lst_NotCities.Items.Clear()
        If notCitiesIds <> "" Then
            arrIds = notCitiesIds.Split(",")
            arrTitles = notCitiesTitles.Split(",")

            For i = 0 To arrIds.Length - 1
                Lst_NotCities.Items.Add(New ListItem(arrTitles(i), arrIds(i)))
            Next
        End If
    End Sub

    Private Sub FillLookups()
        Dim aDS As DataSet
        Dim aDR As DataRow

        aDS = BackEnd.Prop.GetSearchFormLookups()

        'Property Type
       ' With Cmb_PropertyType
       '     .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", 0))

       '     For Each aDR In aDS.Tables(0).Rows
       '         .Items.Add(New System.Web.UI.WebControls.ListItem(aDR("Name"), aDR("ID")))
       '     Next
       'End With


        'Search In
        With Cmb_SearchIn
            .Items.Clear

            .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", "0"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("My Properties", "-1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Colleagues' Props", "-2"))

            For Each aDR In aDS.Tables(1).Rows
                .Items.Add(New System.Web.UI.WebControls.ListItem(aDR("Name"), aDR("ID")))
            Next
        End With

        'View
        With Cmb_View
            .Items.Clear

            .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", "0"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Any View", "1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("City", "2"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Mountain", "3"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Sea View", "4"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("City + Mountain", "5"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("City + Sea", "6"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Mountain + Sea", "7"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("All", "8"))
        End With

        'Age
        With Cmb_Age
            .Items.Clear

            .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", "0"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("<= 5 Years", "-1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("<= 10 Years", "-2"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("<= 15 Years", "-3"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("<= 20 Years", "-4"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("New", "1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Under C.", "2"))
        End With

        'Parking
        With Cmb_Parking
            .Items.Clear

            .Items.Add(New System.Web.UI.WebControls.ListItem("N/A", "0"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Any", "1"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Uncovered", "2"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Covered", "3"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Underground", "4"))
            .Items.Add(New System.Web.UI.WebControls.ListItem("Cov. Or Un.", "5"))
        End With
    End Sub

    Private Sub SelectInCombo(ByVal aItemID As String, ByVal aCombo As DropDownList)
        Dim i As Integer

        For i = 0 To aCombo.Items.Count - 1
            If aCombo.Items(i).Value = aItemID Then
                aCombo.SelectedIndex = i
                Return
            End If
        Next
    End Sub

    Protected Function CreateEmptySearchDT() As DataTable
        Dim aResult As New DataTable

        With aResult
            .Columns.Add("Id", GetType(Integer))
            .Columns.Add("PropertyKey", GetType(String))
            .Columns.Add("Owner", GetType(String))
            .Columns.Add("City", GetType(String))
            .Columns.Add("Surface", GetType(Integer))
            .Columns.Add("Sellable", GetType(Integer))
            .Columns.Add("Sale", GetType(Integer))
            .Columns.Add("Rent", GetType(Integer))

        End With

        Return aResult
    End Function

    Private Sub Backend_frmSearch_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.Img_Status.Visible=False 

        If ValidateUser = False Then Return

        aError = ""

        If Me.IsPostBack = False
            Me.FillLookups()

            GV.DataSource = Me.CreateEmptySearchDT()
            GV.DataBind()

            GotoNewMode()
        Else
            Me.ReconstructLists()
        End If
    End Sub

    Protected Sub ClearControls
        HF_PropertiesIds.Value = ""
        HF_PropertiesTitles.Value = ""
        HF_DistrictsIds.Value = ""
        HF_DistrictsTitles.Value = ""
        HF_PropertyTypesIds.Value = ""
        HF_PropertyTypesTitles.Value = ""
        HF_CitiesIds.Value = ""
        HF_CitiesTitles.Value=""
        HF_NotCitiesIds.Value = ""
        HF_NotCitiesTitles.Value=""

        Cmb_SearchIn.SelectedIndex = 0
        'Cmb_PropertyType.SelectedIndex=0
        Opt_Surface.Checked=False :Opt_Sellable.Checked=True 
        Txt_AreaMin.Text="0":Txt_AreaMax.Text="0"
        Chk_ForSale.Checked=False : Txt_SaleMin.Text="0":Txt_SaleMax.Text="0"
        Chk_ForRent.Checked=False : Txt_RentMin.Text="0":Txt_RentMax.Text="0"
        Txt_BedroomsMin.Text="0": Txt_BedroomsMax.Text="0"

        Txt_Properties.Text="" : Lst_Properties.Items.Clear()
        Txt_Districts.Text="" : Lst_Districts.Items.Clear()
        Txt_PropertyTypes.Text="" : Lst_PropertyTypes.Items.Clear()
        Txt_Cities.Text="" : Lst_Cities.Items.Clear()
        Txt_NotCities.Text="" : Lst_NotCities.Items.Clear()
        Cmb_View.SelectedIndex=0 : Cmb_Age.SelectedIndex=0
        Cmb_Parking.SelectedIndex = 0: Txt_Parking.Text="0"

        Chk_BIW.Checked=False
        Chk_CentralAC.Checked=False
        Chk_Commercial.Checked=False
        Chk_Concierge.Checked=False
        Chk_Decorated.Checked=False
        Chk_DoubleGlazing.Checked=False
        Chk_Duplex.Checked=False
        Chk_LTB.Checked=False        
        Chk_Furnished.Checked=False
        Chk_Heating.Checked=False
        Chk_Interphone.Checked=False
        Chk_IsContractSigned.Checked=False
        Chk_IsFeatured.Checked=False
        Chk_NotGF.Checked=False
        Chk_Lux.Checked=False
        Chk_MaidRoom.Checked=False
        Chk_MaidBath.Checked=False
        Chk_NoSlope.Checked=False
        Chk_PetsAllowed.Checked=False
        Chk_Pool.Checked=False
        Chk_Roof.Checked=False
        Chk_Security.Checked=False
        Chk_Solar.Checked=False
        Chk_Storage.Checked=False
        Chk_NotUsed.Checked=False
        Chk_VideoPhone.Checked=False
        Chk_WillExchange.Checked=False   
        Chk_GF.Checked = False 
        Chk_FirstFloor.Checked=False
        Chk_NotFirstFloor.Checked=False
        Chk_NotLastFloor.Checked=False
        Chk_Garden.Checked=False
        Chk_Terrace.Checked=False   
        Chk_Balcony.Checked = False 
        Chk_IsActive.Checked=True   
        Chk_IsNotActive.Checked = False 
    End Sub

    Protected Sub GotoNewMode()
        HF_Mode.Value = "1"
        HF_SearchId.Value="0"
        HF_SelectedSearchId.Value = ""
        Txt_Searches.Text = ""
        HF_RequestId.Value=""
        Txt_Request.Text=""

        ClearControls 
    End Sub

    Protected Sub Search()
        Dim aDT As DataTable
        Dim aSurfaceType As Integer = 1
        Dim aPropertiesIds As String="", aDistrictsIds As String="", aPropertyTypesIds As String="", aCitiesIds As String="", aNotCitiesIds As String=""

        If Opt_Sellable.Checked = True Then aSurfaceType = 2

        If HF_PropertiesIds.Value IsNot Nothing Then aPropertiesIds=HF_PropertiesIds.Value
        If HF_DistrictsIds.Value IsNot Nothing Then aDistrictsIds=HF_DistrictsIds.Value
        If HF_PropertyTypesIds.Value IsNot Nothing Then aPropertyTypesIds=HF_PropertyTypesIds.Value
        If HF_CitiesIds.Value IsNot Nothing Then aCitiesIds=HF_CitiesIds.Value
        If HF_NotCitiesIds.Value IsNot Nothing Then aNotCitiesIds=HF_NotCitiesIds.Value
        
        aDT = BackEnd.Prop.Search(aCurrentUser.ID, Cmb_SearchIn.SelectedValue,aSurfaceType,Txt_AreaMin.Text, Txt_AreaMax.Text, Chk_ForSale.Checked, Txt_SaleMin.Text, Txt_SaleMax.Text, Chk_ForRent.Checked, Txt_RentMin.Text, Txt_RentMax.Text, Txt_BedroomsMin.Text, Txt_BedroomsMax.Text,aPropertiesIds, aDistrictsIds, aPropertyTypesIds, aCitiesIds, aNotCitiesIds,Cmb_View.SelectedValue, Cmb_Age.SelectedValue,Cmb_Parking.SelectedValue, Txt_Parking.Text, _
                                    Chk_Furnished.Checked, Chk_Decorated.Checked, Chk_NotUsed.Checked, Chk_Lux.Checked, Chk_Duplex.Checked, Chk_Commercial.Checked, Chk_IsFeatured.Checked, Chk_WillExchange.Checked, Chk_NoSlope.Checked, Chk_GF.Checked, Chk_FirstFloor.Checked,Chk_NotGF.Checked, Chk_NotFirstFloor.Checked, Chk_NotLastFloor.Checked,Chk_Garden.Checked,Chk_Terrace.Checked,Chk_Balcony.Checked, Chk_MaidRoom.Checked,  Chk_MaidBath.Checked, Chk_Heating.Checked, Chk_Solar.Checked, Chk_CentralAC.Checked, Chk_Storage.Checked, Chk_DoubleGlazing.Checked, Chk_Interphone.Checked, _
                                    Chk_VideoPhone.Checked, Chk_LTB.Checked, Chk_BIW.Checked, Chk_Concierge.Checked, Chk_Security.Checked, Chk_Pool.Checked, Chk_PetsAllowed.Checked, Chk_Roof.Checked, Chk_IsContractSigned.Checked, Chk_IsActive.Checked, Chk_IsNotActive.Checked )

        GV.DataSource = aDT
        GV.DataBind()

        Session("SearchDS") = aDT

        'aRowsCount = "( " & aDT.Rows.Count & " " & IIf(aDT.Rows.Count <2, "property", "properties") & " found)"
        HF_RowsCount.Value = "( " & aDT.Rows.Count & " )"
    End Sub

    Protected Sub Cmd_Search_Click(sender As Object, e As EventArgs)
        Try
            'Security
            If aCurrentUser Is Nothing Then Return
            Me.Search()

            Me.Img_Status.Visible = True

        Catch ex As Exception
            aError = ex.Message 
        End Try
    End Sub

    Private Sub GV_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GV.RowDataBound
        'Security
        If aCurrentUser Is Nothing Then Return

        if e.Row.RowType = DataControlRowType.DataRow Then
          e.Row.Attributes("ondblclick") = "onRowDoubleClick(this)"

          If DataBinder.Eval(e.Row.DataItem, "IsActive").ToString().ToLower() = "false" Then 
            e.Row.ForeColor  = Drawing.Color.Red
          End If
        End If
    End Sub

    Protected Sub Cmd_Clear_Click(sender As Object, e As EventArgs)
        'Security
        If aCurrentUser Is Nothing Then Return

        GotoNewMode()
        GV.DataSource=Me.CreateEmptySearchDT()
        GV.DataBind()

        HF_RowsCount.Value = ""
    End Sub

    Protected Function PackSearchObject() As Backend.PropertySearch
        Dim aResult As New Backend.PropertySearch()

        With aResult
            If HF_Mode.Value IsNot Nothing AndAlso HF_Mode.Value = "2" AndAlso HF_SearchId.Value IsNot Nothing AndAlso IsNumeric(HF_SearchId.Value) AndAlso CInt(HF_SearchId.Value) > 0 
                aResult.Id = CInt(HF_SearchId.Value)
            Else
                aResult.Id = 0
                aResult.Name = IIf(HF_TempSearchName.Value Is Nothing, "", HF_TempSearchName.Value)
            End If

            .UserId = 0
            If aCurrentUser IsNot Nothing Then .UserId = aCurrentUser.ID

            .SearchIn = Cmb_SearchIn.SelectedValue

            If Opt_Sellable.Checked = True Then
                .SurfaceType = 2
            Else
                .SurfaceType = 1
            End If

            .SurfaceMin = Txt_AreaMin.Text : .SurfaceMax=Txt_AreaMax.Text
            .ForSale = Chk_ForSale.Checked : .SaleMin = Txt_SaleMin.Text : .SaleMax = Txt_SaleMax.Text
            .ForRent = Chk_ForRent.Checked : .RentMin = Txt_RentMin.Text : .RentMax = Txt_RentMax.Text
            .BedroomsMin = Txt_BedroomsMin.Text : .BedroomsMax = Txt_BedroomsMax.Text

            .PropertiesIds = iif(HF_PropertiesIds.Value Is Nothing, "", HF_PropertiesIds.Value)
            .DistrictsIds = iif(HF_DistrictsIds.Value Is Nothing, "", HF_DistrictsIds.Value)
            .PropertyTypesIds = iif(HF_PropertyTypesIds.Value Is Nothing, "", HF_PropertyTypesIds.Value)
            .CitiesIds = iif(HF_CitiesIds.Value Is Nothing, "", HF_CitiesIds.Value)
            .NotCitiesIds = iif(HF_NotCitiesIds.Value Is Nothing, "", HF_NotCitiesIds.Value)

            .View = Cmb_View.SelectedValue
            .Age = Cmb_Age.SelectedValue
            .ParkingType = Cmb_Parking.SelectedValue
            .ParkingCount = Txt_Parking.Text

            .LTB = Chk_LTB.Checked  
            .Furnished = Chk_Furnished.Checked
            .Decorated = Chk_Decorated.Checked
            .NotUsed = Chk_NotUsed.Checked
            .Lux = Chk_Lux.Checked
            .Duplex = Chk_Duplex.Checked
            .Commercial = Chk_Commercial.Checked
            .Hot = Chk_IsFeatured.Checked
            .Exchange = Chk_WillExchange.Checked
            .NoSlope = Chk_NoSlope.Checked
            .GF = Chk_GF.Checked
            .FirstFloor = Chk_FirstFloor.Checked
            .NotGF = Chk_NotGF.Checked
            .NotFirstFloor = Chk_NotFirstFloor.Checked
            .NotLastFloor = Chk_NotLastFloor.Checked
            .Garden = Chk_Garden.Checked
            .Terrace = Chk_Terrace.Checked
            .Balcony = Chk_Balcony.Checked
            .MaidRoom = Chk_MaidRoom.Checked
            .MaidBath = Chk_MaidBath.Checked
            .Heating = Chk_Heating.Checked
            .Solar = Chk_Solar.Checked
            .CentralAC = Chk_CentralAC.Checked
            .Storage = Chk_Storage.Checked
            .DoubleG = Chk_DoubleGlazing.Checked
            .Interphone = Chk_Interphone.Checked
            .Videophone = Chk_Videophone.Checked
            .BIW = Chk_BIW.Checked
            .Concierge = Chk_Concierge.Checked
            .Security = Chk_Security.Checked
            .Pool = Chk_Pool.Checked
            .Pets = Chk_PetsAllowed.Checked
            .Roof = Chk_Roof.Checked
            .Exclusive = Chk_IsContractSigned.Checked
            .IsActive = Chk_IsActive.Checked
            .IsNotActive = Chk_IsNotActive.Checked
        End With

        Return aResult
    End Function

    Protected Sub UnpackSearchObject(aObj As BackEnd.PropertySearch)
        Dim arr1 As String(), arr2 As String()

        With aObj
            SelectInCombo(.SearchIn, Cmb_SearchIn)
            Opt_Surface.Checked = .SurfaceType = 1
            Opt_Sellable.Checked = .SurfaceType = 2
            Txt_AreaMin.Text = .SurfaceMin 
            Txt_AreaMax.Text = .SurfaceMax 
            Chk_ForSale.Checked = .ForSale 
            Txt_SaleMin.Text = .SaleMin
            Txt_SaleMax.Text = .SaleMax
            Chk_ForRent.Checked = .ForRent
            Txt_RentMin.Text = .RentMin
            Txt_RentMax.Text = .RentMax
            Txt_BedroomsMin.Text = .BedroomsMin
            Txt_BedroomsMax.Text = .BedroomsMax

            'Properties
            HF_PropertiesIds.Value = .PropertiesIds 
            HF_PropertiesTitles.Value = .PropertiesTitles 
            Lst_Properties.Items.Clear()

            If .PropertiesIds <> "" Then
                arr1 = .PropertiesIds.Split(",")
                arr2 = .PropertiesTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_Properties.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If

            'Districts
            HF_DistrictsIds.Value = .DistrictsIds 
            HF_DistrictsTitles.Value = .DistrictsTitles 
            Lst_Districts.Items.Clear()

            If .DistrictsIds <> "" Then
                arr1 = .DistrictsIds.Split(",")
                arr2 = .DistrictsTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_Districts.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If


            'PropertyTypes
            HF_PropertyTypesIds.Value = .PropertyTypesIds 
            HF_PropertyTypesTitles.Value = .PropertyTypesTitles 
            Lst_PropertyTypes.Items.Clear()

            If .PropertyTypesIds <> "" Then
                arr1 = .PropertyTypesIds.Split(",")
                arr2 = .PropertyTypesTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_PropertyTypes.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If

            'Cities
            HF_CitiesIds.Value = .CitiesIds 
            HF_CitiesTitles.Value = .CitiesTitles 
            Lst_Cities.Items.Clear()

            If .CitiesIds <> "" Then
                arr1 = .CitiesIds.Split(",")
                arr2 = .CitiesTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_Cities.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If

            'NotCities
            HF_NotCitiesIds.Value = .NotCitiesIds 
            HF_NotCitiesTitles.Value = .NotCitiesTitles 
            Lst_NotCities.Items.Clear()

            If .NotCitiesIds <> "" Then
                arr1 = .NotCitiesIds.Split(",")
                arr2 = .NotCitiesTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_NotCities.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If

            SelectInCombo(.View, Cmb_View)
            SelectInCombo(.Age, Cmb_Age)
            SelectInCombo(.ParkingType, Cmb_Parking)
            Txt_Parking.Text = .ParkingCount 

            'Checkboxes
            Chk_Balcony.Checked = .Balcony
            Chk_BIW.Checked = .BIW
            Chk_CentralAC.Checked = .CentralAC
            Chk_Commercial.Checked = .Commercial
            Chk_Concierge.Checked = .Concierge
            Chk_Decorated.Checked = .Decorated
            Chk_DoubleGlazing.Checked = .DoubleG
            Chk_Duplex.Checked = .Duplex
            Chk_FirstFloor.Checked = .FirstFloor
            Chk_ForRent.Checked = .ForRent
            Chk_ForSale.Checked = .ForSale
            Chk_Furnished.Checked = .Furnished
            Chk_Garden.Checked = .Garden
            Chk_GF.Checked = .GF
            Chk_Heating.Checked = .Heating
            Chk_Interphone.Checked = .Interphone
            Chk_IsActive.Checked=.IsActive
            Chk_IsContractSigned.Checked = .Exclusive
            Chk_IsFeatured.Checked = .Hot
            Chk_IsNotActive.Checked = .IsNotActive
            Chk_NotGF.Checked = .NotGF 
            Chk_LTB.Checked = .LTB
            Chk_Lux.Checked = .Lux
            Chk_MaidBath.Checked = .MaidBath
            Chk_MaidRoom.Checked = .MaidRoom
            Chk_NoSlope.Checked = .NoSlope
            Chk_NotFirstFloor.Checked = .NotFirstFloor
            Chk_NotLastFloor.Checked = .NotLastFloor
            Chk_PetsAllowed.Checked = .Pets
            Chk_Pool.Checked = .Pool
            Chk_Roof.Checked = .Roof
            Chk_Security.Checked=.Security
            Chk_Solar.Checked = .Solar
            Chk_Storage.Checked = .Storage
            Chk_Terrace.Checked = .Terrace
            Chk_NotUsed.Checked = .NotUsed
            Chk_VideoPhone.Checked = .Videophone
            Chk_WillExchange.Checked=.Exchange 
        End With
    End Sub

    Protected Sub GotoSearchMode(id As integer, Optional doSearch As Boolean = true)
        Dim aObj As BackEnd.PropertySearch 

        'Get the search
        aObj= BackEnd.PropertySearch.Load(id)

        'Fill the controls
        Me.UnpackSearchObject(aObj)

        'Set the state
        HF_Mode.Value = "2"
        HF_SearchId.Value = id.ToString()
        HF_SelectedSearchId.Value = id.ToString()
        Txt_Searches.Text = aObj.Name

        HF_RequestId.Value=""
        Txt_Request.Text=""
        
        'Do the search
        If doSearch = True Then Me.Search()
    End Sub

    Protected Sub Cmd_OpenSearch_Click(sender As Object, e As EventArgs)
        'Security
        If aCurrentUser Is Nothing Then Return

        If HF_SelectedSearchId.Value Is Nothing OrElse IsNumeric(HF_SelectedSearchId.Value) = False OrElse CInt(HF_SelectedSearchId.Value) < 1 Then Return

        Try
            Me.GotoSearchMode(CInt(HF_SelectedSearchId.Value), true)
        Catch ex As Exception
            aError=ex.Message 
        End Try
    End Sub

    Protected Sub Cmd_Save_Click(sender As Object, e As EventArgs)
        Dim aName As String = HF_TempSearchName.Value
        Dim aObj As Backend.PropertySearch
        
        'Security
        If aCurrentUser Is Nothing Then Return 

        'Name must be there if new mode
        If HF_Mode.Value IsNot Nothing AndAlso HF_Mode.Value = "1" AndAlso (aName Is Nothing OrElse aName.Trim()="") Then Return

        Try
            aObj = PackSearchObject()

            BackEnd.PropertySearch.Save(aObj)

            HF_TempSearchName.Value = ""

            GotoSearchMode(aObj.Id, False)

            Me.Img_Status.Visible = True

        Catch ex As Exception
            aError = ex.Message 
        End Try
    End Sub


    Protected Sub UnpackRequestObject(aObj As BackEnd.ClientRequest2)
        Dim arr1 As String(), arr2 As String()

        With aObj
            SelectInCombo(1, Cmb_SearchIn)
            'SelectInCombo(.PropertyType, Cmb_PropertyType)
            Opt_Surface.Checked = .AreaType = 1
            Opt_Sellable.Checked = .AreaType = 2
            Txt_AreaMin.Text = .AreaMin 
            Txt_AreaMax.Text = .AreaMax 
            Chk_ForSale.Checked = .ForSale 
            Txt_SaleMin.Text = .SaleMin
            Txt_SaleMax.Text = .SaleMax
            Chk_ForRent.Checked = .ForRent
            Txt_RentMin.Text = .RentMin
            Txt_RentMax.Text = .RentMax
            Txt_BedroomsMin.Text = .BedroomsMin
            Txt_BedroomsMax.Text = .BedroomsMax

            'Properties
            HF_PropertiesIds.Value = .PropertiesIds 
            HF_PropertiesTitles.Value = .PropertiesTitles 
            Lst_Properties.Items.Clear()

            If .PropertiesIds <> "" Then
                arr1 = .PropertiesIds.Split(",")
                arr2 = .PropertiesTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_Properties.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If

            'Districts
            HF_DistrictsIds.Value = .DistrictsIds 
            HF_DistrictsTitles.Value = .DistrictsTitles 
            Lst_Districts.Items.Clear()

            If .DistrictsIds <> "" Then
                arr1 = .DistrictsIds.Split(",")
                arr2 = .DistrictsTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_Districts.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If


            'PropertyTypes
            HF_PropertyTypesIds.Value = .PropertyTypesIds 
            HF_PropertyTypesTitles.Value = .PropertyTypesTitles 
            Lst_PropertyTypes.Items.Clear()

            If .PropertyTypesIds <> "" Then
                arr1 = .PropertyTypesIds.Split(",")
                arr2 = .PropertyTypesTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_PropertyTypes.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If

            'Cities
            HF_CitiesIds.Value = .CitiesIds 
            HF_CitiesTitles.Value = .CitiesTitles 
            Lst_Cities.Items.Clear()

            If .CitiesIds <> "" Then
                arr1 = .CitiesIds.Split(",")
                arr2 = .CitiesTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_Cities.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If

            'NotCities
            HF_NotCitiesIds.Value = .NotCitiesIds 
            HF_NotCitiesTitles.Value = .NotCitiesTitles 
            Lst_NotCities.Items.Clear()

            If .NotCitiesIds <> "" Then
                arr1 = .NotCitiesIds.Split(",")
                arr2 = .NotCitiesTitles.Split(",")

                For i As Integer = 0 To arr1.Length-1
                    Lst_NotCities.Items.Add(New ListItem(arr2(i), arr1(i)))
                Next
            End If

            SelectInCombo(.View, Cmb_View)
            SelectInCombo(.Age, Cmb_Age)
            SelectInCombo(.ParkingType, Cmb_Parking)
            Txt_Parking.Text = .ParkingCount 

            'Checkboxes
            Chk_Balcony.Checked = .Balcony
            Chk_BIW.Checked = .BIW
            Chk_CentralAC.Checked = .CentralAC
            Chk_Commercial.Checked = .Commercial
            Chk_Concierge.Checked = .Concierge
            Chk_Decorated.Checked = .Decorated
            Chk_DoubleGlazing.Checked = .DoubleG
            Chk_Duplex.Checked = .Duplex
            Chk_FirstFloor.Checked = .FirstFloor
            Chk_ForRent.Checked = .ForRent
            Chk_ForSale.Checked = .ForSale
            Chk_Furnished.Checked = .Furnished
            Chk_Garden.Checked = .Garden
            Chk_GF.Checked = .GF
            Chk_Heating.Checked = .Heating
            Chk_Interphone.Checked = .Interphone
            Chk_NotGF.Checked = .NotGF 
            Chk_LTB.Checked = .LTB
            Chk_Lux.Checked = .Lux
            Chk_MaidBath.Checked = .MaidBath
            Chk_MaidRoom.Checked = .MaidRoom
            Chk_NoSlope.Checked = .NoSlope
            Chk_NotFirstFloor.Checked = .NotFirstFloor
            Chk_NotLastFloor.Checked = .NotLastFloor
            Chk_PetsAllowed.Checked = .Pets
            Chk_Pool.Checked = .Pool
            Chk_Roof.Checked = .Roof
            Chk_Security.Checked=.Security
            Chk_Solar.Checked = .Solar
            Chk_Storage.Checked = .Storage
            Chk_Terrace.Checked = .Terrace
            Chk_NotUsed.Checked = .NotUsed
            Chk_VideoPhone.Checked = .Videophone
            Chk_WillExchange.Checked=.Exchange 
        End With
    End Sub

    Protected Sub Cmd_OpenRequest_Click(sender As Object, e As EventArgs)
        Dim aRequestId As String = HF_RequestId.Value
        Dim aObj As Backend.ClientRequest2
        Dim aTagsIds As String="", aTagsTitles As String = ""

        'Security
        If aCurrentUser Is Nothing Then Return 

        'Name must be there if new mode
        If aRequestId Is Nothing OrElse IsNumeric(aRequestId) = False OrElse CInt(aRequestId) <= 0 Then Return
        
        Try
            aObj = BackEnd.ClientRequest2.Load(CInt(aRequestId), aCurrentUser.ID, aCurrentUser.IsAdmin = False AndAlso aCurrentUser.IsSuperUser=False, aTagsIds, aTagsTitles)

            GotoNewMode()
            Chk_IsActive.Checked = False 

            'Bind Controls
            Me.UnpackRequestObject(aObj)

            'Display in grid
            Me.Search()
        Catch ex As Exception
            aError = ex.Message 
        End Try
    End Sub

    Protected Function PackRequestObject() As Backend.ClientRequest2 
        Dim aResult As New Backend.ClientRequest2()

        With aResult
            If Opt_Sellable.Checked = True Then
                .AreaType = 2
            Else
                .AreaType = 1
            End If

            .AreaMin = Txt_AreaMin.Text : .AreaMax=Txt_AreaMax.Text
            .ForSale = Chk_ForSale.Checked : .SaleMin = Txt_SaleMin.Text : .SaleMax = Txt_SaleMax.Text
            .ForRent = Chk_ForRent.Checked : .RentMin = Txt_RentMin.Text : .RentMax = Txt_RentMax.Text
            .BedroomsMin = Txt_BedroomsMin.Text : .BedroomsMax = Txt_BedroomsMax.Text

            .PropertiesIds = iif(HF_PropertiesIds.Value Is Nothing, "", HF_PropertiesIds.Value)
            .PropertiesTitles=iif(HF_PropertiesTitles.Value Is Nothing, "", HF_PropertiesTitles.Value)

            .DistrictsIds = iif(HF_DistrictsIds.Value Is Nothing, "", HF_DistrictsIds.Value)
            .DistrictsTitles = iif(HF_DistrictsTitles.Value Is Nothing, "", HF_DistrictsTitles.Value)

            .PropertyTypesIds = iif(HF_PropertyTypesIds.Value Is Nothing, "", HF_PropertyTypesIds.Value)
            .PropertyTypesTitles = iif(HF_PropertyTypesTitles.Value Is Nothing, "", HF_PropertyTypesTitles.Value)

            .CitiesGroupsIds = ""
            .CitiesGroupsTitles = ""

            .CitiesIds = iif(HF_CitiesIds.Value Is Nothing, "", HF_CitiesIds.Value)
            .CitiesTitles = iif(HF_CitiesTitles.Value Is Nothing, "", HF_CitiesTitles.Value)

            .NotCitiesIds = iif(HF_NotCitiesIds.Value Is Nothing, "", HF_NotCitiesIds.Value)
            .NotCitiesTitles = iif(HF_NotCitiesTitles.Value Is Nothing, "", HF_NotCitiesTitles.Value)


            .View = Cmb_View.SelectedValue
            .Age = Cmb_Age.SelectedValue
            .ParkingType = Cmb_Parking.SelectedValue
            .ParkingCount = Txt_Parking.Text

            .LTB = Chk_LTB.Checked 
            .Furnished = Chk_Furnished.Checked
            .Decorated = Chk_Decorated.Checked
            .NotUsed = Chk_NotUsed.Checked
            .Lux = Chk_Lux.Checked
            .Duplex = Chk_Duplex.Checked
            .Commercial = Chk_Commercial.Checked
            .Exchange = Chk_WillExchange.Checked
            .NoSlope = Chk_NoSlope.Checked
            .GF = Chk_GF.Checked
            .FirstFloor = Chk_FirstFloor.Checked
            .NotGF = Chk_NotGF.Checked
            .NotFirstFloor = Chk_NotFirstFloor.Checked
            .NotLastFloor = Chk_NotLastFloor.Checked
            .Garden = Chk_Garden.Checked
            .Terrace = Chk_Terrace.Checked
            .Balcony = Chk_Balcony.Checked
            .MaidRoom = Chk_MaidRoom.Checked
            .MaidBath = Chk_MaidBath.Checked
            .Heating = Chk_Heating.Checked
            .Solar = Chk_Solar.Checked
            .CentralAC = Chk_CentralAC.Checked
            .Storage = Chk_Storage.Checked
            .DoubleG = Chk_DoubleGlazing.Checked
            .Interphone = Chk_Interphone.Checked
            .Videophone = Chk_Videophone.Checked
            .BIW = Chk_BIW.Checked
            .Concierge = Chk_Concierge.Checked
            .Security = Chk_Security.Checked
            .Pool = Chk_Pool.Checked
            .Pets = Chk_PetsAllowed.Checked
            .Roof = Chk_Roof.Checked

            .CreatedOn=Now
            .CreatedBy=aCurrentUser.ID 
        End With

        Return aResult
    End Function

    Protected Sub NewRequestFromProps_Click(sender As Object, e As EventArgs)
       Dim aObj As New BackEnd.ClientRequest2

        'Security
        If aCurrentUser Is Nothing Then Return 

        'Set its values from controls
        aObj.AreaType = 2
        aObj.PropertiesIds = HF_PropertiesIds.Value 
        aObj.PropertiesTitles = HF_PropertiesTitles.Value 

        'Set Session
        Session("CreateSearchRequest") = aObj

        'Set HF value
        HF_CreateSearchRequest.Value="true"
    End Sub

    Protected Sub NewRequestFromSearch_Click(sender As Object, e As EventArgs)
        Dim aObj As New BackEnd.ClientRequest2

        'Security
        If aCurrentUser Is Nothing Then Return 

        'Set its values from controls
        aObj = Me.PackRequestObject()

        'Set Session
        Session("CreateSearchRequest") = aObj

        'Set HF value
        HF_CreateSearchRequest.Value="true"
    End Sub

    Private Sub GV_Sorting(sender As Object, e As GridViewSortEventArgs) Handles GV.Sorting
        Dim dt As DataTable = Session("SearchDS")

        If dt IsNot Nothing Then         
'         Sort the data.
          dt.DefaultView.Sort = e.SortExpression & " " & GetSortDirection(e.SortExpression)
          GV.DataSource = Session("SearchDS")
          GV.DataBind()
        End If 
    End Sub

  Private Function GetSortDirection(column as string) As string
   'By default, set the sort direction to ascending.
    Dim sortDirection As string = "ASC"

    'Retrieve the last column that was sorted.
    Dim sortExpression As string = ViewState("SortExpression")

    If sortExpression IsNot Nothing Then    
      ' Check if the same column is being sorted.
      ' Otherwise, the default value can be returned.
      If sortExpression = column Then      
        Dim lastDirection as string  = ViewState("SortDirection")
        If lastDirection IsNot Nothing AndAlso lastDirection = "ASC" Then sortDirection = "DESC"
      End If
    End If

    ' Save new values in ViewState.
    ViewState("SortDirection") = sortDirection
    ViewState("SortExpression") = column

    return sortDirection
  End Function
End Class
