﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="frmToReviewProperties.aspx.vb" Inherits="Backend_frmToReviewProperties"  %>
    

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script src="Js/movablediv.js"></script>

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous" />
    <link rel="stylesheet" href="fontawesome/css/font-awesome.min.css" />

    <!--My Every Page -->
    <link rel="Stylesheet" href="css/page.css" />

    <style>
        .toolbar{
            justify-content:flex-start !important;
        }

        .btnGrid{
            padding:2px 8px !important;
        }

        #popup{
            position:absolute;
            z-index:999;
            left:0;
            right:0;
            top:0;
            bottom:0;
            background-color:rgba(0,0,0,0.02);
            width:100%;
            height: 100%;
        }

        #popupInner{
            display:flex;
            flex-direction:column;
            position:absolute;
            z-index:9999;
            left:200px;
            top:10px;
            width:540px;
            border: 5px solid #008fe2;
            border-radius:6px;
            background-color:white;
        }


        #popup .content{
            margin-top:0px;
            display: flex;
            flex-direction:column;
            margin: 0px 0 8px 8px;
            padding-right:8px;
            max-height:510px;
            overflow-y:auto;
        }
        
        #GV, #Grid_Channels{
            color:rgba(0,0,0,0.4);     
            border-color:rgba(0,0,0,0.1) !important ;    
        }

        #GV td, #GV th, #Grid_Channels td, #Grid_Channels th{
            color:black !important;   
            border-color:rgba(0,0,0,0.1) !important ;    
            font-weight:400 !important;
            border-left:none !important;
            border-right:none !important;
        }  
        
        #GV tbody > tr:first-of-type, #Grid_Channels tbody > tr:first-of-type{
            background-color:#f7f8fa !important;
        }

        #GV th, #Grid_Channels th {
            font-weight: 700 !important;
        }

        #GV td, #Grid_Channels td {
            padding-top: 2px;
            padding-bottom: 2px;
        }
    </style>
</head>

<body onload="loadMe()">
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" LoadScriptsBeforeUI="false">
        </asp:ScriptManager>

        <asp:HiddenField ID="HF_Exit" runat="server" />
        <asp:HiddenField ID="HF_ExitTo" runat="server" />        
        <asp:HiddenField ID="HF_ExitMessage" runat="server" />

        <asp:HiddenField ID="HF_ShowPopup" runat="server" />
        <asp:HiddenField ID="HF_EntryId" runat="server" />

        <div class="root">

        <div class="toolbar">
            <div style="font-weight:700 !important; color:#008ef2 !important;">
                To Review Properties
            </div>
        </div>

        <div style="padding:6px;">
            <% If aError IsNot Nothing AndAlso aError <> "" %>
                <div class="errorDiv">
                    <%=aError %>
                </div>
            <%End If %>

            <%If Me.IsPostBack = False AndAlso (aDataSource Is Nothing OrElse aDataSource.Rows.Count < 1) Then %>
                 <div style="display:flex; justify-content:center;align-items:center;height:400px">
                     <h2 style="color:gray;">There are no pending properties to review.</h2>
                 </div>
            <%Else %>
                <asp:GridView ID="GV" runat="server" DataKeyNames="ID" AutoGenerateColumns="false"  Width="100%" Font-Size="10pt" PageSize="9999">
                    <Columns>                         
                        <asp:BoundField DataField="ID" ItemStyle-CssClass="hidden" HeaderStyle-CssClass="hidden" />  

                        <asp:BoundField DataField="PropertyId" HeaderText="Prop. ID" ItemStyle-HorizontalAlign="center" HeaderStyle-HorizontalAlign="center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText" />  
                        <asp:BoundField DataField="PropertyKey" HeaderText="Prop. Key" ItemStyle-HorizontalAlign="center" HeaderStyle-HorizontalAlign="center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText"  />  
                        <asp:BoundField DataField="Info" HeaderText="Info" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="paddingLeft4" ItemStyle-CssClass="paddingLeft4"  />  
                        
                        <asp:TemplateField HeaderText="" ItemStyle-Width="69"  HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center"  HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                            <ItemTemplate> 
                                <asp:Button ID="Cmd_Visit" runat="server" data-path='<%# DataBinder.Eval(Container.DataItem, "Url")%>' Text="Visit" OnClientClick="return visit(this);" CssClass="btn btnToolbar btnGrid btnOrange" Width="65"></asp:Button>
                            </ItemTemplate>
                        </asp:TemplateField> 

                        <asp:TemplateField HeaderText="" ItemStyle-Width="69"  HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center">
                            <ItemTemplate> 
                                <asp:Button ID="Cmd_Review" runat="server" Text="Review" data-id='<%# DataBinder.Eval(Container.DataItem, "ID")%>' OnClientClick="return onReviewClick(this);" OnClick="Cmd_Review_Click" CssClass="btn btnToolbar btnGrid" Width="65"></asp:Button>
                            </ItemTemplate>
                        </asp:TemplateField> 
                    </Columns>

                    <RowStyle Height="26px" />
                    <HeaderStyle BackColor="#f7f8fa"  Height="26px" />
                    <EditRowStyle Height="26px" />
                    <AlternatingRowStyle BackColor="White" />
                </asp:GridView>
            <%End If %>
        </div>

        <!--Popup-->
        <%If HF_ShowPopup.Value = "True" Then %>
            <div id="popup">
                <div id="popupInner" class="movableDiv">
                    <div id="popupInnerheader" class="popupToolbar">
                        <asp:Button ID="Cmd_Save" runat="server" OnClick="Cmd_Save_Click" Text="Process" CssClass="btn btnToolbar" style="margin-right:12px;" />
                        <asp:Button ID="Cmd_Close" runat="server" Text="Close" CssClass="btn btnToolbar" OnClientClick="return onCloseReviewDialog();" />
                    </div>

                    <% If aReviewError IsNot Nothing AndAlso aReviewError <> "" %>
                        <div class="errorDiv">
                            <%= aReviewError %>
                        </div>
                    <%End If %>

                    <div class="content">
                        <asp:Label ID="Lbl_Notes" runat="server" style="margin-top:8px;" Text="Notes" />
                        <asp:TextBox ID="Txt_Notes" runat="server" TextMode="MultiLine" style="min-height:60px;" Height="60" Width="100%" CssClass="form-control txt"/>

                        <asp:Label ID="Lbl_Errors" runat="server" Text="Errors" CssClass="marginTop8" />
                        <asp:TextBox ID="Txt_Errors" runat="server" TextMode="MultiLine" style="min-height:60px;" Height="60" Width="100%" CssClass="form-control txt" />

                        <asp:GridView ID="Grid_Channels" runat="server" DataKeyNames="Id" AutoGenerateColumns="false"  Width="100%" Font-Size="10pt" PageSize="9999" BorderColor="gray" CssClass="marginTop12">
                            <Columns>                         
                                <asp:BoundField DataField="Id" ItemStyle-CssClass="hidden" HeaderStyle-CssClass="hidden" />  

                                <asp:BoundField DataField="ShortTitle" HeaderText="Channel" ItemStyle-HorizontalAlign="left" HeaderStyle-HorizontalAlign="left" HeaderStyle-CssClass="paddingLeft4" ItemStyle-CssClass="paddingLeft4" />  
                                        
                                <asp:TemplateField HeaderText="Yes" ItemStyle-Width="65" ControlStyle-Width="40" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                                    <ItemTemplate> 
                                        <asp:CheckBox ID="Chk_Yes" runat="server" onclick="return onActionChecked(this);" />
                                    </ItemTemplate>
                                </asp:TemplateField>

                                <asp:TemplateField HeaderText="No" ItemStyle-Width="65" ControlStyle-Width="40" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                                    <ItemTemplate> 
                                        <asp:CheckBox ID="Chk_No" runat="server" onclick="return onActionChecked(this);" />
                                    </ItemTemplate>
                                </asp:TemplateField>

                                <asp:TemplateField HeaderText="Maybe" ItemStyle-Width="65" ControlStyle-Width="40" HeaderStyle-HorizontalAlign="Center" ItemStyle-HorizontalAlign ="Center" HeaderStyle-CssClass="centerText" ItemStyle-CssClass="centerText">
                                    <ItemTemplate> 
                                        <asp:CheckBox ID="Chk_Maybe" runat="server" onclick="return onActionChecked(this);" />
                                    </ItemTemplate>
                                </asp:TemplateField>
                            </Columns>

                            <RowStyle Height="26px" />
                            <HeaderStyle Height="26px" />
                            <EditRowStyle Height="26px" />
                            <AlternatingRowStyle BackColor="White" />
                        </asp:GridView>

                    </div>
                </div>
            </div>
        <%End If %>
        </div>


    </form>

    <script type="text/javascript">
      function loadMe()
      {
          if (document.getElementById("HF_Exit").value == "exit") {
              if (document.getElementById("HF_ExitMessage").value != "")
                  alert(document.getElementById("HF_ExitMessage").value);

              var aExitTo = document.getElementById("HF_ExitTo").value;

              if (aExitTo.substring(0, 1) == "1") {
                  if (window.parent.parent)
                      window.parent.parent.location = aExitTo.substring(1);
                  else if (window.parent)
                      window.parent.location = aExitTo.substring(1);
              }

              else {
                  if (window.parent.document.getElementById('myIframe'))
                      window.parent.document.getElementById('myIframe').src = aExitTo.substring(1);
                  else if (window.parent)
                      window.parent.location = aExitTo.substring(1);
              }
          }        
          else
          {
              try {
                  if(document.getElementById("popupInner"))
                     makeElementMovable(document.getElementById("popupInner"));
              }
              catch(ex) {

              }
          }          
        } 

        function visit(btn) {
            var path = btn.getAttribute("data-path");
            window.open(path);
            return false;
        }

        function onReviewClick(btn) {
            var id = btn.getAttribute("data-id");
            document.getElementById("<%= HF_EntryId.ClientID %>").value = id;

            return true;
        }

        function onCloseReviewDialog() {
            document.getElementById("popup").style.display = "none";
            document.getElementById("<%= HF_ShowPopup.ClientID  %>").value = "False";
            return false;  
        }

        function onActionChecked(chk) {
            var tr = chk.closest("tr");
            var descendants = tr.querySelectorAll("input");

            for (var child in descendants) {
                if (descendants[child].type == "checkbox" && child != chk)
                    descendants[child].checked = false;
            }

            chk.checked = true;
            return true;
        }
    </script>

    <script type="text/javascript">
    </script>
</body>
</html>
