﻿
Imports System.Collections.Generic
Imports System.Data

Partial Class Backend_frmToReviewProperties
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Transfer
    Public aCurrentUser As FrontEnd.User = Nothing
    Public aError As String = ""
    Public aReviewError As String = ""
    Public aDataSource As DataTable 

    Private Sub ClientTransferOrRedirect(ByVal aRedirect As Boolean, ByVal aDestination As String, ByVal aErrorMessage As String)
        Me.HF_Exit.Value = "exit"
        Me.HF_ExitMessage.Value = aErrorMessage

        If aRedirect = True Then
            Me.HF_ExitTo.Value = "1" & aDestination
        Else
            Me.HF_ExitTo.Value = "2" & aDestination
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing OrElse (aCurrentUser.IsAgent = False AndAlso aCurrentUser.IsSuperUser = False) Then
            ClientTransferOrRedirect(True, "frmLogin.Aspx", "")
            Return False
        End If

        Return True
    End Function
    
    Private Sub Backend_frmToReviewProperties_Load(sender As Object, e As EventArgs) Handles Me.Load
        If ValidateUser = False Then Return

        aError = ""
        aReviewError = ""

        If Me.IsPostBack = False Then 
            Try
                aDataSource = BackEnd.Prop.GetToReviewProperties(aCurrentUser.ID)
                Me.GV.DataSource = aDataSource
                Me.GV.DataBind()

            Catch ex As Exception
                aError = ex.Message
            End Try
        End If 
    End Sub

    Protected Sub Cmd_Review_Click(sender As Object, e As EventArgs)
        Dim i As Integer = 0
        Dim chk As CheckBox

        Try
            Dim aDTChannels As DataTable = MarketingChannel.GetChannels()
            Me.Grid_Channels.DataSource = aDTChannels
            Me.Grid_Channels.DataBind()

            For Each aDRow As DataRow In aDTChannels.Rows
                If aDRow("DefaultPublish") = 1 Then
                    chk = Grid_Channels.Rows(i).Cells(2).Controls.Item(1)
                    chk.Checked = True
                ElseIf aDRow("DefaultPublish") = 0 Then
                    chk = Grid_Channels.Rows(i).Cells(4).Controls.Item(1)
                    chk.Checked = True
                Else
                    chk = Grid_Channels.Rows(i).Cells(3).Controls.Item(1)
                    chk.Checked = True
                End If

                i = i + 1
            Next

            Txt_Errors.Text = ""
            Txt_Notes.Text = ""

            HF_ShowPopup.Value = "True"

            Txt_Notes.Focus()
        Catch ex As Exception
            aError = ex.Message
        End Try   
    End Sub

    Protected Sub Cmd_Save_Click(sender As Object, e As EventArgs)
        Dim channels As List(Of Backend.PairedInteger) = New List(Of Backend.PairedInteger)
        Dim chk As CheckBox
        Dim channelId As Integer, action As integer

         For Each row As GridViewRow In Grid_Channels.Rows
            channelId= row.Cells(0).Text

            action = 0
            chk = row.Cells(2).Controls.Item(1)
            If chk.Checked = True Then 
                action=1
            Else
                chk = row.Cells(3).Controls.Item(1)
                If chk.Checked = True Then action = -1
            End If

            channels.Add (New BackEnd.PairedInteger(channelId, action))
        Next

        Try
            BackEnd.Prop.ReviewProperty(HF_EntryId.Value, Txt_Errors.Text.Trim(), Txt_Notes.Text.Trim(), channels, aCurrentUser.ID)

            HF_ShowPopup.Value = "False"
            Response.Redirect(Request.Url.AbsoluteUri)
        Catch ex As Exception
            aReviewError = ex.Message
        End Try
    End Sub

End Class
