﻿var Proinns = {};

Proinns.Alert = function (settings) {
    this.id = settings && settings.id ? settings.id : "";
    this.userId = settings && settings.userId ? settings.userId : 0;

    this.markAsViewedUrl = "WSAlert.asmx/MarkAsViewed";
    this.getNotViewedUrl = "WSAlert.asmx/GetNotViewed";

    this.alertsIds = "";
};

Proinns.Alert.prototype.fetchAndShow = function () {
    var _this = this;

    if (this.userId < 1)
        return;

    $.ajax({
        url: this.getNotViewedUrl,
        data: JSON.stringify({ 'userId': this.userId }),
        dataType: "json",
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
            if (data && data.length > 0) {
                _this.show(data);

                //Mark the fetched alerts as viewed
                _this.markAsViewed();
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
        }
    });
};

Proinns.Alert.prototype.show = function (data) {
    var html = "<hr />";
    var ids = "";

    if (!data || data.length < 1)
        return;

    for (var i = 0; i < data.length - 1; i++) {
        ids += "," + data[i].Val1.toString();
        html += "<span>" + data[i].Val2 + "</span><hr />";
    }

    ids += "," + data[i].Val1.toString();
    html += "<span>" + data[i].Val2 + "</span>";

    if (ids)
        this.alertsIds = ids.substr(1);

    //Hide -> Fill -> Display
    $("#" + this.id).slideUp(100);

    $("#" + this.id + " .proinns-alert-content").empty();
    $("#" + this.id + " .proinns-alert-content").append(html);

    $("#" + this.id).slideDown(400, function () {
        $("#" + this.id).css("overflow", "auto");
    });
};

Proinns.Alert.prototype.hide = function (closeClicked) {
    $("#" + this.id).slideUp();
};

//Mark the fetched alerts as viewed
Proinns.Alert.prototype.markAsViewed = function () {
    if (!this.alertsIds || this.userId < 1)
        return;

    $.ajax({
        url: this.markAsViewedUrl,
        data: JSON.stringify({ 'userId': this.userId, 'ids': this.alertsIds }),
        dataType: "json",
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
        }
    });
};

Proinns.Alert.prototype.markAllAsViewed = function () {
    if (this.userId < 1)
        return;

    $.ajax({
        url: this.markAsViewedUrl,
        data: JSON.stringify({ 'userId': this.userId, 'ids': 'all' }),
        dataType: "json",
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
        }
    });
};