Imports Microsoft.VisualBasic
Imports System.Data, System.Data.SqlClient, System.Collections.Generic, System.ComponentModel
Imports PDF, PDF.DAL, PDF.DAL.MSSQL

Imports System.Net.Mail
'Imports System.Web.Mail

Imports System.Xml, System.IO

Imports System.Net.Dns
Imports System.Net



Partial Class properties_pvtInfo
    Inherits System.Web.UI.Page

    'Redirect option = Transfer / Redirect
    Private aRedirectOption As RedirectOptionEnum = RedirectOptionEnum.Redirect

    Public Item As New FrontEnd.Prop
    Public Url As String = ""
    Public aMainPhoto As String = ""

    Public aCurrentUser As FrontEnd.User = Nothing


#Region " Page "

    Protected Sub Page_Error(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Error
        Dim aTicketNumber As Integer
        Dim aErrorPath As String = Request.Path
        Dim aErrorDescription As String = Server.GetLastError.GetBaseException.ToString
        Dim aObj As LOG

        Context.ClearError()

        Try
            aObj = LOG.Create()

            aObj.ErrorPath = aErrorPath
            aObj.ErrorDescription = aErrorDescription

            aObj.Persist(True)

            aTicketNumber = aObj.ID
        Catch Ex As Exception
            aTicketNumber = -1
        End Try

        Cache("LastErrorPath") = aErrorPath
        Cache("LastErrorDescription") = aErrorDescription
        Cache("LastErrorTicketNumber") = aTicketNumber.ToString

        If Me.aRedirectOption = RedirectOptionEnum.Transfer Then
            Server.Transfer("CustomError.Aspx", False)
        Else
            Response.Redirect("CustomError.Aspx", False)
        End If
    End Sub

    Private Function ValidateUser() As Boolean
        aCurrentUser = Session("CurrentUser")

        If aCurrentUser Is Nothing Then
            Response.End()
            Return False
        End If

        Return True
    End Function

    Private Function ValidateQueryString(ByVal aID As String) As Boolean
        If aID Is Nothing OrElse IsNumeric(aID) = False OrElse CInt(aID) <= 0 Then Return False

        Return True
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim aID As String = Request.QueryString("id")

        If ValidateUser() = False Then Return

        Me.HF_Photos.Value = "Client Resources/DefaultProperty.Jpg"

        If Me.ValidateQueryString(aID) = False Then
            Me.HF_Error.Value = "close"
            Response.Redirect("index.aspx")
            Return
        Else
            Url = "http://www.961property.com/properties_detail.aspx?id=" & aID.ToString

            'Url = Application("DomainName") & "/properties_detail.aspx?id=" & aID.ToString
            FillDetails(CInt(aID))
        End If
    End Sub





#End Region


#Region " Misc "

    Public ReadOnly Property ItemKey() As String
        Get
            Return Item.PropertyKey
        End Get
    End Property

    Public ReadOnly Property PropertyType() As String
        Get
            Return Item.PropertyType
        End Get
    End Property


    Public ReadOnly Property Area() As String
        Get
            Return Format(Item.Area, "#,###.##")
        End Get
    End Property

    Public ReadOnly Property Price4Sale() As String
        Get
            Return Item.SaleAmount
        End Get
    End Property

    Public ReadOnly Property Price4Rent() As String
        Get
            Return Item.RentAmount
        End Get
    End Property

    Public ReadOnly Property Price() As String
        Get
            If Price4Sale > 0 AndAlso Price4Rent > 0 Then
                Return Item.SaleAmount & " / " & Item.RentAmount

            ElseIf Price4Sale > 0 Then
                Return Item.SaleAmount
            Else
                Return Item.RentAmount
            End If

        End Get
    End Property


    Public ReadOnly Property DesignedFor() As String
        Get
            Return Item.DesignedFor
        End Get
    End Property


    Public ReadOnly Property Country() As String
        Get
            Return Item.Country
        End Get
    End Property


    Public ReadOnly Property City() As String
        Get
            Return Item.City
        End Get
    End Property

    Public ReadOnly Property Street() As String
        Get
            Return Item.Street
        End Get
    End Property


    Public ReadOnly Property NbBedrooms() As String
        Get
            Return Item.Bedrooms
        End Get
    End Property


    Public ReadOnly Property NbBathrooms() As String
        Get
            Return Item.Bathrooms
        End Get
    End Property

    Public ReadOnly Property NbParking() As String
        Get
            Return Item.Parking
        End Get
    End Property

    Public ReadOnly Property PublicDescription() As String
        Get
            Return Item.PublicDescription
        End Get
    End Property

    Public ReadOnly Property Photos() As List(Of String)
        Get
            Return Item.Photos
        End Get
    End Property


    Sub FillDetails(ByVal aID As Integer)
        Dim aObj As FrontEnd.Prop
        Dim aCount, i As Integer
        Dim aResult As String = ""

        Try
            aObj = FrontEnd.Prop.LoadPvtInfo(aID)

            Item = aObj


            If Item Is Nothing OrElse Item.Photos Is Nothing OrElse Item.Photos.Count <= 0 Then
                Me.HF_Photos.Value = "../Client Resources/DefaultProperty.Jpg"
            Else

                aCount = Item.Photos.Count

                For i = 0 To aCount - 1
                    'If i = 0 Then aMainPhoto = Application("DomainName") & "/" & PictureUtils.RelativePathFromPhysical(Item.Photos(i))
                    If i = 0 Then aMainPhoto = "http://www.961property.com/wwwroot/" & PictureUtils.RelativePathFromPhysical(Item.Photos(i))

                    aResult &= Item.Photos(i) & ";"
                Next

                Me.HF_Photos.Value = aResult.Substring(0, aResult.Length - 1)


            End If

        Catch ex As LoadKeyDoesNotExistException
            Me.HF_Error.Value = "close"
        End Try
    End Sub

#End Region


End Class
