<%@ Page Language="VB" AutoEventWireup="false" CodeFile="properties_detail.aspx.vb" Inherits="properties_detail"%>

<%@ Register Src="headerUC.ascx" TagName="Header"   TagPrefix="ucHeader" %> 
<%@ Register Src="footerUC.ascx" TagName="Footer"   TagPrefix="ucFooter" %> 

<%@ Register Src="NewsletterUC.ascx" TagName="Newsletter"   TagPrefix="ucNewsletter" %> 


<!DOCTYPE html>
<!--[if lt IE 7 ]><html class="ie ie6" lang="en"> <![endif]-->
<!--[if IE 7 ]><html class="ie ie7" lang="en"> <![endif]-->
<!--[if IE 8 ]><html class="ie ie8" lang="en"> <![endif]-->
<!--[if (gte IE 9)|!(IE)]><!--><html lang="en"> <!--<![endif]-->
<head>
	<meta charset="utf-8" />
	
	<!-- Page Title -->
	<title><%= NbBedrooms%> Bedrooms <%=aPropertyTitle%></title>
	
    <meta name="keywords" content="Lebanon realestate, Properties for sale in Ballouneh, Shaile, Under Construction, Bsalim, Rabieh, Rabwe, Ballouneh, Shaile, properties lebanon, properties keserwen." />
	<meta name="description" content="<%= PublicDescription %>" />
	<meta name="author" content="Pierre Francis Eid" />
	
	<!-- Mobile Meta Tag -->
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1" />
	

	<!-- Meta Tags for Social Networks sharing -->
	<meta content="en_US" property="og:locale"/>
	<meta content="article" property="og:type"/>
	<meta content="Pierre Francis (i-sold real estate)" property="og:site_name" />
	<meta content="<%= aPropertyTitle %>" property="og:title"/>
	<meta content="<%= PublicDescription %>"  property="og:description"/>
	<meta content="http://www.961property.com/mm_real-estate-lebanon.aspx" property="og:url"/>
	<meta content="<%= aMainPhoto %>" property="og:image"/>

	<!-- Fav and touch icons -->
	<link rel="shortcut icon" type="image/x-icon" href="images/fav_touch_icons/favicon.ico" />
	<link rel="apple-touch-icon" href="images/fav_touch_icons/apple-touch-icon.png" />
	<link rel="apple-touch-icon" sizes="72x72" href="images/fav_touch_icons/apple-touch-icon-72x72.png" />
	<link rel="apple-touch-icon" sizes="114x114" href="images/fav_touch_icons/apple-touch-icon-114x114.png" />
	
	<!-- IE6-8 support of HTML5 elements -->
	<!--[if lt IE 9]>
	  <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script> 
	<![endif]-->
	
	<!-- Google Web Font -->
	<link href="http://fonts.googleapis.com/css?family=Raleway:300,500,900%7COpen+Sans:400,700,400italic" rel="stylesheet" type="text/css" />
	
	<!-- Bootstrap CSS -->
	<link href="css/bootstrap.min.css" rel="stylesheet" />
	
	<!-- Template CSS -->
	<link href="css/style.css" rel="stylesheet" />
	
	<!-- Modernizr -->
	<script src="js/modernizr-2.8.1.min.js"></script>

    <!-- Handle Buttons by Pierre -->
    <script id="handleButtons" language="javascript" type="text/javascript">
        function joinNewsletter() {


            document.getElementById("HD_Email").value = document.getElementById("newsletter_email").value;
            document.getElementById("Cmd_JoinNewsletter").click();
        }

        function LoadMe() {
            if (document.getElementById("HD_Message").value != '') {
                alert(document.getElementById("HD_Message").value);
            }

        }

    </script>
</head>


<body  onload="LoadMe();">
 
	<!-- BEGIN WRAPPER -->
	<div id="wrapper">
	
		
		<!-- BEGIN HEADER -->
		<header id="header">
		    <ucHeader:Header id="HeaderID" runat="server" />
		</header>
		<!-- END HEADER -->
		
		
		
		<!-- BEGIN PAGE TITLE/BREADCRUMB -->
		<div class="parallax colored-bg pattern-bg" data-stellar-background-ratio="0.5">
			<div class="container">
				<div class="row">
					<div class="col-sm-12">
						<h1 class="page-title">Property Detail</h1>
						
						<ul class="breadcrumb">
							<li><a href="index.aspx">Home </a></li>
							<li><a href="#">Properties</a></li>
							<li><a href="properties-detail.html">Property Detail</a></li>
						</ul>
					</div>
				</div>
			</div>
		</div>
		<!-- END PAGE TITLE/BREADCRUMB -->
		
		
		<!-- BEGIN CONTENT WRAPPER -->
		<div class="content">
			<div class="container">
				<div class="row">
				
					<!-- BEGIN MAIN CONTENT -->
					<div class="main col-sm-8">
					
						<h3 class="property-title"><%=aPropertyTitle%> <small><%= Country %>, <%= City %> </small>
                       </h3>
						
                      
						<div class="property-topinfo">
							<ul class="amenities">
								<li><i class="icon-apartment"></i> <%=PropertyType%></li>
								<li><i class="icon-area"></i> <%= Area %> m2</li>
								<li><i class="icon-bedrooms"></i> <%= NbBedrooms%></li>
								<li><i class="icon-bathrooms"></i> <%= NbBathrooms%></li>
							</ul>
							
							<div id="property-id">Ref # <%= ItemKey %>  &nbsp;&nbsp;&nbsp;&nbsp; [ 71 6655 71 ] . [ 70 592 593 ] </div>
						</div>

						<!-- BEGIN PROPERTY DETAIL SLIDERS WRAPPER -->
						<div id="property-detail-wrapper" class="style1">
							
							<div class="price">
								<i class="fa fa-home"></i> <%=DesignedFor%> 
								<span> <%=Price%> $ </span>
							</div>
									
							<!-- BEGIN PROPERTY DETAIL LARGE IMAGE SLIDER -->
							<div id="property-detail-large" class="owl-carousel">
                             <% 						    
                                  Dim aPicturesList As System.Collections.Generic.List(Of String) = Me.Photos
                                  Dim i As Integer = 0
						   
                                  For i = 0 To aPicturesList.Count - 1
						     %>
								<div class="item">
									<img src="http://www.961property.com/<%= PictureUtils.RelativePathFromPhysical(aPicturesList(i)) %>" alt="" style="width:764px; height:423px"  />
								</div>		
                                <%
                                Next
                                    %>					
							</div>
							<!-- END PROPERTY DETAIL LARGE IMAGE SLIDER -->
							
							<!-- BEGIN PROPERTY DETAIL THUMBNAILS SLIDER -->
							<div id="property-detail-thumbs" class="owl-carousel">
                              <% 						    
                                  Dim aPicturesThumbList As System.Collections.Generic.List(Of String) = Me.Photos
                                  Dim j As Integer = 0
                                  
                                  For j = 0 To aPicturesThumbList.Count - 1
						      %>
								<div class="">       
                                   <img src="http://www.961property.com/<%= PictureUtils.RelativePathFromPhysical(aPicturesThumbList(j)) %>" alt="" title="" style="width:148px; height:131px" />
                                </div>
                                   <%
                                Next
                                    %>	
                                    		
							</div>
							<!-- END PROPERTY DETAIL THUMBNAILS SLIDER -->
						<%=PublicDescription%>		
						</div>
						
						<%'=PublicDescription%>.
						<p>&nbsp;</p>
						
						
						<!-- BEGIN PROPERTY AMENITIES LIST //
						<ul class="property-amenities-list col-md-4">
							<li class="enabled"> Security System </li>
							<li class="enabled"> Parking On Street </li>
							<li class="enabled"> Garage </li>
							<li class="enabled"> Internet </li>
							<li class="enabled"> Telephone </li>
							<li class="disabled"> Alarm Clock </li>
							<li class="disabled"> Water Cooler </li>
							<li class="enabled"> Air Conditioning </li>
							<li class="enabled"> Heating </li>
						</ul>
						
						<ul class="property-amenities-list col-md-4">
							<li class="enabled"> Washing Machine </li>
							<li class="disabled"> Clothes Dryer </li>
							<li class="enabled"> Fireplace </li>
							<li class="disabled"> Sofa Bed </li>
							<li class="enabled"> Dishwasher </li>
							<li class="enabled"> Refrigerator </li>
							<li class="disabled"> Freezer </li>
							<li class="enabled"> Oven </li>
							<li class="enabled"> Microwave </li>
						</ul>
						
						<ul class="property-amenities-list col-md-4">
							<li class="enabled"> Coffee Maker </li>
							<li class="enabled"> Toaster </li>
							<li class="disabled"> Ice Maker </li>
							<li class="enabled"> Stove </li>
							<li class="enabled"> Dishes & Utensils </li>
							<li class="enabled"> Satellite / Cable TV  </li>
							<li class="enabled"> Balcony </li>
							<li class="disabled"> Deck / Patio </li>
							<li class="enabled"> Outdoor Grill </li>
						</ul>
						//END PROPERTY AMENITIES LIST -->
						
						<!--
						<h1 class="section-title">Property Features</h1>
						 // BEGIN PROPERTY FEATURES LIST //
						<ul class="property-features col-sm-6">
							<li><i class="icon-garage"></i> Garage for 2 cars</li>
							<li><i class="icon-pool"></i> Outdoor Pool</li>
							<li><i class="icon-garden"></i> 850 Sq Ft Garden</li>
							<li><i class="icon-security"></i> Security System Installed</li>
						</ul>
						
						<ul class="property-features col-sm-6">
							<li><i class="icon-sale-sign"></i> This property is for sale</li>
							<li><i class="icon-house-usd"></i> Flexible Payments</li>
							<li><i class="icon-rooms"></i> 3 Bedrooms and 2 Bathrooms</li>
							<li><i class="icon-pets"></i> Pets Allowed</li>
						</ul>
						<!-- END PROPERTY FEATURES LIST -->
						
						<!--
						<h1 class="section-title">Property Location</h1>
						// PROPERTY MAP HOLDER //
						<div id="property_location" class="map col-sm-12"></div>-->
						
                   
						<div class="share-wraper col-sm-12">
							<h5>Print this Property:</h5>
							<!--<ul class="social-networks">
								<li><a target="_blank" href="http://www.facebook.com/sharer.php?s=100&amp;p%5Burl%5D=http%3A%2F%2Fwww.wiselythemes.com%2Fhtml%2Fcozy%2Fproperties-detail.html%3Ffb%3Dtrue&amp;p%5Bimages%5D%5B0%5D=http%3A%2F%2Fwww.wiselythemes.com%2Fhtml%2Fcozy%2Fimages%2Fdetail-img1.jpg&amp;p%5Btitle%5D=Cozy%20Property"><i class="fa fa-facebook"></i></a></li>
								<li><a target="_blank" href="https://twitter.com/intent/tweet?url=http://www.wiselythemes.com/html/cozy/properties-detail.html&amp;text=Cozy%20Property"><i class="fa fa-twitter"></i></a></li>
								<li><a target="_blank" href="https://plus.google.com/share?url=http://www.wiselythemes.com/html/cozy/properties-detail.html"><i class="fa fa-google"></i></a></li>
								<li><a target="_blank" href="http://pinterest.com/pin/create/button/?url=http://www.wiselythemes.com/html/cozy/properties-detail.html&amp;description=Cozy%20Property&amp;media=http%3A%2F%2Fwww.wiselythemes.com%2Fhtml%2Fcozy%2Fimages%2Fdetail-img1.jpg"><i class="fa fa-pinterest"></i></a></li>
								<li><a href="mailto:?subject=Check%20out%20this%20property%20I%20found!&amp;body=http://www.wiselythemes.com/html/cozy/properties-detail.html"><i class="fa fa-envelope"></i></a></li>
							</ul>-->
							
						
							<a class="print-button" href="javascript:window.print();">
								<i class="fa fa-print"></i>
							</a>
						</div>
						
					    
						<h1 class="section-title">Agent Information</h1>
						<!-- BEING AGENT INFORMATION -->
						<div class="property-agent-info">
							<div class="agent-detail col-md-4">
								<div class="image">
									<img alt="" src="images\Pierre Francis - Real Estate in Lebanon.jpg" />
								</div>
								
								<div class="info">
									<header>
										<h2>Pierre Francis<small>Maten, Lebanon</small></h2>
									</header>
									
									<ul class="contact-us">
										<li><i class="fa fa-envelope"></i><a href="mailto:info@realestatelebanon.net">info@realestatelebanon.net</a></li>
										<li><i class="fa fa-map-marker"></i> Zalka 690 Bld, Zalka Main Street, Maten, Lebanon</li>
										<li><i class="fa fa-phone"></i> + 961 70 592 593 <br /> + 961 03 908 325</li>
									</ul>
								</div>
							</div>
							

                        <!-- form -->
					<form runat="server" id="form1" class="form-style col-md-8">   
                             <asp:HiddenField ID="HF_Error" runat="server" />
                          <asp:HiddenField ID="HF_Photos" runat="server" />
                          <asp:HiddenField ID="HD_Email" runat="server" />
                          <asp:HiddenField ID="HD_Message"  runat="server" />
                          <asp:Button ID="Cmd_JoinNewsletter" ValidationGroup="VG_Newsletter" runat="server" Text="." Width="1px" Height="1px" BackColor="Transparent" BorderColor="Transparent" />
                   
										
							<div class="col-sm-12">
                                <asp:TextBox ID="Txt_Name" name="Name" placeholder="Name" runat="server" CssClass="form-control required fromName" TabIndex="1"/>		
						        <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" ControlToValidate="Txt_Name" Display="None" ErrorMessage="Please specify your name."></asp:RequiredFieldValidator>
                            </div>    	
                            
                            <div class="col-sm-12">				
                                <asp:TextBox ID="Txt_Email" name="Email" placeholder="Email"  runat="server" CssClass="form-control required fromEmail" TabIndex="2" />                                
                                <asp:RequiredFieldValidator ID="RFV_Email" runat="server" ControlToValidate="Txt_Email" Display="None"   ErrorMessage="Please specify your email"></asp:RequiredFieldValidator>
                                <asp:RegularExpressionValidator ID="REV_Email" runat="server" ControlToValidate="Txt_Email" Display="None" ErrorMessage="Please provide a valid email" ValidationExpression="\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*"></asp:RegularExpressionValidator>
							</div>
                            <div class="col-sm-12">
                                <asp:TextBox ID="Txt_Phone" name="Phone" placeholder="Phone"  runat="server" CssClass="form-control required" TabIndex="3" />	                                				
						        <asp:RequiredFieldValidator ID="RFV_Phone" runat="server"  ControlToValidate="Txt_Phone" Display="None" ErrorMessage="Please specify your phone"></asp:RequiredFieldValidator>
                            </div>
                            <div class="col-sm-12">
                                <asp:TextBox ID="Txt_Notes" name="Message" placeholder="Message" runat="server" TextMode="MultiLine" CssClass="form-control required" TabIndex="4"/>  
                                <asp:RequiredFieldValidator ID="RFV_Notes" runat="server"  ControlToValidate="Txt_Notes" Display="None" ErrorMessage="Please specify your text."></asp:RequiredFieldValidator>
                            </div>
							
							
							<div class="center"> 
                            	
                                <!--button type="submit" class="btn btn-default-color submit_form"><i class="fa fa-envelope"></i> Send Message</button-->              
                                <asp:ImageButton ID="Img_Send" runat="server" ImageUrl="images\sendmail.jpg" />          
                                <br />    <asp:Label ID="Lbl_Error" runat="server"></asp:Label>
						                      
                            </div>

                                 <asp:ValidationSummary ID="ValidationSummary1" runat="server" ShowMessageBox="True" ShowSummary="False" />
						</div>
						<!-- END AGENT INFORMATION -->
						
						
						<!-- BEGIN SIMILAR PROPERTIES -->
						<!-- END PROPERTIES ASSIGNED -->
						
					</div>	
					<!-- END MAIN CONTENT -->
					
					
					<!-- BEGIN SIDEBAR -->
					<div class="sidebar gray col-sm-4">
						
						<!-- BEGIN ADVANCED SEARCH -->
						<h2 class="section-title">Search Property</h2>
					  		    <div class="form-group">
							
								<div class="col-sm-12">
									<!-- <input type="text" class="form-control" name="location" placeholder="City, State, Country, etc..."/>-->
                                     <asp:TextBox ID="Txt_Any" runat="server" CssClass="form-control" name="Keywords" placeholder="Keyword Search" ValidationGroup="VG_Search" ></asp:TextBox>
																
                                     <asp:TextBox ID="Txt_PropertyKey" runat="server" CssClass="form-control" name="search_prop_key" placeholder="Property key" ValidationGroup="VG_Search" ></asp:TextBox>

                                     <asp:DropDownList ID="Cmb_PropertyType" runat="server" CssClass="col-sm-12" name="search_prop_type" data-placeholder="Type of Property" ValidationGroup="VG_Search" >                                     
                                     </asp:DropDownList>
									
                                     <asp:DropDownList ID="Cmb_Country" runat="server" CssClass="col-sm-12" name="search_prop_type" data-placeholder="Location of Property" ValidationGroup="VG_Search"  >                                     
                                     </asp:DropDownList>

                                      <asp:DropDownList ID="Cmb_City" runat="server" CssClass="col-sm-12" name="search_prop_type" data-placeholder="Location of Property" Visible="false" ValidationGroup="VG_Search"  >                                     
                                     </asp:DropDownList>

                                     <asp:DropDownList ID="Cmb_For"  runat="server" name="search_status" data-placeholder="Status" ValidationGroup="VG_Search"  >
                                      <asp:ListItem  Text="" Value="0"></asp:ListItem>                           
                                      <asp:ListItem Selected="True"  Text="For Sale" Value="For Sale"></asp:ListItem>
                                      <asp:ListItem  Text="For Rent" Value="For Rent"></asp:ListItem>
                                     </asp:DropDownList>
								</div>
								
								<div class="col-md-6">
                                    <asp:DropDownList ID="Cmb_Area"  runat="server" name="search_minarea" data-placeholder="Min. Area" Enabled="false" ValidationGroup="VG_Search" >
                                        <asp:ListItem  text="" value=""> </asp:ListItem>
										<asp:ListItem  text="50 m2" value="50"></asp:ListItem>
										<asp:ListItem  text="100 m2" value="100"></asp:ListItem>
										<asp:ListItem  text="150 m2" value="150"></asp:ListItem>
										<asp:ListItem  text="200 m2" value="200"></asp:ListItem>
										<asp:ListItem  text="300 m2" value="300"></asp:ListItem>
										<asp:ListItem  text="500 m2" value="500"></asp:ListItem>
										<asp:ListItem  text="700 m2" value="700"></asp:ListItem>
										<asp:ListItem  text="1000 m2" value="1000"></asp:ListItem>
                                    </asp:DropDownList>									
								</div>
								
								<div class="col-md-6">									
                                    <asp:DropDownList ID="Cmb_MaxArea"  runat="server" name="search_maxarea" data-placeholder="Max. Area" Enabled="false" ValidationGroup="VG_Search" >
                                        <asp:ListItem  text="" value=""> </asp:ListItem>
										<asp:ListItem  text="50 m2" value="50"></asp:ListItem>
										<asp:ListItem  text="100 m2" value="100"></asp:ListItem>
										<asp:ListItem  text="150 m2" value="150"></asp:ListItem>
										<asp:ListItem  text="200 m2" value="200"></asp:ListItem>
										<asp:ListItem  text="300 m2" value="300"></asp:ListItem>
										<asp:ListItem  text="500 m2" value="500"></asp:ListItem>
										<asp:ListItem  text="700 m2" value="700"></asp:ListItem>
										<asp:ListItem  text="1000 m2" value="1000"></asp:ListItem>
                                    </asp:DropDownList>	
								</div>
								
                                <!--
								<div class="col-sm-12">
									<select id="search_bedrooms" name="search_bedrooms" data-placeholder="Bedrooms">
										<option value=""> </option>
										<option value="0">0</option>
										<option value="1">1</option>
										<option value="2">2</option>
										<option value="3">3</option>
										<option value="4">4</option>
										<option value="5">5</option>
										<option value="5plus">5+</option>
									</select>
									
									<select id="search_bathrooms" name="search_bathrooms" data-placeholder="Bathrooms">
										<option value=""> </option>
										<option value="0">0</option>
										<option value="1">1</option>
										<option value="2">2</option>
										<option value="3">3</option>
										<option value="4">4</option>
										<option value="4plus">4+</option>
									</select>
								</div>
									
								<div class="col-md-6">
									<select id="search_minprice" name="search_minprice" data-placeholder="Min. Price">
										<option value=""> </option>
										<option value="0">$0</option>
										<option value="25000">$25000</option>
										<option value="50000">$50000</option>
										<option value="75000">$75000</option>
										<option value="100000">$100000</option>
										<option value="150000">$150000</option>
										<option value="200000">$200000</option>
										<option value="300000">$300000</option>
										<option value="500000">$500000</option>
										<option value="750000">$750000</option>
										<option value="1000000">$1000000</option>
									</select>
								</div>
							
								<div class="col-md-6">
									<select id="search_maxprice" name="search_maxprice" data-placeholder="Max. Price">
										<option value=""> </option>
										<option value="25000">$25000</option>
										<option value="50000">$50000</option>
										<option value="75000">$75000</option>
										<option value="100000">$100000</option>
										<option value="150000">$150000</option>
										<option value="200000">$200000</option>
										<option value="300000">$300000</option>
										<option value="500000">$500000</option>
										<option value="750000">$750000</option>
										<option value="1000000">$1000000</option>
										<option value="1000000plus">>$1000000</option>
									</select>                                  
								</div>
								  -->
                                    <asp:TextBox ID="Txt_Area" runat="server" MaxLength="20" Width="1px" Height="1" Visible="false" ValidationGroup="VG_Search"  ></asp:TextBox>
                                      <asp:TextBox ID="Txt_Street" runat="server" MaxLength="20"  Width="1px" Height="1" Visible="false" ValidationGroup="VG_Search" ></asp:TextBox>
                                      <asp:TextBox ID="Txt_For" runat="server" MaxLength="20" Width="1px" Height="1" Visible="false" ValidationGroup="VG_Search" ></asp:TextBox>

                                      <asp:CheckBox ID="Chk_IsFeatured" runat="server" Visible="false" Text="" ValidationGroup="VG_Search"  />
								<p>&nbsp;</p>
								<p class="center">
                                    <asp:Button ID="Cmd_Go" runat="server" CssClass="btn btn-default-color" Text="Search" OnClientClick="goButtonClicked()" ValidationGroup="VG_Search" />
								</p>
							</div>
                       </form>
					
						<!-- END ADVANCED SEARCH -->
						
						<!-- BEGIN LATEST NEWS -->
						<!-- END LATEST NEWS -->
							
						<!-- BEGIN NEWSLETTER -->
						<div id="newsletter" class="col-sm-12">
						   <h2 class="section-title">Subscribe our weekly<br><span>Newsletter</span></h2>
								<p>Join our newsletter and recieve our weekly updated list of items. You can un-subscribe anytime.</p>
								
							<div class="input-group">
								<input type="text" placeholder="Enter your E-mail" name="newsletter_email" id="newsletter_email" class="form-control" />
								<span class="input-group-btn">
									<button class="btn btn-default-color" type="button" onclick="joinNewsletter();">Subscribe</button>
								</span>
							</div>
						</div>
						<!-- END NEWSLETTER -->
						
					</div>
					<!-- END SIDEBAR -->

				</div>
			</div>
		</div>
		<!-- END CONTENT WRAPPER -->
		
		<!-- BEGIN FOOTER -->
		<footer id="footer">
        <ucFooter:Footer ID="FooterID" runat="server" />
		</footer>
		<!-- END FOOTER -->
	
	</div>
	<!-- END WRAPPER -->
	
	
	<!-- Libs -->
	<script src="js/common.js"></script>
	<script src="js/chosen.jquery.min.js"></script>
    <script src="js/owl.carousel.min.js"></script>
	<script src="http://maps.google.com/maps/api/js?sensor=false" type="text/javascript"></script>
	<script src="js/markerclusterer.min.js" type="text/javascript"></script>
	
	<!-- Template Scripts -->
	<script src="js/variables.js"></script>
	<script src="js/scripts.js"></script>
	
    <!-- Properties list -->
	<script src="js/properties.js"></script>
	
	<script type="text/javascript">
		(function($){
			"use strict";
			
			$(document).ready(function(){
				//Create property map centered on the marker of the property with id=0.
				Cozy.propertiesMap(properties, 'property_location', 0);
			});
		})(jQuery);
	</script>


     <!-- Start of StatCounter Code for Default Guide -->
<script type="text/javascript">
    var sc_project = 10518358;
    var sc_invisible = 1;
    var sc_security = "0296bd09";
    var scJsHost = (("https:" == document.location.protocol) ?
"https://secure." : "http://www.");
    document.write("<sc" + "ript type='text/javascript' src='" +
scJsHost +
"statcounter.com/counter/counter.js'></" + "script>");
</script>
<noscript><div class="statcounter"><a title="shopify traffic
stats" href="http://statcounter.com/shopify/"
target="_blank"><img class="statcounter"
src="http://c.statcounter.com/10518358/0/0296bd09/1/"
alt="shopify traffic stats"></a></div></noscript>
<!-- End of StatCounter Code for Default Guide -->

</body>
</html>