<%@ Page Language="VB" AutoEventWireup="false" CodeFile="properties_list.aspx.vb" Inherits="properties_list" %>

<%@ Register Src="headerUC.ascx" TagName="Header"   TagPrefix="ucHeader" %> 
<%@ Register Src="footerUC.ascx" TagName="Footer"   TagPrefix="ucFooter" %> 

<%@ Register Src="NewsUC.ascx" TagName="News"   TagPrefix="ucNews" %> 

<%@ Register Src="NewsletterUC.ascx" TagName="Newsletter"   TagPrefix="ucNewsletter" %> 

<!DOCTYPE html>
<!--[if lt IE 7 ]><html class="ie ie6" lang="en"> <![endif]-->
<!--[if IE 7 ]><html class="ie ie7" lang="en"> <![endif]-->
<!--[if IE 8 ]><html class="ie ie8" lang="en"> <![endif]-->
<!--[if (gte IE 9)|!(IE)]><!--><html lang="en"> <!--<![endif]-->

<head>
	<meta charset="utf-8" />
	
	<!-- Page Title -->
	<title>Properties for sale in Maten, Lebanon</title>
	
	<meta name="keywords" content="real estate in Maten, lebanon realestate, real estate in Keserwan, Achrafieh, Baabda, Baabda Properties, rabieh, rabwe, bayyada, mtayleb" />
	<meta name="description" content="Welcome to my website. Purchasing a property in Lebanon (apartment, house, land, office) is often a very crucial and important task. Having a huge stock to 
    choose from, my aim is to provide you with the optimum choice making your decision a rewarding one." />
    <meta name="author" content="Pierre Francis Eid" />
	

	<!-- Mobile Meta Tag -->
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1" />

	<!-- Fav and touch icons -->
	<link rel="shortcut icon" type="image/x-icon" href="images/fav_touch_icons/favicon.ico" />
	<link rel="apple-touch-icon" href="images/fav_touch_icons/apple-touch-icon.png" />
	<link rel="apple-touch-icon" sizes="72x72" href="images/fav_touch_icons/apple-touch-icon-72x72.png" />
	<link rel="apple-touch-icon" sizes="114x114" href="images/fav_touch_icons/apple-touch-icon-114x114.png" />
	
	<!-- IE6-8 support of HTML5 elements -->
	<!--[if lt IE 9]>
	  <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script> 
	<![endif]-->
	
	<!-- Google Web Font -->
	<link href="http://fonts.googleapis.com/css?family=Raleway:300,500,900%7COpen+Sans:400,700,400italic" rel="stylesheet" type="text/css" />
	
	<!-- Bootstrap CSS -->
	<link href="css/bootstrap.min.css" rel="stylesheet" />
	
	<!-- Template CSS -->
	<link href="css/style.css" rel="stylesheet" />
	
	<!-- Modernizr -->
	<script src="js/modernizr-2.8.1.min.js"></script>
</head>
<body>
	<!-- BEGIN WRAPPER -->
	<div id="wrapper">
	

		<!-- BEGIN HEADER -->
		<header id="header">
		    <ucHeader:Header id="HeaderID" runat="server" />
		</header>
		<!-- END HEADER -->
		
		
		
		
		<!-- BEGIN PAGE TITLE/BREADCRUMB -->
		<div class="parallax colored-bg pattern-bg" data-stellar-background-ratio="0.5">
			<div class="container">
				<div class="row">
					<div class="col-sm-12">
						<h1 class="page-title">Property Listing</h1>
						
						<ul class="breadcrumb">
							<li><a href="index.aspx">Home </a></li>
							<li><a href="#">Properties</a></li>
							<li><a href="properties-list.html">Property Listing</a></li>
						</ul>
					</div>
				</div>
			</div>
		</div>
		<!-- END PAGE TITLE/BREADCRUMB -->
		
		
		<!-- BEGIN CONTENT WRAPPER -->
		<div class="content">
			<div class="container">
				<div class="row">
				
					<!-- BEGIN MAIN CONTENT -->
					<div class="main col-sm-8">
					
						<div id="listing-header" class="clearfix">
							<div class="form-control-small">
								<select id="sort_by" name="sort_by" data-placeholder="Sort">
									<option value=""> </option>
									<option value="data">Sort by Date</option>
									<option value="area">Sort by Area</option>
								</select>
							</div>
							
							<div class="sort">
								<ul>
									<li class="active"><i data-toggle="tooltip" data-placement="top" title="Sort Descending" class="fa fa-chevron-down"></i></li>
									<li><i data-toggle="tooltip" data-placement="top" title="Sort Ascending" class="fa fa-chevron-up"></i></li>
								</ul>
							</div>
							
							<div class="view-mode">
								<span>View Mode:</span>
								<ul>
									<li data-view="grid-style1" data-target="property-listing"><i class="fa fa-th"></i></li>
									<li data-view="list-style" data-target="property-listing" class="active"><i class="fa fa-th-list"></i></li>
								</ul>
							</div>
						</div>
						<form runat="server">

						<!-- BEGIN PROPERTY LISTING -->
						<div id="property-listing" class="list-style clearfix">
							<div class="row">
								
                              <asp:DataList ID="DL" runat="server" DataSourceID="objDS"> 
                                    <ItemTemplate> 
                                        <div class="item col-md-4"><!-- Set width to 4 columns for grid view mode only -->
									    <div class="image">
										<a href="Properties_detail.aspx?Id=<%# Eval("ID") %>">
											<span class="btn btn-default"><i class="fa fa-file-o"></i>Details</span>
										</a>
									     <img src="http://real-estate-lebanon.net/client%20resources/properties/thumbphotos/<%# Eval("ID") %>.jpg" alt="" />
									    </div>
									    <div class="price">
										    <i class="fa fa-home"></i><%#Eval("PROPERTYKEY")%> 
										    <span><%# FormatCurrency(Eval("SALEAMOUNT"))%></span>
									    </div>
									    <div class="info">
										    <h3>
											    <a href="Properties_detail.aspx?Id=<%# Eval("ID") %>"><%# FormatNumber(Eval("Area"), 0)%> m2 <%# Eval("PropertyType")%> for <%# FrontEnd.Prop.format4SaleOrRent(Eval("FORSALE"), Eval("FORRENT"))%> in <%# Eval("City")%></a>
                                                <small><%# Eval("Country")%>, <%# Eval("City")%></small>
										    </h3>
										    <p> <%# Left(Eval("INFO"), 150)%>...</p>
									
										    <ul class="amenities">
											    <li><i class="icon-area"></i> <%# FormatNumber(Eval("Area"), 0)%> Sqm</li>
											    <li><i class="icon-bedrooms"></i> <%# Eval("Bedrooms")%> </li>
											    <li><i class="icon-bathrooms"></i> <%# Eval("Bathrooms")%> </li>
										    </ul>
									    </div>
								    </div>                                        
                                     </ItemTemplate>
                                 </asp:DataList>                          
							
						
							</div>
						</div>
						<!-- END PROPERTY LISTING -->
						
						
						<!-- BEGIN PAGINATION -->
						<asp:ObjectDataSource ID="ObjDS" runat="server" TypeName="FrontEnd.Prop" Selectmethod="I_Lookup">
                          <SelectParameters>
                              <asp:Parameter Direction="input" Name="aSQLWhere" Type="String"  />
                              <asp:Parameter Direction="Input" Name="aSIndex" Type="Int32" />
                              <asp:Parameter Direction="input" Name="aPageSize" Type="Int32" />
                              <asp:Parameter Direction="input" Name="aConContext" Type="Object" />
                          </SelectParameters>           
                        </asp:ObjectDataSource>	

                        

						<div class="pagination">
                            <asp:LinkButton ID="Lnk_First" runat="server" CssClass="LnkBtnBox" ><<</asp:LinkButton>&nbsp;&nbsp;&nbsp;
                            <asp:LinkButton ID="Lnk_Prev" runat="server" CssClass="LnkBtnBox" ><</asp:LinkButton>&nbsp;&nbsp;<asp:Label ID="Lbl_Nav" runat="server" CssClass="Lbl_CenterText" Font-Size="11px" Font-Bold="true" Width="50px"></asp:Label>&nbsp;&nbsp;<asp:LinkButton ID="Lnk_Next" runat="server" CssClass="LnkBtnBox" >></asp:LinkButton>&nbsp;&nbsp;&nbsp;<asp:LinkButton ID="Lnk_Last" runat="server" CssClass="LnkBtnBox" >>></asp:LinkButton>
                            
                            <!--         
							<ul id="previous">
								<li><a href="#"><i class="fa fa-chevron-left"></i></a></li>
							</ul>
							<ul>
								<li class="active"><a href="#">1</a></li>
								<li><a href="#">2</a></li>
								<li><a href="#">3</a></li>
								<li><a href="#">4</a></li>
							</ul>
							<ul id="next">
								<li><a href="#"><i class="fa fa-chevron-right"></i></a></li>
							</ul>-->
						</div>
						<!-- END PAGINATION -->




                        <!-- asp.net search fields -->
                         <asp:TextBox ID="Txt_Any" runat="server" CssClass="form-control" name="Keywords" placeholder="Keyword Search" ValidationGroup="VG_Search" Visible="false"  ></asp:TextBox>
																
                                     <asp:TextBox ID="Txt_PropertyKey" runat="server" CssClass="form-control" name="search_prop_key" placeholder="Property key" ValidationGroup="VG_Search" Visible="false"></asp:TextBox>

                                     <asp:DropDownList ID="Cmb_PropertyType" runat="server" CssClass="col-sm-12" name="search_prop_type" data-placeholder="Type of Property" ValidationGroup="VG_Search" Visible="false">                                     
                                     </asp:DropDownList>
									
                                     <asp:DropDownList ID="Cmb_Country" runat="server" CssClass="col-sm-12" name="search_prop_type" data-placeholder="Location of Property" ValidationGroup="VG_Search"  Visible="false">                                     
                                     </asp:DropDownList>

                                     <asp:DropDownList ID="Cmb_City" runat="server" CssClass="col-sm-12" name="search_prop_type" data-placeholder="Location of Property"  ValidationGroup="VG_Search" Visible="false" >                                     
                                     </asp:DropDownList>

                                     <asp:DropDownList ID="Cmb_Area" runat="server" CssClass="col-sm-12" name="search_prop_type" data-placeholder="Area Size"  ValidationGroup="VG_Search" Visible="false" >                                     
                                     </asp:DropDownList>


                                     <asp:DropDownList ID="Cmb_For"  runat="server" name="search_status" data-placeholder="Status" ValidationGroup="VG_Search"  Visible="false">
                                      <asp:ListItem  Text="" Value="0"></asp:ListItem>                           
                                      <asp:ListItem Selected="True"  Text="For Sale" Value="For Sale"></asp:ListItem>
                                      <asp:ListItem  Text="For Rent" Value="For Rent"></asp:ListItem>
                                     </asp:DropDownList>

                                      <asp:TextBox ID="Txt_Area" runat="server" MaxLength="20" Width="1px" Height="1"  ValidationGroup="VG_Search"  Visible="false"></asp:TextBox>
                                      <asp:TextBox ID="Txt_Street" runat="server" MaxLength="20"  Width="1px" Height="1"  ValidationGroup="VG_Search" Visible="false"></asp:TextBox>
                                      <asp:TextBox ID="Txt_For" runat="server" MaxLength="20" Width="1px" Height="1"  ValidationGroup="VG_Search" Visible="false"></asp:TextBox>

                                <asp:CheckBox ID="Chk_IsFeatured" runat="server"   Text="" ValidationGroup="VG_Search"  Visible="false"  />
							    <asp:Button ID="Cmd_Go" runat="server" CssClass="btn btn-default-color" Text="Search" OnClientClick="goButtonClicked()" ValidationGroup="VG_Search"  Visible="false" />
						
					
						</form>
					</div>	
					<!-- END MAIN CONTENT -->
					
					
					<!-- BEGIN SIDEBAR -->
					<div class="sidebar gray col-sm-4">
						
						<!-- BEGIN ADVANCED SEARCH -->
						<h2 class="section-title">Search Property</h2>
						<form>
							<div class="form-group">
							
								<div class="col-sm-12">
									<select class="chosen-select" tabindex="-1" multiple="" data-placeholder="Searched Parameters">
										<option value=""> </option>
										<option selected value="New York">New York</option>
										<option selected value="Residential">Residential</option>
										<option selected value="Sale">Sale</option>
										<option selected value="3 bedrooms">3 bedrooms</option>
										<option selected value="2 bathrooms">2 bathrooms</option>
										<option selected value="Min. 70.000$">Min. 70.000$</option>
										<option selected value="Min. 120.000$">Min. 120.000$</option>
									</select>
								</div>
								
								<div class="col-sm-12">
									<input type="text" class="form-control" name="location" placeholder="City, State, Country, etc...">
									
									<select class="col-sm-12" id="search_prop_type" name="search_prop_type" data-placeholder="Type of Property">
										<option value=""> </option>
										<option value="residential">Residential</option>
										<option value="commercial">Commercial</option>
										<option value="land">Land</option>
									</select>
								
									<select id="search_status" name="search_status" data-placeholder="Status">
										<option value=""> </option>
										<option value="sale">For Sale</option>
										<option value="rent">For Rent</option>
									</select>
								</div>
								
								<div class="col-md-6">
									<select id="search_minarea" name="search_minarea" data-placeholder="Min. Area">
										<option value=""> </option>
										<option value="50">50m2</option>
										<option value="100">100m2</option>
										<option value="150">150m2</option>
										<option value="200">200m2</option>
										<option value="300">300m2</option>
										<option value="500">500m2</option>
										<option value="700">700m2</option>
										<option value="1000">1000m2</option>
									</select>
								</div>
								
								<div class="col-md-6">
									<select id="search_maxarea" name="search_maxarea" data-placeholder="Max. Area">
										<option value=""> </option>
										<option value="50">50m2</option>
										<option value="100">100m2</option>
										<option value="150">150m2</option>
										<option value="200">200m2</option>
										<option value="300">300m2</option>
										<option value="500">500m2</option>
										<option value="700">700m2</option>
										<option value="1000">1000m2</option>
									</select>
								</div>
								
								<div class="col-sm-12">
									<select id="search_bedrooms" name="search_bedrooms" data-placeholder="Bedrooms">
										<option value=""> </option>
										<option value="0">0</option>
										<option value="1">1</option>
										<option value="2">2</option>
										<option value="3">3</option>
										<option value="4">4</option>
										<option value="5">5</option>
										<option value="5plus">5+</option>
									</select>
									
									<select id="search_bathrooms" name="search_bathrooms" data-placeholder="Bathrooms">
										<option value=""> </option>
										<option value="0">0</option>
										<option value="1">1</option>
										<option value="2">2</option>
										<option value="3">3</option>
										<option value="4">4</option>
										<option value="4plus">4+</option>
									</select>
								</div>
									
								<div class="col-md-6">
									<select id="search_minprice" name="search_minprice" data-placeholder="Min. Price">
										<option value=""> </option>
										<option value="0">$0</option>
										<option value="25000">$25000</option>
										<option value="50000">$50000</option>
										<option value="75000">$75000</option>
										<option value="100000">$100000</option>
										<option value="150000">$150000</option>
										<option value="200000">$200000</option>
										<option value="300000">$300000</option>
										<option value="500000">$500000</option>
										<option value="750000">$750000</option>
										<option value="1000000">$1000000</option>
									</select>
								</div>
							
								<div class="col-md-6">
									<select id="search_maxprice" name="search_maxprice" data-placeholder="Max. Price">
										<option value=""> </option>
										<option value="25000">$25000</option>
										<option value="50000">$50000</option>
										<option value="75000">$75000</option>
										<option value="100000">$100000</option>
										<option value="150000">$150000</option>
										<option value="200000">$200000</option>
										<option value="300000">$300000</option>
										<option value="500000">$500000</option>
										<option value="750000">$750000</option>
										<option value="1000000">$1000000</option>
										<option value="1000000plus">>$1000000</option>
									</select>
								</div>
								
								<p>&nbsp;</p>
								<p class="center">
									<button type="submit" class="btn btn-default-color">Search</button>
								</p>
							</div>
						</form>
						<!-- END ADVANCED SEARCH -->
						
						<!-- BEGIN LATEST NEWS -->
						<h2 class="section-title">Latest News</h2>
						<ucNews:News id="NewsUcId" runat="server" />
						<!-- END LATEST NEWS -->
							
						<!-- BEGIN NEWSLETTER -->
						<div id="newsletter" class="col-sm-12">
							 <h2 class="section-title">Subscribe our weekly<br/><span>Newsletter</span></h2>
								<p>Join our newsletter and recieve our weekly updated list of items. You can un-subscribe anytime.</p>
								
							<div class="input-group">
								<input type="text" placeholder="Enter your E-mail" name="newsletter_email" id="newsletter_email" class="form-control" />
								<span class="input-group-btn">
									<button class="btn btn-default-color" type="button" onclick="joinNewsletter();">Subscribe</button>
								</span>
							</div>
						</div>
						<!-- END NEWSLETTER -->
						
					</div>
					<!-- END SIDEBAR -->

				</div>
			</div>
		</div>
		<!-- END CONTENT WRAPPER -->
		
		
		<!-- BEGIN FOOTER -->
		<footer id="footer">
        <ucFooter:Footer ID="FooterID" runat="server" />
		</footer>
		<!-- END FOOTER -->
	
	
	</div>
	<!-- END WRAPPER -->
	
	
	<!-- Libs -->
	<script src="js/common.js"></script>
	<script src="js/chosen.jquery.min.js"></script>
	
	<!-- Template Scripts -->
	<script src="js/variables.js"></script>
	<script src="js/scripts.js"></script>
	
</body>
</html>